/*
$Log: umtFilter.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:44:41  sebast
# Revision 2.0
#
# Revision 1.15  1996/02/15  13:20:39  sebast
# some changes because case in RegExp
#
# Revision 1.14  1996/02/14  10:21:27  sebast
#     umtFilterCondition(const umtFilterCondition &); added
#
# Revision 1.13  1996/02/12  12:54:43  sebast
# filters changes done
#
# Revision 1.12  1995/10/25  18:48:54  sebast
# lots remade
#
# Revision 1.11  1995/09/13  18:01:58  sebast
# Lock => public section
#
# Revision 1.10  1995/09/13  13:34:56  sebast
# using umtLock *lock added
#
# Revision 1.9  1995/08/02  11:39:30  sebast
# umtCodingRules
#
# Revision 1.8  1995/07/31  18:12:55  sebast
# some changes for UMT coding rules
#
# Revision 1.7  1995/07/27  16:54:10  lord
# Remove default initialisers in constructors
#
# Revision 1.6  1995/07/04  19:00:40  sebast
# Filter::Save/Load removed.
#
# Revision 1.5  1995/07/04  16:27:24  sebast
# umtString field_value added
#
# Revision 1.4  1995/07/04  16:03:40  sebast
# slist<umtString> FilesList; now public
#
# Revision 1.3  1995/07/04  15:47:17  sebast
# a lot of functions added
#
# Revision 1.2  1995/07/03  18:01:19  sebast
# yet another constructor added
#
# Revision 1.1  1995/05/23  16:25:04  lord
# Initial revision
#

$Header: /export/CVS/UMT/include/umtFilter.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
*/

#ifndef FILTER_H_FLAG
#define FILTER_H_FLAG

#include "umtLock.h++"
#include "umtMsg.h++"
#include "umtRegex.h++"

#define  NUMBER_OF_FILTER_FIELDS  5
#define  NUMBER_OF_FILTER_ACTIONS 4

#define FC_TO       1
#define FC_FROM     2
#define FC_REPLYTO  4
#define FC_SUBJECT  8
#define FC_OTHER   16

#define FA_COPY     1
#define FA_REPLY    2
#define FA_FORWARD  4
#define FA_KILL     8

class umtFilterCondition : public umtMember
{
public:
    unsigned int    Fields;
    umtString       SpecialFieldName;
    
    umtRegex        RegExp;
    status          ErrorStatus;
    
public:
    umtFilterCondition() {} //to make compiler happy
    umtFilterCondition(unsigned int fields,
		       umtRegex reg_exp,
		       umtString spec_field_name);
    umtFilterCondition(const umtFilterCondition &);
    virtual ~umtFilterCondition();

    int Match (umtMsg *m);
    umtFilterCondition& operator =(const umtFilterCondition&);

};

class umtFilter : public umtMember
{
public:
    umtString       FilterName;
    int             IsActive;

    umtFilterCondition FilterCondition;

    unsigned int    Actions;
    umtPath         ActionCopyPath;
    umtPath         ActionReplyPath;
    umtString       ActionForwardAddress;

    status          ErrorStatus;

public: 
    umtFilter(umtString filter_name, int isActive,
	      umtFilterCondition condition,
	      unsigned int actions,
	      umtPath   act_copy,
	      umtPath   act_reply,
	      umtString act_forward
	      );

    virtual ~umtFilter();
    int     Match(umtMsg *);
};

class umtFilterList : public umtSlist
{
public:
    umtFilterList();
    virtual ~umtFilterList();

    umtFilter *GetFirst();
    umtFilter *GetLast();
    umtFilter *GetPrev(umtFilter *);
    umtFilter *GetNext(umtFilter *);

    status Load();
    status Save();

//    umtSlist  FilesList;
    umtLock   *Lock;

private:
    umtString        name;
};


#endif
