#ifndef umtGRTFEditor_H_FLAG
#define umtGRTFEditor_H_FLAG

/*#include <InterViews/glyph.h>
#include <InterViews/printer.h>
*/
#include <InterViews/box.h>
#include <InterViews/hit.h>
#include <OS/list.h>
#include <IV-look/menu.h>
#include <InterViews/session.h>
#include "umtConfiguration.h++"

class umtGRTFEditorImpl;

#define umtGRTF_FONT_NORMAL            "Normal"
#define umtGRTF_FONT_FIXED             "Fixed"
#define umtGRTF_FONT_BOLD              "Bold"
#define umtGRTF_FONT_BOLD_FIXED        "Bold_Fixed"
#define umtGRTF_FONT_ITALIC            "Italic"
#define umtGRTF_FONT_ITALIC_FIXED      "Italic_Fixed"
#define umtGRTF_FONT_ITALIC_BOLD       "Italic_Bold"
#define umtGRTF_FONT_ITALIC_BOLD_FIXED "Italic_Bold_Fixed"

#define umtGRTF_FONT_SMALLER_PREFIX    "Smaller"
#define umtGRTF_FONT_BIGGER_PREFIX     "Bigger"
#define umtGRTF_FONT_NORMAL_PREFIX     "Normal"

class umtGRTFEditor : public Box
{
public:
  umtGRTFEditor
  (
   umtConfiguration *config =nil,
   char *font_section       =nil,
   boolean is_editable      =false,
   Menu *menu               =nil
   );
  
  virtual ~umtGRTFEditor();

  virtual void Clear      (void);
  virtual int Load        (char *fname,boolean is_enriched=true);
  virtual int InsertFile  (char *fname,boolean is_enriched=true);
  virtual int Save        (char *fname=nil,boolean is_enriched=true,boolean is_append=false);
  virtual int AppendString(char *str  ,boolean is_enriched=true);
  virtual int AppendFile  (char *fname,boolean is_enriched=true);
  virtual void ScrollToEnd(void);
  virtual void ScrollToStart(void);
  virtual InputHandler *GetInputHandler(void);


  static  int RtfToText(FILE *rtf ,FILE *text,int width=70);
  static  int TextToRtf(FILE *text,FILE *rtf );
private:
  umtGRTFEditorImpl *impl_;
};

typedef unsigned char RTFCommand;

const  RTFCommand   RtfOffCmd         =100;

const  RTFCommand   RtfUNKNOWN        =12;

const  RTFCommand   RtfBold        =60;
const  RTFCommand   RtfItalic      =61;
const  RTFCommand   RtfFixed       =62;
const  RTFCommand   RtfSmaller     =63;
const  RTFCommand   RtfBigger      =64;
const  RTFCommand   RtfUnderLine   =65;
			  
const  RTFCommand   RtfCenter      =66;
const  RTFCommand   RtfFlushLeft   =67;
const  RTFCommand   RtfFlushRight  =68;
const  RTFCommand   RtfFlushBoth   =69;
const  RTFCommand   RtfNoFill      =70;
			  
const  RTFCommand   RtfIndent      =71;
const  RTFCommand   RtfIndentRight =72;
			  
const  RTFCommand   RtfExcerpt     =73;
const  RTFCommand   RtfParam       =74;
const  RTFCommand   RtfX_Color     =75;

const  RTFCommand   RtfBoldOFF        =RtfBold         +RtfOffCmd;
const  RTFCommand   RtfItalicOFF      =RtfItalic       +RtfOffCmd;
const  RTFCommand   RtfFixedOFF       =RtfFixed        +RtfOffCmd;
const  RTFCommand   RtfSmallerOFF     =RtfSmaller      +RtfOffCmd;
const  RTFCommand   RtfBiggerOFF      =RtfBigger       +RtfOffCmd;
const  RTFCommand   RtfUnderLineOFF   =RtfUnderLine    +RtfOffCmd;
			  
const  RTFCommand   RtfCenterOFF      =RtfCenter       +RtfOffCmd;
const  RTFCommand   RtfFlushLeftOFF   =RtfFlushLeft    +RtfOffCmd;
const  RTFCommand   RtfFlushRightOFF  =RtfFlushRight   +RtfOffCmd;
const  RTFCommand   RtfFlushBothOFF   =RtfFlushBoth    +RtfOffCmd;
const  RTFCommand   RtfNoFillOFF      =RtfNoFill       +RtfOffCmd;
			  
const  RTFCommand   RtfIndentOFF      =RtfIndent       +RtfOffCmd;
const  RTFCommand   RtfIndentRightOFF =RtfIndentRight  +RtfOffCmd;
			  
const  RTFCommand   RtfExcerptOFF     =RtfExcerpt      +RtfOffCmd;
const  RTFCommand   RtfParamOFF       =RtfParam        +RtfOffCmd;
const  RTFCommand   RtfX_ColorOFF     =RtfX_Color      +RtfOffCmd;






const  RTFCommand   RTFUp           =200;
const  RTFCommand   RTFDown         =201;
const  RTFCommand   RTFLeft         =202;
const  RTFCommand   RTFRight        =203;

const  RTFCommand   RTFPageUp       =204;
const  RTFCommand   RTFPageDown     =205;

const  RTFCommand   RTFHome         =206;
const  RTFCommand   RTFEnd          =207;
const  RTFCommand   RTFEndOfText    =208;
const  RTFCommand   RTFStartOfText  =209;

const  RTFCommand   RTFPreviousWord =210;
const  RTFCommand   RTFNextWord     =211;

const  RTFCommand   RTFDelete       =212;
const  RTFCommand   RTFBackSpace    =213;
const  RTFCommand   RTFDeletePreviousWord   =214;
const  RTFCommand   RTFDeleteNextWord       =215;
const  RTFCommand   RTFNewLine              =216;
const  RTFCommand   RTFSpace                =217;

const  RTFCommand   RTFSearch               =218;
const  RTFCommand   RTFRepeatSearchForward  =219;
const  RTFCommand   RTFRepeatSearchBackward =220;
const  RTFCommand   RTFRepeatLastSearch     =221;

const  RTFCommand   RTFSelectKeyboard       =222;

const  RTFCommand   RTFRemoveBlock          =223;
const  RTFCommand   RTFDeleteToEOL          =224;

const  RTFCommand   RTFPasteBuffer          =225;
const  RTFCommand   RTFStartMarking         =226;
const  RTFCommand   RTFCutToBuffer          =227;
const  RTFCommand   RTFCopyToBuffer         =228;



declareList(UCharsArray       ,unsigned char);
declareList(IntArray          ,int          );
declareList(LongArray         ,long         );
declareList(RTFCommandsArray  ,RTFCommand   );
declarePtrList(StringArray    ,char         );








#endif
	


