/*
$Header: /export/CVS/UMT/include/umtHelpCl.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtHelpCl.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:44:50  sebast
# Revision 2.0
#
# Revision 1.3  1996/03/03  14:02:30  voloh
# -----
#
# Revision 1.2  1996/03/02  15:23:34  voloh
# Dock::Open(umtRefPoint) added
#
# Revision 1.1  1996/02/28  13:12:11  voloh
# Initial revision
#
*/


#ifndef _UMT_HELP_CL_H_
#define _UMT_HELP_CL_H_


#include <InterViews/dialog.h>
#include <InterViews/layout.h>
#include <InterViews/window.h>
#include <IV-look/button.h>
#include <IV-look/kit.h>

#include "UMT.h++"
#include "umtDock.h++"
#include "umtSlist.h++"
#include "umtPath.h++"
#include "umtRtfView.h++"
#include "umtHandler.h++"
#include "umtConfiguration.h++"
#include "umtWindowOwner.h++"
#include "umtRefPointList.h++"


class umtHelpDock;

class umtHelp : public umtWindowOwner
{
    friend class umtRefPointList;
    friend class umtHelpDock;
    
public:
    virtual ~umtHelp();
    
protected:
    umtHelp();
    
    void              Exit();
    virtual int       CloseWindow();
    
    int               go_to(umtRefPoint);
    umtRefPoint       where_is();
    
    Glyph*            body_build();

private:
    umtRefPoint       location;
    umtPath           directory;
    umtRTFView*       viewer;
    
    TopLevelWindow*   window;
};


class umtHelpDock : public umtDock
{
    friend class umtHelp;
    friend class umtRefPointList;
    
public:
    umtHelpDock();
    virtual ~umtHelpDock();
    
    virtual void      Open();
    virtual void      Open(umtRefPoint);
    virtual void      Close();
    virtual int       IsOpened();
    
protected:
    virtual void      open(Glyph*, umtRefPoint);
    int               go_to(umtRefPoint);
    
    void              index_page();
    void              previous_page();
    void              next_page();
    
    void              update_buttons();
    
    void              no_kill(Glyph*);
    Glyph*            temp_nokilled;

private:
    umtPath           directory;
    
    umtSlist          history;
    umtRefPoint*      in_history;
        
    umtHelp*          dialog;
    
    Button*           backward_b;
    Button*           forward_b;
};

declareActionCallback(umtHelpDock)
    
    
extern umtError*      UMTError;
extern umtHelpDock    UMTHelpDock;

#endif

