/*
   $Header: /export/CVS/UMT/include/umtInternetAddr.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

   $Log: umtInternetAddr.h++,v $
   Revision 1.1.1.1  1996/10/21 20:46:45  vlad
   Puting to CVS. Version 1.00B3

 * Revision 2.0  1996/03/18  16:44:55  sebast
 * Revision 2.0
 *
 * Revision 1.17  1996/02/15  14:39:25  sebast
 * it works correct with fido- and compuserve- addresses; some functions added
 *
 * Revision 1.16  1995/08/31  11:45:01  lord
 * make addr and real_name not pointers
 *
 * Revision 1.15  1995/07/31  18:01:09  sebast
 * UMT coding rules
 *
 * Revision 1.14  1995/06/22  12:16:27  sebast
 * classname() removed
 *
 * Revision 1.13  1995/06/13  14:06:17  sebast
 * getRTFAddrAndName() added
 *
 * Revision 1.12  1995/05/10  17:55:26  sebast
 * virtual int classname() added
 *
 * Revision 1.11  1995/04/26  11:38:46  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.10  1995/04/26  09:42:54  sebast
 * who knows?
 *
 * Revision 1.9  1995/03/17  19:59:57  sebast
 * changed to use umtString
 *
 * Revision 1.8  1995/02/19  21:49:36  sebast
 * *** empty log message ***
 *
 * Revision 1.7  95/02/19  18:54:03  18:54:03  sebast (Sebastian Kamyshenko)
 * ReadFrom... and WriteToFile() added
 * 
 * Revision 1.6  95/02/13  20:12:40  20:12:40  lord (Vadim Zaliva)
 * Added 2 params to constructor
 * 
 * Revision 1.5  95/02/10  21:44:39  21:44:39  lord (Vadim Zaliva)
 * set_real_name added
 * 
 * Revision 1.4  95/02/10  21:01:07  21:01:07  sebast (Sebastian Kamyshenko)
 * *** empty log message ***
 * 
 * Revision 1.3  95/02/10  19:58:55  19:58:55  sebast (Sebastian Kamyshenko)
 * *** empty log message ***
 * 
 * Revision 1.2  95/02/10  19:58:44  19:58:44  sebast (Sebastian Kamyshenko)
 * *** empty log message ***
 * 
 * Revision 1.1  95/02/10  19:47:07  19:47:07  lord (Vadim Zaliva)
 * Initial revision
 *    
*/

#ifndef INTERNET_ADDR_H_FLAG
#define INTERNET_ADDR_H_FLAG

#include "umtString.h++"

class umtInternetAddr : public umtMember
{
public: 
  
    umtInternetAddr(umtString *addr=NULL,umtString *name=NULL);
    umtInternetAddr(umtInternetAddr *);
    umtInternetAddr(const umtInternetAddr &);
    virtual ~umtInternetAddr();

    umtString GetAddr          ();
    umtString GetName          ();
    umtString GetAddrAndName   ();
    umtString GetRTFAddrAndName();

    void      SetRealName(umtString *);
    void      SetInternetAddr(umtString *);
    
    status    SetFidonetAddr(const umtString *, const umtString * = NULL);
    status    SetCompuserveAddr(const umtString *);

    status    CheckFidoAddr(const umtString *source);
    status    CheckCompuserveAddr(const umtString *source);

    umtInternetAddr& operator = (const umtInternetAddr&);
    
//  status WriteToFile( FILE *fp );
//  status ReadFromFile( FILE *fp );

private: 
  
    umtString addr;
    umtString real_name;

protected: 

};

#endif
