/*
 * $Header: /export/CVS/UMT/include/umtMailbox.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
 * $Log: umtMailbox.h++,v $
 * Revision 1.1.1.1  1996/10/21 20:46:45  vlad
 * Puting to CVS. Version 1.00B3
 *
# Revision 2.0  1996/03/18  16:45:01  sebast
# Revision 2.0
#
# Revision 1.1  1995/09/26  18:47:17  vlad
# Initial revision
#
# Revision 1.3  1995/09/26  17:35:34  vlad
# Work version.
#
# Revision 1.2  1995/09/23  17:41:14  vlad
# Some changed.
#
# Revision 1.1  1995/09/23  15:10:53  vlad
# Initial revision
#
 *
 */

#ifndef UMT_MAILBOX_H_PLUS_PLUS
#define UMT_MAILBOX_H_PLUS_PLUS

#include "umtMember.h++"
#include "umtSlist.h++"
#include "umtString.h++"


class umtMsgInfo: public umtMember
{
public: 
    umtMsgInfo( int n, int s, const umtString& id );
    umtMsgInfo( umtMsgInfo *msg );
    virtual       ~umtMsgInfo();

    int       Number;
    int       IsErase;
    long      Size;
    umtString MsgID;
};


class umtMailbox: public umtSlist
{
public:
    umtMailbox();
    virtual  ~umtMailbox();

    umtMsgInfo *GetFirst( void );
    umtMsgInfo *GetLast( void );
    umtMsgInfo *GetNext(umtMsgInfo *msg );
    umtMsgInfo *GetPrev(umtMsgInfo *msg );
    umtMsgInfo *Find( int n );
    umtMsgInfo *Find( const umtString& id );
    status      Erase( int n );
    status      UnErase( int n );
    status      Status( void ); 
    
    virtual long       GetMailboxSize( void );
    virtual FILE      *GetMessage( int n ) = 0;
    virtual umtString  GetHeader( int n ) = 0;
    virtual status     Refresh( void ) = 0;
    virtual status     Reread( void ) = 0;
protected:
    status      Rc;
};

#endif









