/* 
 * $Header: /export/CVS/UMT/include/umtMailcap.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
 * $Log: umtMailcap.h++,v $
 * Revision 1.1.1.1  1996/10/21 20:46:45  vlad
 * Puting to CVS. Version 1.00B3
 *
# Revision 2.0  1996/03/18  16:45:01  sebast
# Revision 2.0
#
# Revision 1.8  1995/09/20  16:49:15  vlad
# Changed path processing.
#
# Revision 1.7  1995/08/25  13:15:45  lord
# Free added
#
# Revision 1.6  1995/08/03  17:07:03  sebast
# umtCodingRules
#
# Revision 1.5  1995/07/31  16:11:10  lord
# *** empty log message ***
#
# Revision 1.4  1995/06/22  11:16:33  sebast
# call of member() in empty constructor added
#
# Revision 1.3  1995/06/22  11:15:13  sebast
# classname() removed
#
# Revision 1.2  1995/06/12  11:20:13  vlad
# Testing.
#
# Revision 1.1  1995/06/12  11:19:31  vlad
# Initial revision
#
 */
#ifndef MAILCAP_H_PLUS_PLUS_FLAG
#define MAILCAP_H_PLUS_PLUS_FLAG


#include "umt_error.h++"
#include "classnames.h++"

#include "umtString.h++"
#include "umtPath.h++"
#include "umtConfiguration.h++"
#include "umtMsgComponent.h++"

#define MAX_STR_SIZE           2048
#define MAILCAP_GROUP          "Mailcap"
#define MAILCAP_FILES          "MailcapFiles"
#define MAILCAP_TERMINAL       "Terminal"
#define MAILCAP_TERMINAL_FLAGS "TerminalFlags"
#define DEFAULT_XTERM          "xterm"
#define DEFAULT_XTERM_FLAGS    "-e"
#define DIR_SEPARATOR          '/'

class umtMailcap : public umtConfiguration
{

public:
    umtMailcap();
    umtMailcap( const umtPath& filename );
    virtual ~umtMailcap     ();
    status   InitialRead    ();
    status   ReadMailcap    ( const umtPath& filename );
    status   WriteMailcap   ( const umtPath& filename ); 
    
    umtString ViewMessage   ( umtMsgComponent& message );
    umtString EditMessage   ( umtMsgComponent& message );
    umtString PrintMessage  ( umtMsgComponent& message );
    umtString ComposeMessage( umtMsgComponent& message );
    
    umtString ViewMessage   ( umtString file, umtContentStruct *cnt );
    umtString EditMessage   ( umtString file, umtContentStruct *cnt );
    umtString PrintMessage  ( umtString file, umtContentStruct *cnt );
    umtString ComposeMessage( umtString file, umtContentStruct *cnt );

    void      Free();
protected:
    umtConfiguration *find_type_subtype( umtString type, umtString subtype );   
    void             parsing_string   ( char **string, umtString &str );
    umtString        find_subfield    ( umtConfiguration *type_sybtype,
					umtString field,
					umtString subfield );
    umtString        make_command     ( char *format,
					char *filename,
					umtContentStruct *cnt );    
    status           run_command      ( umtString command );
};


#endif

