/*
$Id: umtRtfCommands.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtRtfCommands.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:19  sebast
# Revision 2.0
#
# Revision 1.1  1996/03/03  12:38:03  voloh
# Initial revision
#
*/

#ifndef _RTFCommands_H_
#define _RTFCommands_H_

#include "umtSlist.h++"
#include "umtString.h++"
#include "umtRtfTextComponent.h++"


enum umtRTFCommand
{
    NoCommand=0,

    cmRtfOn,       cmRtfOff,

    cmNewLine,
    cmParam,       cmParamDn,
    cmComment,     cmCommentDn,

    cmBigger,      cmBiggerDn,
    cmSmaller,     cmSmallerDn,
    cmBiggest,     cmBiggestDn,
    cmTinier,      cmTinierDn,

    cmBold,        cmBoldDn,
    cmItalic,      cmItalicDn,
    cmFixed,       cmFixedDn,
    cmUnderline,   cmUnderlineDn,

    cmCenter,      cmCenterDn,
    cmFlushLeft,   cmFlushLeftDn,
    cmFlushRight,  cmFlushRightDn,
    cmFlushBoth,   cmFlushBothDn,    
    cmNofill,      cmNofillDn,

    cmXColor,      cmXColorDn,

    cmIndent,      cmIndentDn,
    cmIndentRight, cmIndentRightDn,

    cmExcerpt,     cmExcerptDn,
    
    cmHRef,        cmHRefDn,
    
    UnknownCommand
};

class umtRTFCom : public umtRTFTextComponent
{
public: 
    umtRTFCommand Mean;

    umtRTFCom(): umtRTFTextComponent(CLASS_RTFCom) { Mean=NoCommand; }
    umtRTFCom(umtRTFCom* r): umtRTFTextComponent(CLASS_RTFCom) { *this=*r; }
    umtRTFCom(umtRTFCommand c): umtRTFTextComponent(CLASS_RTFCom) { *this=c; }
    virtual ~umtRTFCom();

    virtual int GetType();

    umtRTFCom& operator =(umtRTFCommand);
    umtRTFCom& operator =(umtRTFCom&);
};

class umtRTFCommands : public umtSlist
{
public: 
    umtRTFCommands():umtSlist() {}
    ~umtRTFCommands();

    void          Push          (umtRTFCommand);
    status        Pop           (umtRTFCommand);
    umtRTFCommand Top           ();

    int           SizeCount     ();
    umtRTFCommand LastFlush     ();
    void          Clean         ();

    static umtString     Name        (umtRTFCommand);
    static umtRTFCommand WhatCommand (umtString);

protected: 
    int           infirstgroup  (umtRTFCommand);
    int           insecondgroup (umtRTFCommand);
};

#endif
