/*
$Id: umtRtfTextComponent.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtRtfTextComponent.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:22  sebast
# Revision 2.0
#
# Revision 1.1  1996/03/03  12:39:35  voloh
# Initial revision
#
*/

#ifndef _RTF_TextComponent_H_
#define _RTF_TextComponent_H_

#include <InterViews/character.h>
#include <InterViews/background.h>
#include <InterViews/label.h>
#include <InterViews/layout.h>
#include <InterViews/font.h>
#include <InterViews/color.h>
#include <InterViews/action.h>
#include <InterViews/input.h>

#include "umtMember.h++"
#include "umtRtfGlobals.h++"


class umtRefPointListEntry;

class umtRTFTextComponent : public umtMember
{
public:
    umtRTFTextComponent(int cl): umtMember(cl) { }
    virtual ~umtRTFTextComponent();

    virtual int GetType();
    // Means:
    //   -1:  Undefined;
    //   0 :  Char;
    //   1 :  Command;
    //   2 :  Line bracker;
    //   3 :  Hidden char;
    //   4 :  Free space;

};

class umtRTFChar : public umtRTFTextComponent
{
    Glyph*      TheGlyph;
    Glyph*      Hilight;
    
public: 
    int         TheChar;
    int         Type;
    Coord       TheWidth;
    
    umtRTFChar  ();
    umtRTFChar  (int);
    umtRTFChar  (int,Glyph*,Coord);
    umtRTFChar  (umtRTFChar*);
    virtual     ~umtRTFChar();
    
    void        SetVisible()  { Type = 0; }
    void        SetHidden()   { Type = 3; }
    
    Glyph*         GetTheGlyph() { return TheGlyph; }
    Glyph*         GetHilight()  { return Hilight;  }
    virtual Glyph* SetTheGlyph(Glyph*);
    virtual Glyph* SetHilight(Glyph*);
    
    virtual int    GetType();
    virtual int    IsRef();
    
    static char    CharacterType[];
};

class umtRTFLineBr : public umtRTFTextComponent
{
public:
    umtRTFLineBr(): umtRTFTextComponent(CLASS_RTFLineBr) { }
    virtual ~umtRTFLineBr();

    virtual int GetType();
};

class umtRTFSpace : public umtRTFTextComponent
{
public:
    Glyph*  TheGlyph;
    Glyph*  Hilight;
    Coord   TheWidth;

    umtRTFSpace(Glyph* gl, Coord w): umtRTFTextComponent(CLASS_RTFSpace) {
	if ( gl ) Resource::ref(TheGlyph=gl); Hilight=nil; TheWidth=w; }
    virtual ~umtRTFSpace();

    virtual int GetType();
};

class umtRefHandler : public InputHandler
{
    umtRefPointListEntry* the_ref_entry;
    
public:
    umtRefHandler( Glyph*, umtRefPointListEntry* );
    virtual ~umtRefHandler();
    
    virtual void press(const Event&);
    virtual void move(const Event&);
};

class umtRTFRef : public umtRTFChar
{
    umtRefPointListEntry*  the_ref_entry;
    
public:
    umtRTFRef(int);
    umtRTFRef(int,
	      umtRefPointListEntry*);
    umtRTFRef(int, Glyph*, Coord,
	      umtRefPointListEntry*);
    umtRTFRef(umtRTFChar*,
	      umtRefPointListEntry*);
    umtRTFRef(umtRTFRef*);
    virtual ~umtRTFRef();
    
    virtual Glyph* SetTheGlyph(Glyph*);
    virtual Glyph* SetHilight(Glyph*);
    
    void    SetRefEntry(umtRefPointListEntry*);
    
    virtual int GetType();
    virtual int IsRef();
};

    
#endif





