/*
$Id: umtRtfView.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtRtfView.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:23  sebast
# Revision 2.0
#
# Revision 1.2  1996/03/03  14:16:37  voloh
# umtXBuffer removed
#
# Revision 1.1  1996/03/03  12:41:09  voloh
# Initial revision
#
*/

#ifndef _RTFView_H_
#define _RTFView_H_

#include <IV-look/kit.h>
#include <InterViews/background.h>
#include <InterViews/character.h>
#include <InterViews/composition.h>
#include <InterViews/label.h>
#include <InterViews/layout.h>
#include <InterViews/texcomp.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/color.h>
#include <InterViews/font.h>
#include <InterViews/event.h>
#include <InterViews/display.h>
#include <InterViews/cursor.h>
#include <InterViews/input.h>
#include <IV-X11/xdisplay.h>
#include <IV-X11/xfont.h>
#include <OS/file.h>
#include <OS/math.h>
#include <OS/string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#include "umtConfiguration.h++"

#include "UMT.h++"
#include "umtRtfText.h++"


class umtHelp;

class umtRTFView : public InputHandler, public umtRTFText
{
    friend class umtHelp;
    
    int ready;
    
public:
    umtRTFView();
    virtual ~umtRTFView();

    status  Reinit(int);

    status  Reinit(InputFile*, int);

    status  Reinit(umtString&, int);
    
    virtual void   Add(InputFile*, int);
    virtual void   Add(umtString&, int);
    
    virtual void   ReBuildAll();
    virtual void   FastReBuild();
    
    virtual Glyph* Body() const;
    
    virtual umtString GetMarked() const;
    virtual void      ClearMark();
    
    // getting mouse events:
    virtual void double_click(const Event&);
    virtual void press(const Event&);
    virtual void drag(const Event&);
    virtual void release(const Event&);
    virtual void move(const Event&);
    
    virtual void allocate(Canvas*, const Allocation&, Extension&);
    
protected: 
    
    status init_base ();
    
    umtConfiguration*     config;
    Glyph*                full_body;
    InputHandler*         ih;
    
    enum MouseState  {
	NotPressed, LeftMousePressed, MiddleMousePressed, RightMousePressed
    }                     mouse_state;
    enum CursMarking {
	JustPressed, CursAtBegining, CursAtEnd, Released
    }                     marked_stat;
    
    umtRTFTextComponent*  by_coord(Coord, Coord, GlyphIndex&);
    void                  mark_hilight();
    void                  unmark_hilight();
    
#ifdef RTF_IN_DEBUG
    void                  dump_out();
#endif
    
};

declareActionCallback(umtRTFView)

#endif
