/*
$Header: /export/CVS/UMT/include/umtXFace.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtXFace.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:34  sebast
# Revision 2.0
#
# Revision 1.15  1995/09/20  10:08:07  lord
# Make arguments of Read/WritePBM const char * instead of char *
#
# Revision 1.14  1995/09/18  18:15:36  voloh
# CompBitMapInv added.
#
# Revision 1.13  1995/08/25  15:49:29  voloh
# () on some defines added.
#
# Revision 1.12  1995/07/31  18:14:52  sebast
# some changes for UMT coding rules
#
# Revision 1.11  1995/07/28  16:00:59  sebast
# some bugs while VZ' porting removed
#
# Revision 1.10  1995/07/27  16:53:19  lord
# Make all private const members defines
#
# Revision 1.9  1995/05/07  13:27:40  lord
# Opps, small syntax error :-)
#
# Revision 1.8  1995/05/07  13:26:54  lord
# ifdef around class to avoid re-defenitions.
#
# Revision 1.7  1995/05/06  15:01:09  voloh
# Some functions (xReadText,...) deleted.
#
# Revision 1.6  1995/05/05  12:05:52  sebast
# int XFace_empty; now private variable
#
# Revision 1.5  1995/05/03  12:41:58  vlad
# Syntax error in comment fixed
#
# Revision 1.4  1995/05/02  17:30:43  voloh
# Import to pbm added.
#
# Revision 1.3  1995/05/02  15:56:14  lord
# XFACE_W/H added
#
# Revision 1.2  1995/05/02  15:35:13  voloh
# Compact bitmap field added.
#
# Revision 1.1  1995/05/02  13:48:50  voloh
# Initial revision
#
*/

#ifndef XFACE_H_FLAG
#define XFACE_H_FLAG

#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <setjmp.h>

#include <umt_error.h++>

#include <umtMember.h++>
#include <umtString.h++>


#define XFACE_WIDTH       48
#define XFACE_HEIGHT      48

#define XF_PIXELS         (XFACE_WIDTH*XFACE_HEIGHT)
#define XF_WORDCARRY      (1<<8)
#define XF_WORDMASK       (XF_WORDCARRY-1)
#define XF_MAXWORDS       ((XF_PIXELS*2+7)/8)
#define XF_FIRSTPRINT     '!'
#define XF_LASTPRINT      '~'
#define XF_NUMPRINTS      (XF_LASTPRINT-XF_FIRSTPRINT+1)
#define XF_BLACK          0
#define XF_GREY           1
#define XF_WHITE          2
#define XF_ERR_OK         0 
#define XF_ERR_EXCESS     1
#define XF_ERR_INSUFF    -1
#define XF_ERR_INTERNAL  -2

class umtXFace : public umtMember
{
public: 
  
    umtXFace      ();
    umtXFace      (umtXFace *p);
    umtXFace      (char *);
    ~umtXFace     ();
  
    status     ReadPBM        ( const char * );
    status     WritePBM       ( const char * );
  
    void       SetXFace    ( char * );
    void       GetXFace    ( char * );
    char       *GetXFace   ( void );
    void       SetBitMap      ( char * );
    void       GetBitMap      ( char * );
    char       *GetBitMap     ( void );
  
    int        PixelSet       ( int , int );
    void       SetPixel       ( int , int );
    void       ClearPixel     ( int , int );
    void       PaintBar       ( int , int , int , int );
    void       ClearBar       ( int , int , int , int );
    void       ClearXFace  ( void );
  
    int        XFaceEmpty;
    
protected:

    typedef struct fs_guesses
    {	
	char g_00[1<<12];
	char g_01[1<<7];
	char g_02[1<<2];
	char g_10[1<<9];
	char g_20[1<<6];
	char g_30[1<<8];
	char g_40[1<<10];
	char g_11[1<<5];
	char g_21[1<<3];
	char g_31[1<<5];
	char g_41[1<<6];
	char g_12[1<<1];
	char g_22[1<<0];
	char g_32[1<<2];
	char g_42[1<<2];
    } fs_Guesses;

    typedef struct fs_prob
    {
	unsigned char p_range;
	unsigned char p_offset;
    } fs_Prob;

    typedef struct fs_bigint
    {
	int b_words;
	unsigned  char b_word[(48*48*2+7)/8];
    } fs_BigInt;
  
    fs_BigInt  B;  
    char       BitMap[XF_PIXELS];
    char       CompBitMap[XF_PIXELS/8];
    char       CompBitMapInv[XF_PIXELS/8];
    char       XFaceText[3000];
    int        xStatus;
    jmp_buf    XFace_comp_env;

    fs_Prob    *XFace_ProbBuf[XF_PIXELS*2];
    int        XFace_NumProbs;
  
    static     fs_Prob XFace_freqs[];
    static     fs_Prob XFace_levels[4][3];
    static     fs_Guesses XFace_G;
  
    int        compface       ();
    int        uncompface     ();
  
    int        xAllBlack   (char *, int, int);
    int        xAllWhite   (char *, int, int);
    int        xSame       (char *, int, int);
    int        xBigPop     (fs_Prob *);
    void       xBigAdd     (unsigned char);
    void       xBigDiv     (unsigned char, unsigned char *);
    void       xBigMul     (unsigned char);
    void       xBigPrint   ();
    void       xBigPush    (fs_Prob *);
    void       xBigRead    (char *);
    void       xBigSub     (unsigned int);
    void       xBigWrite   (char *);
    void       xCompAll    (char *);
    void       xCompress   (char *, int, int, int);
    void       xPopGreys   (char *, int, int);
    void       xPushGreys  (char *, int, int);
    void       xRevPush    (fs_Prob *);
    void       xUnCompAll  (char *);
    void       xUnCompress (char *, int, int, int);
    void       xGen        (char *);
    void       xGenFace    ();
    void       xUnGenFace  ();
    status     xReadFace   (char *);
    status     xWriteFace  (char *);

}; 
/*     End class definition   */


#endif





