/*
$Header: /export/CVS/UMT/libsrc/addrbook/umtAddrBook.cc,v 1.1 1996/10/22 19:47:20 lord Exp $

$Log: umtAddrBook.cc,v $
Revision 1.1  1996/10/22 19:47:20  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:46  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:39:14  sebast
// Revision 2.0
//
// Revision 1.11  1996/02/19  17:49:39  sebast
// correct loading for empty addrbook
//
// Revision 1.10  1995/10/28  13:26:15  vlad
// Some stuff redone.
//
// Revision 1.9  1995/07/31  18:01:29  lord
// umt coding rules
//
// Revision 1.8  1995/07/09  20:39:28  lord
// sys/stat.h included for Linux
//
// Revision 1.7  1995/07/04  15:34:23  sebast
// #include "umt_const.h++" added
//
// Revision 1.6  1995/07/04  15:28:39  sebast
// use of LOCK_EXTENTION instead of ADDR_BOOK_LOCK_EXTENTION
//
// Revision 1.5  1995/07/01  16:08:41  lord
// removing enties in destructor.
//
// Revision 1.4  1995/06/12  15:49:42  lord
// LOCK_FILE creation mode changed
//
// Revision 1.3  1995/06/12  15:30:19  lord
// Locking
//
// Revision 1.2  1995/05/09  14:44:55  lord
// 1st Working version
//
// Revision 1.1  1995/05/09  14:00:12  lord
// Initial revision
//
*/

#include "umtAddrBook.h++"
#include "misc.h++"
#include "umt_const.h++"
#include <unistd.h>
#include <sys/stat.h>

umtAddrBook::umtAddrBook(umtString n): umtSlist()
{
    name = n;
    n +=LOCK_EXTENTION;
    lock = new umtLock( n );
    if ( lock ) lock->Lock();
}

umtAddrBook::~umtAddrBook()
{
    if ( lock )
    {
	lock->UnLock();
	Delete( lock );
    }
    Kill(nil);
}

status umtAddrBook::Load()
{
    umtAddrBookEntry *i;
    FILE *f;
    status rc;

    if ( !lock || !lock->IsLocked()) return NOT_LOCKED;

    if ( access(name,F_OK) || !filesize(name))
	return OK;
    if((f=fopen(name,"r"))==nil)
	return ERROR_OPEN_FILE;
  
    rc=OK;
    while(!feof(f))
    {
	if((i=new umtAddrBookEntry())==nil)
	{
	    rc=NOT_ENOUGH_MEMORY;
	    break;
	}
	if((i->Load(f))!=OK)
	{
	    rc=ERROR_LOAD;
	    break;
	}
	Append(i);
    }
    fclose(f);
    return rc;
}

status umtAddrBook::Save()
{
    umtAddrBookEntry *i;
    FILE *f;
  
    if ( !lock || !lock->IsLocked()) return NOT_LOCKED;

    unlink(name);

    if((f=fopen(name,"w"))==nil)
	return ERROR_CREATE_FILE;
  
    for(i=(umtAddrBookEntry *)GetFirst();i;i=(umtAddrBookEntry *)umtSlist::GetNext(i))
	if(i->Save(f)!=OK) 
	{
	    fclose(f);
	    return ERROR_SAVE;
	}
  
    fclose(f);
    return OK;
}

umtAddrBookEntry *umtAddrBook::GetByAlias(umtString alias)
{
    umtAddrBookEntry *i;
  
    for(i=(umtAddrBookEntry *)GetFirst();i;i=(umtAddrBookEntry *)umtSlist::GetNext(i))
	if(i->Alias==alias) return i;
  
    return nil;
}









