/* $Header: /export/CVS/UMT/libsrc/coding/umtBTOACode.cc,v 1.1 1996/10/22 19:47:22 lord Exp $

   $Log: umtBTOACode.cc,v $
   Revision 1.1  1996/10/22 19:47:22  lord
   Due to stupidity of SUN CC, all .c++ files renamed to .cc.
   Some platform directories created in lib.
   Makefile.include for SUN created.

   Revision 1.1.1.1  1996/10/21 20:46:46  vlad
   Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:40:58  sebast
// Revision 2.0
//
// Revision 1.9  1996/02/19  19:28:07  vlad
// file name to UUENCODE is added.
//
// Revision 1.8  1995/08/22  16:45:16  lord
// some type casting to avoid warnings.
//
// Revision 1.7  1995/08/01  13:12:48  lord
// umt coding rules
//
// Revision 1.6  1995/07/28  15:46:24  sebast
// work with umtString changed: don't use "umtString a == NULL" !!!
//
// Revision 1.5  1995/07/28  15:38:29  sebast
// some static variables defined
//
// Revision 1.4  1995/05/23  13:25:56  bird
// Kill default constructor
// Update Decode()
//
// Revision 1.3  1995/04/28  14:30:15  sebast
// it works now!?
//
// Revision 1.2  1995/04/27  13:46:39  sebast
// uses *.h++ instead *.h
//
// Revision 1.1  1995/04/27  12:12:50  mohamed
// Initial revision
//
*/

#include <string.h>
#include "umtBTOACode.h++"

const  int umtBTOACode::NOTOPEN_FILE=1;
const  int umtBTOACode::READ_ERROR=2;
const  int umtBTOACode::FORMAT_ERROR=3;
const  int umtBTOACode::LLINE_ERROR=4;
const  int umtBTOACode::CHECK_ERROR=5;

inline int umtBTOACode::CODE_CH(char ch)
{
    return  (int)((ch)+'!');
}

inline char umtBTOACode::CH_CODE(char cd)
{
    return  ((cd)-'!');
}

umtBTOACode::umtBTOACode(umtString s, int *r):umtBaseCodeClass(s,r)
{
Ceor=Csum=Crot=ccount=bcount=0;
}

umtBTOACode::~umtBTOACode(void)
{
}


void umtBTOACode::ba_charout ( int ch )
{
  const MAXPERLINE=78;
  putc(ch,fout);
  if ( ++ccount >= MAXPERLINE )
    {
      ccount = 0;
      putc('\n',fout);
    }
}

void umtBTOACode::ba_wordout ( long int word )
{
  if ( word == 0 )
    {
      ba_charout('z');
    }
  else
    {
      register int tmp = 0;
      
      if ( word < 0 )
	{
	  tmp = 32;
	  word = word - (85L * 85 * 85 * 85 * 32);
	}
      if ( word < 0 )
	{
	  tmp = 64;
	  word = word - (85L * 85 * 85 * 85 * 32);
	}
      ba_charout( CODE_CH((char)((word / (85L * 85 * 85 * 85)) + tmp)) );
      word %= (85L * 85 * 85 * 85);
      ba_charout( CODE_CH((char)(word / (85L * 85 * 85))) );
      word %= (85L * 85 * 85);
      ba_charout( CODE_CH((char)(word / (85 * 85))) );
      word %= (85 * 85);
      ba_charout( CODE_CH((char)(word / 85)) );
      word %= 85;
      ba_charout( CODE_CH((char)word) );
    }
}

void umtBTOACode::en2 ( int ch )
{
  Ceor ^= ch;
  Csum += ch;
  Csum++;
  if ((Crot & 0x80000000L))
    {
      Crot <<= 1;
      Crot += 1;
    }
  else
    Crot <<= 1;
  Crot += ch;
  word <<= 8;
  word |= ch;
  if (bcount == 3)
    {
      ba_wordout(word);
      bcount = 0;
    }
  else
    bcount++;
}

void umtBTOACode::ab_byteout ( int bt )
{
  Ceor ^= bt;
  Csum += bt;
  Csum += 1;
  if ( Crot & 0x80000000L )
    {
      Crot <<= 1;
      Crot += 1;
    }
  else
    Crot <<= 1;
  Crot += bt;
  putc(bt,fout);
}

int umtBTOACode::d2 ( int ch )
{
  if (ch == 'z')
    {
      if (bcount != 0)
	return FORMAT_ERROR;
      else {
	ab_byteout(0);
	ab_byteout(0);
	ab_byteout(0);
	ab_byteout(0);
      }
  }
  else
    if ((ch >= '!') && (ch < ('!' + 85)))
      {
	if (bcount == 0)
	  {
	    word = CH_CODE(ch);
	    ++bcount;
	  }
	else
	  if (bcount < 4)
	    {
	      word*=85;
	      word += CH_CODE(ch);
	      ++bcount;
	    }
	  else
	    {
	      word*=85;word+=CH_CODE(ch);
	      ab_byteout((int)((word >> 24) & 255));
	      ab_byteout((int)((word >> 16) & 255));
	      ab_byteout((int)((word >> 8) & 255));
	      ab_byteout((int)(word & 255));
	      word = 0;
	      bcount = 0;
	    }
      }
    else
      return FORMAT_ERROR;
  return 0;
}


status umtBTOACode::Decode( FILE *f1, FILE *f2 )
{
  static char buf[100];
  register char c;
  long int n1, n2, oeor, osum, orot;
  umtString s;

  RFile->SetFile(f1);   
  fout = f2;
  for (;;)
    { 
      if(!RFile->More()) return ERROR_USAGE;
      //    if ( fgets(buf,sizeof buf,f1) == NULL )
      s=RFile->GetString();
      if(s.IsEmpty()) return ERROR_USAGE;
      strcpy(buf,s);
      if (!strcmp(buf, "xumtBTOACode Begin\n") )
	break;
    }
  while ( (c = RFile->GetChar()) != EOF )
    if (c == '\n')
      continue;
    else
      if (c == 'x')
	break;
      else 
	if ( c = d2(c) )
	  return ERROR_USAGE;
  s=RFile->GetString();
  if(s.IsEmpty()) return ERROR_USAGE;
  strcpy(buf,s);
  if ( sscanf(buf,"umtBTOACode End N %ld %lx E %lx S %lx R %lx\n",
	      &n1, &n2, &oeor, &osum, &orot) != 5 )
    return ERROR_USAGE;
  if ((n1 != n2) || (oeor != Ceor) || (osum != Csum) || (orot != Crot))
    return ERROR_USAGE;
  bcount = Crot = Csum = Ceor = 0;

  if (RFile->GetFound()==2) 
    return LAST_BOUNDARY;
  return OK;
}

status umtBTOACode::Encode ( FILE *f1, FILE *f2, umtString filename )
{
  register long int n = 0;
  register int c;
  fout = f2;
  fprintf(f2,"xumtBTOACode Begin\n");
  while ((c = getc(f1)) != EOF)
    {
      en2(c);
      n++;
    }
  while ( bcount != 0 )
    en2( 0 );
  fprintf (f2,"\nxumtBTOACode End N %ld %lx E %lx S %lx R %lx\n",n,n,Ceor,Csum,Crot); 
  bcount = Crot = Csum = Ceor = 0;

  return OK;
}




