/*
 $Header: /export/CVS/UMT/libsrc/coding/umtBase64Code.cc,v 1.1 1996/10/22 19:47:22 lord Exp $
 $Log: umtBase64Code.cc,v $
 Revision 1.1  1996/10/22 19:47:22  lord
 Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 Some platform directories created in lib.
 Makefile.include for SUN created.

 Revision 1.1.1.1  1996/10/21 20:46:46  vlad
 Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:40:59  sebast
// Revision 2.0
//
// Revision 1.15  1996/02/19  19:26:43  vlad
// file name to UUENCODE is added.
//
// Revision 1.14  1995/08/24  13:30:35  lord
// String->Str
//
// Revision 1.13  1995/08/22  14:56:44  lord
// add const to avoid warning
//
// Revision 1.12  1995/08/01  13:10:31  lord
// umt coding rules
//
// Revision 1.11  1995/07/28  15:44:36  sebast
// small bug removed
//
// Revision 1.10  1995/07/28  15:42:54  sebast
// #include <string.h> added; small bug in working with umtString removed
//
// Revision 1.9  1995/06/10  15:17:10  voloh
// Field int Base64::numl added.
//
// Revision 1.8  1995/05/23  13:09:30  bird
// Kill default consstructor
// update Decode()
//
// Revision 1.7  1995/05/18  17:30:37  voloh
// Small bug in Decode() deleted.
//
*/

#include <string.h>
#include "umtBase64Code.h++"

#define   defDecodeBufferSize 1500

umtBase64Code::umtBase64Code(umtString s, int *r):umtBaseCodeClass(s,r)
{
}

umtBase64Code::~umtBase64Code()
{
}

char umtBase64Code::index_64[128] = {
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,62, -1,-1,-1,63,
  52,53,54,55, 56,57,58,59, 60,61,-1,-1, -1,-1,-1,-1,
  -1, 0, 1, 2,  3, 4, 5, 6,  7, 8, 9,10, 11,12,13,14,
  15,16,17,18, 19,20,21,22, 23,24,25,-1, -1,-1,-1,-1,
  -1,26,27,28, 29,30,31,32, 33,34,35,36, 37,38,39,40,
  41,42,43,44, 45,46,47,48, 49,50,51,-1, -1,-1,-1,-1
};

inline int umtBase64Code::char64(int c)
{
return   (((c) < 0 || (c) > 127) ? -1 : index_64[(c)]);
}



status umtBase64Code::Decode(FILE *f,FILE *f1 )
{
  int       retflg=0;
  unsigned  char d[4];
  unsigned  char v[3];
  umtString Buffer = "";
  unsigned char BufferCut[defDecodeBufferSize];
  unsigned char BufferOutPut[defDecodeBufferSize];
  
  RFile->SetFile(f);  
  while(RFile->More()) { /* suppose file is full and not cut */
    Buffer = RFile->GetString();
    if ( Buffer.IsEmpty() )
      break;
    unsigned const char *pt  = (unsigned const char *)Buffer.Str();
    if ( pt[0]=='-' )
      break;
    unsigned char *ptx = BufferCut;
    while ( *pt )
      if ( *pt=='=' )
	{ *ptx++=64; pt++; }
      else
	*ptx++ = char64(*pt++);
    *ptx++ = 0xff;
    *ptx++ = 0xff;
    *ptx++ = 0xff;
    *ptx   = 0xff;
    pt = BufferCut;
    ptx = BufferOutPut;
    while ( *pt != 0xff ) {
      if(
	 ( d[0] = *pt++ ) == 0xff ||
	 ( d[1] = *pt++ ) == 0xff ||
	 ( d[2] = *pt++ ) == 0xff ||
	 ( d[3] = *pt++ ) == 0xff 
	 ) continue;
      v[0]=(d[0]<<2)|((d[1]&0x30)>>4);
      v[1]=((d[1]&0xf)<<4)|((d[2]&0x3c)>>2);
      v[2]=((d[2]&0x03)<<6)|(d[3]);
      *ptx++ = v[0];
      if(d[2]!=64) *ptx++ = v[1];
      else { retflg=1; break; }
      if(d[3]!=64) *ptx++ = v[2];
      else { retflg=1; break; }
    }
    fwrite (BufferOutPut,1,ptx-BufferOutPut,f1);
    if ( retflg ) break;
  }
  if (RFile->GetFound()==2) 
    return LAST_BOUNDARY;
  return OK;  
}

char * umtBase64Code::get_code (char * bin_string , char * Buff , int len )

{
  const char Alphabet[] =
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  
  char *crBuf=Buff;
  
  register int c1, c2, c3;
  register char *st = bin_string;
           char *end_s = st+len;
  
  if ( (!Buff)||(!bin_string)||(!len) )
    return NULL;
  while ( st<end_s )
    {
      c1 = (*st++)&0xff;
      c2 = (*st++)&0xff;
      c3 = (*st++)&0xff;

      *crBuf++ = Alphabet[c1>>2];
      
      c1 = ( (c1&3)<<4 )|( c2 >> 4 );
      *crBuf++ = Alphabet[c1];
      
      c1 = ( (c2<<2) & 0x3C )|( c3 >> 6 );
      if ( st>end_s+1 ) *crBuf++ = '=';
      else *crBuf++ = Alphabet[c1];
      
      c1 = c3 & 0x3f;
      if ( st>end_s ) *crBuf++ = '=';
      else *crBuf++ = Alphabet[c1];

      if ( ++numl > 17 )
	{
	  *crBuf++ = '\n';
	  numl=0;
	}
    }
  *crBuf = 0;
  return Buff;
}

status umtBase64Code::Encode ( FILE *fin, FILE *fout, umtString filename )
{
  const BUFFER_SIZE = 3000; /* must be number,that % 3 == 0 !!! */
  char StrBuffer[BUFFER_SIZE];
  char CodeBuffer[(BUFFER_SIZE+4)*4/3];
  int  len;
  numl = 0;

  while ( !feof(fin) )
    {
      len = fread(StrBuffer,1,BUFFER_SIZE,fin);
      get_code(StrBuffer,CodeBuffer,len);
      fwrite(CodeBuffer,1,strlen(CodeBuffer),fout);
    }
  return OK;
}


































