/* $Header: /export/CVS/UMT/libsrc/coding/umtRFile.cc,v 1.1 1996/10/22 19:47:23 lord Exp $

   $Log: umtRFile.cc,v $
   Revision 1.1  1996/10/22 19:47:23  lord
   Due to stupidity of SUN CC, all .c++ files renamed to .cc.
   Some platform directories created in lib.
   Makefile.include for SUN created.

   Revision 1.1.1.1  1996/10/21 20:46:46  vlad
   Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:41:04  sebast
// Revision 2.0
//
// Revision 1.10  1995/10/27  15:28:39  sebast
// using UMTError
//
// Revision 1.9  1995/09/23  14:37:39  sebast
// return error when no last boundary in msg done
//
// Revision 1.8  1995/09/23  12:23:25  vlad
// Debug fprintf uncomment.
//
// Revision 1.7  1995/09/22  17:19:59  vlad
// Debug fprintf comment.
//
// Revision 1.6  1995/08/01  13:08:10  lord
// umt coding rules
//
// Revision 1.5  1995/07/28  15:40:10  sebast
// const BUFLEN now static
//
// Revision 1.4  1995/06/22  12:28:55  sebast
// call of member() changed
//
// Revision 1.3  1995/04/28  14:06:55  sebast
// It works now!?
//
// Revision 1.2  1995/04/27  13:45:39  sebast
// uses *.h++ instead *.h
//
// Revision 1.1  1995/04/27  12:11:09  mohamed
// Initial revision
//
*/

#include <string.h>

#include "umtRFile.h++"
#include "umtError.h++"


const  int umtRFile::BUFLEN = 1000;

umtRFile::umtRFile(umtString str, int *ret):umtMember(CLASS_RFILE)
{
  ret_val = ret;

  if((char *)str!=NULL) 
    {
      Boundary = "--";
      Boundary += str;
      Boundary += "\n"; //because fgets() doesn't cut last '\n'

      LastBoundary = "--";
      LastBoundary += str;
      LastBoundary += "--";
      LastBoundary += "\n";

      boundpresent=1;
    }
  else boundpresent=0;
  bpos=blen=0,*ret_val=bfound=0;
  buf=new char[BUFLEN];
}

umtRFile::~umtRFile()
{
  if(boundpresent) while(!bfound) GetString();
  delete[] buf;
}

void umtRFile::SetFile(FILE *f)
{ 
  fin=f;*ret_val=bpos=blen=bfound=0;
}

int umtRFile::readbuf(void)
{
  if(bfound) return -1;
  if(fgets(buf,BUFLEN,fin)==NULL) {
      if (boundpresent) {
	  *ret_val=bfound=2;
	  UMTError->Msg(umtError::Warning,"Error in message!!! EOF found!!");
      }
      return -1;
  }
  bpos=0;
  if(boundpresent) {
    if (Boundary == buf) {
      *ret_val=bfound=1;
      DEBUGM("Boundary found!");
      return -1;
    }
    if (LastBoundary == buf) {
      *ret_val=bfound=2;
      DEBUGM("LastBoundary found!");
      return -1;
    }
  }
  return (blen=strlen(buf));
}

int umtRFile::GetChar(void)
{
  if(bpos<blen) return buf[bpos++];
  if(readbuf()==-1) return EOF;
  return GetChar();
}

umtString  umtRFile::GetString(void)
{ 
  umtString s;
  if(bpos<blen)
    s=(buf+bpos);
  else if(readbuf()==-1) s=NULL;
  else s=buf;
  bpos=blen;
  return s;
}

int umtRFile::More(void)
{
  if(bfound) return 0;
  if(feof(fin) && bpos>=blen) return 0;
  return 1;
}











