/*
  $Header: /export/CVS/UMT/libsrc/folder/umtBackgroundDeliverAgent.cc,v 1.1 1996/10/22 19:47:26 lord Exp $

  $Log: umtBackgroundDeliverAgent.cc,v $
  Revision 1.1  1996/10/22 19:47:26  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:47  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:41:18  sebast
// Revision 2.0
//
// Revision 1.9  1996/03/18  15:18:58  vlad
// *** empty log message ***
//
// Revision 1.8  1995/10/27  11:35:26  sebast
// using UMTError added
//
// Revision 1.7  1995/09/06  14:41:04  lord
// Some fixups for new umtPath interface
//
// Revision 1.6  1995/09/03  17:49:58  voloh
// Can't call umtPath::operator =(char *)
//
// Revision 1.5  1995/09/02  15:48:40  lord
// Serious bug in Deliver fixed.
// msg_path lock_path are automatic now.
//
// Revision 1.4  1995/09/02  10:33:11  lord
// deliver->Deliver
//
// Revision 1.3  1995/08/24  13:22:04  voloh
// umtString::String() -> umtString::Str().
//
// Revision 1.2  1995/08/03  16:59:00  sebast
// umtCodingRules
//
// Revision 1.1  1995/07/18  15:02:23  lord
// Initial revision
//
  */


#include "umtBackgroundDeliverAgent.h++"
#include "umtConfiguration.h++"
#include "umtLock.h++"
#include "UMT.h++"

extern umtConfiguration UMTConfig;

umtBackgroundDeliverAgent::umtBackgroundDeliverAgent():umtDeliverAgent()
{
    umtString tmp;

    tmp=UMTConfig.GetStrField("QueueDir");
    dir=new umtDir(tmp);
}

umtBackgroundDeliverAgent::~umtBackgroundDeliverAgent()
{
    if(dir) Delete(dir);
}

status umtBackgroundDeliverAgent::Deliver(umtMsg *m)
{
    char     *tmp;
    umtDir   msg_path;
    umtPath  lock_path;
    umtLock  *msg_lock;
    umtMsg   *newmsg;
    
    while(1)
    {
	tmp=tempnam(dir->Str(),"Msg_");
	if(!tmp)
	    return ERROR_OBTAINING_TMP_FILE;
	
	msg_path=umtDir(tmp);
	free(tmp);
	
	lock_path  = msg_path;
	lock_path += ".LCK";
	
	msg_lock=new umtLock(lock_path);
	if(msg_lock->Lock()==OK)
	    break;
	else
	    Delete(msg_lock);
    }
    
    // Message path is locked. Now we can use it.
    newmsg=new umtMsg(&msg_path,m);
    if(!newmsg)
    {
	msg_path.Unlink();
	msg_lock->UnLock();
	Delete(msg_lock);
	return NOT_ENOUGH_MEMORY;
    }

    if((newmsg->Save())!=OK)
    {
	msg_path.Unlink();
	Delete(newmsg);
	msg_lock->UnLock();
	Delete(msg_lock);
	return ERROR_IN_CALLED_FUNCTION;
    }

    // Now message is saved in Queue directory.
    // We should unlock it to be processed by UMTServer.

    Delete(newmsg);
    if(msg_lock->UnLock()!=OK) {
	char ds[200];
	sprintf(ds,"UMT Warning: Can't unlock message in queue");
	UMTError->Msg(umtError::Error,ds);
    }
    Delete( msg_lock );
    return OK;
}











