/*
$Header: /export/CVS/UMT/libsrc/folder/umtHistory.cc,v 1.1 1996/10/22 19:47:27 lord Exp $

$Id: umtHistory.cc,v 1.1 1996/10/22 19:47:27 lord Exp $
*/

#include <string.h>

#include "misc.h++"

#include "umtHistory.h++"

umtHistoryEntry::umtHistoryEntry( const char* id, int a )
{
    MsgId =  id;
    access = a;
}

umtHistoryEntry::~umtHistoryEntry()
{
}

umtHistory::umtHistory(char *file,int n) : umtSlist()
{
    limit=n;
    if(file) fname=ustrdup(file);
}

umtHistory::~umtHistory()
{
    if(fname) Delete(fname);
    Kill(nil);
}

status umtHistory::Load()
{
    FILE      *f;
    char      tmp[MAXSTRING];

    if((f=fopen(fname,"r"))==nil)
	return ERROR_OPEN_FILE;
  
    while (fgets(tmp,sizeof(tmp),f))
	Append(tmp, 0);
  
    fclose(f);
    return OK;
}

status umtHistory::Save()
{
    FILE            *f;
    umtHistoryEntry *i;
    int              j;

    if ((f=fopen(fname,"w"))==nil)
	return ERROR_OPEN_FILE;
  
    j=limit;
    i=(umtHistoryEntry *)GetLast();
    while (j && i) 
    {
	fprintf(f,"%s\n",i->MsgId.Str());
	i=(umtHistoryEntry *)GetPrev(i);
	j--;
    }
    fclose(f);
    if ( j < (limit/100)) return HISTORY_LIMIT;
    return OK;
}

// TODO: implement something more clever than linear search.
int  umtHistory::Present(char *w)
{
    umtHistoryEntry *i;
  
    for(i=(umtHistoryEntry *)GetFirst();i;i=(umtHistoryEntry *)GetNext(i)) 
    {
	if(strcmp(i->MsgId.Str(),w)==SAME)
	{
	    i->access = 1; // found!
	    return 1;
	}
    }
    return 0; // not found
}

void umtHistory::Append (char *w, int access )
{
    umtHistoryEntry *s;
  
    s = new umtHistoryEntry(w, access);
    if(s) {
	s->MsgId.StripCRLF();
	umtSlist::Append(s);
    }
}


void umtHistory::Refresh()
{
    umtHistoryEntry *cur,*next;
    
    for ( cur = (umtHistoryEntry *)GetFirst();cur;cur=next )
    {
	next = (umtHistoryEntry *)GetNext( cur ); 
	if ( !(cur->access)) Kill( cur );
    }
}











