/*  $Header: /export/CVS/UMT/libsrc/folder/umtInternetHeader.cc,v 1.1 1996/10/22 19:47:28 lord Exp $

    $Log: umtInternetHeader.cc,v $
    Revision 1.1  1996/10/22 19:47:28  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:46  vlad
    Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:41:26  sebast
Revision 2.0

Revision 1.18  1996/03/11  16:28:24  vlad
status umtInternetHeader::FieldsSplit() patched.

Revision 1.17  1996/01/25  18:47:41  vlad
Quotaed field in message header (for example:
>From vasya by petya at 12:56:79')
is skipped now.

    Revision 1.16  1995/10/08 09:40:05  lord
    Remove useless type casts in umtInternetHeader::SetField

Revision 1.15  1995/09/29  17:19:52  lord
GetField(umtString) added

Revision 1.14  1995/09/21  16:53:38  lord
Add check in FieldsSplit because component can have no header at all

Revision 1.13  1995/09/04  17:49:38  vlad
Removed isspace() in FieldsSplit() for alternative ASCII.

Revision 1.12  1995/08/25  14:36:34  lord
printf commented

Revision 1.11  1995/08/25  14:34:26  lord
2 (!) Bugs in FieldsSplit fixed. How it works before?

Revision 1.10  1995/08/24  13:27:18  voloh
umtString::String() -> umtString::Str().

Revision 1.9  1995/07/31  18:06:17  sebast
UMT coding rules

Revision 1.8  1995/07/28  14:46:27  sebast
Port for SGI done: using smth. like a(&a(addr)) removed

Revision 1.7  1995/05/25  17:00:36  sebast
skipping spaces of the begin of field' body

Revision 1.6  1995/05/18  13:14:23  sebast
reading empty line after header added (function FieldsSplit())

Revision 1.5  1995/04/26  11:38:14  sebast
uses *.h++ instead *.h

Revision 1.4  1995/03/18  14:10:00  sebast
changed to use umtString

Revision 1.3  1995/03/09  17:05:32  sebast
Read/Write written/tested

Revision 1.2  1995/02/19  21:45:47  sebast
inherited from DICTIONARY! WritoToFile added and written

Revision 1.1  95/02/17  18:08:23  18:08:23  sebast (Sebastian Kamyshenko)
Initial revision

*/
#include <ctype.h>

#include "misc.h++"

#include "umtInternetHeader.h++"

umtInternetHeader::umtInternetHeader() : umtDictionary() {}

umtInternetHeader::umtInternetHeader(umtInternetHeader *h) : umtDictionary(h) {}

umtInternetHeader::~umtInternetHeader() 
{
  Kill(NULL);
}

umtString *umtInternetHeader::GetRFC822Header()
{
  return NULL;
}

umtString   *umtInternetHeader::GetField(umtString field_name)
{
  return Get(&field_name);
}

umtString   *umtInternetHeader::GetField(umtString *field_name)
{
  return Get(field_name);
}

status umtInternetHeader::SetField(umtString *full_field)
{
  char n[MAXSTRING],v[MAXSTRING];
  umtString us1, us2;
  sscanf(full_field->Str(),"%s %s",n,v);
  us1 = n;
  us2 = v;
  return SetField(&us1,&us2);
}

status umtInternetHeader::SetField(umtString *field_name, umtString *field)
{
  if (GetField(field_name))
    if (Del(field_name))
      return ERROR_IN_CALLED_FUNCTION;
  return Add(field_name, field);
}

status umtInternetHeader::ReadFromFile( FILE *fp )
{
/*
  char s1[MAXSTRING], s2[MAXSTRING];
  while (!feof(fp))
    {
      fscanf(fp,"%s %[^\n]\n",s1,s2);
      if (SetField(&umtString(s1),&umtString(s2))) 
	return ERROR_IN_CALLED_FUNCTION;
    }
*/
  
  if (FieldsSplit(fp))
    return ERROR_IN_CALLED_FUNCTION;

  return OK;
}

status umtInternetHeader::WriteToFile( FILE *fp )
{
  for (umtDictionaryEntry *d = GetFirst();d;d=GetNext(d) )
    fprintf(fp,"%s%s\n",d->Handler->Str(),d->Value->Str());
  return OK;
}

status umtInternetHeader::FieldsSplit( FILE *fp )
{
    umtString field, body;
    int       byte;

    byte=fgetc(fp);

    if( byte=='\n' ) // Component can have no header at all!
	return OK;
    else
	ungetc(byte, fp);
    
    while (!feof (fp))
    {
	field="";
	body="";
	byte = fgetc(fp);
	if ( byte == '>' ) // Quoted field - '>From vasya by petya 12:56:96...'
	{
	    while (( byte = fgetc( fp )) != '\n' && byte != EOF  );
	    ungetc( byte = fgetc( fp ), fp); // I don't wont rewrite block bellow. 
	}
	else
	{
	    do
	    {
		field+=byte;
		if ( byte == ':' ) break;
		byte = fgetc( fp );
	    }
	    while ( byte != EOF );
	    while ((byte=fgetc(fp))==' '||byte=='\t');
                     // isspace() eats russian chars
	    ungetc(byte,fp);
	    while ( !feof( fp ))
	    {
		byte = fgetc( fp );
		if ( byte == '\n' )
		{
		    byte = fgetc( fp );
		    if ( byte == EOF ) break;
		    if ( byte == ' ' || byte == '\t' )
		    {
//			body+='\n';
//			body+=byte;
			body+=' ';
		    }
		    else 
		    {
			ungetc( byte, fp );
			break;
		    }
		}
		else body+=byte;
	    }
	    if(!(field.IsEmpty() && body.IsEmpty()))
	    {
		if (Add(&field,&body)!=OK)
		    return ERROR_IN_CALLED_FUNCTION;
	    }
	}
	if (byte == '\n') break;
//	fprintf( stderr,"FIELD:'%s' BODY:'%s'\n", field.Str(), body.Str());

    }
    fgetc(fp); // reads empty line after header

    return OK;
  
}



