/*
 * $Header: /export/CVS/UMT/libsrc/folder/umtLocalMailbox.cc,v 1.1 1996/10/22 19:47:28 lord Exp $
 * $Log: umtLocalMailbox.cc,v $
 * Revision 1.1  1996/10/22 19:47:28  lord
 * Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 * Some platform directories created in lib.
 * Makefile.include for SUN created.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:47  vlad
 * Puting to CVS. Version 1.00B3
 *
// Revision 2.1  1996/04/08  14:46:47  vlad
// Bug with crashing in case of absent milbox file is fixed.
//
// Revision 2.0  1996/03/18  16:41:27  sebast
// Revision 2.0
//
// Revision 1.10  1996/03/16  17:23:31  vlad
// *** empty log message ***
//
 * Revision 1.9  1996/03/16 12:52:54  vlad
 *  problem, when mailbox is absent fixed
 *
 * Revision 1.8  1995/11/09 12:38:17  vlad
 * Bug with long fields fixed.
 *
// Revision 1.7  1995/10/24  16:01:42  vlad
// Bug with 'From ..' fixed. Already. Tested a bit.
//
// Revision 1.6  1995/10/23  18:34:23  sebast
// who knows - some f*ck
//
// Revision 1.5  1995/10/23  18:10:27  vlad
// Sintax error fixed.
//
// Revision 1.4  1995/10/23  17:20:39  vlad
// Bug with '\n' befor 'From' fixed. Not tested.
//
// Revision 1.3  1995/10/12  10:41:12  sebast
// small bug rewind_to_msg fixed
//
// Revision 1.2  1995/10/07  18:08:03  sebast
// some debug info removed
//
// Revision 1.1  1995/09/26  18:47:26  vlad
// Initial revision
//
// Revision 1.2  1995/09/26  17:34:44  vlad
// Work version.
//
// Revision 1.1  1995/09/23  17:42:09  vlad
// Initial revision
//
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "misc.h++"
#include "umtPath.h++"
#include "umtLocalMailbox.h++"


// If size == -1   Mailbox file is absent. It's ok.

umtLocalMailbox::umtLocalMailbox( umtPath& mbox_name )
{
    cur_msg = 0;
    size    = -1;
    mailbox = NULL;
    mailbox_name = mbox_name;

    if ( mbox_name.IsExists() == OK )
    {
	if ( mbox_name.IsDir() != OK )
	{
	    mailbox = fopen( mbox_name.Str(), "r" );
	    if ( mailbox )
	    {
		if ( umt_flock( fileno( mailbox ), LOCK_SH | LOCK_NB ) != -1 )
		{
		    fseek( mailbox, 0, SEEK_END );
		    size = ftell( mailbox );
		    Rc = Reread();
		}
		else 
		{
		    Rc = ALREADY_LOCKED;
		    fclose( mailbox );
		    mailbox = NULL;
		}
	    }
	    else Rc = ERROR_OPEN_FILE; /* May be Access denied */
	}
	else Rc = UNDEFINED_VALUE; /* mbox_name is directory */
    }
    else if ( umtPath(mbox_name.GetDir().Str()).IsExists() == OK )
        size = -1;
    else
	Rc = NO_VARIABLE_DEFINED; /* No mail directory at all */ 
}


umtLocalMailbox::~umtLocalMailbox()
{
    if ( mailbox )
    {
	Refresh();
	umt_flock( fileno( mailbox ), LOCK_UN );
	fclose( mailbox );
    }
}


long umtLocalMailbox::GetMailboxSize( void )
{
    long offset;

    if ( size == -1 ) return 0; // mailbox file is absent
    if ( !mailbox ) return -1; 
    if ( !size )
    {
	offset = ftell( mailbox );
	fseek( mailbox, 0, SEEK_END );
	size = ftell( mailbox );
	fseek( mailbox, offset, SEEK_SET );
    }
    return size;
}


FILE *umtLocalMailbox::GetMessage( int n )
{
    FILE       *tmp;
    long        offset;
    
    if ( !mailbox ) return NULL;
    n = index( Find( n ));
    if ( n == -1 )
    {
	Rc = NOT_FOUND;
	return NULL;
    }
    if ( rewind_to_msg( n ) != OK )
    {
	Rc = NOT_FOUND;
	return NULL;
    }
    tmp = tmpfile();
    if ( !tmp )
    {
	Rc = ERROR_OBTAINING_TMP_FILE;
	return NULL;
    }
    fgets( buff, sizeof( buff ), mailbox ); // Read string 'From ...'
    Rc = copy_to_file( tmp );
    if ( Rc == OK )
    {
	offset = ftell( tmp );
	if ( offset )
	{
	    // Skip Last LF 
	    fseek( tmp , -1, SEEK_CUR );
	    ftruncate( fileno( tmp ), --offset );
	    fflush( tmp );
	    fseek( tmp, 0, SEEK_SET );
	}
    }
    else 
    {
	fclose( tmp );
	tmp = NULL;
    }
    return tmp;
}


umtString umtLocalMailbox::GetHeader( int n )
{
    long      offset;
    umtString header = "";
    int  LF_present = 1, cm;
    
    if ( mailbox )
    {
	offset = ftell( mailbox );
	cm = cur_msg;
	if ( rewind_to_msg( n ) != OK ) Rc = NOT_FOUND;
	else 
	{
	    while ( fgets( buff, sizeof( buff ), mailbox ))
	    {
		if ( LF_present && *buff == '\n' ) break;
		LF_present = ( strchr( buff, '\n' ))? 1: 0;
		header += buff;
	    }
	}
	cur_msg = cm;
	fseek( mailbox, offset, SEEK_SET );
    }
    return header;
}


status umtLocalMailbox::Refresh( void )
{
    umtMsgInfo *msg, *del_msg;
    FILE       *wr_mailbox;
    int         n;
    char       *wr_name;
    struct      stat st;
    
    if ( size == -1 ) return Rc = OK; // Mailbox is absent. It's ok.
    if ( !mailbox ) return Rc = NO_VARIABLE_DEFINED;
    wr_name = tmpnam( NULL );
    if ( !wr_name )  return Rc = ERROR_OBTAINING_TMP_FILE;
    wr_mailbox = fopen( wr_name, "w" );
    if ( !wr_mailbox ) return Rc = ERROR_OBTAINING_TMP_FILE;
    for ( msg = GetFirst(), n = 0; msg; msg = GetNext( msg ), n++ )
    {
	if (( Rc = rewind_to_msg( n )) != OK ) break;
        if ( !( msg->IsErase ))
	{
	    if (( Rc = copy_to_file( wr_mailbox )) != OK ) break;
	}
    }
    fclose( wr_mailbox );
    if ( Rc == OK )
    {
	del_msg = msg = GetFirst();
	while ( msg )
	{
	    msg = GetNext( msg );
	    if ( del_msg->IsErase ) Kill( del_msg );
	    del_msg = msg;
	}
	umt_flock( fileno( mailbox ), LOCK_UN );
	fclose( mailbox );
	n = rename( wr_name, mailbox_name.Str());
	if ( n )
	{
	    st.st_mode = S_IRUSR | S_IWUSR; // Default
	    stat( mailbox_name.Str(), &st );
	    filecopy( wr_name, mailbox_name.Str());
	    chmod( mailbox_name.Str(), st.st_mode );
	}
	mailbox = fopen( mailbox_name.Str(), "r" );
	if ( !mailbox ) Rc = ERROR_OPEN_FILE;
	else  if ( umt_flock( fileno( mailbox ), LOCK_SH | LOCK_NB ) == -1 )
	    Rc = ALREADY_LOCKED;
    }
    if ( n ) unlink( wr_name );
    rewind_to_msg( 0 );
    size = 0;
    return Rc;
}


status umtLocalMailbox::Reread( void )
{
    int          LF_counter;
    umtString    id;
    umtMsgInfo   *msg, *prev_msg;
    long          length, offset;

    if ( size == -1 ) return Rc = OK; // Mailbox is absent. It's ok.
    if ( !mailbox ) return Rc = NO_VARIABLE_DEFINED;
    fseek( mailbox, 0, SEEK_SET );
    Kill( NULL );
    for ( cur_msg = 0, offset = 0; rewind_to_msg( cur_msg ) == OK; cur_msg++ )
    {
        LF_counter = 0; // It is need to skip first line,
	                // because it is message separator
	                // 'From  vasia@topmoz. .... 
	length = offset;
	offset = ftell( mailbox );
	length = offset - length;
	if (( prev_msg = GetLast()) != NULL ) prev_msg->Size = length; 
	while ( fgets( buff, sizeof( buff ), mailbox ))
	{
	    if ( LF_counter == 2 )
	    {
		if ( !strncasecmp( buff, "From ", 5 ))
		{
		    fseek( mailbox, -strlen( buff ), SEEK_CUR );
		    id = "";
		    break;
		}
	    }
	    if ( LF_counter )
	    {
		if ( !strncasecmp( buff, "Message-Id", 10 ))
		{
		    id = strchr( buff, '<' );
		    id.SetToSubstr( 1, id.Search( 1, '>' ) - 1 );
		    break;
		}
	        if ( *buff == '\n' ) LF_counter = 2;
	    }
	    else LF_counter = ( strchr( buff, '\n' ))? 1: 0;
	}
	msg = new umtMsgInfo( cur_msg, 0, id );
	if ( !msg )
	{
	    rewind_to_msg( 0 );
	    return NOT_ENOUGH_MEMORY;
	}
	Append( msg );
    }
    if (( prev_msg = GetLast()) != NULL ) prev_msg->Size = length;    
    return OK;
}


status  umtLocalMailbox::rewind_to_msg( int n )
{
    int after_LF_LF;

    *buff = '\n';
    if ( n < cur_msg )
    {
	fseek( mailbox, 0, SEEK_SET );
	cur_msg = 0;
    }
    while ( 1 ) 
    {
	do 
	{
	    after_LF_LF = ( *buff == '\n' )? 1: 0;
	    if ( !fgets( buff, sizeof( buff ), mailbox ))
	    {
		fseek( mailbox, 0, SEEK_SET );
		cur_msg = 0;
		return NOT_FOUND;
	    }
	    while ( !strchr( buff, '\n' ))
	    {
		// End of line doesn't read.
		if (
		    !fgets( buff + 5, sizeof( buff ) - 5,
			    mailbox
		    )
		)
		{
		    fseek( mailbox, 0, SEEK_SET );
		    cur_msg = 0;
		    return NOT_FOUND;
		}
	    }
	}
	while (!( after_LF_LF && !strncasecmp( buff, "From ", 5 )));
	if ( cur_msg == n ) break;
	cur_msg++;
    }
    //  Return to begin string with 'From ..'
    fseek( mailbox, -strlen( buff ), SEEK_CUR );
    return OK;
}


status  umtLocalMailbox::copy_to_file( FILE *to )
{
    int  LF_counter = 0;
    
    while ( fgets( buff, sizeof( buff ), mailbox ))
    {
	if ( LF_counter == 2 && !strncasecmp( buff, "From ", 5 )) break;
	if ( fputs( buff, to ) == EOF )
	{
	    fseek( mailbox, 0, SEEK_SET );
	    cur_msg = 0;
	    return ERROR_SAVE;
	}
	if ( LF_counter && *buff == '\n' ) LF_counter = 2;
	else LF_counter = ( strchr( buff, '\n' ))? 1: 0;
    }
    if ( !feof( mailbox ))
	fseek( mailbox, -strlen( buff ), SEEK_CUR );
    cur_msg++;
    return OK;
}



int     umtLocalMailbox::index( umtMsgInfo *msg )
{
    int n;
    umtMsgInfo *c_msg;
	
    if ( msg )
	for ( n = 0, c_msg = GetFirst(); c_msg; n++, c_msg = GetNext( c_msg ))
	    if ( msg == c_msg ) return n;
    return -1;
} 

















