/*
$Header: /export/CVS/UMT/libsrc/folder/umtMd5.cc,v 1.1 1996/10/22 19:47:29 lord Exp $

$Log: umtMd5.cc,v $
Revision 1.1  1996/10/22 19:47:29  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:47  vlad
Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:41:29  sebast
Revision 2.0

Revision 1.7  1995/08/23  16:45:46  lord
warnings removed

Revision 1.6  1995/08/02  11:26:41  sebast
umtCodingRules

Revision 1.5  1995/07/28  15:15:37  sebast
a lot of class' members made static

Revision 1.4  1995/06/22  11:14:42  sebast
call of member() changed

Revision 1.3  1995/04/26  11:35:59  sebast
uses *.h++ instead *.h

Revision 1.2  1995/02/24  18:34:23  lord
Call to member() added

Revision 1.1  95/02/24  18:31:19  18:31:19  lord (Vadim Zaliva)
Initial revision

*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "umtMd5.h++"

const  int umtMDigest::S11=7;
const  int umtMDigest::S12=12;
const  int umtMDigest::S13=17;
const  int umtMDigest::S14= 22;
const  int umtMDigest::S21=5;
const  int umtMDigest::S22=9;
const  int umtMDigest::S23=14;
const  int umtMDigest::S24=20;
const  int umtMDigest::S31=4;
const  int umtMDigest::S32=11;
const  int umtMDigest::S33=16;
const  int umtMDigest::S34=23;
const  int umtMDigest::S41=6;
const  int umtMDigest::S42=10;
const  int umtMDigest::S43=15;
const  int umtMDigest::S44=21;

umtMDigest::umtMDigest(void) : umtMember(CLASS_MDIGEST)
{
  padding=new unsigned char[64];
  padding[0]=0x80;
  for (int i=1;i<64;padding[i++]=0);
  context=new md5_ctx;
}

umtMDigest::umtMDigest(char *string):umtMember(CLASS_MDIGEST)
{
  padding = new  unsigned  char [64];
  padding[0]=0x80;
  for ( int i=1;i<64;padding[i++]=0);
  context=new md5_ctx;
  ReadString(string);
}

umtMDigest::umtMDigest(FILE *file,long len) : umtMember(CLASS_MDIGEST)
{
  padding=new  unsigned  char [64];
  padding[0]=0x80;
  for(int i=1;i<64;padding[i++]=0);
  context=new md5_ctx;
  ReadFile(file,len);
}

umtMDigest::~umtMDigest(void)
{ 
  delete context;
  delete padding;
}

inline  unsigned  long umtMDigest::md5_f(unsigned long x,
					 unsigned long y,unsigned long z)
{
  return (x & y) | ((~x) & z);
}

inline unsigned long umtMDigest::md5_g(unsigned long x,
				unsigned long y, unsigned long z)
{
  return  (x & z) | (y & (~z));
}

inline unsigned long umtMDigest::md5_h(unsigned long x,
				unsigned long  y,unsigned long  z) 
{
  return (x) ^ (y) ^ (z);
}

inline unsigned long umtMDigest::md5_i(unsigned long x,
				unsigned long  y,unsigned long  z)
{
  return  (y) ^ ((x) | (~z));
}


/* rotate_left rotates x left n bits.
 */
inline unsigned long umtMDigest::rotate_left(unsigned long x, int n)
{ return  (x << n) | (x >> (32-n)); }


/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4.
Rotation is separate from addition to prevent recomputation.
 */
inline void umtMDigest::md5_ff(unsigned long &a,unsigned long  b,
			unsigned long  c,unsigned long  d,
			unsigned long  x,int  s,unsigned long  ac) 
{ 
  a+=md5_f(b,c,d)+x+ac;
  a=rotate_left(a,s);
  a+=b; 
}

inline void umtMDigest::md5_gg(unsigned long &a,unsigned long  b,
			unsigned long  c,unsigned long  d,
			unsigned long  x,int  s,unsigned long  ac) 
{
  a+=md5_g(b,c,d)+x+ac; 
  a=rotate_left(a,s);
  a+=b;
}

inline void umtMDigest::md5_hh(unsigned long &a,unsigned long  b,
			unsigned long  c,unsigned long  d,
			unsigned long  x,int  s,unsigned long  ac) 
{
  a+=md5_h(b,c,d)+x+ac;
  a=rotate_left(a,s);
  a+=b;
}

inline void umtMDigest::md5_ii(unsigned long &a,unsigned long  b,
			unsigned long  c,unsigned long  d,
			unsigned long  x,int  s,unsigned long  ac) 
{
  a+=md5_i(b,c,d)+x+ac; 
  a=rotate_left(a,s);
  a+=b;
}

void umtMDigest::md5_init(void)                                  
{
  context->count[0] = context->count[1] = 0;
  context->state[0] = 0x67452301;
  context->state[1] = 0xefcdab89;
  context->state[2] = 0x98badcfe;
  context->state[3] = 0x10325476;
}

void umtMDigest::md5_update (unsigned char *input, unsigned int input_len)
     
{
  unsigned int i, index, part_len;
  
  /* Compute number of bytes mod 64 */
  index = (unsigned int)((context->count[0] >> 3) & 0x3F);
  
  /* Update number of bits */
  if ((context->count[0] += ((unsigned long int)input_len << 3))
      < ((unsigned long int)input_len << 3))
    context->count[1]++;
  context->count[1] += ((unsigned long int )input_len >> 29);
  
  part_len = 64 - index;
  
  /* Transform as many times as possible.
   */
  if (input_len >= part_len) {
    memcpy
      (&context->buffer[index], input, part_len);
    md5_transform (context->state, context->buffer);
    
    for (i = part_len; i + 63 < input_len; i += 64)
      md5_transform (context->state, &input[i]);
    
    index = 0;
  }
  else
    i = 0;
  
  /* Buffer remaining input */
  memcpy
    (&context->buffer[index],&input[i],
     input_len-i);
}

unsigned  char * umtMDigest::GetDigest(void)
{
  return digest;
}




/* MD5 finalization. Ends an MD5 message-digest operation, writing the
   the message digest and zeroizing the context.
 */
void umtMDigest::md5_final (void)                                    
{
  unsigned char bits[8];
  unsigned int index, padLen;
  
  /* Save number of bits */
  encode (bits, context->count, 8);
  
  /* Pad out to 56 mod 64.
*/
  index = (unsigned int)((context->count[0] >> 3) & 0x3f);
  padLen = (index < 56) ? (56 - index) : (120 - index);
  md5_update (padding, padLen);
  
  /* Append length (before padding) */
  md5_update (bits, 8);
  

  /* Store state in digest */
  encode (digest, context->state, 16);

  /* Zeroize sensitive information.
*/

  memset (context, 0, sizeof (*context));
}


/* MD5 basic transformation. Transforms state based on block.
 */
void umtMDigest::md5_transform (unsigned long int state[4],unsigned char block[64])
{
  unsigned long int a = state[0],
  b = state[1], c = state[2], d = state[3], x[16];

  decode (x, block, 64);
  
  /* Round 1 */
  md5_ff (a, b, c, d, x[ 0], S11, 0xd76aa478); /* 1 */
  md5_ff (d, a, b, c, x[ 1], S12, 0xe8c7b756); /* 2 */
  md5_ff (c, d, a, b, x[ 2], S13, 0x242070db); /* 3 */
  md5_ff (b, c, d, a, x[ 3], S14, 0xc1bdceee); /* 4 */
  md5_ff (a, b, c, d, x[ 4], S11, 0xf57c0faf); /* 5 */
  md5_ff (d, a, b, c, x[ 5], S12, 0x4787c62a); /* 6 */
  md5_ff (c, d, a, b, x[ 6], S13, 0xa8304613); /* 7 */
  md5_ff (b, c, d, a, x[ 7], S14, 0xfd469501); /* 8 */
  md5_ff (a, b, c, d, x[ 8], S11, 0x698098d8); /* 9 */
  md5_ff (d, a, b, c, x[ 9], S12, 0x8b44f7af); /* 10 */
  md5_ff (c, d, a, b, x[10], S13, 0xffff5bb1); /* 11 */
  md5_ff (b, c, d, a, x[11], S14, 0x895cd7be); /* 12 */
  md5_ff (a, b, c, d, x[12], S11, 0x6b901122); /* 13 */
  md5_ff (d, a, b, c, x[13], S12, 0xfd987193); /* 14 */
  md5_ff (c, d, a, b, x[14], S13, 0xa679438e); /* 15 */
  md5_ff (b, c, d, a, x[15], S14, 0x49b40821); /* 16 */

 /* Round 2 */
  md5_gg (a, b, c, d, x[ 1], S21, 0xf61e2562); /* 17 */
  md5_gg (d, a, b, c, x[ 6], S22, 0xc040b340); /* 18 */
  md5_gg (c, d, a, b, x[11], S23, 0x265e5a51); /* 19 */
  md5_gg (b, c, d, a, x[ 0], S24, 0xe9b6c7aa); /* 20 */
  md5_gg (a, b, c, d, x[ 5], S21, 0xd62f105d); /* 21 */
  md5_gg (d, a, b, c, x[10], S22,  0x2441453); /* 22 */
  md5_gg (c, d, a, b, x[15], S23, 0xd8a1e681); /* 23 */
  md5_gg (b, c, d, a, x[ 4], S24, 0xe7d3fbc8); /* 24 */
  md5_gg (a, b, c, d, x[ 9], S21, 0x21e1cde6); /* 25 */
  md5_gg (d, a, b, c, x[14], S22, 0xc33707d6); /* 26 */
  md5_gg (c, d, a, b, x[ 3], S23, 0xf4d50d87); /* 27 */

  md5_gg (b, c, d, a, x[ 8], S24, 0x455a14ed); /* 28 */
  md5_gg (a, b, c, d, x[13], S21, 0xa9e3e905); /* 29 */
  md5_gg (d, a, b, c, x[ 2], S22, 0xfcefa3f8); /* 30 */
  md5_gg (c, d, a, b, x[ 7], S23, 0x676f02d9); /* 31 */
  md5_gg (b, c, d, a, x[12], S24, 0x8d2a4c8a); /* 32 */

  /* Round 3 */
  md5_hh (a, b, c, d, x[ 5], S31, 0xfffa3942); /* 33 */
  md5_hh (d, a, b, c, x[ 8], S32, 0x8771f681); /* 34 */
  md5_hh (c, d, a, b, x[11], S33, 0x6d9d6122); /* 35 */
  md5_hh (b, c, d, a, x[14], S34, 0xfde5380c); /* 36 */
  md5_hh (a, b, c, d, x[ 1], S31, 0xa4beea44); /* 37 */
  md5_hh (d, a, b, c, x[ 4], S32, 0x4bdecfa9); /* 38 */
  md5_hh (c, d, a, b, x[ 7], S33, 0xf6bb4b60); /* 39 */
  md5_hh (b, c, d, a, x[10], S34, 0xbebfbc70); /* 40 */
  md5_hh (a, b, c, d, x[13], S31, 0x289b7ec6); /* 41 */
  md5_hh (d, a, b, c, x[ 0], S32, 0xeaa127fa); /* 42 */
  md5_hh (c, d, a, b, x[ 3], S33, 0xd4ef3085); /* 43 */
  md5_hh (b, c, d, a, x[ 6], S34,  0x4881d05); /* 44 */
  md5_hh (a, b, c, d, x[ 9], S31, 0xd9d4d039); /* 45 */
  md5_hh (d, a, b, c, x[12], S32, 0xe6db99e5); /* 46 */
  md5_hh (c, d, a, b, x[15], S33, 0x1fa27cf8); /* 47 */
  md5_hh (b, c, d, a, x[ 2], S34, 0xc4ac5665); /* 48 */

  /* Round 4 */
  md5_ii (a, b, c, d, x[ 0], S41, 0xf4292244); /* 49 */
  md5_ii (d, a, b, c, x[ 7], S42, 0x432aff97); /* 50 */
  md5_ii (c, d, a, b, x[14], S43, 0xab9423a7); /* 51 */
  md5_ii (b, c, d, a, x[ 5], S44, 0xfc93a039); /* 52 */
  md5_ii (a, b, c, d, x[12], S41, 0x655b59c3); /* 53 */
  md5_ii (d, a, b, c, x[ 3], S42, 0x8f0ccc92); /* 54 */
  md5_ii (c, d, a, b, x[10], S43, 0xffeff47d); /* 55 */
  md5_ii (b, c, d, a, x[ 1], S44, 0x85845dd1); /* 56 */
  md5_ii (a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
  md5_ii (d, a, b, c, x[15], S42, 0xfe2ce6e0); /* 58 */
  md5_ii (c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
  md5_ii (b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
  md5_ii (a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
  md5_ii (d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
  md5_ii (c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
  md5_ii (b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */

  state[0] += a;
  state[1] += b;
  state[2] += c;
  state[3] += d;

  /* Zeroize sensitive information.
*/
  memset (x, 0, sizeof (x));
}


void umtMDigest::encode (unsigned char *output,
                      unsigned long int *input,unsigned int len)
{
  unsigned int i, j;
  
  for (i = 0, j = 0; j < len; i++, j += 4) {
    output[j] = (unsigned char)(input[i] & 0xff);
    output[j+1] = (unsigned char)((input[i] >> 8) & 0xff);
    output[j+2] = (unsigned char)((input[i] >> 16) & 0xff);
    output[j+3] = (unsigned char)((input[i] >> 24) & 0xff);
  }
}

/* Decodes input (unsigned char) into output (UINT4). Assumes len is
  a multiple of 4.
  */
void umtMDigest::decode (unsigned long int  *output,
		      unsigned char *input,unsigned int len)
{
  unsigned int i, j;
  
  for (i = 0, j = 0; j < len; i++, j += 4)
    output[i] = ((unsigned long int)input[j]) |
      (((unsigned long int)input[j+1]) << 8) |
	(((unsigned long int)input[j+2]) << 16) |
	  (((unsigned long int)input[j+3]) << 24);
}

/* Digests a string and prints the result.
 */
int umtMDigest::ReadString (char *string)
{
  unsigned int len = strlen (string);
  if(string==NULL) return -1;
  md5_init ();
  md5_update ((unsigned char *) string, len);
  md5_final ();
  return 0;
}

/* Digests a file and prints the result.
 */
int umtMDigest::ReadFile (FILE *file,long len)
{
  int length;
  int  i;
  unsigned char buffer[1024];
  
  md5_init ();
  if(len!=-1) 
    while(len>0)  {
      if(len>1024) 
	i=1024; else i=(int)len;
      if(fread(buffer,1,i,file)!=i) return -1;
      md5_update(buffer,i);
      len-=i;
    }
  else {
    while (length = fread (buffer, 1, 1024, file))
      md5_update (buffer, length);
  }
  md5_final ();
  return 0;
}






