/*
 *  $Header: /export/CVS/UMT/libsrc/parsing/umtParseHeader.cc,v 1.4 1997/08/21 02:35:17 lord Exp $
 *  $Log: umtParseHeader.cc,v $
 *  Revision 1.4  1997/08/21 02:35:17  lord
 *  bug in timezone fixed. Everything seems to work fine on FreeBSD
 *
 *  Revision 1.3  1997/08/21 02:02:16  lord
 *  Compiled on FREEBSD. Starts OK.
 *
 *  Revision 1.2  1997/08/20 02:01:59  lord
 *  Starting FreeBSD port
 *
 *
 *  Revision 1.1  1996/10/22 19:47:33  lord
 *  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 *  Some platform directories created in lib.
 *  Makefile.include for SUN created.
 *  
 *  Revision 1.1.1.1  1996/10/21 20:46:47  vlad
 *  Puting to CVS. Version 1.00B3
 *  
 *  Revision 2.2  1996/04/12 15:40:09  vlad
 *  Content-Disposition header field process staff added.
 *  
 *  Revision 2.1  1996/04/01 13:57:36  vlad
 *  tz setings modified.
 *  
 *  Revision 2.0  1996/03/18 16:42:01  sebast
 *  Revision 2.0
 *
 *  Revision 1.25  1996/03/04  15:02:58  vlad
 *  umtParseHeader::ParseContentEncoding( char *str ) redone.
 *  
 *  Revision 1.24  1996/02/22  12:55:48  vlad
 *  Time zone bug fixed again. :-)
 *  
 *  Revision 1.23  1996/02/21  18:19:07  vlad
 *  Time zone bug fixed one more time.
 *  
 *  Revision 1.22  1996/02/20  17:49:40  vlad
 *  Time zone bug fixed.
 *  
 *  Revision 1.21  1996/02/19  16:48:38  vlad
 *  Fatal bug in parsing MAILBOX1 ' aaa@bbb.ccc.dd (Real (name))' is fixed.
 *  
 *  Revision 1.20  1995/10/05  16:59:53  vlad
 *  Address '<aa@bb.cc.dd>' implemented. (Not in RFC822)
 *  
 *  Revision 1.19  1995/09/20  13:13:00  vlad
 *  umtParseHeader::GetDate() changed.
 *  
 *  Revision 1.18  1995/09/14  10:20:52  sebast
 *  some changes because renaming umtString::Convert() => ConvertTo
 *  
 *  Revision 1.17  1995/09/06  18:04:21  vlad
 *  Fatal bug in  umtParseHeader::PostParsingString() function fixed.
 *  
 *  Revision 1.16  1995/08/01  10:56:39  lord
 *  tune interface with lex
 *  
 *  Revision 1.15  1995/08/01  07:57:48  lord
 *  *** empty log message ***
 *  
 *  Revision 1.14  1995/07/28  16:10:12  sebast
 *  non-supported by SGI line changed
 *  
 *  Revision 1.13  1995/07/05  13:44:30  vlad
 *  function of parsing Content type/subtype removed.
 *  
 *  Revision 1.12  1995/06/15  15:00:51  vlad
 *  Something a few changed in processing timezone and MAILBOX1
 *  
 *  Revision 1.11  1995/06/11  15:08:15  vlad
 *  function 'char* post_parsing_string( char *str )' added.
 *  
 *  Revision 1.10  1995/06/11  13:31:07  vlad
 *  'TimeZone' stuff changed.
 *  
 *  Revision 1.9  1995/05/27  12:50:48  vlad
 *  Added seting field sContentEncoding in ContentStruct.
 *  
 *  Revision 1.8  1995/05/26  14:30:37  vlad
 *  Transfering TIMEZONE changed.
 *  
 *  Revision 1.7  1995/05/26  12:54:05  vlad
 *  Processing of new fields added to  void pars_content_attribute()
 *  
 *  Revision 1.6  1995/04/26  11:46:48  sebast
 *  use *.h++ instead *.h
 *  
 *  Revision 1.5  1995/04/18  18:30:12  vlad
 *  At last in RCS.
 *  
 *  Revision 1.4  1995/04/02  16:39:38  vlad
 *  First revision
 *
 */

#include <ctype.h>
#include <stdio.h>
#include <strings.h>
#include <time.h>

#include "UMT.h++"
#include "umtMsgComponent.h++"
#include "umtParseHeader.h++"

#if (defined(HPUX)||defined(LINUX))
# define altzone (timezone-3600)
#else
extern time_t altzone;
#endif

const int   umtParseHeader::PARS_STRING_INC=20;
const int   umtParseHeader::TZ_MAX_LEN=20;
const char *umtParseHeader::TZ_GROUP={"TimeZones"};

umtParseHeader::~umtParseHeader()
{
};

char *umtParseHeader::GetText( void )
{
    States st;
    char *str = NULL;
    
    while (( st = yylex()) != PARS_EOF )
	ParsStrcat( &str, yytext );
    if ( str == NULL ) ParsStrcat( &str, "" ); 
    return str;
}


// status umtParseHeader::ParseFieldContentType( char *str, umtContentStruct *put_here )
// {
//     status st;
    
//     pars_string = str;     // Initializing parsed string 
//     st = ( yylex() == CONTENT_TYPE )?
// 	GetContentType( put_here ) :
// 	NOT_FOUND;
//     while ( yylex() != PARS_EOF ); 
//     return st;
// }


status umtParseHeader::GetContentTransferEncoding( umtContentStruct *put_here )
{
    if ( yylex() != TOKEN ) return NOT_FOUND;
    put_here->SContentEncoding = yytext;
    put_here->ContentEncoding = ParseContentEncoding( yytext );
    // fprintf( stderr,"get_content_transfer_enccding - OK! <<%i>>\n",( int )put_here->ContentEncoding );
    return OK;
}


ContentTransferEncoding umtParseHeader::ParseContentEncoding( char *str )
{
    int i;

    for ( i = 0; i < NUMBER_OF_ENCODINGS_SUPPORTED; i++ )
    {
	if (!strcasecmp( str, EncodingNames[i].Name ))
	    return  EncodingNames[i].Code;
    }
    return x_encoding;
}


status umtParseHeader::GetContentType( umtContentStruct *put_here )
{
    States   st;
    char    *str;
    
    if ( yylex() != TOKEN ) return NOT_FOUND;
    put_here->SContentType = yytext;
    if (( st = yylex()) != SLASH )
    {
	if ( st == PARS_EOF ) return OK; // if only content type is present 
	else  return NOT_FOUND;
    }
    if ( yylex() != TOKEN ) return NOT_FOUND;
    put_here->SContentSubtype = yytext;
    if ( yylex() == SEMICOLON )
	while (1)
	{
	    if ( yylex() != ATTRIBUTE ) return NOT_FOUND;
	    str = ParsStrcat( NULL, yytext );
	    if ( yylex() != VALUE )
	    {
		Delete( str );
		return NOT_FOUND;
	    }
	    ParseContentAttribute( put_here, str, yytext );
	    Delete( str );
	    if (( st = yylex()) == PARS_EOF ) break;
	    if ( st != SEMICOLON ) return NOT_FOUND;
	}
    return OK;
}


void umtParseHeader::ParseContentAttribute( umtContentStruct *put_here,
					    char *attrib,
					    const char *value )
{
    if ( !strcasecmp( attrib, "BOUNDARY" ))
	put_here->BoundaryString = value;
    else  if ( !strcasecmp( attrib, "NAME" ))
	put_here->Name = value;
    else  if ( !strcasecmp( attrib, "CHARSET" ))
	put_here->CharSet = value;
}


status umtParseHeader::GetContentDisposition( umtContentStruct *put_here )
{
    States   st;
    char    *str;
    
    if ( yylex() != TOKEN ) return NOT_FOUND; // Disposition type
    if ( yylex() == SEMICOLON )
	while (1)
	{
	    if ( yylex() == ATTRIBUTE )
	    {
		str = ParsStrcat( NULL, yytext );
		if ( yylex() != VALUE )
		{
		    Delete( str );
		    return NOT_FOUND;
		}
		ParseDispositionAttribute( put_here, str, yytext );
		Delete( str );
	    }
	    if (( st = yylex()) == PARS_EOF ) break;
	    if ( st != SEMICOLON ) return NOT_FOUND;
	}
    return OK;
}



void umtParseHeader::ParseDispositionAttribute( umtContentStruct *put_here,
						char *attrib,
						const char *value )
{
    if ( !strcasecmp( attrib, "FILENAME" ))
	put_here->Name = value;
}


time_t umtParseHeader::GetDate(char* date_time)
{
    char       month[4], t_zone[TZ_MAX_LEN+1];
    struct tm  mess_time;
    char       *str;
    const char *monthes[] = { "JAN", "FEB", "MAR", "APR",
			      "MAY", "JUN", "JUL", "AUG",
			      "SEP", "OCT", "NOV", "DEC" };
    
    memset( &mess_time, 0, sizeof( struct tm ));
    memset( t_zone, 0, sizeof( t_zone ));
    if((str = strchr( date_time, ',' )) == NULL )
	str = date_time;
    else str++;
    if(strchr( str, ':' ) != strrchr( str,':' ))
	sscanf( str,
		"%d %3s %d %d:%d:%d %s",
		&(mess_time.tm_mday),
		month,
		&(mess_time.tm_year),/* years since 0 or 1900 */
		&(mess_time.tm_hour),/* hours - [0,23] */
		&(mess_time.tm_min), /* minutes after the hour - [0,59] */
		&(mess_time.tm_sec), /* seconds after the minute - [0,61] !???*/
		t_zone );	     
    else 			     
	sscanf( str,		     
		"%d %3s %d %d:%d %s", 
		&(mess_time.tm_mday),
		month,		     
		&(mess_time.tm_year),/* years since 0 or 1900 */
		&(mess_time.tm_hour),/* hours - [0,23] */
		&(mess_time.tm_min), /* minutes after the hour - [0,59] */
		t_zone );
    
    if(mess_time.tm_year > 1900 ) mess_time.tm_year -= 1900;
    mess_time.tm_isdst = -1;

    for(mess_time.tm_mon = 0; mess_time.tm_mon < 12; mess_time.tm_mon++ )
	if (!strcasecmp( month, monthes[mess_time.tm_mon] )) break;

    if(mess_time.tm_mon == 12 )
	return (time_t)-1; // fprintf( stderr, " Error in month name '%s'\n", month ); // Remove it.
    tzset(); // Seting global variable 'timezone'
    
#ifdef FREEBSD
    time_t now=time(NULL);
    struct tm *lt= localtime(&now);

    return mktime(&mess_time) -
	lt->tm_gmtoff -
	- GetTZDifference(umtString(t_zone)); // TODO: local timezone
#else    
    return mktime(&mess_time) -
	((daylight > 0) ? altzone: (( daylight == 0 )? timezone: 0 ))
	- GetTZDifference(umtString(t_zone));
#endif
    
}


status umtParseHeader::GetAddresses( umtSlist *put_here, States terminator )
{
    States st;
    int flag = 1;
    
    while (1)
    {
	st = GetAddress( put_here );
	if ( st == terminator ) return OK; 
	switch ( st )
	{
	case  ONE  :
	    if ( !flag ) return NOT_FOUND; // Comma is absent.
	    flag = 0;
	    break;
	case  PARS_EOF :
	    return NOT_FOUND;
	case  COMMA    :
	    flag = 1;
	    break;
	default:
//	    fprintf( stderr, " ERROR in ADDRESSES  <%s>, %d\n", yytext, st );
	    return UNDEFINED_VALUE;
	}
    }
}


umtParseHeader::States umtParseHeader::GetAddress(umtSlist *put_here )
{
    States st;
    
    st = yylex();
//    fprintf( stderr, "ADDRESS %d\n", st );    
    switch ( st )
    {
    case GROUP   :
	if ( GetMailboxes( put_here, SEMICOLON ) != OK )
	    return PARS_ERROR;
	else  return ONE;
    case MAILBOX :
	if ( GetMailbox( put_here ) != OK )
	    return  PARS_ERROR;
	else  return ONE;
    default: 
	return st;
    }
}


status umtParseHeader::GetMailboxes( umtSlist *put_here, States terminator )
{
    States st;
    status stat;
    int flag = 1;
    
    while (1)
    {
	st = yylex();
//	fprintf( stderr, "MAILBOXES %d\n", st );
	if ( st == terminator ) return OK; 
	switch ( st )
	{
	case  MAILBOX  :
	    if ( ! flag ) return NOT_FOUND; // Comma is absent.
	    if (( stat = GetMailbox( put_here )) != OK )
		return stat; // Error in MAILBOX.	     
	    flag = 0;
	    break;
	case  PARS_EOF :
	    return NOT_FOUND;
	case  COMMA    :
	    flag = 1;
	    break;
	default:
//	    fprintf( stderr, " ERROR in MAILBOXES  <%s>, %d\n", yytext, st );
	    return UNDEFINED_VALUE;
	}
    }
}


status umtParseHeader::GetMailbox( umtSlist *put_here )
{
    States           st;
    char             *addr,
	*name = NULL;
    umtInternetAddr  *address;
    
    st = yylex();
    switch ( st )
    {
    case MAILBOX1 :
// Real name is in the last COMMENT. ( not in RFC822 but frequently used )
	yylex(); // Get internet address
	addr = ParsStrcat( NULL, yytext );
	yylex(); // Get comment . Comment will be returned in external variable
	         // char* pars_comment
// Deleting parentheses '(' ')'.
//	UMTError->Msg( umtError::Debug, "'%s'\n", pars_comment );
	if ( pars_comment )
	{
	    if ( ParsStrcat( &name, pars_comment + 1 ) == NULL )
		return NOT_ENOUGH_MEMORY;
	    name[strlen(name)-1] = '\0';
	    Delete( pars_comment );
	    pars_comment = NULL;
	}
	break;
    case MAILBOX2 :
// Real name is absent. 
//	fprintf( stderr, "in mailbox2 end %i %s\n", st, yytext );
	addr = ParsStrcat( NULL, yytext );
	break;
    case MAILBOX3 :
// Real name is first phrase. 
	while ( yylex() == WORD )
	{
	    ParsStrcat( &name, yytext );
	    ParsStrcat( &name, " " );
	}
	if ( name && *name ) name[strlen(name)-1] = '\0';
	yylex();
	addr = ParsStrcat( NULL, yytext );
//	fprintf( stderr, "in mailbox3 end %i %s\n", st, yytext );
	yylex();
	break;
    default: return NOT_FOUND; 
    }
//    fprintf ( stderr, "name - <%s>\naddr - <%s>\n", name, addr );   
    PostParsingString( name );
    PostParsingString( addr );
    umtString us1 = addr;
    umtString us2 = name;
    if (( address = new umtInternetAddr(&us1,&us2))== NULL )
	return NOT_ENOUGH_MEMORY;
    if ( !put_here->Search( address )) put_here->Append( address );
    else Delete( address );
    if ( addr ) Delete(addr);
    if ( name ) Delete(name);
    return OK;
}


void umtParseHeader::ToUppercase( char *str )
{
    while ( *str )
    {
	*str = ( char )toupper(( int )*str );
	str++;
    }
    return ;
}


int  umtParseHeader::GetTZDifference( umtString tz )
{
    int diff = 0;
    umtConfiguration *cfg;
    
    cfg = UMTConfig.GetConfiguration( umtString( TZ_GROUP )); 
    if ( !cfg || cfg->GetIntField( tz, &diff ) != OK )
	sscanf( tz.Str(),"%d", &diff );
//    UMTError->Msg( umtError::Debug,"TZ = '%s' %d", tz.Str(), diff );
    diff = ( diff/100 )*3600 + ( diff%100 )*60;
//    UMTError->Msg( umtError::Debug,"TZ dif = %d",diff );
    return diff;
}


char* umtParseHeader::PostParsingString( char *str )
{
    char *tmp, *ret_str;

    if ( str == NULL || *str == '\0' ) return str;
    ret_str = tmp = str;
    while ( *str == ' ' || *str == '\t' ) str++;
    while ( *str )
    {
	if ( *str != '"' )
	{
	    if (  *str == '\\' )
		if ( *++str == '\0' ) break;
	    *tmp++ = *str;
	}
	str++;
    }
    while ( tmp > ret_str && *(tmp-1) == ' ' ) tmp--;
    *tmp = '\0';
    return ret_str;
}



