/* StAmP! Last Modifyed by: green from castle at Sat May  6 19:55:20 1995 */

#include <InterViews/event.h>
#include <InterViews/session.h>
#include <InterViews/color.h>
#include <InterViews/layout.h>
#include <InterViews/window.h>
#include <InterViews/background.h>

#include <IV-look/kit.h>
#include <stdio.h>
#include <string.h>

#include "umtGRTFColorDialog.h++"
#include "UMT.h++"

implementActionCallback(umtColorDialog);

umtColorDialogEntry::umtColorDialogEntry(umtColorDialog* Owner,const char* color_name):
  InputHandler
(
 WidgetKit::instance()->outset_frame
 (new Background
  (LayoutKit::instance()->fixed
   (LayoutKit::instance()->hbox
    (LayoutKit::instance()->hglue(),LayoutKit::instance()->vglue()),32,32),
   Color::lookup(Session::instance()->default_display(),color_name)
   )
  ),
 WidgetKit::instance()->style()
 )
{
  strcpy(name,color_name);
  owner=Owner;
  l_c=nil;
}

void umtColorDialogEntry::draw(Canvas* c,const Allocation& a) const
{
  ((umtColorDialogEntry*)(this))->l_c=c;
  ((umtColorDialogEntry*)(this))->last_ext.set_xy(c,a.left(),a.bottom(),a.right(),a.top());
  InputHandler::draw(c,a);
}

void umtColorDialogEntry::undraw()
{
  l_c=nil;
  InputHandler::undraw();
}

umtColorDialogEntry::~umtColorDialogEntry()
{
}

void umtColorDialogEntry::Select(void)
{
  if(owner->cur!=nil)
    owner->cur->Unselect();
  //  fprintf(stderr,"Select :>%s<\n",Name());
  body(WidgetKit::instance()->inset_frame(((MonoGlyph*)body())->body()));
  owner->cur=this;
  if(l_c)
    l_c->damage(last_ext); 
}

void umtColorDialogEntry::Unselect(void)
{
  body(WidgetKit::instance()->outset_frame(((MonoGlyph*)body())->body()));
  if(l_c)
    l_c->damage(last_ext); 
}

void umtColorDialogEntry::press(const Event&)
{
  //  fprintf(stderr,"Press\n");
  Select();
}

const char* umtColorDialogEntry::Name(void)
{
  return name;  
}



umtColorDialog::umtColorDialog(const char *name) :
  umtDialog
(WidgetKit::instance()->outset_frame(LayoutKit::instance()->vbox()),
 WidgetKit::instance()->style(),
 "Select Color Dialog"
 )
{
  cur=nil;
  is_default_pressed = 0;  
  WidgetKit *kit=WidgetKit::instance();
  LayoutKit *layout=LayoutKit::instance();
  float vv[]={0,1/(float)3,2/(float)3,1};
  int r,g,b,i=0;
  Glyph *h=NULL,*v=layout->vbox();
  Glyph  *mn_box=((MonoGlyph*)body())->body();

  char tmp[128];
  umtColorDialogEntry *dlge=nil,*dlgi;

  tmp[0]='#';
  for( i=0 , b=0 ; b<4 ; b++ )
    for( r=0 ; r<4 ; r++ )
      for( g=0 ; g<4 ; g++)
      {
	if(!(i%8))
	{
	  if(h) v->append(h);
	  h=layout->hbox();
	}
	sprintf(&tmp[1],"%02x%02x%02x",
		(int)(vv[r]*255+0.5),
		(int)(vv[g]*255+0.5),
		(int)(vv[b]*255+0.5)
		);
	//	fprintf(stderr," Append color :>%s<\n",tmp);
	  dlgi=new umtColorDialogEntry(this,tmp);
	  
	if((!strcmp(name,tmp)) || (i==0))
	  dlge=dlgi;
	h->append(
		  layout->margin(dlgi,3,3)
		  );
	append_input_handler(dlgi);
	i++;
      }
  cur=dlge;
  if(cur)cur->Select();
  v->append(h);
  //  fprintf(stderr,"Append ok\n");
  mn_box->append(v);
  mn_box->append(
		 kit->outset_frame
		 (
		  layout->hbox
		  (
		   layout->hglue(),
		   kit->push_button
		   (
		    kit->label(UMTSTR(110)),
		    new ActionCallback(umtColorDialog)((umtColorDialog *)this,umtColorDialog::cb_ok)
		    ),
		   layout->hglue(),
		   kit->push_button
		   (
		    kit->label(UMTSTR(542)),
		    new ActionCallback(umtColorDialog)((umtColorDialog *)this,umtColorDialog::cb_default)
		    ),
		   layout->hglue(),
		   kit->push_button
		   (
		    kit->label(UMTSTR(111)),
		    new ActionCallback(umtColorDialog)((umtColorDialog *)this,umtColorDialog::cb_cancel)
		    ),
		   layout->hglue()
		   )
		  )
		 );
}

umtColorDialog::~umtColorDialog()
{
}

const char* umtColorDialog::GetCurName(void)
{
  if(cur!=nil)
    return cur->Name();
  else
    return nil;
}

void umtColorDialog::cb_ok()
{
  dismiss(true);
}

void umtColorDialog::cb_cancel()
{
  dismiss(false);
}

void umtColorDialog::cb_default()
{
    is_default_pressed = 1;
    dismiss(true);
}







