#include <IV-look/bevel.h>
#include <IV-look/slider.h>
#include <IV-look/kit.h>
#include <IV-X11/Xlib.h>
#include <IV-X11/xcanvas.h>
#include <IV-X11/xwindow.h>
#include <IV-X11/xdisplay.h>
#include <IV-X11/xcolor.h>
#include <IV-X11/xfont.h>
#include <X11/Xatom.h>
#include <InterViews/adjust.h>
#include <InterViews/bitmap.h>
#include <InterViews/canvas.h>
#include <InterViews/color.h>
#include <InterViews/font.h>
#include <InterViews/hit.h>
#include <InterViews/layout.h>
#include <InterViews/observe.h>
#include <InterViews/session.h>
#include <InterViews/selection.h>
#include <InterViews/shadow.h>
#include <InterViews/stencil.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/tile.h>
#include <InterViews/align.h>
#include <InterViews/superpose.h>
#include <InterViews/patch.h>
#include <InterViews/input.h>
#include <InterViews/event.h>
#include <InterViews/deck.h>
#include <OS/list.h>
#include <OS/string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "umtGRTFEditor.h++"
#include "umtGRTFBlock.h++"
#include "umtGRTFLine.h++"
#include "umtGRTFParagraf.h++"
#include "umtGRTFColorDialog.h++"
#include "umtGRTFLoader.h++"
#include "umtGRTFKeyboard.h++"
#include "umtSearchDialog.h++"

//void INIT_CL(void);
class umtGRTFEditorInpuHandler;
class umtGRTFEditorImpl:public Glyph,public Adjustable
{
public:
  umtGRTFEditorImpl
  (
   umtConfiguration *config =nil,
   char *font_section       =nil,
   boolean is_editable      =false,
   Menu *menu               =nil
   );
  virtual ~umtGRTFEditorImpl();
  
  virtual void request(Requisition&) const;
  virtual void allocate(Canvas*, const Allocation&, Extension&);
  //  virtual void allotment(GlyphIndex,DimensionName,Allotment&) const;
  virtual void draw(Canvas*, const Allocation&) const;
  virtual void undraw();

  virtual Coord lower(DimensionName d) const ;
  virtual Coord length(DimensionName d) const ;
  virtual Coord cur_lower(DimensionName d) const ;
  virtual Coord cur_length(DimensionName d) const ;
  virtual void  scroll_to(DimensionName d,Coord lower) ;

  
  virtual void ProcessEvent(const Event&);
  
  virtual void Clear     (void);
  virtual int  Load      (umtGRTFLoader &f,
			  UCharsArray &text,
			  RTFBlocksArray &blocks,
			  RTFParagrafsArray &par
			  );
  virtual int  LoadText  (umtGRTFLoader &f,
			  UCharsArray &text,
			  RTFBlocksArray &blocks,
			  RTFParagrafsArray &par
			  );
  virtual int  Save      (FILE *f);
  virtual int  SaveText  (FILE *f);
  boolean is_tokotoko_load;
  virtual void Prepare   (void);
  virtual void Redraw    (void);
  virtual void Reallocate(void);

  char    *last_file_name;
  
  
  Allocation last_allocation;
  Canvas     *last_canvas;
  Extension  last_extension;
  
  int        X_Left;
  int        X_Top;
  int        X_Right;
  int        X_Bottom;
  

  virtual void UpdateLines(long begin=-1,long end=-1);
  //  virtual void GetCharExt(long ch,const umtGRTFBlock *b,long &w,long &h) const;
//  virtual void Print (void);
  
  UCharsArray       text;
  
  RTFBlocksArray    blocks;
  RTFLinesArray     lines;
  RTFParagrafsArray paragrafs;

  // KeyMap
  void          LoadKeyMap  (umtConfiguration*);
  void          DoneKeyMap  (void);
  RTFCommand    FindKey     (const Event&,char&);
  
  StringArray      KeyMapStrings;
  RTFCommandsArray KeyMapCommands;
  UCharsArray      KeyMapChars;

  void          LoadKeyboards(umtConfiguration*);
  void          DoneKeyboards(void);
  
  RTFKeyboardsArray     Keyboards;
  long             current_keyboard_index;

  
  // Fonts
  void          LoadFonts   (umtConfiguration*);
  void          DoneFonts   (void);
  umtGRTFFont*   FindFont    (int style,int size);

  RTFFontsArray fonts[8];
  long          fonts_starts[8];

  // Colors
  void          LoadColors     (umtConfiguration*);
  void          DoneColors (void);

  umtGRTFColor   *FindColor     (const char *colorname) const;
  umtGRTFColor   *DefaultColor  (void) const;
  umtGRTFColor   *CursorColor   (void) const;
  umtGRTFColor   *BackgroundColor(void) const;
  umtGRTFColor   *BlockColor    (void) const;

  umtGRTFColorsArray    rtf_colors;
  boolean UpdateColorsBeforeDraw;
  //  umtConfiguration*   ColorConfig;
  
  umtGRTFColor   *cursor_color;
  umtGRTFColor   *background_color;
  umtGRTFColor   *block_color;
  umtGRTFColor   *default_color;

  // Menu
  void          InitMenu (Menu *menu);
  void          InitToolBar(Glyph *bar);
  void          UpdateInterface(void);
  void          UpdateMenu(void);
  void          UpdateToolBar(void);
  

  void          ProcessSearch(char *str,boolean is_forward,boolean is_case_sensitive);
  
  umtSearchDialog *search_dialog;
  
  MenuItem      *m_bold;
  MenuItem      *m_italic;
  MenuItem      *m_underline;
  MenuItem      *m_fixed;

  MenuItem      *m_a_left;
  MenuItem      *m_a_center;
  MenuItem      *m_a_right;
  Menu          *m_kbd_menu;
  

  Button        *b_bold;
  Button        *b_italic;
  Button        *b_underline;
  Button        *b_fixed;
  Button        *b_a_left;
  Button        *b_a_center;
  Button        *b_a_right;
  Patch         *b_font_size;
  Patch         *b_indent_left_size;
  Patch         *b_indent_right_size;
  Glyph         *tool_bar;

  // Editor

  UCharsArray    last_bl_txt;
  RTFBlocksArray last_bl_blc;
  RTFParagrafsArray last_bl_par;
  void           ClearLastBuffer(void);
 

  void          UnMark(void);
  void          NotifyText(long start=-1,long end=-1);
  void          FetchBuf(long start);
  
  void          FlushParagrafs(void);
  void          FlushBlocks(void);
  boolean       IsEditable;
  umtGRTFBlock   *current_block;
  
  long        cur_line_count;
  long        cur_line_start;
  Session     *session_;

  long        cur_cursor_pos;

  long        mark_start;
  long        mark_end;

  Handler     *grab_handler;
  boolean     is_mark_mode;

  long        user_x;

  void        ProcessCommand (RTFCommand cmd,long param=0);
  
  long        CharLineNumber (long char_number) const; //+
  long        CharBlockNumber(long char_number) const; //+
  long        CharParagrafNumber(long char_number) const; //+
  void        SetUserX (void);             //+
  long        EventToIndex(const Event&); //+

  //  void        GetCursorCenter(long &x_pos,long &y_pos);
  //  void        SetCursorCenter(long  x_pos,long  y_pos);

  void        GetCursorPos   (long &line ,long &x_pos) const; //+
  void        SetCursorPos   (long line  ,long  x_pos); //+

  void        ScrollToCursor (void);
  void        CursorToScroll (void);

  long        CalcCurLineCount(void);
  
  long        GetLineStartX  (umtGRTFLine *line,umtGRTFBlock *block,umtGRTFParagraf *par) const; //+


  void        DeleteText     (long start,long count);
  void        InsertText     (long start,UCharsArray &txt,RTFBlocksArray &blk,RTFParagrafsArray &par);

  void        InsertChar     (long pos,long ch);

    umtGRTFEditorInpuHandler *my_handler;

  boolean IsShowCursor;
};

#include "umtGRTFEditor_Load.cc"
#include "umtGRTFEditor_Convert.cc"
#include "umtGRTFEditor_Save.cc"
#include "umtGRTFEditor_Fonts.cc"
#include "umtGRTFEditor_Colors.cc"
#include "umtGRTFEditor_KeyMap.cc"
#include "umtGRTFEditor_Menu.cc"
#include "umtGRTFEditor_ToolBar.cc"
#include "umtGRTFEditor_Keyboards.cc"


class umtGRTFEditorInpuHandler:public InputHandler
{
public:
  umtGRTFEditorInpuHandler(umtGRTFEditorImpl  *Owner);
  
  virtual ~umtGRTFEditorInpuHandler();
  virtual void move(const Event&);
  virtual void press(const Event&);
  virtual void drag(const Event&);
  virtual void release(const Event&);
  virtual void keystroke(const Event&);

 
  umtGRTFEditorImpl  *owner;
};


umtGRTFEditor::umtGRTFEditor
(umtConfiguration *config,
 char             *font_section,
 boolean          is_editable,
 Menu             *menu
 ):Box( new Superpose(new Tile(Dimension_Y), new Align(Dimension_X)),10)
// Box( new Superpose(new Tile(Dimension_X), new Align(Dimension_Y)),10)
{
/*  impl_=new umtGRTFEditorImpl(config,font_section,is_editable,menu);
    Resource::ref(impl_);
    append(impl_->my_handler=new umtGRTFEditorInpuHandler(impl_));
    append(WidgetKit::instance()->vscroll_bar(impl_));
*/
//  impl_->tool_bar=(is_editable==true)?LayoutKit->instance()->hbox():nil;
//  Resource::ref(tool_bar);
  impl_=new umtGRTFEditorImpl(config,font_section,is_editable,menu);
  Resource::ref(impl_);
  append
    (LayoutKit::instance()->hbox(
				 impl_->my_handler=new umtGRTFEditorInpuHandler(impl_),
				 WidgetKit::instance()->vscroll_bar(impl_)
				 )
     );
  if(impl_->tool_bar!=nil)
    append
      (//LayoutKit::instance()->hbox
//       (
	WidgetKit::instance()->outset_frame(impl_->tool_bar)//,
//	LayoutKit::instance()->hglue()  
//	)
       );
//  append(WidgetKit::instance()->vscroll_bar(impl_));

  //INIT_CL();
}

umtGRTFEditor::~umtGRTFEditor()
{
  Resource::unref(impl_);
  //    fprintf(stderr,"Remove umtGRTFEditor\n");
}

int umtGRTFEditor::Save(char *fname,boolean is_enriched,boolean is_append)
{
  char *name=nil;
  FILE *f;
  int ret;
  
  if(fname==nil)
    name=impl_->last_file_name;
  else
    name=fname;

  if(name==nil)
    return 1;

  f=fopen(name,(is_append==true)?"at":"wt");
  if(f==nil)return 1;
  if(is_enriched==true)
    ret=impl_->Save(f);
  else
    ret=impl_->SaveText(f);
  fclose(f);
  
  return ret;
  //impl_->Save(fname,is_enriched);
}

void umtGRTFEditor::Clear(void)
{
  impl_->Clear();
  impl_->text.append('\n');
  impl_->blocks.append(new umtGRTFBlock());
  impl_->blocks.item(0)->font=impl_->FindFont(0,0);
  impl_->blocks.item(0)->color=impl_->DefaultColor();
  impl_->paragrafs.append(new umtGRTFParagraf());
  impl_->UpdateLines();
  impl_->Redraw();
}

int umtGRTFEditor::Load(char *fname,boolean is_enriched)
{
  FILE *f=fopen(fname,"rb");
  long i;
  if(!f)return 1;
  umtGRTFLoader l;
  UCharsArray    txt;
  RTFBlocksArray blc;
  RTFParagrafsArray par;
  
  impl_->Clear();
  l.StartFile(f);
  //  fprintf(stderr,"Load\n");
  if(impl_->last_file_name!=nil)
    delete impl_->last_file_name;
  impl_->last_file_name=new char[strlen(fname)+2];
  strcpy(impl_->last_file_name,fname);
  if(is_enriched==true)
    impl_->Load(l,txt,blc,par);
  else
    impl_->LoadText(l,txt,blc,par);

  impl_->is_tokotoko_load=true;
  //  fprintf(stderr,"Insert\n");
  if(txt.count()==0)
    txt.append('\n');
  if(blc.count()==0)
    {
      blc.append(new umtGRTFBlock(*(impl_->current_block)));
      blc.item(0)->start=0;
    }
  impl_->InsertText(0,txt,blc,par);
  for( i=0 ; i<blc.count() ; i++ )
    delete blc.item(i);
  blc.remove_all();
  for( i=0 ; i<par.count() ; i++ )
    delete par.item(i);
  par.remove_all();
  txt.remove_all();
  fclose(f);
  //  fprintf(stderr,"Return\n");
  impl_->Reallocate();
  // impl_->Redraw();
  impl_->notify_all();
  impl_->scroll_to(Dimension_Y,impl_->lines.count()+10);
  impl_->notify_all();
  return 0;
  /*
    return impl_->Load(fname);
  */
    
}

int umtGRTFEditor::InsertFile(char *fname,boolean is_enriched)
{
  FILE *f=fopen(fname,"rb");
  long i;
  if(!f)return 1;
  umtGRTFLoader l;
  UCharsArray    txt;
  RTFBlocksArray blc;
  RTFParagrafsArray par;
  
  l.StartFile(f);
  //  fprintf(stderr,"Load\n");

  if(is_enriched==true)
    impl_->Load(l,txt,blc,par);
  else
    impl_->LoadText(l,txt,blc,par);

/*  fprintf(stderr,"\n\npar-s: %d\n",(int)impl_->paragrafs.count());
  fprintf(stderr,"par: %d\n",(int)par.count());
  {
    long i;
    for( i=0 ; i<par.count() ; i++ )
      fprintf(stderr,"%d(%d)  ",(int)par.item(i)->Start(),(int)par.item(i)->Align());
    fprintf(stderr,"\n");
  }
*/
  //  fprintf(stderr,"Insert\n");
  if(txt.count()==0)
    txt.append('\n');
  if(blc.count()==0)
    {
      blc.append(new umtGRTFBlock(*(impl_->current_block)));
      blc.item(0)->start=0;
    }
  impl_->InsertText(impl_->cur_cursor_pos,txt,blc,par);
  //fprintf(stderr,"par-s: %d\n",(int)impl_->paragrafs.count());

  impl_->cur_cursor_pos+=txt.count();
  impl_->ScrollToCursor();
  impl_->Redraw();

  for( i=0 ; i<blc.count() ; i++ )
    delete blc.item(i);
  blc.remove_all();
  for( i=0 ; i<par.count() ; i++ )
    delete par.item(i);
  par.remove_all();
  txt.remove_all();
  fclose(f);
  //  fprintf(stderr,"Return\n");
//  impl_->Reallocate();
  // impl_->Redraw();
//  impl_->notify_all();
//  impl_->scroll_to(Dimension_Y,impl_->lines.count()+10);
//  impl_->notify_all();	      

  return 0;
  /*
    return impl_->Load(fname);
  */
    
}

int umtGRTFEditor::AppendString(char *str  ,boolean is_enriched)
{
  long i;
  if(!str)return 1;
  umtGRTFLoader l;
  UCharsArray    txt;
  RTFBlocksArray blc;
  RTFParagrafsArray par;
  
  //  impl_->Clear();
  l.StartString(str);
  if(is_enriched==true)
    impl_->Load(l,txt,blc,par);
  else
    impl_->LoadText(l,txt,blc,par);
/*  fprintf(stderr,"\nAppp\n\n");

  for( i=0 ; i<impl_->paragrafs.count() ; i++ )
    fprintf(stderr,"%d(%d)  ",
	    (int)impl_->paragrafs.item(i)->Start(),
	    (int)impl_->paragrafs.item(i)->Align()
	    );
*/
  impl_->InsertText(impl_->text.count()-1,txt,blc,par);

/*  fprintf(stderr,"\nAppp\n\n");

  for( i=0 ; i<impl_->paragrafs.count() ; i++ )
    fprintf(stderr,"%d(%d)  ",
	    (int)impl_->paragrafs.item(i)->Start(),
	    (int)impl_->paragrafs.item(i)->Align()
	    );
  fprintf(stderr,"\nKabuka\n\n");
*/
  for( i=0 ; i<blc.count() ; i++ )
    delete blc.item(i);
  blc.remove_all();
  for( i=0 ; i<par.count() ; i++ )
    delete par.item(i);
  par.remove_all();
  txt.remove_all();
  impl_->Redraw();
  return 0;
}

int umtGRTFEditor::AppendFile(char *fname,boolean is_enriched)
{
  long i;
  FILE *f=fopen(fname,"rb");
  if(!f)return 1;
  umtGRTFLoader l;
  UCharsArray    txt;
  RTFBlocksArray blc;
  RTFParagrafsArray par;
  
  //  impl_->Clear();
  l.StartFile(f);
  if(is_enriched==true)
    impl_->Load(l,txt,blc,par);
  else
    impl_->LoadText(l,txt,blc,par);
/*  fprintf(stderr,"Apppfffffffff\n\n");
  for( i=0 ; i<impl_->paragrafs.count() ; i++ )
    fprintf(stderr,"%d(%d)  ",
	    (int)impl_->paragrafs.item(i)->Start(),
	    (int)impl_->paragrafs.item(i)->Align()
	    );
*/
  impl_->InsertText(impl_->text.count()-1,txt,blc,par);
/*  fprintf(stderr,"\nApppfffffffff\n\n");

  for( i=0 ; i<impl_->paragrafs.count() ; i++ )
    fprintf(stderr,"%d(%d)  ",
	    (int)impl_->paragrafs.item(i)->Start(),
	    (int)impl_->paragrafs.item(i)->Align()
	    );
*/
  for( i=0 ; i<blc.count() ; i++ )
    delete blc.item(i);
  blc.remove_all();
  for( i=0 ; i<par.count() ; i++ )
    delete par.item(i);
  par.remove_all();
  txt.remove_all();
  fclose(f);
  impl_->Redraw();
  return 0;
}

InputHandler *umtGRTFEditor::GetInputHandler(void)
{
  return impl_->my_handler;
}

void umtGRTFEditor::ScrollToEnd(void)
{
  if(
     (impl_->text.count()!=0) &&
     (impl_->last_canvas!=nil)
     )
    {
      impl_->ProcessCommand(RTFEndOfText);
      impl_->ScrollToCursor();
      impl_->Redraw();
    }
}

void umtGRTFEditor::ScrollToStart(void)
{
  if(
     (impl_->text.count()!=0) &&
     (impl_->last_canvas!=nil)
     )
    {
      impl_->ProcessCommand(RTFStartOfText);
      impl_->ScrollToCursor();
      impl_->Redraw();
    }
}

umtGRTFEditorImpl::umtGRTFEditorImpl
(
   umtConfiguration *config,
   char *font_section      ,
   boolean is_editable     ,
   Menu *menu              
 ):Adjustable()
{
  user_x=0;
  is_mark_mode=false;
  current_keyboard_index=0;
  search_dialog=nil;
  is_tokotoko_load=true;
  last_file_name=nil;
  session_=Session::instance();
  cur_line_count=0;
  cur_line_start=0;
  cur_cursor_pos=0;
  last_canvas=nil;
  current_block=new umtGRTFBlock();
  IsEditable=is_editable;

  if(config!=nil)
    config=config->GetConfiguration("RTFEditor");

  
  IsShowCursor=false;
  if(IsEditable)
    IsShowCursor=true;
  else
    if(config!=nil)
      {
	umtString u;
	u=config->GetStrField("ShowCursorInViewer");
	if(!u.IsEmpty())
	  {
	    if(!strcasecmp(u.Str(),"Yes"))
	      IsShowCursor=true;
	  }
      }

  cursor_color=background_color=block_color=default_color=nil;
  if(
     (font_section!=nil) &&
     (font_section[0]!='\0')
     )
    LoadFonts ((config==nil)?nil:(config->GetConfiguration(font_section)));
  else
    LoadFonts ((config==nil)?nil:(config->GetConfiguration("Fonts")));
  
  LoadKeyMap((config==nil)?nil:(config->GetConfiguration("KeyMap")));
  LoadKeyboards((config==nil)?nil:(config->GetConfiguration("Keyboards")));
  LoadColors((config==nil)?nil:(config->GetConfiguration("Colors")));
  //  if(IsEditable)
  InitMenu(menu);
  tool_bar=(is_editable==true)?LayoutKit::instance()->hbox():nil;
  Resource::ref(tool_bar);
  InitToolBar(tool_bar);
  UpdateInterface();
  text.append('\n');
  blocks.append(new umtGRTFBlock());
  blocks.item(0)->font=FindFont(0,0);
  blocks.item(0)->color=DefaultColor();

  paragrafs.append(new umtGRTFParagraf());

  UpdateColorsBeforeDraw=true;
  mark_start=mark_end=0;
  grab_handler=nil;
}

void umtGRTFEditorImpl::ClearLastBuffer(void)
{
  long i;

  for( i=0 ; i<last_bl_blc.count() ; i++ )
    delete last_bl_blc.item(i);
  last_bl_blc.remove_all();
  for( i=0 ; i<last_bl_par.count() ; i++ )
    delete last_bl_par.item(i);
  last_bl_par.remove_all();
  last_bl_txt.remove_all();
}

umtGRTFEditorImpl::~umtGRTFEditorImpl()
{
  Resource::unref(tool_bar);
  Resource::unref(search_dialog);
  if(last_file_name!=nil)delete last_file_name;
  last_file_name=nil;
  delete current_block;
  ClearLastBuffer();
  Clear();
  //    fprintf(stderr,"Done Fonts\n");
  DoneFonts();
  //    fprintf(stderr,"Done Colors\n");
  DoneColors();
  //    fprintf(stderr,"Done KeyMap\n");
  DoneKeyMap();
  //    fprintf(stderr,"Remove umtGRTFEditorImpl\n");
  DoneKeyboards();
}

void umtGRTFEditorImpl::Redraw(void)
{
  if(last_canvas!=nil)
    {
      last_canvas->damage(last_extension);
      notify_all();
    }
}

void umtGRTFEditorImpl::Reallocate(void)
{
  if(last_canvas!=nil)
    allocate(last_canvas,last_allocation,last_extension);
}

Coord umtGRTFEditorImpl::lower(DimensionName d) const
{
  d=d;
  return 0;
}

Coord umtGRTFEditorImpl::length(DimensionName d) const
{
  d=0;
  if(lines.count()!=0)
    return lines.count();
  else
    return 100;
}

Coord umtGRTFEditorImpl::cur_lower(DimensionName d) const
{
  d=d;
  if(cur_line_count!=0)
    return lines.count()-cur_line_start-cur_line_count;
  else
    return 0;
}

Coord umtGRTFEditorImpl::cur_length(DimensionName d) const
{
  d=d;
  if(cur_line_count!=0)
    return cur_line_count;
  else
    return 100;
}

void  umtGRTFEditorImpl::scroll_to(DimensionName d,Coord lower)
{
  //  constrain(d,lower);
  d=d;
  if(lines.count()==0)return;
  //  fprintf(stderr,"%d lower !!! %d\n",(int)lines.count(),(int)lower);
  lower=lines.count()-lower-cur_line_count;
  if(lower>=lines.count())
    lower=lines.count()-1;
  if(lower<0)lower=0;
  //  fprintf(stderr,"mylower !!! %d\n",(int)lower);
  if(
     (lower>cur_line_start) &&
     (cur_line_start+cur_line_count>=lines.count())
     )return;
  cur_line_start=(long)lower;
  cur_line_count=CalcCurLineCount();
  CursorToScroll();
  Redraw();
}

long umtGRTFEditorImpl::CalcCurLineCount(void)
{
  long ret;
  long i;
  long y;
  
  if(cur_line_start<lines.count() && last_canvas)
    {
      ret=0;
      
      y=X_Top;
      
      for( i=cur_line_start ; i<lines.count() ; i++ )
	{
	  if(y+lines.item(i)->h>X_Bottom)break;
	  ret++;
	  y+=lines.item(i)->h;
	}
    }
  return ret;
}

void umtGRTFEditorImpl::request(Requisition& r) const
{
  Requirement x(200,10000,100,1);
  Requirement y(200,10000,160,1);

  r.require_x(x);
  r.require_y(y);
}

/*void umtGRTFEditorImpl::allotment(GlyphIndex,DimensionName d,Allotment& a) const
{
  a=last_allocation.allotment(d);
}
*/

void umtGRTFEditorImpl::allocate(Canvas* c, const Allocation& a, Extension& ext)
{
  boolean is_update_colors=false;
  
  if(c==nil)return;
  
  X_Top   =c->rep()->pheight_-c->to_pixels(a.top());
  X_Left  =c->to_pixels(a.left());
  X_Right =c->to_pixels(a.right());
  X_Bottom=c->rep()->pheight_-c->to_pixels(a.bottom());
  //  fprintf(stderr,"Start alloc %d %d %d %d\n",(int)X_Top,(int)X_Left,(int)X_Right,(int)X_Bottom);
  
  if(X_Right-X_Left<10)return;

  //  fprintf(stderr,"Start alloc %d %d %d %d\n",(int)X_Top,(int)X_Left,(int)X_Right,(int)X_Bottom);
  if(last_canvas==nil)
    {
      last_canvas=c;
      //      LoadColors(ColorConfig);
      is_update_colors=true;
      //  fprintf(stderr,"11\n");
      UpdateLines();
      //      fprintf(stderr,"22\n");
      if(is_tokotoko_load==true)
	{
	  //  fprintf(stderr,"33\n");

	  cur_line_start=0;
	  cur_line_count=CalcCurLineCount();
	  cur_cursor_pos=0;
	  is_tokotoko_load=false;
	}
      notify_all();
    }
  //  fprintf(stderr,"44\n");

  if(c!=last_canvas)
    is_update_colors=true;
  
  if(
     (is_update_colors==true) ||
     (UpdateColorsBeforeDraw==true)
     )
    {
      long i;
      //  fprintf(stderr,"55\n");

      for( i=0 ; i<rtf_colors.count() ; i++ )
	rtf_colors.item(i)->Update(c);
      UpdateColorsBeforeDraw=false;
    }
  ext.set_xy(c,a.left(),a.bottom(),a.right(),a.top());
  last_canvas=c;
  last_extension=ext;
  //  fprintf(stderr,"allocate\n");
  last_allocation.allot_x(a.x_allotment());
  last_allocation.allot_y(a.y_allotment());
  
  X_Top   =c->rep()->pheight_-c->to_pixels(a.top());
  X_Left  =c->to_pixels(a.left());
  X_Right =c->to_pixels(a.right());
  X_Bottom=c->rep()->pheight_-c->to_pixels(a.bottom());
  //  fprintf(stderr,"66\n");
  
  UpdateLines();
  //      fprintf(stderr,"77\n");
  notify_all();
  //  fprintf(stderr,"88\n");
  /*  fprintf(stderr,"  Allocation\n");
  fprintf(stderr,"   x %f\n",(float)a.x());
  fprintf(stderr,"   y %f\n",(float)a.y());
  fprintf(stderr,"   left %f\n",(float)a.left());
  fprintf(stderr,"   right %f\n",(float)a.right());
  fprintf(stderr,"   bottom %f\n",(float)a.bottom());
  fprintf(stderr,"   top %f\n",(float)a.top());
  fprintf(stderr,"\n");*/
}

void umtGRTFEditorImpl::undraw()
{
  last_canvas=nil;
  //  fprintf(stderr,"Undraw !!!\n");
}

void umtGRTFEditorImpl::draw(Canvas* c, const Allocation& ) const
{
  //  Extension ext;
  unsigned long old_font=0;
  unsigned long old_color=0;
  XDisplay* x_dpy  ;
  XDrawable x_draw ;
  GC        x_gc   ;
  CanvasRep *c_rep;

  unsigned long last_foreground=0xffffffffUL;
  XID           last_font      =(XID)0xffffffffUL;
  
  unsigned long new_foreground;
  XID           new_font      ;
  
  
  if(!c)return;
  if(last_canvas!=c)return;

  if(is_tokotoko_load==true)
    {
      ((umtGRTFEditorImpl*)(this))->cur_line_start=0;
      ((umtGRTFEditorImpl*)(this))->cur_line_count=((umtGRTFEditorImpl*)(this))->CalcCurLineCount();
      ((umtGRTFEditorImpl*)(this))->cur_cursor_pos=0;
      ((umtGRTFEditorImpl*)(this))->is_tokotoko_load=false;
      ((umtGRTFEditorImpl*)(this))->notify_all();
    }
 
  if(UpdateColorsBeforeDraw==true)
    {
      long i;
      
      for( i=0 ; i<rtf_colors.count() ; i++ )
	rtf_colors.item(i)->Update(c);
      ((umtGRTFEditorImpl*)(this))->UpdateColorsBeforeDraw=false;
    }

  //  if(!last_allocation.equals(a,1))return ;
  c_rep=c->rep();
  
/*  {
    long i;
    fprintf(stderr,"\nC:%d\n",(int)text.count());
    for( i=0 ; i<paragrafs.count() ; i++ )
      fprintf(stderr,"%d(%d)  ",(int)paragrafs.item(i)->Start(),(int)paragrafs.item(i)->Align());
    fprintf(stderr,"\n\n");
  }*/
  //  fprintf(stderr,"draw\n");
//  const Color *f=WidgetKit::instance()->foreground();
//  if(f)
    {      
      x_dpy  = c_rep->dpy();
      x_draw = c_rep->drawbuffer_;
      x_gc   = c_rep->drawgc_;
      if(c_rep->color_)
	old_color=c_rep->color_->rep(c_rep->window_->rep()->visual_)->xcolor_.pixel;
      if(c_rep->font_)		 
	old_font =c_rep->font_->rep(c_rep->display_)->font_->fid;
      
      XSetForeground
	(x_dpy,x_gc,
	 BackgroundColor()->pixel()
	 );
      XFillRectangle(x_dpy,x_draw,x_gc,X_Left,X_Top,X_Right-X_Left,X_Bottom-X_Top);


      
      if(cur_line_start<lines.count())
      {
	long i,j;
	long x,y,c_w,asc;
	umtGRTFBlock *cur_bl;
	umtGRTFParagraf *cur_par;
	umtGRTFLine  *cur_line;
	long        cur_bl_index=0;
	long        cur_par_index=0;
	unsigned char  char_j;
//	long     CPos=cur_cursor_pos;
//	boolean  IsLeftCur=true;
	//	long        alloc_w=(long)(X_Right-X_Left);

	y=(long)(X_Top);

/*	if((CPos-1)>=0)
	{
	  long t =CharBlockNumber(CPos  );
	  long tp=CharBlockNumber(CPos-1);

	  if((t>0) && (tp>=0) && (t<blocks.count()))
	    if(blocks.item(t)->align!=blocks.item(tp)->align)
	      {
		if(blocks.item(t)->align!=current_block->align)
		  {
		    CPos--;
		    IsLeftCur=false;
		  }
	      }
	}
*/
	for( i=cur_line_start ; i<lines.count() ; i++ )
	  {
	    cur_line=lines.item(i);
	    if(y+cur_line->h>X_Bottom)break;
	    x=(long)(X_Left);

	    //	   	    fprintf(stderr,"Draw line : %d  X:>%d< Y:>%d<\n",(int)i,(int)x,(int)y);
	    for( j=cur_line->start ; j<text.count() ; j++ )
	      {
		if(
		   (i+1<lines.count()) &&
		   (lines.item(i+1)->start<=j)
		   )break;
		
		asc=cur_line->asc;
		while(1)
		  {
		    if(cur_bl_index+1>=blocks.count())break;
		    if(blocks.item(cur_bl_index+1)->start>j)break;
		    cur_bl_index++;
		  } 
		cur_bl=blocks.item(cur_bl_index);
		//         j;
		//		fprintf(stderr,"BL=%d\n",(int)cur_bl);
		while(1)
		  {
		    if(cur_par_index+1>=paragrafs.count())break;
		    if(paragrafs.item(cur_par_index+1)->Start()>j)break;
		    cur_par_index++;
		  } 
		cur_par=paragrafs.item(cur_par_index);
		//  'paragraf'       j;
		//		fprintf(stderr,"BL=%d\n",(int)cur_bl);
		if(j==cur_line->start)
		  {
		    x=GetLineStartX(cur_line,cur_bl,cur_par);
/*		    fprintf(stderr,"%d(%d) %d X:%d\n",
			    (int)cur_par_index,
			    (int)cur_par->Start(),
			    (int)cur_par->Align(),
			    (int)x
			    );		    
*/
		  }
		
		char_j=text.item(j);
		if(char_j=='\n')char_j=' ';
		if(char_j!='\n')
		  {
		    c_w=cur_bl->font->char_width(char_j);



		    if(
		       ((j>=mark_start) && (j<mark_end)) ||
		       ((j>mark_end) &&j<=mark_start)
		       )
		      {
			new_foreground=BlockColor()->pixel();
			if(last_foreground!=new_foreground)
			  XSetForeground
			    (x_dpy,x_gc,
			     last_foreground=new_foreground
			     );
			XFillRectangle(
				       x_dpy,x_draw,x_gc,(int)x,(int)y,
				       (unsigned int)c_w,(unsigned int)cur_line->h
				       );
		      }

		    
///
  
		    if(
		       (j==cur_cursor_pos) &&
		       (IsShowCursor==true)
		       )
		      {
			new_foreground=CursorColor()->pixel();
			if(last_foreground!=new_foreground)
			  XSetForeground
			    (x_dpy,x_gc,
			     last_foreground=new_foreground
			     );
			XFillRectangle(
				       x_dpy,x_draw,x_gc,(int)x,(int)y,
				       (unsigned int)c_w,(unsigned int)cur_line->h
				       );
		      }
		      
///
		    new_font=cur_bl->font->XId();
		    if(last_font!=new_font)
		      XSetFont
			(
			 x_dpy,x_gc,
			 last_font=new_font
			 );
		    new_foreground=cur_bl->color->pixel();
		    if(last_foreground!=new_foreground)
		      XSetForeground
			(x_dpy,x_gc,
			 last_foreground=new_foreground
			 );
		    if((cur_bl->font_style&RTFFONT_UnderLine)==RTFFONT_UnderLine)
		      XDrawLine(x_dpy,x_draw,x_gc,(int)x,(int)(y+asc),(int)(x+c_w),(int)(y+asc));
		    
		    XDrawString(x_dpy,x_draw,x_gc,(int)x,(int)(y+asc),(const char*)(&char_j),1);
/*
		    if(
		       (CPos==j) &&
		       (IsShowCursor==true)
		       )
		      {
			if(IsLeftCur==true)
			  {
			    new_foreground=CursorColor()->pixel();
			    if(last_foreground!=new_foreground)
			      XSetForeground
				(x_dpy,x_gc,
				 last_foreground=new_foreground
				 );
			    XDrawLine(x_dpy,x_draw,x_gc,(int)(x),(int)(y),
				                        (int)(x),(int)(y+cur_line->h)
				      );
			  }
			else
			  {
			    new_foreground=CursorColor()->pixel();
			    if(last_foreground!=new_foreground)
			      XSetForeground
				(x_dpy,x_gc,
				 last_foreground=new_foreground
				 );
			    XDrawLine(x_dpy,x_draw,x_gc,(int)(x+c_w),(int)(y),
				      (int)(x+c_w),(int)(y+cur_line->h)
				      );
			  }
		      }
*/		    
		    x+=c_w;
		  }
	      }
	    y+=lines.item(i)->h;
	  }
      }
      if(old_font)
	XSetFont(c_rep->dpy(),c_rep->drawgc_,old_font);
      if(old_color)
      XSetForeground(c_rep->dpy(),c_rep->drawgc_,old_color);
    }
}




void umtGRTFEditorImpl::Clear(void)
{
  int i;
  //  fprintf(stderr,"Run Clear\n");
  text.remove_all();
  for( i=0 ; i<blocks.count() ; i++ )
    if(blocks.item(i))delete blocks.item(i);
  blocks.remove_all();
  for( i=0 ; i<lines.count() ; i++ )
    if(lines.item(i))delete lines.item(i); 
  lines.remove_all();
  for( i=0 ; i<paragrafs.count() ; i++ )
    if(paragrafs.item(i))delete paragrafs.item(i); 
  paragrafs.remove_all();
  cur_line_start=0;
  cur_line_count=0;
  cur_cursor_pos=0;
  
  //  fprintf(stderr,"Done Clear\n");
}

void umtGRTFEditorImpl::UpdateLines(long begin,long end)
{
  long i;
  long c_w;
  long cur_char=0,max_char=text.count();
  umtGRTFLine  *l;
  umtGRTFBlock *cur_bl;
  umtGRTFParagraf *cur_par;
  RTFCommand   cur_align=RtfFlushLeft;
  long        cur_bl_index=0;
  long        cur_par_index=0;
  long W=(long)(X_Right-X_Left);
  unsigned char char_cur_char;
  int is_new_line=0;

  long insert_pos=0;
  
  if(last_canvas==nil)return;
  if(W<10)return;

  if(blocks.count()<1)return;
  //  begin=begin;
  //;
  if(lines.count()==0)
    {
      begin=end=0;
      max_char=text.count();
      cur_char=0;
      insert_pos=0;
    }
  else
    if((begin==-1)||(end==-1))
      {
	begin=0;
	end=lines.count();
	max_char=text.count();
	cur_char=0;
	insert_pos=0;
      }
    else
      {
	if(end>lines.count())end=lines.count();
	
	if(lines.item(0)->start!=0)
	  {
	    begin=0;
	    lines.insert(0,new umtGRTFLine());
	  }
	
	cur_char=lines.item(begin)->start;
      
	if(end>=lines.count())
	  max_char=text.count();
	else
	  max_char=lines.item(end)->start;
	insert_pos=begin;
      }
/*  for( i=begin ; i>=0 ; i-- )
    if(text.item(i))*/
  //;
  
/*  for( i=0 ; i<lines.count() ; i++ )
    delete lines.item(i);
  lines.remove_all();
  */
    for( i=begin ; i<end ; i++ )
      {
	delete lines.item(begin);
	lines.remove(begin);
      }
  
    
    //  fprintf(stderr,"Beg U\n");
  //  cur_char=0;

  while(cur_char<max_char)
    {
      
      l=new umtGRTFLine();
      l->start=cur_char;
      is_new_line=0;
      while(1)
	{
	  //  fprintf(stderr," \n");
	  while(1)
	    {
	      if(cur_bl_index+1>=blocks.count())break;
	      if(blocks.item(cur_bl_index+1)->start>cur_char)break;
	      cur_bl_index++;
	    } 
	  cur_bl=blocks.item(cur_bl_index);
	  //         cur_char;
	  //fprintf(stderr,"  %d\n",(int)cur_bl_index);
	  //fprintf(stderr," %d\n",(int)cur_bl->font);
	  while(1)
	    {
	      if(cur_par_index+1>=paragrafs.count())break;
	      if(paragrafs.item(cur_par_index+1)->Start()>cur_char)break;
	      cur_par_index++;
	    } 
	  cur_par=paragrafs.item(cur_par_index);
	  //  'paragraf'       cur_char;
	  if(l->start==cur_char)
	    {
//	      cur_align=cur_bl->align;
	      cur_align=cur_par->Align();
	      l->w+=cur_bl->font->font_width()*4*cur_bl->indent_left;
	      l->w+=cur_bl->font->font_width()*4*cur_bl->indent_right;
	      if(l->w>(W-W/5))l->w=0;
	    }
	  else
	    {
//	      if(cur_align!=cur_bl->align)
	      if(cur_align!=cur_par->Align())
		{
		  fprintf(stderr,"Attention !!! It's impossible (1)\n");
		  break;
		}
	    }
	  char_cur_char=text.item(cur_char);
	  if(char_cur_char=='\n')
	    {
	      /*	      cur_bl->font->font_ext(l->w,l->h);
			      cur_char++;
			      break;
	      */
	      char_cur_char=' ';
	      is_new_line=1;
	    }
	  c_w=cur_bl->font->char_width(char_cur_char);
	  //	  fprintf(stderr,"\n");
	  if(l->w+c_w>=W)
	    {
	      long tmp=cur_char;
	      while(tmp>l->start)
		{
		  if(isspace(text.item(tmp)))break;
		  tmp--;
		}
	      if(
		 ((tmp+1)<=cur_char) &&
		 (tmp>l->start)
		 )tmp++;
	      if(tmp>l->start)
		{
		  cur_char=tmp;
		  while(1)
		    {
		      if(cur_bl_index-1<0)break;
		      if(blocks.item(cur_bl_index)->start<=cur_char)break;
		      cur_bl_index--;
		    } 
		  cur_bl=blocks.item(cur_bl_index);
		  //         cur_char;		  
		}
	      break;
	    }
	  l->w+=c_w;
	  
	  if(l->asc<cur_bl->font->font_ascent())
	    l->asc=cur_bl->font->font_ascent();
	  
	  if(l->desc<cur_bl->font->font_descent())
	    l->desc=cur_bl->font->font_descent();
	  
	  cur_char++;
	  if(cur_char>=max_char)break;
	  if(is_new_line)break;
	  /*	  if(text.item(cur_char)=='\n')
		  {
		  cur_char++;
		  break;
	    }*/
	}
      l->h=l->asc+l->desc;
      lines.insert(insert_pos,l);
      insert_pos++;
    }
  //  fprintf(stderr,"End U\n");
  
}
  



void umtGRTFEditorImpl::ProcessEvent(const Event& e)
{
  //  fprintf(stderr,"Event\n");
  RTFCommand cmd;
  char       c;
  
  //  fprintf(stderr,"Event type ");
  switch(e.type())
    {
    case Event::undefined:
      //      fprintf(stderr,"undefined ");
      break;
    case Event::motion:
      //      fprintf(stderr,"motion ");
      //      fprintf(stderr," coord %d %d ",(int)e.pointer_x(),(int)e.pointer_y());
      if(grab_handler!=nil)
	{
	  long t=EventToIndex(e);
	  //	  fprintf(stderr,"Grabbed !!!!");
	  if(t!=cur_cursor_pos)
	    if((t>=0) && (t<text.count()))
	      {
		is_mark_mode=true;
		cur_cursor_pos=t;
		SetUserX();
		mark_end=t;
		ScrollToCursor();
		Redraw();
		UpdateInterface();
	      }
	}
      break;
    case Event::down:
      //      fprintf(stderr,"down ");
      {
	long t=EventToIndex(e);
	if(e.pointer_button()==Event::left)
	  {
	    //	    fprintf(stderr," Left ");
	    if(t!=cur_cursor_pos)
	      if((t>=0) && (t<text.count()))
		{
/*
		  if(
		     ((t+1)<text.count()) &&
		     (text.item(t+1)!='\n')
		     )
		    {
		      long q=CharLineNumber(t+1);
		      if(
			 (q>=0) &&
			 (q<lines.count()) &&
			 ((t+1)==lines.item(q)->start)
			 )t++;			
		    }
*/
		  cur_cursor_pos=t;
		  SetUserX();
		  if(grab_handler==nil)
		    {
		      grab_handler=e.handler();
		      e.grab(grab_handler);
		      //		      fprintf(stderr,"Grab !!!");
		      mark_start=t;
		      mark_end=t;
		      is_mark_mode=false;
		    }
		  Redraw();
		  UpdateInterface();
		}
	    
	  }
	else
	  {
	    if(e.pointer_button()==Event::right)
	      {
		//		fprintf(stderr," Right ");
		if((t>=0) && (t<text.count()))
		  {
		    delete current_block;
		    current_block=new
		      umtGRTFBlock
		      (*blocks.item(CharBlockNumber(t)));
		    current_block->start=0;
		    UpdateInterface();
		  }
	      }
	    else
	      {
		if(
		   (t>=0) && (t<text.count()) &&
		   (e.pointer_button()==Event::middle) &&
		   (IsEditable==true)
		   )
		  {
		    /*		    if(t+1<text.count())
				    FetchBuf(t+1);
				    else*/
		      FetchBuf(t);
		      UpdateInterface();
		  }
	      }
	  }
      }
      break;
    case Event::up:
      //      fprintf(stderr,"up ");
      if(grab_handler!=nil)
	{
	  e.ungrab(grab_handler);
	  grab_handler=nil;
	  //	  fprintf(stderr,"UnGrab !!!");
	  NotifyText();
	  UpdateInterface();
	}
     break;
    case Event::key:
      if(text.count()==0)break;
      //      fprintf(stderr,"key ");
      cmd=FindKey(e,c);
      if(cmd==RtfUNKNOWN)
	{
	  if((IsEditable==true)&&(c!=0))
	    {
/*	      fprintf(stderr," Char :>%c< ",c);
	      fprintf(stderr," Transl %d :>%c< \n",
		      (int)current_keyboard_index,
		      Keyboards.item(current_keyboard_index)->TranslateKey(c)
);*/
	      UnMark();
	      is_mark_mode=false;
	      InsertChar(
			 cur_cursor_pos,
			 Keyboards.item(current_keyboard_index)->TranslateKey(c)
			 //c
			 );
	      cur_cursor_pos++;
	      ScrollToCursor();
	      SetUserX();
	      Redraw();
	      UpdateInterface();
	    }
	  //	  else
	    //	    fprintf(stderr," No char ");
	}
      else
	{
	  ProcessCommand(cmd,c);
	  ScrollToCursor();
	  Redraw();
	}
      break;
    case Event::other_event:
      //      fprintf(stderr,"other_event ");
      break;
    }

  //  fprintf(stderr,"\n");  
}

void umtGRTFEditorImpl::ProcessCommand (RTFCommand cmd,long param)
{
  if(text.count()==0)return;
  long cursor_line=CharLineNumber(cur_cursor_pos);
  //  fprintf(stderr," Command :>%d< >%d<",(int)cmd,(int)cursor_line);
  switch(cmd)
    {
      // Cursor movement ;
    case RTFLeft :if(cur_cursor_pos>0)cur_cursor_pos--;
      SetUserX();
      break;
      
    case RTFRight:if(cur_cursor_pos+1<text.count())cur_cursor_pos++;
      SetUserX();
      break;
      
    case RTFUp:
      if(IsEditable==true)
	{
	  if(cursor_line>0)
	    SetCursorPos(cursor_line-1,user_x);
	}
      else
	{
	  if(cur_line_start>0)
	    {
	      cur_line_start--;
	      cur_line_count=CalcCurLineCount();
//	      CursorToScroll();
              SetCursorPos(cur_line_start,user_x);
	    }
	}
      break;
      
    case RTFDown:
      if(IsEditable==true)
	{
	  if(cursor_line+1<lines.count())
	    SetCursorPos(cursor_line+1,user_x);
	}
      else
	{
	  if(cur_line_start+cur_line_count<lines.count())
	    {
	      cur_line_start++;
	      cur_line_count=CalcCurLineCount();
	      if(cur_line_start+2<lines.count())
		SetCursorPos(cur_line_start+2,user_x);
//	      CursorToScroll();
	    }
	}
      break;
      
    case RTFHome:
      if(cursor_line>0)
	cur_cursor_pos=lines.item(cursor_line)->start;
      else
	cur_cursor_pos=0;
      SetUserX();
      break;
      
    case RTFEnd:
      if(cursor_line+1<lines.count())
	cur_cursor_pos=lines.item(cursor_line+1)->start-1;
      else
	cur_cursor_pos=text.count()-1;
      SetUserX();
      break;
      
    case RTFEndOfText:
      cur_cursor_pos=text.count()-1;
      SetUserX();
      break;
      
    case RTFStartOfText:
      cur_cursor_pos=0;
      SetUserX();
      break;
      
    case RTFPageUp:
      {
	long old_line_start=cur_line_start;
	while(
	      (cur_line_start>0) &&
	      (cur_line_start+cur_line_count>old_line_start)
	      )
	  {
	    cur_line_start--;
	    cur_line_count=CalcCurLineCount();
	  }
	if(cur_line_start==0)
	  SetCursorPos(0,user_x);
	else
	  SetCursorPos(cur_line_start+cur_line_count,user_x);
      }
      break;
      
    case RTFPageDown:
      if(cur_line_start+cur_line_count<lines.count())
	{
	  cur_line_start+=cur_line_count;
	  cur_line_count =CalcCurLineCount();
	  SetCursorPos(cur_line_start,user_x);
	}
      else
	{
	  /* cur_line_start=lines.count()-1;
	  cur_line_count=CalcCurLineCount();*/
	  SetCursorPos(lines.count()-1,user_x);
	  ScrollToCursor();
	}
      break;
      
    case RTFPreviousWord:
      if(cur_cursor_pos>0)cur_cursor_pos--;
      while(
	    (cur_cursor_pos>0) &&
	    (isspace(text.item(cur_cursor_pos)))
	    )cur_cursor_pos--;
      while(
	    (cur_cursor_pos>0) &&
	    (!isspace(text.item(cur_cursor_pos)))
	    )cur_cursor_pos--;
      if(
	 (cur_cursor_pos!=0) &&
	 (cur_cursor_pos+1<text.count())
	 )cur_cursor_pos++;
      SetUserX();
      break;

    case RTFNextWord:
      if(cur_cursor_pos+1<text.count())cur_cursor_pos++;
      while(
	    (cur_cursor_pos+1<text.count()) &&
	    (isspace(text.item(cur_cursor_pos)))
	    )cur_cursor_pos++;
      while(
	    (cur_cursor_pos+1<text.count()) &&
	    (!isspace(text.item(cur_cursor_pos)))
	    )cur_cursor_pos++;
      //	      if(cur_cursor_pos>0)cur_cursor_pos--;
      SetUserX();
      break;
      // Text manipulations;
    case RTFSearch:
      if(last_canvas!=nil)
	{
	  if(search_dialog==nil)
	    Resource::ref(search_dialog=new umtSearchDialog());
	  if( search_dialog->post_for(last_canvas->rep()->window_) == true )
	    {
	      //Ok
	      //fprintf(stderr," %s  %d\n",(char*)search_dialog->data,(int)search_dialog->is_back);
	      ProcessSearch(
			    (char*)search_dialog->data,
			    search_dialog->is_back?false:true,
			    search_dialog->is_case_sens?true:false
			    );
	    }
	}
      break;
    case RTFRepeatSearchForward:
      if(search_dialog==nil)break;
      ProcessSearch(
		    (char*)search_dialog->data,
		    true,
		    search_dialog->is_case_sens?true:false
		      );
      break;
    case RTFRepeatSearchBackward:
      if(search_dialog==nil)break;
      ProcessSearch(
		    (char*)search_dialog->data,
		    false,
		    search_dialog->is_case_sens?true:false
		    );
      break;
    case RTFRepeatLastSearch:
      if(search_dialog==nil)break;
      ProcessSearch(
		    (char*)search_dialog->data,
		    search_dialog->is_back?false:true,
		    search_dialog->is_case_sens?true:false
		    );
      break;
    case RTFStartMarking:
      is_mark_mode=true;
      mark_start=cur_cursor_pos;
      break;
    case RTFCopyToBuffer:
      is_mark_mode=false;
      NotifyText();
      break;
    }
  
  if(IsEditable==true)
    switch(cmd)
      {
      case RTFDelete:
	DeleteText(cur_cursor_pos,1);
	if(cur_cursor_pos>=text.count())
	  cur_cursor_pos=text.count()-1;
	SetUserX();
	      UnMark();
	is_mark_mode=false;
	break;
	
      case RTFBackSpace:
	if(cur_cursor_pos>0)
	  {
	  cur_cursor_pos--;
	  DeleteText(cur_cursor_pos,1);
	  SetUserX();
	  }
	      UnMark();
	is_mark_mode=false;
	break;
	
      case RTFDeletePreviousWord:
	if(cur_cursor_pos>0)
	{
	  long count=0;
	  if(cur_cursor_pos>0)cur_cursor_pos--;
	  while(
		(cur_cursor_pos>=0) &&
		(isspace(text.item(cur_cursor_pos)))
		){cur_cursor_pos--;count++;}
	  while(
		(cur_cursor_pos>=0) &&
		(!isspace(text.item(cur_cursor_pos)))
		){cur_cursor_pos--;count++;}
	  if(cur_cursor_pos+1<text.count())cur_cursor_pos++;
	  if(cur_cursor_pos<0)cur_cursor_pos=0;
	  UnMark();
	  NotifyText(cur_cursor_pos,cur_cursor_pos+count);
	  DeleteText(cur_cursor_pos,count);
	  SetUserX();
          is_mark_mode=false;
	}
	break;
	
      case RTFDeleteNextWord:
	{
	  long new_pos=cur_cursor_pos;
	  long count=0;
	  
	  if(new_pos+1<text.count())
	    {
	      new_pos++;
	      count++;
	    }
	  
	  while(
		(new_pos+1<text.count()) &&
		(isspace(text.item(new_pos)))
		){new_pos++;count++;}
	  while(
		(new_pos+1<text.count()) &&
		(!isspace(text.item(new_pos)))
		){new_pos++;count++;}
	  UnMark();
	  NotifyText(cur_cursor_pos,cur_cursor_pos+count);
	  DeleteText(cur_cursor_pos,count);
	  SetUserX();
	  is_mark_mode=false;
	}
	break;

      case RTFRemoveBlock:
	if(mark_start!=mark_end)
	  {
	    long s,e;

	    NotifyText();

	    if(mark_start<mark_end)
	      {
		s=mark_start;
		e=mark_end;
	      }
	    else
	      {
		e=mark_start;
		s=mark_end;
	      }	    
	    DeleteText(s,e-s);
	    cur_cursor_pos=s;
	    SetUserX();
	  }
	break;

      case RTFDeleteToEOL:
	{
	  long e=cur_cursor_pos;

	  if(cursor_line+1<lines.count())
	    e=lines.item(cursor_line+1)->start-1;
	  else
	    e=text.count()-1;

	  UnMark();
	  NotifyText(
		     cur_cursor_pos,
		     cur_cursor_pos+((e==cur_cursor_pos)?1:(e-cur_cursor_pos))
		     );

	  DeleteText(cur_cursor_pos,(e==cur_cursor_pos)?1:(e-cur_cursor_pos));
	  SetUserX();
	  is_mark_mode=false;
	}
	break;

      case RTFNewLine:
	InsertChar(cur_cursor_pos,'\n');
	cur_cursor_pos++;
	      UnMark();
	is_mark_mode=false;
	break;
	
      case RTFSpace:
	InsertChar(cur_cursor_pos,' ');
	cur_cursor_pos++;
	      UnMark();
	is_mark_mode=false;
	break;
	
      case RtfBold:
	if((current_block->font_style&RTFFONT_Bold)==RTFFONT_Bold)
	  current_block->font_style&=~RTFFONT_Bold;
	else
	  current_block->font_style|=RTFFONT_Bold;
	break;
      case RtfItalic:
	if((current_block->font_style&RTFFONT_Italic)==RTFFONT_Italic)
	  current_block->font_style&=~RTFFONT_Italic;
	else
	  current_block->font_style|=RTFFONT_Italic;  
	break;
      case RtfFixed:
	if((current_block->font_style&RTFFONT_Fixed)==RTFFONT_Fixed)
	  current_block->font_style&=~RTFFONT_Fixed;
	else
	  current_block->font_style|=RTFFONT_Fixed;  
	break;
      case RtfUnderLine:
	if((current_block->font_style&RTFFONT_UnderLine)==RTFFONT_UnderLine)
	  current_block->font_style&=~RTFFONT_UnderLine;
	else
	  current_block->font_style|=RTFFONT_UnderLine;  
	break;
      case RtfBigger:
	if(current_block->char_size<10)
	  current_block->char_size++;      
	break;
      case RtfBiggerOFF:
	if(current_block->char_size>-10)
	  current_block->char_size--;
	break;
/*
      case RtfCenter:
	current_block->align=cmd;
	break;
      case RtfFlushLeft:
	current_block->align=cmd;
	break;
      case RtfFlushRight:
	current_block->align=cmd;
	break;
*/
      case RtfCenter:
      case RtfFlushLeft:
      case RtfFlushRight:
	{
	  long t=CharParagrafNumber(cur_cursor_pos);
//	  fprintf(stderr,"Cmd %d\n",(int)cmd);
	  if(
	     (t>=0) &&
	     (t<paragrafs.count())
	     )
	    {
	      paragrafs.item(t)->Align(cmd);
	      UpdateLines
		(
		 CharLineNumber(paragrafs.item(t)->Start()),
		 ((t+1)<paragrafs.count())?
		 CharLineNumber(paragrafs.item(t+1)->Start()):
		 lines.count()
		 );
//	      current_block->align=cmd;
	    }
	}
	break;

      case RtfIndent:
	if(current_block->indent_left<10)
	  current_block->indent_left++;
	break;
      case RtfIndentOFF:
	if(current_block->indent_left>0)
	  current_block->indent_left--;
	break;
      case RtfIndentRight:
	if(current_block->indent_right<10)
	  current_block->indent_right++;
	break;
      case RtfIndentRightOFF:
	if(current_block->indent_right>0)
	  current_block->indent_right--;
	break;
      case RtfX_Color:
	if(last_canvas!=nil)
	{
	  umtColorDialog  *color_dialog;
	  color_dialog = new umtColorDialog
	    ((current_block==nil)?"#000000":
	     ((current_block->color==nil)?"#000000":current_block->color->name()));
	  Resource::ref(color_dialog);
	  if(color_dialog->post_for(last_canvas->rep()->window_)==true)
	    {
	      if(color_dialog->is_default_pressed)
		current_block->color=DefaultColor();
	      else
		current_block->color=FindColor(color_dialog->GetCurName());
	    }
	  current_block->color->Update(last_canvas);
	  Resource::unref(color_dialog);
	}
	break;
      case RTFSelectKeyboard:
	if(current_keyboard_index==param)
	  current_keyboard_index=0;
	else
	  current_keyboard_index=param;
	break;
      case RTFPasteBuffer:
	FetchBuf(cur_cursor_pos);	
	break;
      case RTFCutToBuffer:
        is_mark_mode=false;
        NotifyText();
	ProcessCommand(RTFRemoveBlock);
        break;
      }
  if(is_mark_mode==true)
    mark_end=cur_cursor_pos;

  current_block->font=FindFont(current_block->font_style,current_block->char_size);
  UpdateInterface();

}

void umtGRTFEditorImpl::ProcessSearch
(char *str,
 boolean is_forward,
 boolean is_case_sensitive
 )
{
  long pos;
  long s_ln,i;
  
  if(str==nil)return;
  if(strlen(str)==0)return;

  s_ln=strlen(str);
  if(is_forward==true)
    {
      pos=cur_cursor_pos+1;
      if(pos+s_ln>=text.count())return;

      for( ; pos+s_ln<text.count() ; pos++ )
	{
	  for( i=0 ; i<s_ln ; i++ )
	    if(is_case_sensitive==true)
	      {
		if( str[i]!=text.item(pos+i) )break;
	      }
	    else
	      if( tolower(str[i])!=tolower(text.item(pos+i)) )break;
	  if(i==s_ln)
	    {
	      cur_cursor_pos=pos;
	      ScrollToCursor();
	      mark_start=pos;
	      mark_end=pos+s_ln;
	      Redraw();
	      return;
	    }
	}
    }
  else
    {
      pos=cur_cursor_pos-1;
      if(pos<0)return;
      
      if(pos+s_ln>=text.count())
       pos=text.count()-s_ln-1;
	
      if(pos<0)return;

      for( ; pos>=0 ; pos-- )
	{
	  for( i=0 ; i<s_ln ; i++ )
	    if(is_case_sensitive==true)
	      {
		if( str[i]!=text.item(pos+i) )break;
	      }
	    else
	      if( tolower(str[i])!=tolower(text.item(pos+i)) )break;
	  if(i==s_ln)
	    {
	      cur_cursor_pos=pos;
	      ScrollToCursor();
	      mark_start=pos;
	      mark_end=pos+s_ln;
	      Redraw();
	      return;
	    }	    
	}
    }
}

void umtGRTFEditorImpl::DeleteText(long start,long count)
{
  long i;
  long s_line,e_line;
  
  if(count==0)return;
  if(start>=text.count())return;
  if(start+count>text.count())count=text.count()-start;


  //   'paragrafs',    
  for( i=CharParagrafNumber(start) ; i<paragrafs.count() ; i++ )
    {
      if(paragrafs.item(i)->Start()<start)continue;
      if(paragrafs.item(i)->Start()>start+count)break;
      if(
	 (i+1<paragrafs.count()) &&
	 (paragrafs.item(i+1)->Start()<=start+count)
	 )
	{
	  delete paragrafs.item(i);
	  paragrafs.remove(i);
	  i--;
	}
    }
  //  'paragrafs'   start+count    count
  for( i=CharParagrafNumber(start) ; i<paragrafs.count() ; i++ )
    {
      if(paragrafs.item(i)->Start()<start)continue;
      if(paragrafs.item(i)->Start()>start+count)
	paragrafs.item(i)->Start(paragrafs.item(i)->Start()-count);
      else
	paragrafs.item(i)->Start(start);
    }
  

  //   ,    
  for( i=CharBlockNumber(start) ; i<blocks.count() ; i++ )
    {
      if(blocks.item(i)->start<start)continue;
      if(blocks.item(i)->start>start+count)break;
      if(
	 (i+1<blocks.count()) &&
	 (blocks.item(i+1)->start<=start+count)
	 )
	{
	  delete blocks.item(i);
	  blocks.remove(i);
	  i--;
	}
    }
  //     start+count    count
  for( i=CharBlockNumber(start) ; i<blocks.count() ; i++ )
    {
      if(blocks.item(i)->start<start)continue;
      if(blocks.item(i)->start>start+count)
	blocks.item(i)->start-=count;
      else
	blocks.item(i)->start=start;
    }

  {
    int co=0;

    //   -  ;
    for( i=start  ; i>0 ; i-- )
      {
	if(text.item(i)=='\n')co++;
	if(co>1)break;
      }
    s_line=CharLineNumber(i);
    
    //   -  ;
    for( i=start+count,co=0 ; i<text.count() ; i++ )
      {
	if(text.item(i)=='\n')co++;
	if(co>1)
	  {
	    i++;
	    break;
	  }
      }
    e_line=CharLineNumber(i);
    //     e_line    count;
    for( i=e_line ; i<lines.count() ; i++ )
      if(e_line!=0)
	lines.item(i)->start-=count;
  }

  
  for( i=0 ; i<count ; i++ )
    text.remove(start);

  if(text.count()==0)
    {
      text.append('\n');
      paragrafs.append(new umtGRTFParagraf(text.count()-1));
    }
  if(text.item(text.count()-1)!='\n')
    {
      text.append('\n');
      paragrafs.append(new umtGRTFParagraf(text.count()-1));
    }

/*
  // If last simbol of start paragraf not equal '\n',
  // remove next paragraf
  i=CharParagrafNumber(start);
  if(
     (start>=0) &&
     (start<text.count()) &&
     (i>=0) &&
     (i+1<paragrafs.count()) &&
     (text.item(paragrafs.item(i+1)->Start()-1)!='\n')
     )
    {
      delete paragrafs.item(i+1);
      paragrafs.remove(i+1);
    }
*/
  FlushParagrafs();
  FlushBlocks();
  UpdateLines((s_line>0)?(s_line-1):s_line,((e_line+4)>lines.count())?lines.count():e_line);
  if(cur_cursor_pos>=text.count())
    cur_cursor_pos=text.count()-1;

  if(mark_start!=mark_end)
    {
      if(mark_start>=start)
	{
	  if(mark_start>start+count)
	    mark_start-=count;
	  else
	    mark_start=start;
	}
      if(mark_end>=start)
	{
	  if(mark_end>start+count)
	    mark_end-=count;
	  else
	    mark_end=start;
	}
    }
}

void umtGRTFEditorImpl::UnMark(void)
{
  if(grab_handler==nil)
    mark_start=mark_end=0;
}

void umtGRTFEditorImpl::FlushBlocks(void)
{
  long i;
  umtGRTFBlock *a,*b;

  for( i=0 ; i<blocks.count()-1 ; i++ )
    {
      a=blocks.item(i);
      b=blocks.item(i+1);
      
      if(
	 (a->indent_left   ==b->indent_left   ) &&
	 (a->indent_right  ==b->indent_right  ) &&
	 (a->char_size     ==b->char_size     ) &&
//	 (a->align         ==b->align         ) &&
	 (a->font_style    ==b->font_style    ) &&
	 (a->color         ==b->color         )
	 )
	{
	  delete blocks.item(i+1);
	  blocks.remove(i+1);
	  i--;
	}      
    }
}

void umtGRTFEditorImpl::FlushParagrafs(void)
{
  long i;
  umtGRTFParagraf *a,*b;

/*  fprintf(stderr,"\n\nFlushPar %d\n",(int)text.count());
  for( i=0 ; i<paragrafs.count() ; i++ )
    fprintf(stderr,"%d(%d)  ",
	    (int)paragrafs.item(i)->Start(),
	    (int)paragrafs.item(i)->Align()
	    );
  fprintf(stderr,"\n");
 */
  for( i=0 ; i<paragrafs.count()-1 ; i++ )
    {
      a=paragrafs.item(i);
      b=paragrafs.item(i+1);
      
      if(
//	 (a->align         ==b->align         ) 
	 (
	  (b->Start()>0) &&
	  (text.item(b->Start()-1)!='\n')
	  ) ||
	 (b->Start()==a->Start())
	 )
	{
	/*  fprintf(stderr,"Rem:%d(%d)  ",
		  (int)paragrafs.item(i+1)->Start(),
		  (int)paragrafs.item(i+1)->Align()
		  );*/
	  delete paragrafs.item(i+1);
	  paragrafs.remove(i+1);
	  i--;
	}      
    }
//  fprintf(stderr,"\n");
}

void umtGRTFEditorImpl::Prepare(void)
{
    
}

void umtGRTFEditorImpl::NotifyText(long start,long end)
{
  long   s,e,i;
  char   *t;
  
  if(
     (start==-1) ||
     (end  ==-1)
     )
    {
      start=mark_start;
      end  =mark_end;
    }

  if(start==end)return;
  if(start<end)
    {
      s=start;
      e=end;
    }
  else
    {
      e=start;
      s=end;
    }

  if(e>=text.count())e=text.count()-1;

  t=new char[e-s+10];
  for( i=s ; i<e ; i++ )
    t[i-s]=(char)text.item(i);
  t[i-s]=0;
  //  fprintf(stderr,"Store >%s<\n",t);
  XStoreBytes(session_->default_display()->rep()->display_,t,strlen(t));
  delete t;
  ClearLastBuffer();

  {
    long cur_bl,n_bl;
    unsigned char cur_char;
    cur_bl=CharBlockNumber(s);

    last_bl_blc.append(new umtGRTFBlock(*blocks.item(cur_bl)));
    last_bl_blc.item(0)->start=0;
    for( i=s ; i<e ; i++ )
      {
	cur_char=text.item(i);
	n_bl=cur_bl;
	while(1)
	  {
	    if(n_bl+1>=blocks.count())break;
	    if(blocks.item(n_bl+1)->start>i)break;
	    n_bl++;
	  } 
	//         i;
	if(cur_bl!=n_bl)
	  {
	    cur_bl=n_bl;
	    last_bl_blc.append(new umtGRTFBlock(*blocks.item(cur_bl)));
	    last_bl_blc.item(last_bl_blc.count()-1)->start=i-s;
	  }
	last_bl_txt.append(text.item(i));
      }
  }


  {
    long cur_par,n_par;
    unsigned char cur_char;
    cur_par=CharParagrafNumber(s);

    last_bl_par.append(new umtGRTFParagraf(*paragrafs.item(cur_par)));
    last_bl_par.item(0)->Start(0);
    for( i=s ; i<e ; i++ )
      {
	cur_char=text.item(i);
	n_par=cur_par;
	while(1)
	  {
	    if(n_par+1>=paragrafs.count())break;
	    if(paragrafs.item(n_par+1)->Start()>i)break;
	    n_par++;
	  } 
	//  'paragraf'       i;
	if(cur_par!=n_par)
	  {
	    cur_par=n_par;
	    last_bl_par.append(new umtGRTFParagraf(*paragrafs.item(cur_par)));
	    last_bl_par.item(last_bl_par.count()-1)->Start(i-s);
	  }
      }
  }
}


void umtGRTFEditorImpl::FetchBuf(long start)
{
  char *ret;
  long j;
  int n;
  
  UCharsArray    txt;
  RTFBlocksArray blc;
  RTFParagrafsArray par;
  long cur_par_start=0;

  

  if((ret=XFetchBytes(session_->default_display()->rep()->display_,&n))!=NULL)
    {
      //  fprintf(stderr,"\n buffer %d\n",(int)i);      
      if(n!=0)
	{
	  j=-1;
	  if(n==last_bl_txt.count())
	    for( j=0 ; j<n ; j++ )
	      if( last_bl_txt.item(j)!= ret[j] )break;

	  if(
	     (j==n) &&
	     (n==last_bl_txt.count())
	     )
	    {
//	      RTFParagrafsArray last_bl_par;
	      InsertText(start,last_bl_txt,last_bl_blc,last_bl_par);
	      cur_cursor_pos=start+last_bl_txt.count();
	      ScrollToCursor();
	      Redraw();
	    }
	  else
	    {
	      blc.append(new umtGRTFBlock(*current_block));
	      blc.item(0)->start=0;
	      par.append(new umtGRTFParagraf(cur_par_start));
	      for( j=0 ; j<n ; j++ )
		{
		  txt.append(ret[j]);
		  if(ret[j]=='\n')
		    {
		      par.append(new umtGRTFParagraf(txt.count()/*cur_par_start*/));
		      cur_par_start=j+1;
		    }
		}
		  //  fprintf(stderr,"%c",ret[j]);
	      
//	      par.append(new umtGRTFParagraf(txt.count()));

	      InsertText(start,txt,blc,par);
	      cur_cursor_pos=start+txt.count();
	      ScrollToCursor();
	      Redraw();
	      delete blc.item(0);
	      blc.remove_all();
	      for( j=0 ; j<par.count() ; j++ )
		delete par.item(j);
	      par.remove_all();
	      txt.remove_all();
	    }
	  //fprintf(stderr,"\n");
	}
      XFree(ret);
    }
}

void umtGRTFEditorImpl::InsertText(long start,
				   UCharsArray &txt,
				   RTFBlocksArray &blk,
				   RTFParagrafsArray &par
				   )
{
  long start_bl_index=CharBlockNumber(start);
  long i;
  long s_line,e_line; 
  RTFCommand  cur_algn;
  long start_pr_index=CharParagrafNumber(start);

  //  fprintf(stderr,"I Start\n");
  if(txt.count()==0)return;
  if(blk.count()==0)return;
  
  //       ;
  //    ;
  if(blocks.count()!=0)
  if(blocks.item(start_bl_index)->start<start)
    {
      blocks.insert
	(start_bl_index+1,
	 new umtGRTFBlock(*blocks.item(start_bl_index))
	 );
      blocks.item(start_bl_index+1)->start=start;
      start_bl_index++;
    }
  //    ;  
  for( i=0 ; i<blocks.count() ; i++ )
    if(blocks.item(i)->start>=start)
      blocks.item(i)->start+=txt.count();

  //   ;
  for( i=blk.count()-1 ; i>=0 ; i-- )
    {
      blocks.insert
	(start_bl_index,
	 new umtGRTFBlock(*blk.item(i))
	 );
      blocks.item(start_bl_index)->start+=start;
    }


  {
    int co=0;

    //   -  ;
    for( i=start ; i>0 ; i-- )
      {
	if(text.item(i)=='\n')co++;
	if(co>1)break;
      }
    s_line=CharLineNumber(i);
    
    //   -  ;
    for( i=start,co=0 ; i<text.count() ; i++ )
      {
	if(text.item(i)=='\n')co++;
	if(co>1)
	  {
	    i++;
	    break;
	  }
      }
    e_line=CharLineNumber(i);
    //     e_line    count;
    for( i=e_line ; i<lines.count() ; i++ )
      lines.item(i)->start+=txt.count();
  }

  if(paragrafs.count()>0)
    cur_algn=paragrafs.item(start_pr_index)->Align();
  else
    cur_algn=RtfFlushLeft;
  //   'paragrafs';  
  for( i=0 ; i<paragrafs.count() ; i++ )
    if(paragrafs.item(i)->Start()>=start)
      paragrafs.item(i)->Start(paragrafs.item(i)->Start()+txt.count());
  //  'paragrafs';
/*
  if(start_pr_index<paragrafs.count())
    start_pr_index++;
*/
  if(
     (start_pr_index<paragrafs.count()) &&
     (paragrafs.item(start_pr_index)->Start()<start) &&
     (start<text.count())
     )
    start_pr_index++;

  for( i=par.count()-1 ; i>=0 ; i-- )
    {
      paragrafs.insert
	(start_pr_index,
	 new umtGRTFParagraf(*par.item(i))
	 );
      paragrafs.item(start_pr_index)->Start(par.item(i)->Start()+start);
    }
  if(paragrafs.count()==0)
    paragrafs.append(new umtGRTFParagraf());
  
  //   ;
  for( i=txt.count()-1 ; i>=0 ; i-- )
    text.insert(start,txt.item(i));

  if(text.item(text.count()-1)!='\n')
    {
      text.append('\n');
      paragrafs.append(new umtGRTFParagraf(text.count()-1));
    }

  FlushParagrafs();
  FlushBlocks();
  if(s_line!=e_line)
    {
      if(e_line+4>lines.count())
	e_line=lines.count();
      UpdateLines(s_line,e_line);
    }
  else
    UpdateLines();

  if(mark_start!=mark_end)
    {
      if(mark_start>=start)
	mark_start+=txt.count();
      if(mark_end>start)
	mark_end+=txt.count();
    }
}

void umtGRTFEditorImpl::InsertChar(long pos,long ch)
{
  UCharsArray    txt;
  RTFBlocksArray blk;
  RTFParagrafsArray par;

  txt.append((unsigned char)ch);
  blk.append(new umtGRTFBlock(*current_block));
  blk.item(0)->start=0;

  par.append(new umtGRTFParagraf(0,paragrafs.item(CharParagrafNumber(pos))->Align()));
  par.append(new umtGRTFParagraf(1,paragrafs.item(CharParagrafNumber(pos))->Align()));

  InsertText(pos,txt,blk,par);

  delete par.item(0);
  delete par.item(1);
  par.remove_all();
  delete blk.item(0);
  blk.remove_all();
  txt.remove_all();
}

void umtGRTFEditorImpl::SetUserX(void)
{
  long line,x;
  
  GetCursorPos(line,x);
  //  fprintf(stderr,"User line(%d) x(%d)\n",(int)line,(int)x);
  user_x=x;
}

void umtGRTFEditorImpl::GetCursorPos(long &line ,long &x_pos) const
{
  long cur_char;
  unsigned char ch;
  
  line     =CharLineNumber(cur_cursor_pos);
  x_pos    =GetLineStartX (
			   lines.item    (line),
			   blocks.item   (CharBlockNumber   (cur_cursor_pos)),
			   paragrafs.item(CharParagrafNumber(cur_cursor_pos))
			   );
  cur_char =lines.item(line)->start;
  
  while(cur_char<cur_cursor_pos)
    {
      ch=text.item(cur_char);
      if(ch=='\n')ch=' ';
      x_pos+=blocks.item(CharBlockNumber(cur_char))->font->char_width(ch);
      cur_char++;
    }
  ch=text.item(cur_char);
  if(ch=='\n')ch=' ';
  x_pos+=blocks.item(CharBlockNumber(cur_char))->font->char_width(ch)/2;  
}

void umtGRTFEditorImpl::SetCursorPos(long line ,long x_pos)
{
  long x;
  long cur_char;
  unsigned char ch;


  
  cur_char =lines.item(line)->start;
  x=GetLineStartX(
		  lines.item    (line),
		  blocks.item   (CharBlockNumber   (cur_char)),
		  paragrafs.item(CharParagrafNumber(cur_char))
		  );

  //  fprintf(stderr,"cur_char %d curline %d xpos %d x %d\n",(int)cur_char,(int)line,(int)x_pos,(int)x);
  if(x>=x_pos)
    {
      cur_cursor_pos=cur_char;
      return;
    }

  for( ; cur_char<text.count() ; cur_char++ )
    {
      if(
	 (line+1<lines.count()) &&
	 (lines.item(line+1)->start<=cur_char)
	){cur_char--;break;}
      ch=text.item(cur_char);
      if(ch=='\n')ch=' ';
      x+=blocks.item(CharBlockNumber(cur_char))->font->char_width(ch);
      
      if(x>=x_pos)
	{
	  cur_cursor_pos=cur_char;
	  return;
	}
    }
  if(cur_char==text.count())
    cur_cursor_pos=text.count()-1;
  else
    cur_cursor_pos=cur_char;
}

long umtGRTFEditorImpl::CharLineNumber(long char_number) const
{
  long i;
  if(lines.count()==0)return 0;
  for( i=0 ; i<lines.count() ; i++ )
    if(
       (i+1<lines.count()) &&
       (lines.item(i+1)->start>char_number)
       )break;
  if(i==lines.count())return lines.count()-1;
  else
    return i;
}

long umtGRTFEditorImpl::CharBlockNumber(long char_number) const
{
  long i;
  if(blocks.count()==0)return 0;
  for( i=0 ; i<blocks.count() ; i++ )
    if(
       (i+1<blocks.count()) &&
       (blocks.item(i+1)->start>char_number)
       )break;
  if(i==blocks.count())return blocks.count()-1;
  else
    return i;
}

long umtGRTFEditorImpl::CharParagrafNumber(long char_number) const
{
  long i;
  if(paragrafs.count()==0)return 0;
  for( i=0 ; i<paragrafs.count() ; i++ )
    if(
       (i+1<paragrafs.count()) &&
       (paragrafs.item(i+1)->Start()>char_number)
       )break;
  if(i==paragrafs.count())return paragrafs.count()-1;
  else
    return i;
}

void umtGRTFEditorImpl::CursorToScroll(void)
{
  long l_num=CharLineNumber(cur_cursor_pos);

  if(lines.count()==0)return;
  if(cur_line_start>l_num)
    SetCursorPos(cur_line_start,user_x);
  else
    if(cur_line_start+cur_line_count<l_num)
      SetCursorPos(cur_line_start+cur_line_count-1,user_x);
}

void umtGRTFEditorImpl::ScrollToCursor(void)
{
/*
  long l_num=CharLineNumber(cur_cursor_pos);
  
  cur_line_count=CalcCurLineCount();
  
  if(
     (cur_line_start               <=l_num) &&
     (cur_line_start+cur_line_count> l_num)
     )return;
  if(cur_line_start>l_num)
    {
      cur_line_start=l_num;
      cur_line_count=CalcCurLineCount();
    }
  else
    {
      while(cur_line_start+cur_line_count<=l_num)
	{
	  cur_line_start++;
	  cur_line_count=CalcCurLineCount();
	}
    }
*/
  long l_num=CharLineNumber(cur_cursor_pos);
  
  cur_line_count=CalcCurLineCount();
  
  if(
     (cur_line_start               < l_num) &&
     (cur_line_start+cur_line_count> l_num)
     )return;
  if(cur_line_start>=l_num)
    {
      if(
	 (cur_line_start==l_num) &&
	 (l_num>0)
	 )l_num--;
      
      cur_line_start=l_num;
      cur_line_count=CalcCurLineCount();
    }
  else
    {
      while(cur_line_start+cur_line_count<=l_num)
	{
	  cur_line_start++;
	  cur_line_count=CalcCurLineCount();
	}
    }
}

long umtGRTFEditorImpl::EventToIndex(const Event& e)
{
  umtGRTFLine  *cur_line;
  umtGRTFBlock *cur_bl;
  long         cur_bl_index=0;
  umtGRTFParagraf *cur_par;
  long             cur_par_index=0;
  long px,py,x;
  long i,j;
  long Y=X_Top;//,X=X_Left;
  //  long        alloc_w=(long)(X_Right-X_Left);
  unsigned char char_j;
  long c_w;
  long CurS=cur_line_start;

  if(lines.count()<1)return 0;
  if(blocks.count()<1)return 0;
  py=last_canvas->rep()->pheight_-last_canvas->to_pixels(e.pointer_y());
  px=last_canvas->to_pixels(e.pointer_x());

  if(cur_line_start>0)
    {
      CurS--;
      Y-=lines.item(CurS)->h;
    }
  
  for( i=CurS ; i<lines.count() ; i++ )
    {
      if((Y+lines.item(i)->h)>py)break;
      if((Y+lines.item(i)->h)>X_Bottom)break;
      Y+=lines.item(i)->h;
    } //   (i);

    if(i>=lines.count())i=lines.count()-1;
    cur_line=lines.item(i);

    for( j=cur_line->start ; j<text.count() ; j++ )
      {
	if(
	   (i+1<lines.count()) &&
	   (lines.item(i+1)->start<=j)
	   )return j-1;
	
	while(1)
	  {
	    if(cur_bl_index+1>=blocks.count())break;
	    if(blocks.item(cur_bl_index+1)->start>j)break;
	    cur_bl_index++;
	  } 
	if(cur_bl_index>=blocks.count())
	  cur_bl_index=blocks.count()-1;
	cur_bl=blocks.item(cur_bl_index);
	//         j;
	//		fprintf(stderr,"BL=%d\n",(int)cur_bl);
	while(1)
	  {
	    if(cur_par_index+1>=paragrafs.count())break;
	    if(paragrafs.item(cur_par_index+1)->Start()>j)break;
	    cur_par_index++;
	  } 
	if(cur_par_index>=paragrafs.count())
	  cur_par_index=paragrafs.count()-1;
	cur_par=paragrafs.item(cur_par_index);
	//  'paragraf'       j;
	//		fprintf(stderr,"BL=%d\n",(int)cur_bl);
	if(j==cur_line->start)
	  {
	    x=GetLineStartX(cur_line,cur_bl,cur_par);
	    if(x>px)return j;
	  }
	char_j=text.item(j);
	if(char_j=='\n')char_j=' ';
	c_w=cur_bl->font->char_width(char_j);
	    	    
	if(x+c_w>px)return j;
	x+=c_w;
      }
    if(j>=text.count())j=text.count()-1;
    else
      j--;
    if(j>0)
      return j;
    else return 0;
}

long umtGRTFEditorImpl::GetLineStartX
(umtGRTFLine *line,umtGRTFBlock *block,umtGRTFParagraf *par) const
{
  long alloc_w=X_Right-X_Left;
  long l=(long)(block->font->font_width()*4*block->indent_left );
  long r=(long)(block->font->font_width()*4*block->indent_right);
  long ret;
  
  if(l+r>alloc_w-alloc_w/5)
    {
      switch(par->Align())
	{
	case RtfCenter        :
	  ret=(long)(((X_Right+X_Left)/2)-(line->w/2));
	  break;
	case RtfFlushRight    :
	  ret=(long)(X_Right-line->w);
	  break;
	default:
	case RtfFlushLeft     :
	case RtfFlushBoth     :
	  ret=(long)(X_Left);
	  break;			
	}
    }
  else
    {
      switch(par->Align())
	{
	case RtfCenter        :
	  ret=(long)(((X_Right+X_Left)/2)-(line->w/2))+l;
	  break;
	case RtfFlushRight    :
	  ret=(long)(X_Right-line->w+l);
	  break;
	default:
	case RtfFlushLeft     :
	case RtfFlushBoth     :
	  ret=(long)(X_Left+l);
	  break;			
	}
    }
  
  return ret;
}


umtGRTFEditorInpuHandler::umtGRTFEditorInpuHandler(umtGRTFEditorImpl  *Owner):
  InputHandler(Owner,WidgetKit::instance()->style())
{
  owner=Owner;
}
  
umtGRTFEditorInpuHandler::~umtGRTFEditorInpuHandler()
{
}

void umtGRTFEditorInpuHandler::move(const Event& e)
{
  owner->ProcessEvent(e);
}

void umtGRTFEditorInpuHandler::press(const Event& e)
{
  owner->ProcessEvent(e);
}

void umtGRTFEditorInpuHandler::drag(const Event& e)
{
  owner->ProcessEvent(e);
}

void umtGRTFEditorInpuHandler::release(const Event& e)
{
  owner->ProcessEvent(e);
}

void umtGRTFEditorInpuHandler::keystroke(const Event& e)
{
  owner->ProcessEvent(e);
}




implementList(UCharsArray       ,unsigned char);
implementList(IntArray          ,int          );
implementList(LongArray         ,long         );
implementList(RTFCommandsArray  ,RTFCommand   );
implementPtrList(StringArray    ,char         );






/*
void umtGRTFEditorImpl::Print(void)
{
  
  long i=0,j;
  umtGRTFBlock *cur_bl;
  long         cur_start,cur_end;
  char tmp[1024];

  for( i=0 ; i<blocks.count() ; i++ )
    {
      cur_bl=blocks.item(i);
      cur_start=cur_bl->start;
      if(i+1<blocks.count())
	cur_end=blocks.item(i+1)->start;
      else
	cur_end=text.count();
      
      
      if(cur_bl->char_size!=0)
	{
	  if(cur_bl->char_size>0)
	    {
	      if(!GetRtfCommandStr(RtfBigger,tmp))
		for( j=0 ; j<cur_bl->char_size ; j++ )
		  fprintf(stderr,tmp);
	    }
	  else
	    {
	      if(!GetRtfCommandStr(RtfSmaller,tmp))
		for( j=0 ; j>cur_bl->char_size ; j-- )
		  fprintf(stderr,tmp);
	    }
	}
      if((cur_bl->font_style | RTFFONT_Bold)==RTFFONT_Bold)
	{
	  if(!GetRtfCommandStr(RtfBold,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_Italic)==RTFFONT_Italic)
	{
	  if(!GetRtfCommandStr(RtfItalic,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_Fixed)==RTFFONT_Fixed)
	{
	  if(!GetRtfCommandStr(RtfFixed,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_UnderLine)==RTFFONT_UnderLine)
	{
	  if(!GetRtfCommandStr(RtfUnderLine,tmp))
	    fprintf(stderr,tmp);
	}


      
      for( j=cur_start ; j<cur_end ; j++ )
	fprintf(stderr,"%c",text.item(j));


      
      if((cur_bl->font_style | RTFFONT_Bold)==RTFFONT_Bold)
	{
	  if(!GetRtfCommandStr(RtfBoldOFF,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_Italic)==RTFFONT_Italic)
	{
	  if(!GetRtfCommandStr(RtfItalicOFF,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_Fixed)==RTFFONT_Fixed)
	{
	  if(!GetRtfCommandStr(RtfFixedOFF,tmp))
	    fprintf(stderr,tmp);
	}
      if((cur_bl->font_style | RTFFONT_UnderLine)==RTFFONT_UnderLine)
	{
	  if(!GetRtfCommandStr(RtfUnderLineOFF,tmp))
	    fprintf(stderr,tmp);
	}
      if(cur_bl->char_size!=0)
	{
	  if(cur_bl->char_size>0)
	    {
	      if(!GetRtfCommandStr(RtfBiggerOFF,tmp))
		for( j=0 ; j<cur_bl->char_size ; j++ )
		  fprintf(stderr,tmp);
	    }
	  else
	    {
	      if(!GetRtfCommandStr(RtfSmallerOFF,tmp))
		for( j=0 ; j>cur_bl->char_size ; j-- )
		  fprintf(stderr,tmp);
	    }
	}
		
    }
  
  fprintf(stderr,"\n");
}
*/
/*
class MK
{
public:
  MK(){};
  virtual ~MK(){};

  void conv(SelectionManager *m);
};

void MK::conv(SelectionManager *m)
{
  m=nil;
  fprintf(stderr,"Conv !!!\n");
}

declareSelectionCallback(MK)

MK tt;

void INIT_CL(    )
{
  SelectionManager *m=Session::instance()->default_display()->primary_selection();
  if(m==nil)
    {
      fprintf(stderr,"WWWWWWWWWWWW\n");
      return;
    }
  m->own(new SelectionCallback(MK)(&tt,MK::conv),
	 new SelectionCallback(MK)(&tt,MK::conv),
	 new SelectionCallback(MK)(&tt,MK::conv),
	 );
}

implementSelectionCallback(MK) 
*/








void umtGRTFEditorImpl::UpdateInterface(void)
{
  UpdateMenu();
  UpdateToolBar();
}



