
static int GetRtfCommand(char*);

int  umtGRTFEditorImpl::Load(
			     umtGRTFLoader     &f,
			     UCharsArray       &text,
			     RTFBlocksArray    &blocks,
			     RTFParagrafsArray &par
			     )
{
  int  c,nl=0,pc=0,nf=0,i;
  RTFCommand command;
  char cmd[70],*p;
  
  RTFCommandsArray commands;
  LongArray        commands_starts;

  StringArray      params;
  char cur_param[82];
  
  //  Clear();
  while((c=f.GetC())!=EOF)
    {
      if(c=='<') 
	{
	  if(nl==1)text.append(' ');
	  nl=0;
	  c=f.GetC();
	  if(c=='<')
	    {
	      if(pc<=0)text.append('<');
	    }
	  else
	    {
	      f.UnGetC(c);	      
	      for( i=0,p=cmd ; ((c=f.GetC())!=EOF) && (c!='>') ; i++ )
		{
		  if(i<int(sizeof(cmd)-1))
		    {
		      *p=isupper(c) ? tolower(c) : c;
		      p++;
		    }
		}
	      *p=0;
	      if(c==EOF)break;
	      command=GetRtfCommand(cmd);
	      switch(command)
		{
		case RtfUNKNOWN   :break;
		case RtfParam     :pc++;
		  // TODO:   
		    if(pc>0)
		      {
			cur_param[0]=0;
		      }
		  break;
		case RtfParamOFF  :pc--;
		  // TODO:   
		    if(pc==0)
		      {
			params.append(new char[strlen(cur_param)+1]);
			strcpy(params.item(params.count()-1),cur_param);
			//			fprintf(stderr,"Param :>%s<\n",cur_param);
			commands.append(RtfParam);
			commands_starts.append(text.count());
		      }
		  break;
		case RtfNoFill    :nf++;break;
		case RtfNoFillOFF :nf--;break;
		default:
		  //    
		    commands.append(command);
		  commands_starts.append(text.count());
		  break;		  
		}
	    }
	}
      else
	{
	  if(pc>0) // TODO:    
	    {
	      if(strlen(cur_param)<80)
		{
		  cur_param[strlen(cur_param)+1]=0;
		  cur_param[strlen(cur_param)]=char(c);
		}
	    }
	  else
	    {
	      if( (c=='\n') && (nf<=0) )
		{
		  nl++;
		  if(nl>1) 
		    {
		      text.append((unsigned char)c);
		      commands.append(RTFNewLine);
		      commands_starts.append(text.count());
		    }
		}
	      else
		{
		  if(nl==1) text.append(' ');
		  nl=0;
		  text.append((unsigned char)c);
		  if(c=='\n')
		    {
		      commands.append(RTFNewLine);
		      commands_starts.append(text.count());
		    }
		}
	    }	    
	}
    }
/*  text.append('\n');
  commands.append(RTFNewLine);
  commands_starts.append(text.count());
  */
  {
    // !!!!!!!!!     
    // !!!!!!!!!     
      int i=0;
    int cur=0;
    umtGRTFBlock *b;
    umtGRTFParagraf *pp;
    RTFCommand  cur_align=RtfFlushLeft;
    umtGRTFColorsArray  color_stack;
    int cur_param_num   =0;
    int cur_size        =0;
    int italic_count    =0;
    int bold_count      =0;
    int fixed_count     =0;
    int underline_count =0;
    int cur_left_indent =0;
    int cur_right_indent=0;

    long current_paragraf_start=0;

    color_stack.append(DefaultColor());
    
    blocks.append(new umtGRTFBlock());
    blocks.item(0)->font=FindFont(0,0);
    blocks.item(0)->color=color_stack.item(0);

      par.append(new umtGRTFParagraf());
    
    while(cur<commands.count())
      {
	i=cur;
	while(1)
	  {
/*	    fprintf(stderr,"Cur: %d(%d) i:%d(%d)\n",
		    (int)cur,
		    (int)commands_starts.item(cur),
		    (int)i,
		    (int)commands_starts.item(i)
		    );
*/
	    switch(commands.item(i))
	      {
	      case RtfBold          :bold_count++;break;
	      case RtfItalic        :italic_count++;break; 
	      case RtfFixed         :fixed_count++;break;
	      case RtfSmaller       :cur_size--;break;
	      case RtfBigger        :cur_size++;break;
	      case RtfUnderLine     :underline_count++;break;
		
	      case RtfCenter        :
	      case RtfFlushLeft     :
	      case RtfFlushRight    :
	      case RtfFlushBoth     :
		if(cur_align!=commands.item(i))
		  {
//		    if(par.item(par.count()-1)->Start()!=current_paragraf_start)
//		      {
			current_paragraf_start=commands_starts.item(cur);
			pp=new umtGRTFParagraf(current_paragraf_start,commands.item(i));
			par.append(pp);
//			fprintf(stderr,"AP(ON) %d(%d)\n",(int)pp->Start(),(int)pp->Align());
//		      }
//		    else
//		      par.item(par.count()-1)->Align(commands.item(i));
		  }
		cur_align=commands.item(i);
		break;

	      case RTFNewLine:	      
//		if(par.item(par.count()-1)->Start()!=current_paragraf_start)
//		  {
		    current_paragraf_start=commands_starts.item(cur);
		    pp=new umtGRTFParagraf(current_paragraf_start,cur_align);
		    par.append(pp);
//		    fprintf(stderr,"AP(NL) %d(%d)\n",(int)pp->Start(),(int)pp->Align());
//		  }
/*		else
		  par.item(par.count()-1)->Align(cur_align);*/
		break;
				     
	      case RtfIndent        :cur_left_indent++;break;
	      case RtfIndentRight   :cur_right_indent++;break;
		
		
	      case RtfBoldOFF       :bold_count--;break;
	      case RtfItalicOFF     :italic_count--;break;
	      case RtfFixedOFF      :fixed_count--;break;
	      case RtfSmallerOFF    :cur_size++;break;
	      case RtfBiggerOFF     :cur_size--;break;
	      case RtfUnderLineOFF  :underline_count--;break;
		
	      case RtfCenterOFF     :
	      case RtfFlushLeftOFF  :
	      case RtfFlushRightOFF :
	      case RtfFlushBothOFF  :
		//   ,    align
		{
		  int Center_count=0;
		  int FlushLeft_count=0;
		  int FlushRight_count=0;
		  int FlushBoth_count=0;
		  RTFCommand old_align=cur_align;

		  int j;
		  
		  cur_align=RtfFlushLeft;
		  
		  for( j=i ; j>=0 ; j-- )
		    {
		      switch(commands.item(j))
			{
			case RtfCenter        :Center_count++;     break;
			case RtfFlushLeft     :FlushLeft_count++;  break;
			case RtfFlushRight    :FlushRight_count++; break;
			case RtfFlushBoth     :FlushBoth_count++;  break;
			  
			case RtfCenterOFF     :Center_count--;     break;
			case RtfFlushLeftOFF  :FlushLeft_count--;  break;
			case RtfFlushRightOFF :FlushRight_count--; break;
			case RtfFlushBothOFF  :FlushBoth_count--;  break;
			}
		      
		      if(Center_count>0)     {cur_align=RtfCenter     ;break;}
		      if(FlushLeft_count>0)  {cur_align=RtfFlushLeft  ;break;}
		      if(FlushRight_count>0) {cur_align=RtfFlushRight ;break;}
		      if(FlushBoth_count>0)  {cur_align=RtfFlushBoth  ;break;}
		    }
		  
		  if(old_align!=cur_align)
		    {
//		      if(par.item(par.count()-1)->Start()!=current_paragraf_start)
//			{
			  current_paragraf_start=commands_starts.item(cur);
			  pp=new umtGRTFParagraf(current_paragraf_start,cur_align);
			  par.append(pp);
/*		    fprintf(stderr,"AP(OFF) %d(%d) -%d\n",
			    (int)pp->Start(),
			    (int)pp->Align(),
			    (int)commands_starts.item(i)
			    );*/
//			}
//		      else
//			par.item(par.count()-1)->Align(cur_align);
		    }
		}
		break;
		
	      case RtfIndentOFF     :cur_left_indent--;break;
	      case RtfIndentRightOFF:cur_right_indent--;break;
	      case RtfX_ColorOFF:
		if(color_stack.count()>1)
		  color_stack.remove(color_stack.count()-1);
		break;
	       
	      case RtfParam:
		if(cur_param_num<params.count())
		  {
		    int j;
		    RTFCommand cc=RtfUNKNOWN;
		    int   x_color_count=0;
		    //      ;
		    //   ;
		    for( j=i ; j>=0 ; j-- )
		      {
			switch(commands.item(j))
			  {
			  case RtfX_Color   :x_color_count++;break;
			  case RtfX_ColorOFF:x_color_count--;break;			    
			  }
			if(x_color_count>0){cc=RtfX_Color;break;}
		      }
		    switch(cc)
		      {
		      case RtfX_Color:
			color_stack.append(FindColor(params.item(cur_param_num)));
			break;
		      }
		  }
		cur_param_num++;
		break;	
	      }
	    
	    if(
	       (i+1<commands.count()) &&
	       (commands_starts.item(i+1)==commands_starts.item(cur))
	       )
	      i++;
	    else
	      break;
	  };
	
	b=new umtGRTFBlock(commands_starts.item(cur));
	
	b->indent_left   =(cur_left_indent >0)?cur_left_indent :0;
	b->indent_right  =(cur_right_indent>0)?cur_right_indent:0;
	
	b->char_size     =cur_size;
//	b->align         =cur_align;
	if(italic_count   >0)b->font_style|=RTFFONT_Italic;
	if(bold_count     >0)b->font_style|=RTFFONT_Bold;
	if(fixed_count    >0)b->font_style|=RTFFONT_Fixed;
	if(underline_count>0)b->font_style|=RTFFONT_UnderLine;
	b->font=FindFont(b->font_style,cur_size);
	b->color=color_stack.item(color_stack.count()-1);
	blocks.append(b);

	//	fprintf(stderr,"Block : SZ:%d I:%d B:%d F:%d U:%d Fnt:%d C:%d\n",
	//(int)cur_size,(int)italic_count,(int)bold_count,(int)fixed_count,(int)underline_count,(int)b->font,(int)b->color
	//);
	cur=i+1;
      }

    if(blocks.count()>1)
      {
	if(blocks.item(0)->start==blocks.item(1)->start)
	  {
	    delete blocks.item(0);
	    blocks.remove(0);
	  }
      }
    
    i=0;
    while(i+1<blocks.count())
      {
	if(blocks.item(i)->equals(blocks.item(i+1)))
	  {
	    delete blocks.item(i+1);
	    blocks.remove(i+1);
	  }
	else
	  i++;
      }
    color_stack.remove_all();

/*      fprintf(stderr,"\nLoad Rtf %d\n",(int)text.count());

      for( i=0 ; i<par.count() ; i++ )
	fprintf(stderr,"%d(%d)  ",
		(int)par.item(i)->Start(),
		(int)par.item(i)->Align()
		);

      fprintf(stderr,"\n");
*/
    if(par.count()!=0)
      for( i=0 ; i+1<par.count() ; i++ )
	if(par.item(i)->Start()==par.item(i+1)->Start())
	  {
/*	    {
	      fprintf(stderr,"Remove par %d(%d) '%c'\n",
		      (int)par.item(i)->Start(),
		      (int)par.item(i)->Align(),
		      (par.item(i)->Start()<text.count())?text.item(par.item(i)->Start()):'0'
		      );
	    }*/
	    delete par.item(i);
	    par.remove(i);
	    i--;
	  }
//      fprintf(stderr,"\n\n");
    if(
       (text.count()!=0) &&
       (par.count()!=0)
       )
      {
	long j;
	long jjj;
	
	for( i=0 ; i+1<par.count() ; i++ )
	  if(
	     (par.item(i)->Align()==par.item(i+1)->Align()) &&
	     (text.item(par.item(i+1)->Start()-1)!='\n')
	     )
	    {
/*	      {
		fprintf(stderr,"Remove par %d(%d) '%c'\n",
			(int)par.item(i+1)->Start(),
			(int)par.item(i+1)->Align(),
			text.item(par.item(i+1)->Start())
			);
	      }
*/	      
	      delete par.item(i+1);
	      par.remove(i+1);
	      i--;
	    }
	
//      fprintf(stderr,"\n\n");
	for( i=0 ; i+1<par.count() ; i++ )
	  if(text.item(jjj=(par.item(i+1)->Start()-1))!='\n')
	    {
	      text.insert(jjj+1,'\n');
	      for( j=i+1 ; j<par.count(); j++ )
		par.item(j)->Start(par.item(j)->Start()+1);
	      
	      for( j=0 ; j<blocks.count(); j++ )
		if(blocks.item(j)->start>(jjj))
		  blocks.item(j)->start++;
	    }

/*	if(
	   (par.count()==1) &&
	   (text.item(text.count()-1)!='\n')
	   )
	  {
	    delete par.item(0);
	    par.remove_all();
	  }
*/
      }
      par.append(new umtGRTFParagraf(text.count(),par.item(par.count()-1)->Align()));
/*      fprintf(stderr,"\nLoad Rtf(2) %d\n",(int)text.count());

      for( i=0 ; i<par.count() ; i++ )
	fprintf(stderr,"%d(%d)  ",
		(int)par.item(i)->Start(),
		(int)par.item(i)->Align()
		);

      fprintf(stderr,"\n");
*/
  }

  //  
  {
    int i;
    for( i=0 ; i<params.count() ; i++)
      delete params.item(i);
    params.remove_all();
  }
  //  Print();
  //  Reallocate();
  //  Redraw();
  //  scroll_to(Dimension_Y,0);
  return 0;
}

int  umtGRTFEditorImpl::LoadText(
				 umtGRTFLoader &f,
				 UCharsArray &text,
				 RTFBlocksArray &blocks,
				 RTFParagrafsArray &par
				 )
{
  int  c;
  long cur_par_start=0;
  //  Clear();
  par.append(new umtGRTFParagraf(cur_par_start));
  while((c=f.GetC())!=EOF)
    {
      text.append((unsigned char)c);
      if(c=='\n')
	{
	  par.append(new umtGRTFParagraf(cur_par_start));
	  cur_par_start=text.count();
	}
    }
  if(text.count()==0)
    {
      delete par.item(0);
      par.remove_all();
    }
  else
    {
      par.append(new umtGRTFParagraf(text.count()));
    }
  blocks.append(new umtGRTFBlock());
  blocks.item(0)->font=FindFont(0,0);
  blocks.item(0)->color=DefaultColor();
  return 0;
}

static struct
{
  int  cmd;
  char *str;
}RtfCommands[]=
 {
   {RtfBold        ,"bold"       },
   {RtfItalic      ,"italic"     },
   {RtfFixed       ,"fixed"      },
   {RtfSmaller     ,"smaller"    },
   {RtfBigger      ,"bigger"     },
   {RtfUnderLine   ,"underline"  },
   
   {RtfCenter      ,"center"     },
   {RtfFlushLeft   ,"flushleft"  },
   {RtfFlushRight  ,"flushright" },
   {RtfFlushBoth   ,"flushboth"  },
   {RtfNoFill      ,"nofill"     },
  
   {RtfIndent      ,"indent"     },
   {RtfIndentRight ,"indentright"},
   
   {RtfExcerpt     ,"excerpt"    },
   {RtfParam       ,"param"      },
   {RtfX_Color     ,"x-color"    }
};

static int GetRtfCommand(char *c)
{
  int i;

  if(!c)return RtfUNKNOWN;
  
  for( i=0 ; i<int(sizeof(RtfCommands)/sizeof(RtfCommands[0])) ; i++ )
    {
      if(c[0]=='/')
	{
	  if(!strcasecmp(&c[1],RtfCommands[i].str))return RtfCommands[i].cmd+RtfOffCmd;
	}
      else
	{
	  if(!strcasecmp(c,RtfCommands[i].str))return RtfCommands[i].cmd;
	}
    }
  
  return RtfUNKNOWN;
}

static int GetRtfCommandStr(int cmd,char *str)
{
  int i;
  
  for( i=0 ; i<int(sizeof(RtfCommands)/sizeof(RtfCommands[0])) ; i++ )
    {
    if(cmd==RtfCommands[i].cmd+RtfOffCmd)
      {
	strcpy(str,"</");
	strcat(str,RtfCommands[i].str);
	strcat(str,">");
	return 0;
      }
    if(cmd==RtfCommands[i].cmd)
      {
	strcpy(str,"<");
	strcat(str,RtfCommands[i].str);
	strcat(str,">");
	return 0;
      }
    }
  return 1;
}
