#include "UMT.h++"

declareActionCallback(umtGRTFEditorImpl)
implementActionCallback(umtGRTFEditorImpl)


class ImplCb:public Action
{
public:
  ImplCb(umtGRTFEditorImpl* impl,RTFCommand cmd,long param=0);
  virtual ~ImplCb();
  
  virtual void execute ();

  umtGRTFEditorImpl* im;
  RTFCommand cm;
  long       p;
};

ImplCb::ImplCb(umtGRTFEditorImpl* impl,RTFCommand cmd,long param):
Action()
{
  im=impl;
  cm=cmd;
  p=param;
}

ImplCb::~ImplCb()
{
}
  
void ImplCb::execute ()
{
  if(im)
    {
      im->ProcessCommand(cm,p);	  
      im->ScrollToCursor();
      im->Redraw();
    }
}


void umtGRTFEditorImpl::InitMenu(Menu *menu)
{
  MenuItem  *cur,*pri;
  Menu      *pd=menu,*pr;
  WidgetKit *k=WidgetKit::instance();
  LayoutKit *l=LayoutKit::instance();
  long i;

  m_bold=m_italic=m_underline=m_fixed=
    m_a_left=m_a_center=m_a_right=nil;

  m_kbd_menu=nil;
  if(menu==nil)return;
  //  if(IsEditable==false)return;
  
  //  mi=k->menubar_item(" Edit ");
  //   pd=k->pulldown();
  if(IsEditable==true)
    {
    pd->append_item(k->menu_item_separator());


    pri=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(900)), 0.0, fil, 0.0));
     pr=k->pullright();
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(901)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfBigger));
      pr->append_item(cur);
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(902)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfBiggerOFF));
      pr->append_item(cur);
      pr->append_item(k->menu_item_separator());
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(903)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfBold));
      pr->append_item(cur);
      m_bold=cur;
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(904)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfItalic));
      pr->append_item(cur);
      m_italic=cur;
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(905)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfUnderLine));
      pr->append_item(cur);
      m_underline=cur;
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(906)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfFixed));
      pr->append_item(cur);
      m_fixed=cur;
     pri->menu(pr);  
    pd->append_item(pri);

    pri=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(907)), 0.0, fil, 0.0));
     pr=k->pullright();
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(908)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfIndent));
      pr->append_item(cur);
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(909)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfIndentOFF));
      pr->append_item(cur);
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(910)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfIndentRight));
      pr->append_item(cur);
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(911)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfIndentRightOFF));
      pr->append_item(cur);
      
     pri->menu(pr);  
    pd->append_item(pri);

    pri=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(912)), 0.0, fil, 0.0));
     pr=k->pullright();
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(913)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfFlushLeft));
      pr->append_item(cur);
      m_a_left=cur;
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(914)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfCenter));
      pr->append_item(cur);
      m_a_center=cur;
      cur=k->check_menu_item(l->r_margin(k->fancy_label(UMTSTR(915)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfFlushRight));
      pr->append_item(cur);
      m_a_right=cur;
     pri->menu(pr);  
    pd->append_item(pri);

    pd->append_item(k->menu_item_separator());
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(916)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RtfX_Color));
      pd->append_item(cur);




    if(Keyboards.count()>1)
      {
	pri=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(921)), 0.0, fil, 0.0));
	 pr=k->pullright();
	  for( i=0 ; i<Keyboards.count() ; i++ )
	    {
	      cur=k->check_menu_item
		(l->r_margin
		 (k->fancy_label
		  (
		   (Keyboards.item(i)->Name()==nil)?UMTSTR(923):
		   Keyboards.item(i)->Name()
		   ), 0.0, fil, 0.0
		  )
		 );
	      cur->action(new ImplCb(this,RTFSelectKeyboard,i));
	      pr->append_item(cur);
	    }
	m_kbd_menu=pr;
        pri->menu(pr);  
       pd->append_item(pri);
    }
    pd->append_item(k->menu_item_separator());
  }  
      cur=k->menu_item(l->r_margin(k->fancy_label(UMTSTR(917)), 0.0, fil, 0.0));
      cur->action(new ImplCb(this,RTFSearch));
      pd->append_item(cur);

    
      //   mi->menu(pd);
      //  menu->append_item(mi);
}


void umtGRTFEditorImpl::UpdateMenu(void)
{
  long i;

  if(m_bold!=nil)
    m_bold->state()->set
    (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Bold)?true:false);
  
  if(m_italic!=nil)
    m_italic->state()->set
    (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Italic)?true:false);
  
  if(m_underline!=nil)
    m_underline->state()->set
    (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_UnderLine)?true:false);
  
  if(m_fixed!=nil)
    m_fixed->state()->set
    (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Fixed)?true:false);
  
/*  
  if(m_a_left!=nil)
    m_a_left->state()->set
    (TelltaleState::is_chosen, (current_block->align ==RtfFlushLeft)?true:false);
  
  if(m_a_center!=nil)
    m_a_center->state()->set
    (TelltaleState::is_chosen, (current_block->align ==RtfCenter)?true:false);
  
  if(m_a_right!=nil)
    m_a_right->state()->set
    (TelltaleState::is_chosen, (current_block->align ==RtfFlushRight)?true:false);
*/
  {
    boolean bl=true,bc=false,br=false;
    long t=CharParagrafNumber(cur_cursor_pos);
    
    if(
       (t>=0) &&
       (t<paragrafs.count())
       )
      {
	switch(paragrafs.item(t)->Align())
	    {
	    case RtfCenter    :bl=false;bc=true;break;
	    case RtfFlushRight:bl=false;br=true;break;
	    }
      }
    
    if(m_a_left!=nil)
      m_a_left->state()->set
	(TelltaleState::is_chosen, bl);
    
    if(m_a_center!=nil)
      m_a_center->state()->set
	(TelltaleState::is_chosen, bc);
    
    if(m_a_right!=nil)
      m_a_right->state()->set
	(TelltaleState::is_chosen, br);
  }
  

  if(
     (m_kbd_menu!=nil) &&
     (Keyboards.count()>1)
     )
    for( i=0 ; (i<m_kbd_menu->item_count()) && (i<Keyboards.count()) ; i++ )
      m_kbd_menu->item(i)->state()->set
	(TelltaleState::is_chosen, (i==current_keyboard_index)?true:false);
}





















