#include "umtGRTFFont.h++"
#include <IV-X11/xfont.h>
#include <string.h>
#include <stdio.h>
  
umtGRTFFont::umtGRTFFont(const char *name,Display *display)
{
  font_name=new char[strlen(name)+5];
  strcpy(font_name,name);
  fnt=nil;
  display_=display;
}

umtGRTFFont::~umtGRTFFont ()
{
  delete font_name;
  //  if(fnt)delete fnt;
  Resource::unref(fnt);
}

const Font* umtGRTFFont::font(void)
{
  Update();
  return fnt;
}

XID umtGRTFFont::XId(void)
{
  Update();
  return id;
}
  
long  umtGRTFFont::font_width(void)
{
  Update();
  return font_w;
}

long  umtGRTFFont::font_height(void)
{
  Update();
  return font_h;
}

void  umtGRTFFont::font_ext(long& width,long &height)
{
  Update();
  width =font_w;
  height=font_h;
}

long  umtGRTFFont::font_ascent (void)
{
  Update();
  return font_asc;
}

long  umtGRTFFont::font_descent(void)
{
  Update();
  return font_desc;
}

long  umtGRTFFont::char_x_offset(long ch)
{
  Update();
  if(
     (ch>=0) &&
     (ch<0xff)
     )return offs[ch];
  else
    return 0;    
}

unsigned char umtGRTFFont::char_width(long ch)
{
  Update();
  if(
     (ch>=0) &&
     (ch<0xff)
     )return w[ch];
  else
    return font_w;    
}

unsigned char umtGRTFFont::char_height(long ch)
{
  Update();
  ch=ch;
  return font_h;
}

void  umtGRTFFont::char_ext(long ch,long& width,long &height)
{
  Update();
  if(
     (ch>=0) &&
     (ch<0xff)
     )width =w[ch];
  else
    width =font_w;
  height=font_h;
}
  
  
void  umtGRTFFont::Update(void)
{
  int i;
  
  if(fnt!=nil)return;
  {
    FontBoundingBox bx;
    //    fprintf(stder"Start lookup >%s<\n",font_name);
    fnt=Font::lookup(font_name);
    //fprintf(stderr,"Process llockup %d\n",(int)fnt);
    Resource::ref(fnt);
    //fprintf(stderr,"Normal llockup\n");
    id=fnt->rep(display_)->font_->fid;
    //fprintf(stderr,"Normal Q\n");
    //    fprintf(stderr,"font >%s<  %d\n",font_name,(int)id);
    font_w=0;
    font_h=(unsigned char)(fnt->size()+0.5);

    fnt->font_bbox(bx);
    //fprintf(stderr,"Normal bboxQ\n");
    font_asc=(unsigned char)(bx.font_ascent()+0.5);
    font_desc=(unsigned char)(bx.font_descent()+0.5);
    //fprintf(stderr,"Normal Sc\n");

    for( i=0 ; i<0xff ; i++ )
      {
	fnt->char_bbox((char)i,bx);
	w[i]=(unsigned char)(bx.width()+0.5);
	offs[i]=-((signed char)bx.left_bearing());
	if(w[i]>font_w)font_w=w[i];
      }
    for( i=0 ; i<0xff ; i++ )
      if(w[i]<2)w[i]=font_w;
    //fprintf(stderr,"Normal CCC\n");

  }
}
  
implementPtrList(RTFFontsArray ,umtGRTFFont);
