#ifndef umtGRTFFont_H_FLAG
#define umtGRTFFont_H_FLAG

#include <InterViews/font.h>
#include <OS/list.h>
#include <IV-X11/Xlib.h>

#define RTFFONT_Normal     0
#define RTFFONT_Fixed      (1<<0)
#define RTFFONT_Bold       (1<<1)
#define RTFFONT_Italic     (1<<2)
#define RTFFONT_UnderLine  (1<<3)

class umtGRTFFont
{
public:
  umtGRTFFont  (const char *name,Display *display);
  ~umtGRTFFont ();

  const Font  *font (void);
  XID   XId         (void);
  
  long  font_width  (void);
  long  font_height (void);
  void  font_ext    (long& width,long &height);
  long  font_ascent (void);
  long  font_descent(void);
  
  long  char_x_offset (long ch);
  unsigned char char_width (long ch);
  unsigned char char_height(long ch);
  void  char_ext    (long ch,long& width,long &height);
  
  

private:
  void  Update (void);
  
  const Font  *fnt;
  char  *font_name;
  unsigned char w[0xff];
  signed   char offs[0xff];
  unsigned char font_w;
  unsigned char font_h;
  
  unsigned char font_asc;
  unsigned char font_desc;

  XID           id;
  Display       *display_;
};

declarePtrList(RTFFontsArray ,umtGRTFFont);

#endif
