/*
$Id: umtHelpCl.cc,v 1.1 1996/10/22 19:47:41 lord Exp $

$Log: umtHelpCl.cc,v $
Revision 1.1  1996/10/22 19:47:41  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 1.6  1996/04/08  15:44:50  voloh
// .
//
// Revision 1.5  1996/03/09  13:14:39  voloh
// UMTLanguage support
//
// Revision 1.4  1996/03/03  16:30:46  voloh
// cosmetics
//
// Revision 1.3  1996/03/03  15:24:12  voloh
// small bug
//
// Revision 1.2  1996/03/03  14:01:03  voloh
// -----
//
// Revision 1.1  1996/03/03  12:49:28  voloh
// Initial revision
//
*/

#include <stdlib.h>
#include <InterViews/cursor.h>
#include <InterViews/image.h>
#include <InterViews/tiff.h>
#include <InterViews/patch.h>

#include "umtHelp.h++"


umtHelpDock UMTHelpDock;

umtHelp::umtHelp()
{
    directory =
	UMTConfig.GetStrField(HELP_PATH);
    if ( directory.IsEmpty() )
	directory = ".";
    directory += "/";
    viewer = new umtRTFView();
    Resource::ref(viewer);
    viewer->ReBuildAll();
    window = new TopLevelWindow(
	body_build()
    );
    window->wm_delete(new umtHandler(this));
    WindowName( window,
		UMTSTR(1100),
		WidgetKit::instance()->style()
    );
    window->map();
    viewer->SetWindow(window);
}

umtHelp::~umtHelp()
{
    Resource::unref(viewer);
    window->unmap();
    delete window;
}


void umtHelp::Exit() { }

int umtHelp::CloseWindow() { return 0; }


Glyph* umtHelp::body_build()
{
    LayoutKit* layout = LayoutKit::instance();
    WidgetKit* kit = WidgetKit::instance();
    Glyph* im = new Image(TIFFRaster::load("/usr/local/lib/UMT/Images/UMT.tif"));
    return kit->outset_frame(
	layout->vbox(
	    layout->hbox(
		im,
		    layout->hglue(),
//		    layout->hbox(
//			imh,
//			    layout->vglue()
//		    ),
//		    layout->hglue(),
		    im
	    ),
		kit->inset_frame(
		    layout->hbox(
			kit->push_button(
			    UMTSTR(117),
				new ActionCallback(umtHelpDock)(
				    &UMTHelpDock,
					umtHelpDock::index_page
				)
			),
			    UMTHelpDock.backward_b =
			    kit->push_button(
				UMTSTR(1101),
				    new ActionCallback(umtHelpDock)(
					&UMTHelpDock,
					    umtHelpDock::previous_page
				    )
			    ),
			    UMTHelpDock.forward_b =
			    kit->push_button(
				UMTSTR(1102),
				    new ActionCallback(umtHelpDock)(
					&UMTHelpDock,
					    umtHelpDock::next_page
				    )
			    ),
			    layout->hglue(),
			    kit->push_button(
				UMTSTR(111),
				    new ActionCallback(umtHelpDock)(
					&UMTHelpDock,
					    umtHelpDock::Close
				    )
			    )
		    )
		),
		layout->hbox(
		    kit->inset_frame(
			layout->variable_span(
			    layout->natural_span(
				layout->vcenter(
				    viewer, 1.0),
				    6*72.0, 5*72.0
			    )
			)
		    ),
			kit->inset_frame(
			    kit->vscroll_bar(
				viewer->Adjust()
			    )
			)
		)
	)
    );
}


int umtHelp::go_to(umtRefPoint page)
{
    int r = 0;
    InputFile* file;
    file = InputFile::open((char*)(directory+page.Loc()));
    if ( file ) {
	location = page;
	viewer->Reinit(file, 1);
	viewer->ReBuildAll();
	r = 1;
	delete file;
    }
    return r;
}


umtHelpDock::umtHelpDock()
{
    dialog = nil;
    temp_nokilled = nil;
    directory =
	UMTConfig.GetStrField(HELP_PATH);
    if ( directory.IsEmpty() )
	directory = ".";
    directory += "/";
    umtString fl =
	UMTConfig.GetStrField(HELP_INDEX_FILE);
    if ( fl.IsEmpty() ) fl = "index.rtf";
    history.Append(
	in_history =
	    new umtRefPoint(
		HELP_INDEX_COMMENT, fl )
    );
}

umtHelpDock::~umtHelpDock()
{
    history.Kill(nil);
    no_kill(nil);
    Close();
}

void umtHelpDock::Open()
{
    open(nil, UMT_HELP_INDEX);
}

void umtHelpDock::Open(umtRefPoint hr)
{
    open(nil, hr);
}

void umtHelpDock::open(Glyph* gl, umtRefPoint hp)
{
    if ( !dialog ) {
	dialog = new umtHelp();
	if ( !go_to(hp) )
	    Close();
    } else {
	no_kill(gl);
	go_to(hp);
    }
}

void umtHelpDock::Close()
{
    if ( dialog ) {
	Delete(dialog);
	dialog = nil;
    }
}

int umtHelpDock::IsOpened()
{
    return ( dialog != nil );
}


int umtHelpDock::go_to(umtRefPoint hp)
{
    int r = 0;
    if ( hp.Loc().Search(':').IsEmpty() ) {
	if ( dialog->go_to(hp) ) {
	    if ( in_history->Next &&
		 hp != *(umtRefPoint*)history.GetLast() )
		history.Append(new umtRefPoint(*in_history));
	    if ( hp != *in_history )
		history.Append(new umtRefPoint(hp));
	    in_history = (umtRefPoint*)history.GetLast();
	    r = 1;
	} else {
	    if ( UMTError )
		UMTError->Msg(
		    umtError::Error,
		    umtString("Page \"")+
		    hp.Name()+
		    umtString("\" at path '")+
		    directory+hp.Loc()+
		    umtString("' not found !")
		);
	}
    } else
	if ( UMTError )
	    UMTError->Msg(
		umtError::Error,
	        umtString("Unknown reference manager \"")+
	    hp.Loc().Left(hp.Loc().Index(':'))+
	    umtString("\" !")
		);
    update_buttons();
    return r;
}

void umtHelpDock::previous_page()
{
    if ( in_history && in_history->Prev )
	dialog->go_to(
	    *(in_history =
	      (umtRefPoint*)in_history->Prev)
	);
    update_buttons();
}

void umtHelpDock::next_page()
{
    if ( in_history && in_history->Next )
	dialog->go_to(
	    *(in_history =
	      (umtRefPoint*)in_history->Next)
	);
    update_buttons();
}

void umtHelpDock::index_page()
{
    go_to(*(umtRefPoint*)history.GetFirst());
}

void umtHelpDock::update_buttons()
{
    if ( in_history->Prev )
	backward_b->state()->set(TelltaleState::is_enabled, true);
    else
	backward_b->state()->set(TelltaleState::is_enabled, false);
    if ( in_history->Next )
	forward_b->state()->set(TelltaleState::is_enabled, true);
    else
	forward_b->state()->set(TelltaleState::is_enabled, false);
}

void umtHelpDock::no_kill(Glyph* gl)
{
    if ( temp_nokilled )
	Resource::unref(temp_nokilled);
    if ( temp_nokilled = gl )
	Resource::ref(gl);
}


implementActionCallback(umtHelpDock)
