/*
$Id: umtRtfText.cc,v 1.1 1996/10/22 19:47:43 lord Exp $

$Log: umtRtfText.cc,v $
Revision 1.1  1996/10/22 19:47:43  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:43  sebast
// Revision 2.0
//
// Revision 1.1  1996/03/03  12:45:55  voloh
// Initial revision
//
*/


#include "umtRtfText.h++"



umtRTFText::umtRTFText():
    umtSlist()
{
    already = 0;
    colors = nil;
    fonts = nil;
    ref_callbacks = nil;
    cursor = nil;
    first_marked =
	last_marked = nil;
    RTFHintsInUse = 0;
    ErrorStatus = UNDEFINED_VALUE;
    ErrStream = nil;
}

umtRTFText::~umtRTFText()
{
    if ( ErrorStatus || !already ) return;
    Kill(nil);
    cmdstack.Clean();
    colors_pars.Kill(nil);
    Resource::unref(begin_par_);
    Resource::unref(end_par_);
    Resource::unref(begin_line_);
    Resource::unref(end_line_);
    Resource::unref(word_space_);
    Resource::unref(interline_);
    Resource::unref(vfil_glue_);
    Resource::unref(page_);
    Resource::unref(box_);
    Resource::unref(colors);
    Resource::unref(fonts);
    if ( cursor_on )
	Resource::unref(cursor_on);
    if ( ErrStream )
	Resource::unref((InputHandler*)ErrStream);
}


void umtRTFText::flow_up()
{
    update_to(cursor);
}

void umtRTFText::InsertInT(umtRTFTextComponent* w, int rd)
{
    if ( !cursor )
	if ( first ) {
	    cursor = (umtRTFTextComponent*)first;
	    cursor_placed();
    	} else
	    umtSlist::Append(
		cursor = new umtRTFTextComponent(
		    CLASS_RTFTextComponent
		)
	    );
    umtSlist::Insert(
	w, ( cursor->GetType() == 2 &&
	     cursor->Prev &&
	     ((umtRTFTextComponent*)cursor->Prev)->GetType() == 1 &&
	     ((umtRTFCom*)cursor->Prev)->Mean == cmNewLine ) ?
        cursor->Prev : cursor
    );
    if ( w->GetType()==2 ) {
 	cursor_line += 2;
 	page_->insert(cursor_position++,
 		      XLayout->discretionary(
 			  PenaltyGood,
		          end_par_,
		          end_par_,
		          XLayout->discretionary(
			      0, interline_, vfil_glue_, nil, nil
 		          ),
		          begin_par_
		      )
 	    );
    }
    if ( rd )
	FastReBuild();
    else if ( w->GetType()==0 ) {
 	if ( ((umtRTFChar*)w)->GetTheGlyph() ) {
 	    page_->insert(cursor_position++,
 			  ((umtRTFChar*)w)->GetTheGlyph());
 	    Repair();
 	}
    } else
 	Repair();
}
void umtRTFText::InsertInTWM(umtRTFTextComponent* w, int rd)
{
    umtSlist::Insert(
	w, ( cursor->GetType() == 2 &&
	     cursor->Prev &&
	     ((umtRTFTextComponent*)cursor->Prev)->GetType() == 1 &&
	     ((umtRTFCom*)cursor->Prev)->Mean == cmNewLine ) ?
        cursor->Prev : cursor
    );
    cursor = w;
    if ( w->GetType()==2 ) {
 	cursor_line += 2;
 	page_->insert(cursor_position++,
 		      XLayout->discretionary(
 			  PenaltyGood,
		          end_par_,
		          end_par_,
		          XLayout->discretionary(
			      0, interline_, vfil_glue_, nil, nil
 		          ),
		          begin_par_
		      )
 	    );
    }
    if ( rd )
	FastReBuild();
    else if ( w->GetType()==0 ) {
	if ( ((umtRTFChar*)w)->GetTheGlyph() ) {
	    page_->insert(cursor_position,
			  ((umtRTFChar*)w)->GetTheGlyph());
	    Repair();
	}
    } else Repair();
}


void umtRTFText::SetErrorStream(umtScrollBox* s)
{
    if ( s ) Resource::ref((InputHandler*)s);
    if ( ErrStream )
	Resource::unref((InputHandler*)ErrStream);
    ErrStream = s;
}

status umtRTFText::Init(umtRTFFonts* fs, umtRTFColors* cl)
{
    if ( !fs || fs->ErrorStatus ||
         ( !colors && ( !cl || cl->ErrorStatus ) ) ) {
	RTF_CRITICAL_MSG("Error RTF-Text building.");
	return UNDEFINED_VALUE;
    }
    if ( fonts ) Resource::unref(fonts);
    Resource::ref( fonts = fs );
    if ( cl )
	Resource::ref( colors = cl );
    excerpt_on =
	excerpt_off = "";
    init();
    if ( !already ) {
	Resource::ref(word_space_=
		      XLayout->spaces(1,0,cfont,
				      Kit->foreground()));
	Resource::ref( interline_ = XLayout->vglue()                 );
	Resource::ref( vfil_glue_ = XLayout->vglue(fil,fil,fil)      );
	Resource::ref( begin_par_ = XLayout->vstrut(0)               );
	Resource::ref( end_par_   = XLayout->strut(cfont,0,fil,fil)  );
	Resource::ref( begin_line_= XLayout->vstrut(0)               );
	Resource::ref( end_line_  = XLayout->strut(cfont,fil,fil,fil));
//	Resource::ref( box_       = XLayout->vscrollbox()            );
	Resource::ref( box_       = new TBScrollBox()                );
	box_->small_scroll(Dimension_Y, 2);
	page_ = new LRComposition(box_, new TeXCompositor(1), // 10
				  nil, 0, fil, fil, 0);
	Resource::ref(page_);
    }
    cursor    = nil;
    cursor_gl = nil;
    cursor_on = nil;
    cursor_placed();
    cr_color  = ccolor;
    cr_font   = cfont;
    c_indent  = c_indent_right = 0;
    already   = 1;
    return ErrorStatus = OK;
}


void umtRTFText::Repair()
{
    page_->repair();
    box_->notify(Dimension_Y);
}

void umtRTFText::Clean()
{
    cursor_unactivate();
    cmdstack.Clean();
    cur_st.Clean();
    colors_pars.Kill(nil);
    Kill(nil);
    while ( (page_->count())>0 )
	page_->remove(0);
    Repair();
    cursor = nil;
    init();
}

void umtRTFText::ReDrawIn()
{
    int i    = 0;
    int lp   = 0;
    Coord xp = 0;
    cursor_unactivate();
    while ( (page_->count())>0 ) page_->remove(0);
    Repair();
    umtRTFTextComponent* pt = (umtRTFTextComponent*)first;
    page_->append(begin_par_);
    if ( wind_width != 0.0 )
	while ( pt ) {
	    switch ( pt->GetType() ) {
	    case 0: // Char
		if ( ((umtRTFChar*)pt)->GetTheGlyph() ) {
		    page_->append(((umtRTFChar*)pt)->GetTheGlyph());
		    xp += ((umtRTFChar*)pt)->TheWidth;
		    i++;
		}
		if ( pt == cursor ) {
		    cursor_position = i;
		    cursor_line = 2*lp;
		    x_position = xp;
		}
		break;
	    case 4: // Space
		i++;
		if ( ((umtRTFSpace*)pt)->TheGlyph ) {
		    page_->append(((umtRTFSpace*)pt)->TheGlyph);
		    xp += ((umtRTFSpace*)pt)->TheWidth;
		}
		break;
	    case 2: // Line braker
		i++; lp++;
		xp = 0;
		page_->append(
		    XLayout->discretionary(
			PenaltyGood, end_par_, end_par_,
		        XLayout->discretionary(
			    0, interline_, vfil_glue_, nil, nil),
		        begin_par_
                    )
		);
		break;
	    }
	    pt = (umtRTFTextComponent*)pt->Next;
	}
    page_->append(vfil_glue_);
    page_->append(end_par_);
    Repair();
}

void umtRTFText::cursor_activate()
{
    Color* cr_hi_color = cr_color;

    Glyph* gll;
    if ( cursor_gl ) cursor_unactivate();
    if ( !cursor )
	cursor_placed();
    if ( cursor ) {
	cursor_gl = cursor;
// 	while ( cursor_gl &&
// 		cursor_gl->GetType()!=0 &&
// 		cursor_gl->GetType()!=2 )
// 	    cursor_gl = (umtRTFTextComponent*)cursor_gl->Next;
	if ( cursor_gl ) {
	    _REMEMBER_SCROLL_POS_;
	    if ( cursor_gl->GetType() == 2 ) {
		page_->insert(
		    cursor_position,
		    new Background(
			new Character(
			    ' ',
			    cr_font,
			    Kit->background()
			),
		        ((umtRTFChar*)cursor_gl)->GetHilight() ?
		            cr_color : cr_hi_color
		    )
		);
	    } else {
		if ( ((umtRTFChar*)cursor_gl)->GetTheGlyph() )
		    page_->remove(cursor_position);
		if ( ((umtRTFChar*)cursor_gl)->GetHilight() )
		    cursor_on = ((umtRTFChar*)cursor_gl)->GetHilight();
		else
		    cursor_on = ((umtRTFChar*)cursor_gl)->GetTheGlyph();
		Resource::ref(cursor_on);
		if ( ((umtRTFChar*)cursor_gl)->TheChar == '\t' ) {
		    char tb[9];
		    char *cc=tb;
		    Font* fd = fonts->Default();
		    int i = (int)(((umtRTFChar*)cursor_gl)->TheWidth/
				  fd->width(' '));
		    for(;i>0;i--) *cc++ = ' ';
		    *cc = 0;
		    gll = new Label(tb,fd,cr_color);
		    if ( ((umtRTFChar*)cursor_gl)->GetHilight() )
			((umtRTFChar*)cursor_gl)->SetHilight(
			    new Background(
				gll,
				    cr_hi_color
			    )
			);
		    else
			((umtRTFChar*)cursor_gl)->SetTheGlyph(
			    new Background(
				gll,
				    cr_color
			    )
			);
		} else {
		    gll = new Character(
			((umtRTFChar*)cursor_gl)->TheChar,
		        cr_font,
		        Kit->background()
		    );
		    if ( ((umtRTFChar*)cursor_gl)->GetHilight() )
			((umtRTFChar*)cursor_gl)->SetHilight(
			    new Background(
				gll,
				    cr_hi_color
			    )
			);
		    else
			((umtRTFChar*)cursor_gl)->SetTheGlyph(
			    new Background(
				gll,
				    cr_color
			    )
			);
		}
		page_->insert(cursor_position,
			      ((umtRTFChar*)cursor_gl)->GetHilight() ?
			      ((umtRTFChar*)cursor_gl)->GetHilight() :
			      ((umtRTFChar*)cursor_gl)->GetTheGlyph()
		);
	    }
	    Repair();
	    _RESTORE_SCROLL_POS_;
	}
    }
}

void umtRTFText::cursor_unactivate()
{
    if ( cursor_gl ) {
	_REMEMBER_SCROLL_POS_;
	if ( cursor_gl->GetType() == 0 ) {
	    if ( ((umtRTFChar*)cursor_gl)->GetHilight() ) {
//		page_->remove(cursor_position);
		if ( ((umtRTFChar*)cursor_gl)->
		     SetHilight(cursor_on) )
		    page_->replace(cursor_position, cursor_on);
	    } else if ( ((umtRTFChar*)cursor_gl)->GetTheGlyph() ) {
//		page_->remove(cursor_position);
		if ( ((umtRTFChar*)cursor_gl)->
		     SetTheGlyph(cursor_on) )
		    page_->replace(cursor_position, cursor_on);
	    }
	} else
	    page_->remove(cursor_position);
	if ( cursor_on )
	    Resource::unref(cursor_on);
	cursor_on = nil;
	cursor_gl = nil;
	Repair();
	_RESTORE_SCROLL_POS_;
    }
}

void umtRTFText::pop_color()
{
    colors_pars.Drop();
    umtString *cl = (umtString*)colors_pars.Top();
    if ( cl && cl->Str() )
	ccolor = colors->ByName(*cl);
    else
	ccolor = colors->Default();
}

status umtRTFText::ResetFonts(umtRTFFonts* fs)
{
    if ( fs && !fs->ErrorStatus ) {
	Resource::unref(fonts);
	Resource::ref(fonts = fs);
	cr_font = cfont = fonts->Default();
	return OK;
    } else
	return ERROR_IN_CALLED_FUNCTION;
}

status umtRTFText::ResetColors(umtString& cl)
{
    status r = colors->SetDefault(cl);
    cr_color = ccolor = colors->Default();
    return r;
}

Adjustable* umtRTFText::Adjust() const
{
    return box_;
}

Glyph* umtRTFText::Body() const
{
    return page_;
}

void umtRTFText::scroll_to_cursor()
{
    GlyphIndex lf=0, ll=0;
    GlyphIndex f = box_->first_shown();
    GlyphIndex l = box_->last_shown();
    if ( f > cursor_line ) do {
	if ( lf == f ) break;
	box_->scroll_forward(Dimension_Y);
	lf = f;
	f = box_->first_shown();
    } while ( f > cursor_line );
    else while ( l < cursor_line ) {
	if ( ll == l ) break;
	box_->scroll_backward(Dimension_Y);
	ll = l;
	l = box_->last_shown();
    }
}

int umtRTFText::CursorLeft()
{
    int r;
    ccolor = cr_color;
    cfont = cr_font;
    r = cursor_placed_bk();
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return r;
}

int umtRTFText::CursorRight()
{
    int r;
    ccolor = cr_color;
    cfont = cr_font;
    r = cursor_placed();
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return r;
}

#define CURSOR_ON_SPACE ( cursor->GetType()!=0 || \
		     ((umtRTFChar*)cursor)->      \
		     TheChar==' ' ||              \
		     ((umtRTFChar*)cursor)->      \
		     TheChar=='\t' ||             \
		     ((umtRTFChar*)cursor)->      \
		     TheChar==',' )
int umtRTFText::CursorWLeft()
{
    int r;
    ccolor = cr_color;
    cfont = cr_font;
    do r = cursor_placed_bk();
    while ( r<2 && CURSOR_ON_SPACE );
    do r = cursor_placed_bk();
    while ( r<2 && !CURSOR_ON_SPACE );
    cursor_placed();
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return r;
}

int umtRTFText::CursorWRight()
{
    int r;
    ccolor = cr_color;
    cfont = cr_font;
    do r = cursor_placed();
    while ( r<2 && CURSOR_ON_SPACE );
    do r = cursor_placed();
    while ( r<2 && !CURSOR_ON_SPACE );
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return r;
}
#undef CURSOR_ON_SPACE

int umtRTFText::CursorUp()
{
    int rs;
    Coord lx = x_position;
    ccolor = cr_color;
    cfont = cr_font;
    while ( (rs=cursor_placed_bk())==0 );
    if ( (rs=cursor_placed_bk()) < 2 )
	while ( x_position > lx &&
		(rs=cursor_placed_bk())==0 );
    if ( rs == 1 ) {
	cursor_placed();
	rs = 0;
    }
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return rs;
}

int umtRTFText::CursorDown()
{
    int rs;
    Coord lx = x_position;
    ccolor = cr_color;
    cfont = cr_font;
    while ( (rs=cursor_placed())==0 );
    if ( (rs=cursor_placed()) < 2 )
	while ( x_position < lx &&
		(rs=cursor_placed())==0 );
    if ( rs == 1 ) {
	cursor_placed_bk();
	rs = 0;
    }
    cr_color = ccolor;
    cr_font = cfont;
    scroll_to_cursor();
    return rs;
}

int umtRTFText::CursorHome()
{
    int rs = 0;
    ccolor = cr_color;
    cfont = cr_font;
    cursor_placed_bk();
    do rs = cursor_placed_bk();
    while ( cursor->GetType()!=2 && rs==0 );
    if ( rs < 2 ) {
	cursor_placed();
	if ( rs==1 )
	    cursor_placed();
    }
    cr_color = ccolor;
    cr_font = cfont;
    return rs;
}

int umtRTFText::CursorEnd()
{
    int rs;
    ccolor = cr_color;
    cfont = cr_font;
    while ( (rs=cursor_placed())==0 );
    if ( rs==1 ) cursor_placed_bk();
    cr_color = ccolor;
    cr_font = cfont;
    return rs;
}

int umtRTFText::CursorPgUp()
{
    int rs;
    if ( box_->cur_upper(Dimension_Y) ==
	 box_->upper(Dimension_Y) )
	return 2;
    GlyphIndex ps = box_->last_shown() -
	box_->first_shown() - 2;
    while ( ps > 0 && (rs=CursorUp()) < 2 ) ps -= 2;
    if ( rs == 2 ) CursorHome();
    scroll_to_cursor();
    return rs;
}

int umtRTFText::CursorPgDown()
{
    int rs;
    if ( box_->cur_lower(Dimension_Y) == 0 )
	return 2;
    GlyphIndex ps = box_->last_shown() -
	box_->first_shown() - 2;
    int lls = ps;
    while ( ps > 0 && (rs=CursorDown()) < 2 ) ps -= 2;
    if ( rs == 2 ) CursorEnd();
    for ( ; lls > 0 ; lls-- )
	box_->scroll_backward(Dimension_Y);
    scroll_to_cursor();
    return rs;
}

int umtRTFText::CursorTop()
{
    while ( CursorUp() < 2 );
    CursorHome();
    scroll_to_cursor();
    return 2;
}

int umtRTFText::CursorBottom()
{
    while ( CursorDown() < 2 );
    CursorEnd();
    scroll_to_cursor();
    return 2;
}


int umtRTFText::BS()
{
    if ( CursorLeft() < 2 )
        return Del();
    else return 2;
}

int umtRTFText::Del()
{
    int r = 0;
    umtRTFTextComponent* c2k = cursor;
    if ( c2k ) {
      	if ( CursorRight() == 2 )
      	    return 2;
	if ( c2k->GetType() == 2 ) {
	    umtRTFTextComponent* nc;
	    nc = (umtRTFTextComponent*)c2k->Prev;
	    if ( nc->GetType() == 1 &&
		 ((umtRTFCom*)nc)->Mean == cmNewLine ) {
		umtSlist::Remove(c2k);
		delete c2k;
		c2k = nc;
		r = 2;
	    } else
	        return 1;
	} else
	    r = 1;
	page_->remove(--cursor_position);
	umtSlist::Remove(c2k);
	delete c2k;
	Repair();
    }
    scroll_to_cursor();
    return r;
}

int umtRTFText::cursor_placed()
{
    if ( !cursor ) {
	cursor = (umtRTFTextComponent*)first;
	cursor_line = 0;
	if ( cursor ) {
	    cursor_position = 1;
	    if ( cursor->GetType()==0 )
		return 0;
	} else {
	    cursor_position = 0;
	    return 2;
	}
    }
    int r = 0;
    umtRTFTextComponent* prv =
	(umtRTFTextComponent*)cursor->Next;
    while ( prv && prv->GetType()!=0 )
	prv = (umtRTFTextComponent*)prv->Next;
    if ( !prv ) return 2;
    if ( cursor )
	do {
	    switch ( cursor->GetType() ) {
	    case 1:
		switch ( ((umtRTFCom*)cursor)->Mean ) {

		case cmBigger:        set_bigger();              break;
		case cmSmallerDn:     set_bigger();              break;
		case cmSmaller:       set_smaller();             break;
		case cmBiggerDn:      set_smaller();             break;
		case cmBold:          set_bold();                break;
		case cmBoldDn:        unset_bold();              break;
		case cmItalic:        set_italic();              break;
		case cmItalicDn:      unset_italic();            break;
		case cmFixed:         set_fixed();               break;
		case cmFixedDn:       unset_fixed();             break;

		case cmIndent:        c_indent++;                break;
		case cmIndentDn:      c_indent--;                break;
		case cmIndentRight:   c_indent_right++;          break;
		case cmIndentRightDn: c_indent_right--;          break;

		case cmNofill:        cur_st.Push(cmNofill    ); break;
		case cmNofillDn:      cur_st.Pop (cmNofill    ); break;
		case cmFlushLeft:     cur_st.Push(cmFlushLeft ); break;
		case cmFlushLeftDn:   cur_st.Pop (cmFlushLeft ); break;
		case cmFlushRight:    cur_st.Push(cmFlushRight); break;
		case cmFlushRightDn:  cur_st.Pop (cmFlushRight); break;
		case cmFlushBoth:     cur_st.Push(cmFlushBoth ); break;
		case cmFlushBothDn:   cur_st.Pop (cmFlushBoth ); break;
		case cmXColor:        cur_st.Push(cmXColor    ); break;

		case cmParam:
		    if ( cur_st.Top() == cmXColor ) {
			umtRTFTextComponent* pt =
			    (umtRTFTextComponent*)cursor->Next;
			char  nm[20];
			char* n = nm;
			while ( pt && pt->GetType()==3 && n-nm<sizeof(nm) ) {
			    *n++ = ((umtRTFChar*)pt)->TheChar;
			    pt = (umtRTFTextComponent*)pt->Next;
			}
			*n = 0;
			umtString* nms = new umtString(nm);
			ccolor = colors->ByName(*nms);
			colors_pars.Push(nms);
			cursor = pt;
		    }
		    break;
		case cmXColorDn:
		    cur_st.Pop(cmXColor);
		    pop_color();
		    break;
		case cmNewLine:
		    // r = 1;
		    break;
		default: break;
		}
		break;
	    case 0:
		if ( ((umtRTFChar*)cursor)->GetTheGlyph() ) {
		    x_position += ((umtRTFChar*)cursor)->TheWidth;
		    cursor_position++;
		}
		break;
	    case 2:
		x_position = 0;
		cursor_position++;
		cursor_line += 2;
		r = 1;
		break;
	    case 4:
		if ( ((umtRTFSpace*)cursor)->TheGlyph ) {
		    x_position += ((umtRTFSpace*)cursor)->TheWidth;
		    cursor_position++;
		}
		break;
	    }
	    cursor = (umtRTFTextComponent*)cursor->Next;
	} while ( cursor &&
		  ( cursor->GetType()!=0 ||
		    !((umtRTFChar*)cursor)->GetTheGlyph() ) &&
		  cursor->GetType()!=2 );
//		  ( cursor->GetType()!=1 ||
//		    ((umtRTFCom*)cursor)->Mean!=cmNewLine )
//	    );
    else {
	umtSlist::Append( cursor =
			  new umtRTFChar(' ')
	    );
	cursor_position = 1;
	x_position = 0;
    }
    if ( !cursor )
	return 2;
    return r;
}

int umtRTFText::cursor_placed_bk()
{
    if ( !cursor ) {
	cursor = (umtRTFTextComponent*)last;
	cursor_line = 0;
	if ( cursor ) {
	    cursor_position--;
	    if ( cursor->GetType()==0 )
		return 0;
	} else {
	    cursor_position = 0;
	    return 2;
	}
    }
    int r = 0;
    umtRTFTextComponent* tt = cursor;
    if ( tt )
	do tt = (umtRTFTextComponent*)tt->Prev;
	while ( tt && tt->GetType()!=0 && tt->GetType()!=2 );
    if ( !tt ) return 2;
    if ( cursor ) {
	do {
	    switch ( cursor->GetType() ) {
	    case 1:
		switch ( ((umtRTFCom*)cursor)->Mean ) {

		case cmBigger:        set_smaller();               break;
		case cmSmallerDn:     set_smaller();               break;
		case cmSmaller:       set_bigger();                break;
		case cmBiggerDn:      set_bigger();                break;
		case cmBold:          unset_bold();                break;
		case cmBoldDn:        set_bold();                  break;
		case cmItalic:        unset_italic();              break;
		case cmItalicDn:      set_italic();                break;
		case cmFixed:         unset_fixed();               break;
		case cmFixedDn:       set_fixed();                 break;
		case cmUnderline:     unset_underline();           break;
		case cmUnderlineDn:   set_underline();             break;

		case cmIndent:        c_indent--;                  break;
		case cmIndentDn:      c_indent++;                  break;
		case cmIndentRight:   c_indent_right--;            break;
		case cmIndentRightDn: c_indent_right++;            break;

		case cmNofill:        cmdstack.Push(cmNofill    ); break;
		case cmNofillDn:      cmdstack.Pop (cmNofill    ); break;
		case cmFlushLeft:     cmdstack.Push(cmFlushLeft ); break;
		case cmFlushLeftDn:   cmdstack.Pop (cmFlushLeft ); break;
		case cmFlushRight:    cmdstack.Push(cmFlushRight); break;
		case cmFlushRightDn:  cmdstack.Pop (cmFlushRight); break;
		case cmFlushBoth:     cmdstack.Push(cmFlushBoth ); break;
		case cmFlushBothDn:   cmdstack.Pop (cmFlushBoth ); break;

		case cmXColor:        pop_color();
		                      cur_st.Pop(cmXColor);        break;
		case cmXColorDn: {
		    cur_st.Push(cmXColor);
		    umtRTFTextComponent* pp;
		    int rl = 1;
		    pp = cursor;
		    while ( pp && rl>0 ) {
			pp = (umtRTFTextComponent*)pp->Prev;
			if ( pp && pp->GetType()==1 )
			    if ( ((umtRTFCom*)pp)->Mean==cmXColor )
				rl--;
			    else if ( ((umtRTFCom*)pp)->Mean==cmXColorDn )
				rl++;
		    }
		    if ( pp ) {
			do
			    pp = (umtRTFTextComponent*)pp->Next;
			while ( pp && pp->GetType()!=1 );
			if ( pp && ((umtRTFCom*)pp)->Mean==cmParam ) {
			    pp = (umtRTFTextComponent*)pp->Next;
			    char  nm[20];
			    char* n = nm;
			    while ( pp && pp->GetType()==3 && n-nm<sizeof(nm) ) {
				*n++ = ((umtRTFChar*)pp)->TheChar;
				pp = (umtRTFTextComponent*)pp->Next;
			    }
			    *n = 0;
			    umtString* nms = new umtString(nm);
			    ccolor = colors->ByName(*nms);
			    colors_pars.Push(nms);
			}
		    }
		    break;
		}
		default: break;
		}
		break;
	    case 0:
		if ( ((umtRTFChar*)cursor)->GetTheGlyph() ) {
		    x_position -= ((umtRTFChar*)cursor)->TheWidth;
		    cursor_position--;
		}
		break;
	    case 2:
		umtRTFTextComponent* tmpp;
		tmpp = (umtRTFTextComponent*)cursor->Prev;
		x_position = 0;
		while ( tmpp && tmpp->GetType()!=2 ) {
		    switch ( tmpp->GetType() ) {
		    case 0:
			if ( ((umtRTFChar*)tmpp)->GetTheGlyph() )
			    x_position += ((umtRTFChar*)tmpp)->TheWidth;
			break;
		    case 4:
			if ( ((umtRTFSpace*)tmpp)->TheGlyph )
			    x_position += ((umtRTFSpace*)tmpp)->TheWidth;
			break;
		    }
		    tmpp = (umtRTFTextComponent*)tmpp->Prev;
		}
		cursor_position--;
		r = 1;
		break;
	    case 4:
		if ( ((umtRTFSpace*)cursor)->TheGlyph ) {
		    x_position -= ((umtRTFSpace*)cursor)->TheWidth;
		    cursor_position--;
		}
		break;
	    }
	    cursor = (umtRTFTextComponent*)cursor->Prev;
	} while
	    ( cursor &&
	      (cursor->GetType()!=0 ||
	       !((umtRTFChar*)cursor)->GetTheGlyph() ) &&
	      cursor->GetType()!=2 );
	if ( cursor &&
	     cursor->GetType() == 2 )
	    cursor_line -= 2;
    } else if ( !cursor ) {
	cursor_position = 1;
	cursor_line = 0;
	umtSlist::Append( cursor =
			  new umtRTFChar(' ')
	    );
    }
    return r;
}

void umtRTFText::init()
{
    crtextrtf = 1;
    bold = italic = fixed = underline =
	sized = indent = indent_right =
	indent_fl = 0;
    indent_width = def_indent_width;
    ccolor = colors->Default();
    cfont = fonts->Default();
}

Coord umtRTFText::update_to(umtRTFTextComponent* to)
{
    Coord ret=0;
    init();
    if ( !to ) return 0;
    umtRTFTextComponent* p = (umtRTFTextComponent*)first;
    int ncrp = 1;
    int crl = 0;
    while ( p && p!=to ) {
	switch( p->GetType() ) {
	case 0:
	    ret += ((umtRTFChar*)p)->TheWidth;
	    ncrp++;
	    break;
	case 1:
	    switch ( ((umtRTFCom*)p)->Mean ) {
	    case cmBigger:
	    case cmSmallerDn:
		set_bigger();
		break;
	    case cmSmaller:
	    case cmBiggerDn:
		set_smaller();
		break;
	    case cmXColor:
		cmdstack.Push(cmXColor);
		break;
	    case cmParam:
		if ( cmdstack.Top() == cmXColor ) {
		    umtRTFTextComponent* pt = (umtRTFTextComponent*)p->Next;
		    char  nm[20];
		    char* n = nm;
		    while ( pt && pt->GetType()==3 && n-nm<sizeof(nm) ) {
			*n++ = ((umtRTFChar*)pt)->TheChar;
			pt = (umtRTFTextComponent*)pt->Next;
		    }
		    *n = 0;
		    umtString* nms = new umtString(nm);
		    ccolor = colors->ByName(*nms);
		    colors_pars.Push(nms);
		    p = pt;
		}
		break;
	    case cmXColorDn:
		cmdstack.Pop(cmXColor);
		pop_color();
		break;
	    case cmIndent: indent++; break;
	    case cmIndentDn: indent--; break;
	    case cmIndentRight: indent_right++; break;
	    case cmIndentRightDn: indent_right--; break;
	    case cmNofill: cmdstack.Push(cmNofill); break;
	    case cmNofillDn: cmdstack.Pop(cmNofill); break;
	    case cmFlushLeft: cmdstack.Push(cmFlushLeft); break;
	    case cmFlushLeftDn: cmdstack.Pop(cmFlushLeft); break;
	    case cmFlushRight: cmdstack.Push(cmFlushRight); break;
	    case cmFlushRightDn: cmdstack.Pop(cmFlushRight); break;
	    case cmFlushBoth: cmdstack.Push(cmFlushBoth); break;
	    case cmFlushBothDn: cmdstack.Pop(cmFlushBoth); break;
	    default: break;
	    }
	    break;
	case 2:
	    ret = 0;
	    ncrp++;
	    crl += 2;
	    break;
	case 4:
	    ncrp++;
	    break;
	default: break;
	}
	p = (umtRTFTextComponent*)p->Next;
    }
    if ( to == cursor ) {
	cr_color = ccolor;
	cr_font = cfont;
	cursor_position = ncrp;
	cursor_line = crl;
    }
    return ret;
}

void umtRTFText::set_bigger()
{
    cfont = fonts->GetFont(FONT_ID,++sized);
}
void umtRTFText::set_smaller()
{
    cfont = fonts->GetFont(FONT_ID,--sized);
}
void umtRTFText::set_bold()
{
    if ( !bold++ )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::unset_bold()
{
    if ( !--bold )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::set_italic()
{
    if ( !italic++ )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::unset_italic()
{
    if ( !--italic )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::set_fixed()
{
    if ( !fixed++ )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::unset_fixed()
{
    if ( !--fixed )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::set_underline()
{
    if ( !underline++ )
	cfont = fonts->GetFont(FONT_ID,sized);
}
void umtRTFText::unset_underline()
{
    if ( !--underline )
	cfont = fonts->GetFont(FONT_ID,sized);
}

#ifdef RTF_IN_DEBUG
void umtRTFText::dump_out()
{
    char zz[4096];
    RTF_INFO_MSG("UMT: variables states dump :")
    RTF_INFO_MSG("  at (umtRTFText::) :")
    sprintf(zz,"     Font defs:  sized(%d), bold(%d), italic(%d),",
	    sized, bold, italic );
    RTF_INFO_MSG(zz)
    sprintf(zz,"                 fixed(%d), underline(%d).",
	    fixed, underline );
    RTF_INFO_MSG(zz)
    sprintf(zz,"     Cursor position: %ld", cursor_position);
    RTF_INFO_MSG(zz)
    sprintf(zz,"     Cursor line: %ld", cursor_line);
    RTF_INFO_MSG(zz)
    sprintf(zz,"         first shown: %ld",
	    box_->first_shown());
    RTF_INFO_MSG(zz)
	sprintf(zz,"         last  shown: %ld",
	    box_->last_shown());
    RTF_INFO_MSG(zz)
}
#endif
