/*
$Id: umtRtfTextComponent.cc,v 1.1 1996/10/22 19:47:43 lord Exp $

$Log: umtRtfTextComponent.cc,v $
Revision 1.1  1996/10/22 19:47:43  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:45  sebast
// Revision 2.0
//
// Revision 1.1  1996/03/03  12:44:18  voloh
// Initial revision
//
*/

#include <IV-look/kit.h>

#include "umtRtfTextComponent.h++"
#include "umtHelpCl.h++"


umtRTFTextComponent::~umtRTFTextComponent() { }

int umtRTFTextComponent::GetType()
{
    return  -1;
}


umtRTFChar::umtRTFChar(): umtRTFTextComponent(CLASS_RTFChar)
{
    TheChar  = 0;
    TheGlyph = nil;
    Hilight  = nil;
    TheWidth = 0;
    SetHidden();
}
umtRTFChar::umtRTFChar(int c): umtRTFTextComponent(CLASS_RTFChar)
{
    TheChar  = c&0xff;
    TheGlyph = nil;
    Hilight  = nil;
    TheWidth = 0;
    SetVisible();
}
umtRTFChar::umtRTFChar(int c,Glyph* g,Coord wd): umtRTFTextComponent(CLASS_RTFChar)
{
    Type     = 0;
    TheChar  = c;
    TheGlyph = g;
    Hilight  = nil;
    TheWidth = wd;
    if ( TheGlyph )
	Resource::ref(TheGlyph);
}
umtRTFChar::umtRTFChar(umtRTFChar* c): umtRTFTextComponent(CLASS_RTFChar)
{
    Type     = c->Type;
    TheChar  = c->TheChar;
    TheGlyph = c->TheGlyph;
    TheWidth = c->TheWidth;
    Hilight  = nil;
    if ( TheGlyph )
	Resource::ref(TheGlyph);
}

umtRTFChar::~umtRTFChar()
{
    if ( TheGlyph )
	Resource::unref(TheGlyph);
    if ( Hilight )
	Resource::unref(Hilight);
}

Glyph* umtRTFChar::SetTheGlyph(Glyph* gl)
{
    if ( TheGlyph )
	Resource::unref(TheGlyph);
    if ( TheGlyph = gl )
	Resource::ref(TheGlyph);
    return TheGlyph;
}

Glyph* umtRTFChar::SetHilight(Glyph* gl)
{
    if ( Hilight )
	Resource::unref(Hilight);
    if ( Hilight = gl )
	Resource::ref(Hilight);
    return Hilight;
}

int umtRTFChar::GetType()
{
    return Type;
}

int umtRTFChar::IsRef()
{
    return 0;
}

char umtRTFChar::CharacterType[256] =
{
    0,0,0,0,0,0,0,0,0,3,4,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,                   // 31  //  0 - not-printable
                          1,1,1,1,1,1,1,1,1,        //  1 - normal char
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,        //  2 - label char
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,        //  3 - TAB
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,        //  4 - line breaker
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,                             // 126
                2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,           // 175
                                  2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,   // 239
                                          2,
    2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
};


umtRTFLineBr::~umtRTFLineBr() { }

int umtRTFLineBr::GetType()
{
    return  2;
}


umtRTFSpace::~umtRTFSpace()
{
    if ( TheGlyph )
	Resource::unref( TheGlyph );
    if ( Hilight )
	Resource::unref( Hilight );
}

int umtRTFSpace::GetType()
{
    return  4;
}


umtRefHandler::umtRefHandler(
    Glyph* gl, umtRefPointListEntry* hpli
) : InputHandler(gl, nil)
{
    the_ref_entry = hpli;
}

umtRefHandler::~umtRefHandler() { }


void umtRefHandler::press(const Event& ev)
{
    if ( the_ref_entry )
	the_ref_entry->Act(this);
//    InputHandler::press(ev);
}

void umtRefHandler::move(const Event& ev)
{
//    InputHandler::move(ev);
    if ( the_ref_entry )
	the_ref_entry->CursorHilight();
}


umtRTFRef::umtRTFRef( int ch ) :
    umtRTFChar( ch )
{
    the_ref_entry = nil;
}

umtRTFRef::umtRTFRef( int ch, umtRefPointListEntry* re ) :
    umtRTFChar( ch )
{
    the_ref_entry = re;
}

umtRTFRef::umtRTFRef( int ch, Glyph* gl, Coord w,
		      umtRefPointListEntry* re) :
    umtRTFChar(
	ch,
	    new umtRefHandler(
		gl, re
	    ),
	    w
    )
{
    the_ref_entry = re;
}

umtRTFRef::umtRTFRef(
    umtRTFChar* c, umtRefPointListEntry* re ) :
    umtRTFChar(
	c->TheChar,
	    new umtRefHandler(
		c->GetTheGlyph(), re
	    ),
	    c->TheWidth
    )
{
    the_ref_entry = re;
}

umtRTFRef::umtRTFRef( umtRTFRef* rf ) :
    umtRTFChar(rf)
{
    the_ref_entry = rf->the_ref_entry;
}

umtRTFRef::~umtRTFRef() { }


void umtRTFRef::SetRefEntry(umtRefPointListEntry* re)
{
    the_ref_entry = re;
}

int umtRTFRef::GetType()
{
    return  0;//5;
}

int umtRTFRef::IsRef()
{
    return 1;
}

Glyph* umtRTFRef::SetTheGlyph(Glyph* gl)
{
    Glyph* g;
    umtRTFChar::SetTheGlyph(
	gl ? (g=new umtRefHandler(gl,the_ref_entry)) :
	    (g=nil)
    );
    return g;
}

Glyph* umtRTFRef::SetHilight(Glyph* gl)
{
    Glyph* g;
    umtRTFChar::SetHilight(
	gl ? (g=new umtRefHandler(gl,the_ref_entry)) :
	      (g=nil)
    );
    return g;
}
