/*
$Id: umtRtfViewer.cc,v 1.1 1996/10/22 19:47:44 lord Exp $

$Log: umtRtfViewer.cc,v $
Revision 1.1  1996/10/22 19:47:44  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:46  sebast
// Revision 2.0
//
// Revision 1.6  1996/03/07  14:44:34  voloh
// umtRTFFonts -> ref/unref
//
// Revision 1.5  1996/03/03  18:17:20  voloh
// some debuging removed
//
// Revision 1.4  1996/03/03  15:24:31  voloh
// corrections.
//
// Revision 1.3  1996/03/03  14:17:10  voloh
// umtXBuffer removed.
//
// Revision 1.2  1996/03/03  14:07:50  voloh
// -----
//
// Revision 1.1  1996/03/03  12:41:52  voloh
// Initial revision
//
*/

#include "umtRtfView.h++"
#include "umtRefPointList.h++"


implementActionCallback(umtRTFView)

umtRTFView::umtRTFView() :
    InputHandler(nil, WidgetKit::instance()->style()),
    umtRTFText()
{
    ready = 0;
    ih = nil;
    ref_callbacks = new umtRefPointList();
    ErrorStatus = OK;
    mouse_state = NotPressed;
    set_wind_width(0);
    init_base();
}

umtRTFView::~umtRTFView() {
    Delete(ref_callbacks);
    remove_all_input_handlers();
    if ( ih ) Resource::unref(ih);
    if ( full_body ) Resource::unref(full_body);
}


status umtRTFView::Reinit(int TextIsRTF)
{
    ClearMark();
    Clean();
    ReDrawIn();
    if ( !TextIsRTF ) {
	Append(new umtRTFCom(cmRtfOff));
	crtextrtf = TextIsRTF;
    }
    return ErrorStatus;
}

status umtRTFView::Reinit(InputFile* file, int TextIsRTF)
{
    if ( Reinit(TextIsRTF) != OK )
	return ErrorStatus;
    Add ( file, TextIsRTF );
    return OK;
}

status umtRTFView::Reinit(umtString& strng, int TextIsRTF)
{
    if ( Reinit(TextIsRTF) != OK )
	return ErrorStatus;
    Add ( strng, TextIsRTF );
    return OK;
}


status umtRTFView::init_base()
{
    umtString fntscfg = BaseFonts;
    ErrorStatus = OK;
    Kit = WidgetKit::instance();
    XLayout = LayoutKit::instance();
    XStyle = Kit->style();
    XDisplay = Session::instance()->default_display();
    full_body = nil;
    first_marked =
	last_marked = nil;
    umtConfiguration* cfg =
	UMTConfig.GetConfiguration(GroupRTFCfgName);
    if ( !cfg ) {
	RTF_CRITICAL_MSG("NULL Configuration for umtRTFView");
	return ErrorStatus = NO_VARIABLE_DEFINED;
    }
    umtRTFFonts* fnt =
	new umtRTFFonts(BaseFonts);
    Resource::ref(fnt);
    if ( !fnt ) {
	RTF_CRITICAL_MSG("Not enough memory for fonts initialization.");
	return ErrorStatus = NOT_ENOUGH_MEMORY;
    } else if ( fnt->ErrorStatus) {
	Resource::unref(fnt);
	RTF_CRITICAL_MSG("Error fonts initialization.");
	return ErrorStatus = ERROR_IN_CALLED_FUNCTION;
    }
    umtRTFColors* clr =
	new umtRTFColors(UMTConfig.GetStrField(DefaultColor));
    if ( !clr ) {
	RTF_DEBUG_MSG("Not enough memory for colors initialization.");
	Resource::unref(fnt);
	return ErrorStatus = NOT_ENOUGH_MEMORY;
    } else if ( clr->ErrorStatus ) {
	Resource::unref(fnt);
	delete clr;
	RTF_DEBUG_MSG("Error colors initialization.");
	return ErrorStatus = ERROR_IN_CALLED_FUNCTION;
    }
    Init ( fnt, clr );
    if ( ErrorStatus ) return ErrorStatus;
    umtString bgn = UMTConfig.GetStrField(BackgroundColor);
    if ( bgn.IsEmpty() )
	back = Kit->background();
    else
	back = clr->ByName(bgn);
    bgn = UMTConfig.GetStrField(HiBackgroundColor);
    if ( bgn.IsEmpty() )
	hi_back = Kit->background();
    else
	hi_back = clr->ByName(bgn);
    full_body = new Background(page_, back);
    Resource::ref(full_body);
    body(full_body);
    ReDrawIn();
    umtString swe;
    swe = cfg->GetStrField(SWITCH_EXCERPT_ON);
    set_excerpt_on(swe);
    swe = cfg->GetStrField(SWITCH_EXCERPT_OFF);
    set_excerpt_off(swe);
    double iw;
    if ( cfg->GetDoubleField(DEFAULT_INDENT_WIDTH,&iw) )
	iw = 4*fnt->Default()->width(' ');
    set_indent_width((Coord)iw);
    set_tab_width(8*fnt->Default()->width(' '));
    remove_all_input_handlers();
    if ( ih ) Resource::unref(ih);
    ih = new InputHandler(full_body, Kit->style());
    Resource::ref(ih);
    append_input_handler(ih);
    ready = 1;
    return OK;
}

void umtRTFView::Add(InputFile *file, int TextIsRTF)
{
    if ( !ready ) return;
    const char* data;
    umtString str;
    for (;file;) {
	int len = file->read(data);
	if (len <= 0) break;
	str = umtString(data,len);
	umtRTFText::Add(str,TextIsRTF);
    }
}

void umtRTFView::Add(umtString& str, int TextIsRTF)
{
    if ( ready )
	umtRTFText::Add(str,TextIsRTF);
}

Glyph* umtRTFView::Body() const
{
    return body();
}

void umtRTFView::ReBuildAll()
{
    umtRTFText::ReBuildAll();
    ReBuild();
}

void umtRTFView::FastReBuild()
{
    unmark_hilight();
    umtRTFText::FastReBuild();
    mark_hilight();
}

void umtRTFView::allocate(
    Canvas* c, const Allocation& a, Extension& e
) {
    int ld = 0;
    MonoGlyph::allocate(c,a,e);
    unmark_hilight();
    if ( cursor ) {
	while ( cursor->GetType()==2 &&
		CursorLeft() < 2 ) ld++;
	if ( cursor->GetType() == 2 ) {
	    init();
	    cursor = nil;
	}
    }
    Coord newW = a.right()-a.left();
    int restorec =
	( get_wind_width() == 0 ) ? 0:1;
    if ( newW != get_wind_width() ) {
	set_wind_width(newW);
	_REMEMBER_SCROLL_POS_;
	ReBuild();
	if ( restorec )
	    {_RESTORE_SCROLL_POS_;}
    } else
	Repair();
    while ( ld-- > 0 )
	CursorRight();
    mark_hilight();
}

void umtRTFView::press(const Event& ev)
{
    if ( mouse_state == NotPressed ) {
	marked_stat = JustPressed;
	if ( ev.pointer_button() == Event::right ) {
	    mouse_state = RightMousePressed;
	} else if ( ev.pointer_button() == Event::middle ) {
	    mouse_state = MiddleMousePressed;
	} else /*if ( ev.pointer_button() == Event::left )*/ {
	    mouse_state = LeftMousePressed;
	    ClearMark();
	}
    }
}

void umtRTFView::drag(const Event& ev)
{
    GlyphIndex gi_gr;
    umtRTFTextComponent* drag_at;
    if ( mouse_state == NotPressed )
	return;
    drag_at = by_coord(
	ev.pointer_x(),
        ev.pointer_y(),
        gi_gr
    );
    unmark_hilight();
    if ( mouse_state == LeftMousePressed ) {
	switch ( marked_stat ) {
	case JustPressed:
	    first_marked =
		last_marked = drag_at;
	    gi_first = gi_last = gi_gr;
	    marked_stat = CursAtEnd;
	    break;
	case CursAtBegining:
	    if ( gi_gr <= gi_last ) {
		first_marked = drag_at;
		gi_first     = gi_gr;
	    } else {
		first_marked = last_marked;
		gi_first     = gi_last;
		last_marked  = drag_at;
		gi_last      = gi_gr;
		marked_stat  = CursAtEnd;
	    }
	    break;
	case CursAtEnd:
	    if ( gi_gr >= gi_first ) {
		last_marked  = drag_at;
		gi_last      = gi_gr;
	    } else {
		last_marked  = first_marked;
		gi_last      = gi_first;
		first_marked = drag_at;
		gi_first     = gi_gr;
		marked_stat  = CursAtBegining;
	    }
	default:
	    break;
	}
    }
    mark_hilight();
}

void umtRTFView::release(const Event& ev)
{
    if ( mouse_state != NotPressed ) {
	if ( marked_stat == JustPressed )
	    switch ( mouse_state ) {
	    case LeftMousePressed:
		break;
	    case MiddleMousePressed:
		break;
	    case RightMousePressed:
	    default:
		break;
	    }
	else {
	    drag(ev);
	    umtString zz = GetMarked();
	    XStoreBytes(
		Session::instance()->
		    default_display()->rep()->display_,
		    strdup(zz.Str()),
		    strlen(zz.Str())
	    );
	}
	marked_stat  = Released;
	mouse_state  = NotPressed;
    }
}

void umtRTFView::double_click(const Event&)
{
    ClearMark();
}

void umtRTFView::move(const Event&)
{
    ref_callbacks->CursorUnHilight();
}

umtString umtRTFView::GetMarked() const
{
    umtString ret = "";
    umtRTFTextComponent* c = first_marked;
    while ( c ) {
	if ( c->GetType() == 0 ) {
	    if ( ((umtRTFChar*)c)->Type == 0 )
		if ( ((umtRTFChar*)c)->GetHilight() )
		    ret += ((umtRTFChar*)c)->TheChar;
		else break;
	} else if ( c->GetType()==1 )
	    if ( ((umtRTFCom*)c)->Mean == cmNewLine )
		ret += '\n';
	c = (umtRTFTextComponent*)c->Next;
    }
    return ret;
}

void umtRTFView::mark_hilight()
{
    int fc = 1;
    _REMEMBER_SCROLL_POS_;
    umtRTFTextComponent* cc;
    GlyphIndex cg;
    cc = first_marked;
    cg = gi_first;
    while ( cc && fc ) {
	switch ( cc->GetType() ) {
	case 0:
	    if ( ((umtRTFChar*)cc)->GetTheGlyph() ) {
		if ( !((umtRTFChar*)cc)->GetHilight() ) {
		    ((umtRTFChar*)cc)->SetHilight(
		        new Background(
			    ((umtRTFChar*)cc)->GetTheGlyph(),
				hi_back
		        )
		    );
		    page_->replace(cg,((umtRTFChar*)cc)->GetHilight());
		}
		cg++;
	    }
	    break;
	case 4:
	    if ( ((umtRTFSpace*)cc)->TheGlyph ) {
		if ( !((umtRTFSpace*)cc)->Hilight ) {
		    Resource::ref(
			((umtRTFSpace*)cc)->Hilight =
		        new Background(
			    ((umtRTFSpace*)cc)->TheGlyph,
		            hi_back
		        )
		    );
		    page_->replace(cg,((umtRTFSpace*)cc)->Hilight);
		}
		cg++;
	    }
	    break;
	case 2: cg++;
	default:
	    break;
	}
	if ( cc == last_marked ) fc = 0;
	cc = (umtRTFTextComponent*)cc->Next;
    }
    Repair();
    _RESTORE_SCROLL_POS_;
}

void umtRTFView::unmark_hilight()
{
    Allotment a;
    allotment(
	page_->beginning_of(box_->last_shown()),
	    Dimension_Y, a
    );
    int fc = 1;
    umtRTFTextComponent* cc;
    _REMEMBER_SCROLL_POS_;
    GlyphIndex cg;
    cc = first_marked;
    cg = gi_first;
    while ( cc && fc ) {
	switch ( cc->GetType() ) {
	case 0:
	    if ( ((umtRTFChar*)cc)->GetHilight() ) {
		((umtRTFChar*)cc)->SetHilight(nil);
		page_->replace(cg,((umtRTFChar*)cc)->GetTheGlyph());
		cg++;
	    }
	    break;
	case 4:
	    if ( ((umtRTFSpace*)cc)->Hilight ) {
		Resource::unref(((umtRTFSpace*)cc)->Hilight);
		((umtRTFSpace*)cc)->Hilight = nil;
		page_->replace(cg,((umtRTFSpace*)cc)->TheGlyph);
		cg++;
	    }
	    break;
	case 2: cg++;
	default:
	    break;
	}
	if ( cc == last_marked ) fc = 0;
	cc = (umtRTFTextComponent*)cc->Next;
    }
    Repair();
    if ( a.begin() != a.end() )
	{ _RESTORE_SCROLL_POS_; }
}

void umtRTFView::ClearMark()
{
    unmark_hilight();
    first_marked =
	last_marked = nil;
}

umtRTFTextComponent* umtRTFView::by_coord(
    Coord _x, Coord _y, GlyphIndex& gi )
{
    umtRTFTextComponent* f =
	(umtRTFTextComponent*)first;
    umtRTFTextComponent* pf = f;
    Allotment al;
    GlyphIndex gil = 1;
    gi = gil;
    if ( f ) do {
	while ( f->Next &&
		( f->GetType()!=0 ||
		  !((umtRTFChar*)f)->GetTheGlyph() ) &&
		f->GetType()!=2 ) {
	    if ( f->GetType() == 4 ) gil++;
	    f = (umtRTFTextComponent*)f->Next;
	}
	if ( f ) { pf = f; gi = gil; }
	if ( f->GetType() == 0 &&
	     ((umtRTFChar*)f)->GetTheGlyph() ) {
	    page_->
		allotment(gil,Dimension_Y,al);
	    if ( al.begin() != 0 &&
		 al.begin() < _y )
		break;
	}
	while ( f && f->GetType()!=2 ) {
	    switch ( f->GetType() ) {
	    case 0:
		if ( ((umtRTFChar*)f)->GetTheGlyph() )
		    gil++;
		break;
	    case 4:
		gil++;
		break;
	    }
	    f = (umtRTFTextComponent*)f->Next;
	}
	if ( f ) {
	    f = (umtRTFTextComponent*)f->Next;
	    gil++;
	}
    } while ( f );
    if ( pf ) do {
	page_->allotment(gi,Dimension_X,al);
	if ( al.end() < _x ) {
	    while( pf &&
		   pf->GetType()!=0 &&
		   pf->Next &&
		   ((umtRTFTextComponent*)
		    (pf->Next))->GetType()!=2 ) {
		if ( pf->GetType() == 4 ) gi++;
		pf = (umtRTFTextComponent*)pf->Next;
	    }
	    if ( pf ) {
		if ( pf->GetType() == 0 ) {
		    if ( ((umtRTFChar*)pf)->GetTheGlyph() )
			gi++;
		} else {
		    gi++;
		    break;
		}
		if ( pf->Next )
		    pf = (umtRTFTextComponent*)pf->Next;
	    }
	}
    } while ( al.end() < _x &&
	      pf->GetType()!=2 &&
	      pf->Next );
    return pf;
}


#ifdef RTF_IN_DEBUG
void umtRTFView::dump_out()
{
    char zz[4096];
    umtRTFText::dump_out();
    sprintf(zz,"umtRTFView:  Marked line = '%s'",GetMarked().Str());
    RTF_INFO_MSG(zz)
}
#endif
