/*
  $Header: /export/CVS/UMT/libsrc/umtIV/umtFancyStrSelectionList.cc,v 1.1 1996/10/22 19:47:46 lord Exp $
  
  $Log: umtFancyStrSelectionList.cc,v $
  Revision 1.1  1996/10/22 19:47:46  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:47  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:50  sebast
// Revision 2.0
//
// Revision 1.9  1996/03/18  15:13:27  bird
// argument of constructor added
//
// Revision 1.8  1995/11/09  16:21:57  bird
// append hnatural() in constructer
//
// Revision 1.7  1995/08/24  13:54:27  lord
// String->Str
//
// Revision 1.6  1995/08/24  13:31:20  lord
// String->Str
//
// Revision 1.5  1995/08/02  11:44:07  lord
// umt coding rules
//
// Revision 1.4  1995/07/28  16:13:54  sebast
// some members made static
//
// Revision 1.3  1995/06/28  15:40:58  lord
// flip_to(0) in constructor added
//
// Revision 1.2  1995/06/28  15:11:25  lord
// second patch removed.
//
// Revision 1.1  1995/06/26  13:26:28  lord
// Initial revision
//
*/

#include <InterViews/deck.h>
#include <IV-look/kit.h>

#include "umtFancyStrSelectionList.h++"
#include "umt_const.h++"

const  unsigned  int  umtFancyStrSelectionListEntry::checkmark_width  = 32;
const  unsigned  int  umtFancyStrSelectionListEntry::checkmark_height = 12;


unsigned  char umtFancyStrSelectionListEntry::checkmark_bits[] = {
    0x00, 0x00, 0x3e, 0x00, 0x00, 0xc0, 0x0f, 0x00,
    0x04, 0xf0, 0x03, 0x00, 0x1e, 0xf8, 0x00, 0x00,
    0x3f, 0x3e, 0x00, 0x00, 0xbf, 0x1f, 0x00, 0x00,
    0xf8, 0x07, 0x00, 0x00, 0xf0, 0x03, 0x00, 0x00,
    0xf0, 0x01, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

const Color   * umtFancyStrSelectionListEntry::checkmark_color=nil;
Stencil * umtFancyStrSelectionListEntry::checkmark=nil;
int umtFancyStrSelectionListEntry::ninstances=0;

umtFancyStrSelectionListEntry::umtFancyStrSelectionListEntry(umtString      s, 
							     umtSelectionList *l,
							     Style          *st,
							     WidgetKit      *kt,
							     LayoutKit      *la,
							     Glyph *g) :
    umtSelectionListEntry(la->hbox(),
			  l,
			  st)
{
    
    layout=la;
    kit=kt;
    Str=s;
    
    if(!checkmark_color)
	checkmark_color = new Color( 
	    DefaultFStrListSelectionColorR,
	    DefaultFStrListSelectionColorG, 
	    DefaultFStrListSelectionColorB, 
	    DefaultFStrListSelectionColorA 
	);
    
    checkmark_color->Resource::ref();
    
    if(!checkmark)
	checkmark = new Stencil(
	    new Bitmap(checkmark_bits, checkmark_width, checkmark_height, 0, 13),
	    checkmark_color
	);
    
    checkmark->Resource::ref();

    ninstances++;

    if( g )
	label = g;
    else
	label = kit->label(s);
	    
    body(
	la->hnatural(
	    kit->inset_frame(
		patch=new Patch(
		    layout->hbox(
			layout->hspace(5),
			de=layout->deck(
			    layout->hspace(checkmark_width),
			    checkmark
			),
			layout->hspace(checkmark_width),
			label,
			layout->hglue()
		    )
		)
	    ),500)
    );
    
    de->flip_to(0);
}

umtFancyStrSelectionListEntry::umtFancyStrSelectionListEntry(umtFancyStrSelectionListEntry *o)
    :umtSelectionListEntry(o)
{
    Str         = o->Str;
    label       = o->label ;
    patch       = o->patch ;
}

umtFancyStrSelectionListEntry::~umtFancyStrSelectionListEntry()
{
    checkmark         -> Resource::unref();
    checkmark_color   -> Resource::unref();
    
    ninstances--;
    if(ninstances==0)
    {
	checkmark         = nil;
	checkmark_color   = nil;
    }
}

void umtFancyStrSelectionListEntry::ClickL()
{
    umtSelectionListEntry::ClickL();
    de->flip_to(IsSelected);
    patch->redraw();
}

void umtFancyStrSelectionListEntry::ChangeString(umtString newstring)
{
    label=kit->label(newstring.Str());
    Str=newstring;
    patch->body()->replace(3,label);
    patch->redraw();
}









