/*
$Header: /export/CVS/UMT/libsrc/umtIV/umtSelectionList.cc,v 1.1 1996/10/22 19:47:48 lord Exp $

$Log: umtSelectionList.cc,v $
Revision 1.1  1996/10/22 19:47:48  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:47  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:56  sebast
// Revision 2.0
//
// Revision 1.26  1996/03/18  15:12:55  bird
// *** empty log message ***
//
// Revision 1.25  1996/02/15  18:04:21  bird
// Update scrollbar
//
// Revision 1.24  1995/11/20  17:05:37  bird
// bug in umtSelectionList::Remove() fixed
//
// Revision 1.23  1995/11/18  13:50:27  bird
// remove entrys from umtSelectionList in destructor
//
// Revision 1.22  1995/11/09  16:23:02  bird
// empty_glyph & is_empty added
//
// Revision 1.21  1995/10/19  15:28:33  bird
// port to gcc
//
// Revision 1.20  1995/10/01  15:35:37  bird
// Insert() added
//
// Revision 1.19  1995/09/27  17:42:23  lord
// Move added
//
// Revision 1.18  1995/09/09  15:11:27  lord
// GetSelected added
//
// Revision 1.17  1995/09/08  09:42:44  lord
// Bug with selection in reverse order fixed
//
// Revision 1.16  1995/08/29  16:34:54  lord
// bug with marking items in reverse order fixed.
//
// Revision 1.15  1995/08/29  14:46:43  lord
// do not ref/unref items in constructor/destructor, append/remove because
// it is done by container.
//
// Revision 1.14  1995/08/25  13:10:04  lord
// remove ref in Append.
//
// Revision 1.13  1995/08/25  11:39:30  lord
// Fix bug in press in single mode
//
// Revision 1.12  1995/08/02  11:21:54  lord
// umt coding rules
//
// Revision 1.11  1995/06/24  15:31:29  lord
// remove fixed.
// Remove ref,unref from constructor
// Ref/unref in append/remove
//
// Revision 1.10  1995/06/24  14:53:28  lord
// test for member to be appended or removed not to be NILL
//
// Revision 1.9  1995/06/22  12:31:31  sebast
// call of member() in constructors added
//
// Revision 1.8  1995/06/21  16:11:03  lord
// Disallow deselection in single mode
//
// Revision 1.7  1995/06/21  14:18:46  lord
// Single selection mode
//
// Revision 1.6  1995/06/21  12:28:17  lord
// is_multy handling
//
// Revision 1.5  1995/06/21  11:22:23  lord
// Debuging printfs removed
//
// Revision 1.4  1995/06/19  16:18:08  lord
// *** empty log message ***
//
// Revision 1.3  1995/06/18  16:34:27  lord
// unmark_all added
//
// Revision 1.2  1995/06/18  12:29:54  lord
// First implementation.
// Normally this should not work ;-)
//
// Revision 1.1  1995/06/18  11:55:39  lord
// Initial revision
//
*/

#include "umtSelectionList.h++"

#include <InterViews/event.h>

// ---------- class umtSelectionList_entry --------------

umtSelectionListEntry::umtSelectionListEntry(Glyph *p,umtSelectionList *l,Style *s)
    :ActiveHandler(p,s), umtMember(CLASS_SELECTION_LIST_ENTRY)
{
  lst=l;
  par=p;
  sty=s;
  IsSelected=0;
}

umtSelectionListEntry::umtSelectionListEntry(umtSelectionListEntry *o)
    :ActiveHandler(o->par,o->sty), umtMember(CLASS_SELECTION_LIST_ENTRY)
{
  lst=o->lst;
  par=o->par;
  sty=o->sty;
  IsSelected=o->IsSelected;
}

umtSelectionListEntry::~umtSelectionListEntry()
{
}

void umtSelectionListEntry::release(const Event &)
{
// We are in in this function if single key is pressed only.
  lst->press_flag=0; // Just to be safe
}

void umtSelectionListEntry::press       (const Event &event)
{
  if(event.pointer_button() == Event::right)
    { // Right mouse button pressed
      lst->press_flag=0;
      ClickR();
    }
  else 
    { // Left mouse button pressed
      
      if(lst->is_multy)
	{
	  lst->start_drag=this;
	  if(!(event.control_is_down()))
	    lst->UnmarkAll();
	  lst->press_flag=1;
	  ClickL();
	} else {
//	  if(!IsSelected) {
	    lst->UnmarkAll();
	    ClickL();
//	  }
	}
    }
}

void umtSelectionListEntry::move        (const Event &event)
{
  umtSelectionListEntry *i;
  int in;

  Move();
  if(!(lst->is_multy)) return;
  if(lst->press_flag) 
  {
      if(!(event.left_is_down())) // Strop Dragging
	  lst->press_flag=0;
      in=0;
      for(
	  i=(umtSelectionListEntry*)(lst->Members.GetFirst());
	  i;
	  i=(umtSelectionListEntry*)(lst->Members.GetNext(i))
      ){
	  if(!(i->IsSelected) && in)
	      i->ClickL();
	  if(i==this || i==lst->start_drag) in=1-in;
	  if(!(i->IsSelected) && in)
	      i->ClickL();
      }
  }
} 


void umtSelectionListEntry::drag        (const Event &event)
{
    if(lst->is_multy) event.ungrab(handler());
}

void umtSelectionListEntry::double_click(const Event &) 
{
    ClickD();
}

void umtSelectionListEntry::ClickL()
{
    IsSelected=1-IsSelected;
}

void umtSelectionListEntry::ClickR()
{

}

void umtSelectionListEntry::ClickD()
{

}

void umtSelectionListEntry::Move()
{

}

// ---------- class umtSelectionList --------------

umtSelectionList::umtSelectionList(int multi_selection_allowed,Glyph *g)
:TBScrollBox()
{
  is_multy=multi_selection_allowed;
  press_flag=0;

  empty_glyph = g;
  if( empty_glyph )
  {
      empty_glyph->ref();
      is_empty = 1;
      TBScrollBox::append(empty_glyph);  
  }
}

umtSelectionList::~umtSelectionList()
{
      if( empty_glyph )
      {
      	  if( is_empty )
	  {
	      is_empty = 0;
	      TBScrollBox::remove(0);
	  }
	  empty_glyph->unref();
      }

      while( TBScrollBox::count() > 0 )
	  TBScrollBox::remove(0);
      
//      Members.Kill(NULL);
}

void umtSelectionList::Insert(umtSelectionListEntry *e1,umtSelectionListEntry *e2)
{
    Coord cc;
    if(e1)
    {
	GlyphIndex i;
      
	if( empty_glyph )
	    if( is_empty )
	    {
		is_empty = 0;
		TBScrollBox::remove(0);
	  }
	
	Members.Insert(e1,e2);
	for( i = 0; i < TBScrollBox::count(); i++)
	    if( TBScrollBox::component(i) == e2 )
		break;
	i = i?i-1:i;
	
	TBScrollBox::insert(i,e1);
	notify_all();
//	cc = TBScrollBox::cur_lower(Dimension_Y);
// 	constrain(Dimension_Y,cc);
// 	scroll_to(Dimension_Y,cc);
// 	notify_all();
  }
}

void umtSelectionList::Append(umtSelectionListEntry *e)
{
    Coord cc;
    if(e) {
	
	if( empty_glyph )
      	  if( is_empty )
	  {
	      is_empty = 0;
	      TBScrollBox::remove(0);
	  }
	
	Members.Append(e);
	TBScrollBox::append(e);
	notify_all();
// 	cc = TBScrollBox::cur_lower(Dimension_Y);
// 	constrain(Dimension_Y,cc);
// 	scroll_to(Dimension_Y,cc);
// 	notify_all();
    }
}

void umtSelectionList::Remove(umtSelectionListEntry *e)
{
  umtSelectionListEntry *i;
  int n;
  Coord cc;
  
  if(e) {
    n=0;
    for(
	i=(umtSelectionListEntry *)(Members.GetFirst());
	i;
	i=(umtSelectionListEntry *)(Members.GetNext(i)))
      {
	if(i==e) {
	  Members.Remove(e);
	  TBScrollBox::remove(n);
	  notify_all();
// 	  cc = TBScrollBox::cur_lower(Dimension_Y);
// 	  constrain(Dimension_Y,cc);
// 	  scroll_to(Dimension_Y,cc);
// 	  notify_all();
	  break;
	}
	n++;
      }
    
    if( TBScrollBox::count() == 0 )
	if( empty_glyph )
	    if( is_empty == 0 )
	    {
		is_empty = 1;
		TBScrollBox::append(empty_glyph);
		notify_all();
// 		cc = TBScrollBox::cur_lower(Dimension_Y);
// 		constrain(Dimension_Y,cc);
// 		scroll_to(Dimension_Y,cc);
// 		notify_all();
	    }
    
  }
}

void umtSelectionList::UnmarkAll()
{
  umtSelectionListEntry *i;
  
  for(
      i=(umtSelectionListEntry *)(Members.GetFirst());
      i;
      i=(umtSelectionListEntry *)(Members.GetNext(i)))
    {
      if(i->IsSelected)
	{
	  i->ClickL();
	}
    }
}

umtSelectionListEntry *umtSelectionList::GetSelected()
{
    umtSelectionListEntry *i;
    
    for(
	i=(umtSelectionListEntry *)(Members.GetFirst());
	i;
	i=(umtSelectionListEntry *)(Members.GetNext(i)))
    {
	if(i->IsSelected)
	    return i;
    }
    return nil;
}













