/*
  $Header: /export/CVS/UMT/libsrc/umtIV/umtViewError.cc,v 1.1 1996/10/22 19:47:49 lord Exp $

  $Log: umtViewError.cc,v $
  Revision 1.1  1996/10/22 19:47:49  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:47  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:59  sebast
// Revision 2.0
//
// Revision 1.25  1996/03/07  15:12:40  vlad
// enother constructor added.
//
  Revision 1.24  1996/03/04 10:53:52  bird
  AppendString() added

// Revision 1.23  1996/02/27  10:32:39  bird
// *** empty log message ***
//
// Revision 1.22  1996/02/23  15:40:47  bird
// SLyout added
//
// Revision 1.21  1996/02/22  17:28:21  vlad
// Limit of log file implemented.
//
// Revision 1.20  1996/02/19  18:52:50  bird
// Bug in Msg fixed
//
// Revision 1.19  1996/01/30  19:16:15  vlad
// In Critical error exit(1) will be called.
//
// Revision 1.18  1996/01/16  13:02:26  bird
// *** empty log message ***
//
// Revision 1.17  1995/11/20  13:14:16  bird
// wm_delete added
//
// Revision 1.16  1995/11/18  13:40:13  bird
// insert Menu in bright_inset_frame for Openlook style
//
// Revision 1.15  1995/11/18  13:08:39  voloh
// .
//
// Revision 1.14  1995/11/03  17:58:46  voloh
// *** empty log message ***
//
// Revision 1.13  1995/11/03  17:14:03  voloh
// corrections
//
// Revision 1.12  1995/11/03  16:09:03  voloh
// Parent's Msg() mast called everytimes !
//
// Revision 1.11  1995/11/03  15:39:44  voloh
// Some bugs removed
//
// Revision 1.10  1995/10/28  14:43:02  bird
// wm_delete
//
// Revision 1.9  1995/10/25  18:47:33  sebast
// some bugs removed
//
// Revision 1.8  1995/10/25  13:08:18  sebast
// lots changes
//
// Revision 1.7  1995/10/09  11:13:23  voloh
// ScrollBar for umtScrollBox added
//
// Revision 1.6  1995/10/09  09:56:44  lord
// Make flagAll set by default.
//
// Revision 1.5  1995/10/08  16:51:26  voloh
// linux don't understand void in non-void functions
//
// Revision 1.4  1995/10/08  14:57:46  lord
// Info dialog cration added
//
// Revision 1.3  1995/10/08  14:19:17  lord
// Check, should I show it or not.
//
// Revision 1.2  1995/10/08  14:15:43  lord
// Add ScrollBox
//
// Revision 1.1  1995/10/08  12:45:57  lord
// Initial revision
//
  */

#include <InterViews/label.h>
#include "umt_const.h++"
#include "umtViewError.h++"
#include "umtInfoDialog.h++"

umtViewError::umtViewError(umtConfiguration *cfg,
			   umtLayout *l,
			   WidgetKit *wk,
			   LayoutKit *lk,
			   Style     *st)
{
    Kit       = wk;
    Layout    = lk;
    style     = st;
    config    = cfg;
    SLayout   = l;
    sb        = nil;

    for (int i=Critical; i<=Debug; i++ )
        t_flags[i] = nil;
    t_flag_all = nil;
} 

umtViewError::umtViewError(umtError *err,
                           umtConfiguration *cfg,
			   umtLayout *l,
			   WidgetKit *wk,
			   LayoutKit *lk,
			   Style     *st): umtError( err )
{
    Kit       = wk;
    Layout    = lk;
    style     = st;
    config    = cfg;
    SLayout   = l;
    sb        = nil;

    for (int i=Critical; i<=Debug; i++ )
        t_flags[i] = nil;
    t_flag_all = nil;
} 

umtViewError::~umtViewError()
{
    Close();
    umtError::Close();
}

status umtViewError::Open(umtPath pa,enum Priority pri, int lim)
{
    status rc;
    char   *Labels[6] = {
	"Critical",
	"Error",
	"Warning",
	"Statistics",
	"Info",
	"Debug"
    };
    umtString st;
    
    rc=umtError::Open(pa, pri,lim );
    sb = new umtGRTFEditor(config);
    Resource::ref(sb);
    
    for(int i=Critical; i<=Debug; i++)
        if ( t_flags[i] )
	{
	    st = "Main.Show.";
	    st += Labels[i];
	    t_flags[i]->set(TelltaleState::is_chosen, SLayout->GetMenuCheck(st));
	}
    if ( t_flag_all )
        t_flag_all->set(TelltaleState::is_chosen, SLayout->GetMenuCheck("Main.Show.ShowAll"));
 
    return rc;
}

void umtViewError::StoreLayout()
{
    char   *Labels[6] = {
	"Critical",
	"Error",
	"Warning",
	"Statistics",
	"Info",
	"Debug"
    };
    umtString st;
    for (int i=Critical; i<=Debug; i++ )
    {
	st = "Main.Show.";
	st += Labels[i];
	SLayout->SetMenuCheck(st,t_flags[i]->test(TelltaleState::is_chosen));
    }
    SLayout->SetMenuCheck("Main.Show.ShowAll",t_flag_all->test(TelltaleState::is_chosen));
    
}

status umtViewError::Close()
{
    if ( sb )
    {
	Resource::unref(sb);
	sb = nil;
    }

    for (int i=Critical; i<=Debug; i++ )
	t_flags[i] = nil;
    t_flag_all = nil;
    return OK;
}

void umtViewError::Msg(enum Priority pri,umtString s)
{
    umtInfoDialog *id;
    umtString tmp;

    if(pri==Critical || pri==Error) {
	if(pri==Critical)
	    tmp = "Critical error";
	else tmp = "Error";
	id=new umtInfoDialog(Kit,Layout,style,
			     tmp,
			     (pri==Critical)?UMTCriticalIcon:UMTErrorIcon,
			     &s
	);
	id->ref();
	(void)id->post_at(500,500);
	id->unref();
    }
    if(sb && ( FlagShowMsgOn(pri) || FlagShowAllOn() ))
	AppendString(pri,s);
    
    umtError::Msg(pri,s);
}

boolean umtViewError::FlagShowMsgOn(Priority pri)
{
    return t_flags[pri] ?
        t_flags[pri]->test(TelltaleState::is_chosen) :
        (pri<level);
}

boolean umtViewError::FlagShowAllOn()
{
    return t_flag_all ?
        t_flag_all->test(TelltaleState::is_chosen) :
        false;
}

void umtViewError::AppendString(enum Priority pr, umtString msg)
{
    char   *Labels[6] = {
	"Crl: ",
	"Err: ",
	"Wrn: ",
	"Sts: ",
	"Inf: ",
	"Dbg: "
    };
    const char *templ =
	"<X-Color><Param>%s</Param>%s</X-Color><X-Color><Param>%s</Param>%s</X-Color>\n\n";
    umtString str;
    umtString handl;
    umtString hand_color;
    umtString val_color;
    umtConfiguration *colors = config->GetConfiguration("Debug.Colors");

    handl = Labels[pr];
    if(colors == nil)
    {
	hand_color = "#ff0000";
	val_color  = "#000000";
    }
    else
    {
	switch ( pr )
	{
	case umtError::Critical :
	    hand_color = colors->GetStrField("Critical",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Critical",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	case umtError::Error :
	    hand_color = colors->GetStrField("Error",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Error",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	case umtError::Warning :
	    hand_color = colors->GetStrField("Warning",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Warning",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	case umtError::Statistics :
	    hand_color = colors->GetStrField("Statistics",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Statistics",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	case umtError::Info :
	    hand_color = colors->GetStrField("Info",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Info",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	default:
	    hand_color = colors->GetStrField("Debug",0);
	    if( hand_color.IsEmpty() )
		hand_color = "#ff0000";
	    val_color = colors->GetStrField("Debug",1);
	    if( val_color.IsEmpty() )
		val_color  = "#000000";
	    break;
	}
    }
    str.Sprintf(templ,
		hand_color.Str(),
		handl.Str(),
		val_color.Str(),
		msg.Str());
    sb->AppendString(str);
    sb->ScrollToEnd();
}


implementActionCallback(umtViewError);




