/*
 * $Header: /export/CVS/UMT/libsrc/umtbase/umtError.cc,v 1.2 1996/10/22 21:41:20 lord Exp $
 * 
 * $Log: umtError.cc,v $
 * Revision 1.2  1996/10/22 21:41:20  lord
 * Alpha version for SUN done and works.
 * Still few warning to be eleminated and
 * file locking to be done.
 * file 'build_number' renamed to 'build_num'.
 *
 *
 */

#include <stdarg.h>
#include <unistd.h>
#include <time.h>
#include "misc.h++"
#include "umtError.h++"

#ifdef SUN
# include <stdlib.h>
#endif

umtError::umtError()
{
    logfile      = NULL;
    limit        = -1;
    logfile_name = "";
    count        = 0;
}

umtError::umtError( umtError *err )
{
    if ( err )
    {
	logfile      = err->logfile;
	err->logfile = NULL;
	limit        = err->limit;
	logfile_name = err->logfile_name;
	count        = err->count;
	err->count   = 0;
	level        = err->level;
    }
    else
    {
	logfile      = NULL;
	limit        = -1;
	logfile_name = "";
	count        = 0;
    }
}


umtError::~umtError()
{
    Close();
}

status umtError::Open(umtPath path, enum Priority pr, int lim )
{
    level    = pr;
    limit    = lim;
    time_t t = time( NULL );

    if ( IsOpened()) return ALREADY_LOCKED;
    count = 0;
//    fprintf( stderr,"Limit is %d\n", limit );

    if ( limit > 0 )
    {
	logfile = fopen(path.Str(),"r+");
//	fprintf( stderr, "%s Begin calc...", path.Str());
	if ( logfile )
	{
	    rewind( logfile );
	    while ( !feof( logfile ))
		if (fgetc( logfile ) == '\n' ) count++;
//	    fprintf( stderr, "Ok. %d lines\n", count );
	    clearerr( logfile );
	}
    }
    if ( logfile == nil ) logfile=fopen(path.Str(),"w");
    if ( logfile == nil )
    {
	fprintf(stderr,"Can't open LOG file: <%s>\n",path.Str());
	fprintf(stderr,"You may want to remove it!\n");
	return ERROR_OPEN_FILE;
    }
    logfile_name = path;
    fprintf( logfile, "\n---> UMT Session from %s", ctime( &t ));
    return OK;
}

status umtError::Close()
{
    char buff[MAXSTRING];
    FILE* temp;

    if ( logfile )
    {
	if ( limit > 0 )
	{
	    rewind( logfile );
	    if ( count > limit )
	    {
		count -= limit - 1;
		rewind( logfile );
		while( count-- && !feof( logfile ))
		    while( fgetc( logfile ) != '\n' && !feof( logfile ));
		temp = tmpfile();
		if ( temp )
		{
		    count = 0;
		    while (1)
		    {
			if ( fgets( buff, sizeof( buff ), logfile ) == NULL )
			    break;
			fputs( buff, temp );
			count++;
		    }
//		    fprintf( stderr, "log->tmp %d lines\n", count );
		    logfile = freopen( logfile_name.Str(),"w", logfile );
		    rewind( temp );
		    count = 0;
		    while (1)
		    {
			if ( fgets( buff, sizeof( buff ), temp ) == NULL )
			    break;
			fputs( buff, logfile );
			count++;
		    }
//		    fprintf( stderr,"Finish calc... %d lines\n", count );
		    fclose( temp );
		}
		// else error.
	    }
	}
	fclose(logfile);
	logfile = NULL;
	logfile_name = "";
	count = 0;
	return OK;
    }
    else
	return NO_VARIABLE_DEFINED;
}

int umtError::IsOpened()
{
    return (logfile!=NULL);
}

void umtError::ChangeLevel(enum Priority pr)
{
    level = pr;
}

void umtError::Msg(enum Priority pr, umtString msg)
{
    char names[]="CEWSID";
    
    if( logfile /*&& pr>level*/)
    {
	count++;
	fprintf(logfile,"%c %s\n",
		names[pr],
		msg.Str()
	);
	fflush( logfile );
    }
// Critical and errors printed to STDERR
//    else if ( pr == Error )
//	fprintf(stderr,"%c %s\n",
//		names[pr],
//		msg.Str()
//	);
    if ( pr == Critical )
    {
	fprintf(stderr,"Critical error: %s\n",
		msg.Str()
	);
	exit(1);
    }
}

void umtError::Msg( enum Priority pr, const char *format, ... )
{
    static  char s[MAX_FOPMAT_STRING];
    va_list ap;
    
    *s = '\0';
    va_start(ap, format);
    (void)vsprintf(s, format, ap);
    va_end(ap);
    Msg(pr, umtString(s));
}

void umtError::Msg(umtString msg,char *filename,int line)
{
    umtString s;
    char tmp[MAXSTRING];
    
    sprintf(tmp," at %s:%d",filename,line);
    
    s = msg;
    s+= tmp;
    Msg(Debug,s);
}







