/*
  $Id: umtLayout.cc,v 1.1 1996/10/22 19:47:53 lord Exp $
  $Log: umtLayout.cc,v $
  Revision 1.1  1996/10/22 19:47:53  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:48  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:43:15  sebast
// Revision 2.0
//
// Revision 1.1  1996/02/26  19:12:45  bird
// Initial revision
//
 */

#include "umtLayout.h++"

umtLayout::umtLayout(umtPath p) : umtMember(CLASS_UMT_LAYOUT)
{
    SetPath(p);
    config = nil;
    BuildConfig();
}            

umtLayout::umtLayout(umtLayout &l)  : umtMember(CLASS_UMT_LAYOUT)
{
    SetPath(l.path);
    config = new umtConfiguration(l.config);
}

umtLayout &umtLayout::operator =(umtLayout &l)
{
    SetPath(l.path);
    if(config)
	delete config;
    config = new umtConfiguration(l.config);
    return *this;
}

umtLayout::~umtLayout()
{
 if( config )
 {
     config->Write(path);
     delete config;
 }
}

void umtLayout::SetPath(umtPath p)
{
    path = p;
}

void umtLayout::SetMenuCheck(umtString str, int st)
{
    umtString         name;
    
    if( config )
    {
	name = "Menu.";
	name += str;
	config->Set(name,st?"Yes":"No");
    }
}

void umtLayout::SetMenuRadio(umtString str, int val)
{
    umtString         name;
    
    if( config )
    {
	name = "Menu.";
	name += str;
	config->Set(name,val);
    }
}

int umtLayout::GetMenuCheck(umtString n,int *err_status)
{
    umtString st;
    umtString tmp = "Menu.";
    tmp += n;
    if(err_status) *err_status = 0;
    if( config )
    {
	st = config->GetStrField(tmp);
	if( st.IsEmpty() )
	{
	    if(err_status) *err_status = 1;
	    return 1;
	}
	if( st.CaseInsensitiveEqual("yes") )
	    return 1;
        return 0;
    }
   if(err_status) *err_status = 1; 
   return 1;
}

int umtLayout::GetMenuRadio(umtString n,int *err_status)
{
    int st;
    status rc;
    umtString tmp("Menu.");
    tmp += n;
    if(err_status) *err_status = 0; 
    if( config )
    {
	rc = config->GetIntField(tmp,&st);
	if( rc != OK )
	{
	    if(err_status) *err_status = 1; 
	    return 0;
	}
	return st;
    }
    if(err_status) *err_status = 1; 
    return 0;
}

void umtLayout::BuildConfig()
{
    if( config )
	delete config;
    config = new umtConfiguration("Layout");
    
    if( path.IsExists() == OK )
	config->Read(path);

}





