/*
 * $Header: /export/CVS/UMT/libsrc/umtbase/umtLicensee.cc,v 1.4 1996/10/22 22:57:27 vlad Exp $
 * $Log: umtLicensee.cc,v $
 * Revision 1.4  1996/10/22 22:57:27  vlad
 * Some sintax bugs fixed.
 *
 * Revision 1.3  1996/10/22 22:52:35  vlad
 * Host ID number can be in HEX now.
 *
 * Revision 1.2  1996/10/22 21:41:21  lord
 * Alpha version for SUN done and works.
 * Still few warning to be eleminated and
 * file locking to be done.
 * file 'build_number' renamed to 'build_num'.
 *
 * Revision 1.1  1996/10/22 19:47:54  lord
 * Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 * Some platform directories created in lib.
 * Makefile.include for SUN created.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:48  vlad
 * Puting to CVS. Version 1.00B3
 *
// Revision 2.0  1996/03/18  16:43:16  sebast
// Revision 2.0
//
// Revision 1.8  1996/03/07  15:15:54  vlad
// *** empty log message ***
//
 * Revision 1.7  1996/03/07 15:11:54  vlad
 * UMTlicense::GetDiffTime() added.
 *
 * Revision 1.6  1996/03/06 19:06:51  vlad
 * *** empty log message ***
 *
// Revision 1.5  1996/02/16  13:10:45  vlad
// New version.
//
// Revision 1.4  1996/01/24  12:28:37  vlad
// Debug printfs commented.
//
// Revision 1.3  1995/11/22  15:02:54  vlad
// Work version.
//
// Revision 1.2  1995/11/21  19:35:53  vlad
// Imported to library.
//
// Revision 1.1  1995/11/21  19:24:38  vlad
// Initial revision
//
 *
 */

#ifdef SVR4
#include <sys/systeminfo.h>
#else
#ifdef LINUX
#include <unistd.h>
#endif //LINUX
#endif //IRIX

#include "UMT.h++"
#include "umtLicensee.h++"
#include "umt_const.h++"
#include "umt_error.h++"
#include <time.h>

const unsigned char umtLicense::Q = 172;
const unsigned char umtLicense::P = 253;

umtLicense::umtLicense()
{
    FILE          *file;
    char           file_name[] = "76626+*6860%&)\"*DB=@JPC";
    int            i; 
    unsigned long  licensee_time = 0,
	           sys_ID = 0,
	           cur_sys_ID;
    
//    fprintf( stderr, "%s\n" file_name );
//    fprintf( stderr, "%s\n" sorry_msg ); 
    cur_sys_ID = umt_get_sys_ID();
    for ( i = 0; file_name[i]; i++ ) file_name[i] -= i - '?';
    file = fopen( file_name, "r" );
    if ( !file )
	ret_stat = ERROR_OPEN_FILE;
    else
    {
	ret_stat = decript_buff( file );
//	fprintf( stderr, "'%s'\n", d_buff );
	fclose( file );
    }
    if ( ret_stat == OK )
    {
//	fputs( "Oops..\n", stderr );
	 if (
	     ( sscanf( d_buff,
		       "%lu %lu %lu",
		       &UMTLicenceNumber,
		       &sys_ID,
		       &licensee_time ) != 3
	     ) &&
		 ( sscanf( d_buff,
			   "%lu 0x%lx %lu",
			   &UMTLicenceNumber,
			   &sys_ID,
			   &licensee_time
		 ) != 3 ))
	     ret_stat = LICENSEE_WRONG_KEY;
	 else 
	 {
//	    fputs( "Oops..\n", stderr );
	     diff_time = (( signed long )
			  ( licensee_time-
			   (unsigned long)time(NULL)))/(24*3600);
//	    fprintf( stderr,"Diff time %ld %ld\n",
//		     (unsigned long)time(NULL),  diff_time );
	     if ( sys_ID != cur_sys_ID &&
		  sys_ID != 1762175887 &&  // vugluskr
		  sys_ID != 1762176976 &&  // indy
		  sys_ID != 750945550  &&  // shark
		  sys_ID != 12             // HPUX
	     )
		ret_stat = LICENSEE_WRONG_KEY;
	     else if ( diff_time < 0 )
		 ret_stat = LICENSEE_EXPIRED;
	     else if ( diff_time < W_LICENSE_EXP_DAYS )
		 ret_stat = LICENSEE_WILL_BE_EXPIRED;
	     else ret_stat = OK;
	 }
    }
}

umtLicense::~umtLicense()
{
}


status umtLicense::Test()
{
    return ret_stat;
}

long umtLicense::GetDiffTime()
{
    return diff_time;
}

unsigned long umtLicense::umt_get_sys_ID( void )
{
#ifdef SVR4
    char num[20];
    sysinfo( SI_HW_SERIAL, num, 20 );
//    fprintf( stderr , "NUMBER - %lu\n", atol(num));
    return atol(num);
#else
#ifdef LINUX
    return gethostid();
#else
    return 12;  
#endif //LINUX
#endif //IRIX
}


int umtLicense::decript( int byte )
{
    static unsigned char prev_byte,
                         key,
	                 first_byte;
    int                  i;

//    fprintf( stderr,"prev_byte=%d\n",prev_byte);
    if ( byte != -1 )
    {
	if ( !first_byte )
	{
	    first_byte = key = ( unsigned char )byte;
//	    fprintf( stderr,"<%x> ", first_byte );
	    prev_byte = 0;
	    return 0;
	}
    for ( i = 0; i <= prev_byte; i++ )
	    key = key * Q - (( key * Q ) / P ) * P;
//	fprintf( stderr,"%d-%d=%d p=%d q=%d prev_k=%d\n",
//		 (unsigned char)byte, key,
//		 (unsigned char)((unsigned char)byte - key),
//		 P,Q,prev_byte );
	prev_byte = ( unsigned char )byte;
	return (unsigned char)((unsigned char)byte - key);
    }
    else
    {
//	fprintf( stderr,"[%d=%d]\n",
//		 ( unsigned char)( prev_byte - key ),
//		 first_byte );
	i = (( unsigned char)( prev_byte - key ) == first_byte )? 0: -1;
	first_byte = 0;
	return i;
    }
}

status umtLicense::decript_buff( FILE* id )
{
    int i, byte;
    
    for ( i = 0; i < DECRIPT_BUFF_LENGTH; i++ )
    {
	if ( fscanf( id,"%2x", &byte ) == EOF ) break;
	byte = ( unsigned char )decript((unsigned char)byte );
	if ( i )            /* First time - decrip initialization */
	    d_buff[i-1] = byte;
    }
    if ( i == DECRIPT_BUFF_LENGTH ) return ERROR_LOAD;
    return ((decript( -1 ))? LICENSEE_WRONG_KEY :OK );
}



