/*
  $Header: /export/CVS/UMT/libsrc/umtbase/umtPath.cc,v 1.2 1996/10/22 21:41:21 lord Exp $

  $Log: umtPath.cc,v $
  Revision 1.2  1996/10/22 21:41:21  lord
  Alpha version for SUN done and works.
  Still few warning to be eleminated and
  file locking to be done.
  file 'build_number' renamed to 'build_num'.

  Revision 1.1  1996/10/22 19:47:55  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:48  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:43:19  sebast
// Revision 2.0
//
// Revision 1.15  1996/02/19  18:01:45  sebast
// normalizing of "~" string added
//
// Revision 1.14  1996/02/16  13:16:19  sebast
// call of     Normalize(); added to all holes
//
// Revision 1.13  1995/11/30  18:45:18  bird
// umtPath::umtPath(umtPath  &s) added
//
// Revision 1.12  1995/10/17  11:54:23  sebast
// a bug in operator =(const umtPath *p) removed
//
// Revision 1.11  1995/09/18  16:57:25  lord
// Normalise implemnted. Handle only ~ and ~user
//
// Revision 1.10  1995/09/08  10:04:10  lord
// Bug in GetBaseName fixed
//
// Revision 1.9  1995/08/24  13:21:53  lord
// String->Str
//
// Revision 1.8  1995/07/31  17:04:33  lord
// two more constructors added
//
// Revision 1.7  1995/07/31  16:39:34  lord
// umt coding rules
//
// Revision 1.6  1995/07/31  10:46:37  sebast
// some operators =() add
//
// Revision 1.5  1995/07/18  13:54:22  lord
// rename implemented
//
// Revision 1.4  1995/07/15  16:29:24  lord
// const char *s constructor added
//
// Revision 1.3  1995/07/15  13:54:12  lord
// empty and umtString constructors added
// operator = umt_path * added
//
// Revision 1.2  1995/07/15  12:08:40  lord
// unlink,is_dir,is_exists added
//
// Revision 1.1  1995/07/11  11:11:21  lord
// Initial revision
//
  */

#include "misc.h++"
#include "umtPath.h++"
#include <unistd.h>
#include <malloc.h>
#include <sys/stat.h>

umtPath::umtPath(umtString &s):umtString(s) { Normalize(); }

umtPath::umtPath(umtPath  &s):umtString(s.Str()) { Normalize(); }

umtPath::umtPath(umtString *s):umtString(s) { Normalize(); }

umtPath::umtPath(const char *s):umtString(s) { Normalize(); }

umtPath::umtPath():umtString() { Normalize(); }

umtPath::~umtPath() {};

umtPath  &umtPath::operator =(const umtPath *p)
{
    if (p)
	set_value(p->Str());
    else
	set_value("");
    Normalize();
    return *this;
}

umtPath  &umtPath::operator =(const umtPath &p)
{
    set_value(p.Str());
    Normalize();
    return *this;
}

umtPath  &umtPath::operator =(const char *p)
{
    set_value(p);
    Normalize();
    return *this;
}

umtPath  &umtPath::operator =(const umtString& p)
{
    set_value(p.Str());
    Normalize();
    return *this;
}

umtString umtPath::GetDir     ()
{
    int n;
    
    n=RIndex('/'); 
    if(n!=-1) return Left(n);
    else return "";
}

umtString umtPath::GetName()
{
    int n;
    
    n=RIndex('/'); 
    if(n!=-1) return Right(n+1);
    else return "";
}

umtString umtPath::GetExt()
{
    int n;
    
    n=RIndex('.'); 
    if(n!=-1) return Right(n+1);
    else return "";
}

umtString umtPath::GetBaseName()
{
    umtString tmp;
    int n;
    
    tmp=GetName();
    n=tmp.RIndex('.'); 
    if(n!=-1) return tmp.Left(n);
    else return "";
}

void umtPath::SetName(umtString n)
{
    Compose(GetDir(),n,"");
}

void umtPath::SetDir (umtString d)
{
    Compose(d,GetName(),"");
}

void umtPath::SetExt (umtString e)
{
    Compose(GetDir(),GetBaseName(),e);
}

void umtPath::Compose(umtString d,umtString n, umtString e)
{
    set_value(d.Str());
    if(!n.IsEmpty())
    {
	*this+="/"; //TODO: check if nesseary
	*this+=n;
	if(!e.IsEmpty())
	{
	    *this+="."; //TODO: check if nesseary
	    *this+=e;
	}
    }
    Normalize();
}

status umtPath::IsExists()
{
    return ::access(Str(),F_OK) ? NOT_FOUND : OK;
}

status umtPath::IsDir()
{
    struct stat   buf;
    
    if (stat(Str(),&buf)) return ERROR_OPEN_FILE;
    if (S_ISDIR(buf.st_mode))
	return OK;
    else
	return NOT_FOUND;
}

status umtPath::Unlink()
{
    return ::unlink(Str()) ? ERROR_REMOVE : OK ;
}

status umtPath::Rename(const char *target)
{
    return ::rename(Str(),target) ? ERROR_REMOVE : OK ;
}


// Not all features implemented at the moment. Only ~/
status umtPath::Normalize()
{
    char      *home;
    umtString tmp;
    int       i; 
    
    if(Str() && Str()[0]=='~')
    {
	if(Str()[1]=='/' || !Str()[1]) // My home dir
	{
	    home=gethomedir();
	    if(home==nil) return CANT_GET_HOME_DIR;
	    i=1;
	}
	else // somebody else homedir.
	{
	    i=0;
	    while(Str()[i]!='\0')
	    {
		if(Str()[i]=='/') break;
		else i++;
	    }
	    home=getuserhomedir(SubStr(1,i-1));
	    if(home==nil) return CANT_GET_HOME_DIR; 
	}
	tmp=home;
	tmp+=Str()+i;
	*this=tmp;
	free(home);
    }
    return OK;
}



