/*
$Header: /export/CVS/UMT/libsrc/umtbase/umtSockClient.cc,v 1.2 1996/10/22 21:41:22 lord Exp $

$Log: umtSockClient.cc,v $
Revision 1.2  1996/10/22 21:41:22  lord
Alpha version for SUN done and works.
Still few warning to be eleminated and
file locking to be done.
file 'build_number' renamed to 'build_num'.

Revision 1.1  1996/10/22 19:47:56  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:48  vlad
Puting to CVS. Version 1.00B3

Revision 2.3  1996/04/19 14:50:05  vlad
Numeric port numbers processing changed one more.

Revision 2.2  1996/04/19 13:02:50  vlad
Numeric port numbers processing changed.

Revision 2.1  1996/04/18  16:46:58  vlad
Socket understand numeric port value now.

Revision 2.0  1996/03/18 16:43:22  sebast
Revision 2.0

Revision 1.12  1995/09/13  14:32:33  vlad
Method SendFileToSocket( int f, int size, int opt ) added,
method SendFileToSocket( const char *name, int size, int opt ) changed.

Revision 1.11  1995/09/13  13:13:00  vlad
Changed method int umtSockClient::SetIOTimeOut( long input, long output )
name.

Revision 1.10  1995/09/12  12:18:42  vlad
Method int umtSockClient::SetIOTimeout( long input, long output ) added.

Revision 1.9  1995/09/09  12:01:50  vlad
Method umtSockClient::ReadLn() corrected a bit.

Revision 1.8  1995/08/25  09:47:44  lord
bug in constructor with order of memcpy's arguments corrected.

Revision 1.7  1995/08/25  08:24:01  lord
Add const to constructor. Remove server_name.
Add const to SendFileToSocket

Revision 1.6  1995/07/31  14:32:58  lord
umt coding convention

Revision 1.5  1995/07/27  16:24:13  lord
Change bzero and bcopy to memset and memcpy

Revision 1.4  1995/06/22  12:34:18  sebast
call of member() changed

Revision 1.3  1995/04/26  10:57:56  sebast
uses *.h++ instead *.h

Revision 1.2  1995/02/17  21:41:34  lord
Make readln not to remove \n

Revision 1.1  95/02/16  10:14:15  10:14:15  lord (Vadim Zaliva)
Initial revision

*/

#include "umtSockClient.h++"

#include <unistd.h>
#include <stdlib.h>
#include <strings.h>
#include <fcntl.h>
#include <sys/time.h>

char *umtSockClient::ReadLn(char *buf,int maxlen)
{
    int i;
  
    i=0;
    maxlen--;
    while(i<maxlen)
    {
	if(Recv(buf+i,1,0)!=1) return(NULL);
	if(buf[i]=='\n') {i++;break;}
	i++;
    }
    buf[i]='\0';
    return buf;
}


umtSockClient::umtSockClient(const char *servern,const char *service):umtMember(CLASS_SOCK_CLIENT)
{
    memset(&server,0,sizeof(server));
    
    sp = getservbyname(service,"tcp");
    if ( sp )
	server.sin_port = sp->s_port;
    else
	server.sin_port = htons( atoi( service ));
    if ( !server.sin_port )
    {
	fprintf(stderr,"umtSockClient:: Can't find service: %s\n",service);
	return;
    }
    
    
    if((s=socket(AF_INET,SOCK_STREAM,0))==-1)
    {
	fprintf(stderr,"umtSockClient:: Can't create Internet domain socket\n");
	return;
    }
    
// #ifdef SCO
    
//   if( setsockopt( s, SOL_SOCKET, SO_REUSEADDR, 1, sizeof(int) )!=0)
//   {
//     fprintf(stderr,"umtSockClient:: Can't set socket options!\n");
//     return;
//   }
    
// #endif
    
    if((hp=gethostbyname(servern))==NULL)
    {
	fprintf(stderr,"umtSockClient:: %s - Unknown host\n",servern);
	return;
    }
  
    memcpy((char *)&server.sin_addr,hp->h_addr,hp->h_length);

    server.sin_family=hp->h_addrtype;
  
    if(connect(s,(struct sockaddr *)&server,sizeof(server)) == -1)
    {
	fprintf(stderr, "umtSockClient:: Can't connect %s\n",servern);
	return;
    }
}

umtSockClient::~umtSockClient()
{
    close(s);
}

int umtSockClient::SetIOTimeOut( long input, long output )
{
#ifndef LINUX
    struct timeval tm;
    
    tm.tv_sec = input;
    tm.tv_usec = 0;
    if ( setsockopt( s, SOL_SOCKET, SO_RCVTIMEO, (char *)(&tm), sizeof( tm ))) return -1;
    tm.tv_sec = output;
    if ( setsockopt( s, SOL_SOCKET, SO_SNDTIMEO, (char *)(&tm), sizeof( tm ))) return -1;
#endif /*  Options SO_RCVTIMEO and SO_SNDTIMEO not implement in Linux */
    return 0;
}

int umtSockClient::Send(const char *buf,int size,int opt)
{
    return(::send(s,buf,size,opt));
}

int umtSockClient::Recv(char *buf,int size,int opt)
{
    return(::recv(s,buf,size,opt));
}

/* 
   Send named file to scoket 
   RC:
     0 - OK
     1 - No memory
     2 - Can't open file
     3 - Socket write error
     4 - File read error
*/

int umtSockClient::SendFileToSocket( const char *name, int size, int opt )
{
    int  f, rc;
    
    if((f = open( name, O_RDONLY )) == -1 )
	return 1;
    rc = SendFileToSocket( f, size, opt );
    close( f );
    return rc;
}


int umtSockClient::SendFileToSocket( int f, int size, int opt )
{
    char *buf;
    int  len;
    
    if((buf=(char *)malloc(size+10))==NULL)
	return(2);
    
    while(1)
    {
	len=read(f,buf,size);
	switch(len)
	{
	case 0: 
	    free(buf);
	    return(0);
	case -1: 
	    free(buf);
	    return(4);
	default:
	    if(Send(buf,len,opt)==-1) 
	    {
		free(buf);
		return(3);
	    }
	} /* switch */
    } /* while */
}

