/* StAmP! Last Modifyed by: green from castle at Sat Apr 22 13:53:45 1995 */

#include <IV-look/kit.h>
#include <OS/string.h>
#include <IV-look/fchooser.h>
#include <InterViews/background.h>
#include <IV-look/dialogs.h>
#include <InterViews/layout.h>
#include <InterViews/session.h>
#include <InterViews/window.h>
#include <InterViews/style.h>
#include <InterViews/font.h>
#include <InterViews/color.h>
#include <stdio.h>
#include <string.h>
#include "umtGRTFEditor.h++"
#include "UMT.h++"

umtConfiguration     UMTConfig;
umtLanguage          UMTLanguage;

unsigned  long UMTLicenceNumber;

class App {
public:
  App(int argc, char** argv);
  ~App();
  void exit();
  void run();
  
  void file();
  void file_text();
  void append();
  void append_text();

  void save_as();
  void save_as_text();
  void save();
  void save_text();
  void clear();



  void to_rtf();
  void to_text();
protected:
  WidgetKit *kit;
  DialogKit *dkit;
  LayoutKit *layout;
  Session* session;
  ApplicationWindow *win;
  FileChooser *fc;
  
  umtGRTFEditor *ed;
};

declareActionCallback(App)
implementActionCallback(App)
     
     //     umtConfiguration UMTConfig;

ApplicationWindow *main_win;

App::App(int argc, char** argv)
{
  session = new Session("App", argc, argv);
  kit    = WidgetKit::instance();
  dkit   = DialogKit::instance();
  fc     = nil;
  
  layout = LayoutKit::instance();
  Menu  *menu,*pd;
  MenuItem *mi,*tmp;
  
  menu=kit->menubar();
  
  mi=kit->menubar_item(" File ");
   pd=kit->pulldown();



    tmp=kit->menu_item(" to_rtf ");
      tmp->action(new ActionCallback(App)(this, App::to_rtf));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" to_text ");
      tmp->action(new ActionCallback(App)(this, App::to_text));	
      pd->append_item(tmp);

      pd->append_item(kit->menu_item_separator());





    tmp=kit->menu_item(" Open rich");
      tmp->action(new ActionCallback(App)(this, App::file));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" Open text");
      tmp->action(new ActionCallback(App)(this, App::file_text));	
      pd->append_item(tmp);
      pd->append_item(kit->menu_item_separator());

    tmp=kit->menu_item(" Save As ");
      tmp->action(new ActionCallback(App)(this, App::save_as));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" Save As Text");
      tmp->action(new ActionCallback(App)(this, App::save_as_text));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" Save ");
      tmp->action(new ActionCallback(App)(this, App::save));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" Save Text ");
      tmp->action(new ActionCallback(App)(this, App::save_text));	
      pd->append_item(tmp);

      pd->append_item(kit->menu_item_separator());

      
    tmp=kit->menu_item(" append ");
      tmp->action(new ActionCallback(App)(this, App::append));	
      pd->append_item(tmp);
    tmp=kit->menu_item(" append_text ");
      tmp->action(new ActionCallback(App)(this, App::append_text));	
      pd->append_item(tmp);
      pd->append_item(kit->menu_item_separator());
      
    tmp=kit->menu_item(" Clear !!!! ");
      tmp->action(new ActionCallback(App)(this, App::clear));	
      pd->append_item(tmp);
      pd->append_item(kit->menu_item_separator());





      
    tmp=kit->menu_item(" Exit ");
      tmp->action(new ActionCallback(App)(this, App::exit));	
      pd->append_item(tmp);
   mi->menu(pd);
  menu->append_item(mi);
  
  mi=kit->menubar_item(" Edit !!! ");
   pd=kit->pulldown();
   mi->menu(pd);
  menu->append_item(mi);

  umtConfiguration config;
  config.Read("rtfedit.cfg");
  main_win=win=
    new ApplicationWindow
    (new Background
     (
      layout->hbox
      (layout->hglue(50,0,0),
       layout->vbox
       (menu,ed=new umtGRTFEditor
	(&config,nil,true,pd),layout->vglue(150,0,0)
	)
       ),
      kit->background()
      )
     );
  //  ed->Load("./m.rtf");
}

void App::run()
{
 session->run_window(win);
}

App::~App()
{
}

declareFileChooserCallback(App)
implementFileChooserCallback(App)

void App::file()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->Load(tmp);
  }

}

void App::file_text()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->Load(tmp,false);
  }

}
void App::append()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->AppendString(tmp);
  }

}
void App::append_text()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->AppendString(tmp,false);
  }

}


void App::save_as()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
    strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->Save(tmp);
  }

}

void App::save_as_text()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
    strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
   ed->Save(tmp,false);
  }
}

void App::save()
{
  ed->Save();
}

void App::save_text()
{
  ed->Save(nil,false);
}

void App::clear()
{
  ed->Clear();
}



void App::to_rtf()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
//   ed->Load(tmp);
    {
      FILE *text=fopen(tmp,"rb");
      FILE *rtf =fopen("aa","wb");

      umtGRTFEditor::TextToRtf(text,rtf);
      
      fclose(text);
      fclose(rtf);
    }
  }

}

void App::to_text()
{
  char tmp[1024];
  const String *nm;
  
  if(fc==nil)
  {
    fc=dkit->file_chooser(".", kit->style());
    Resource::ref(fc);
  }
  if(fc->post_for(win))
  {
    nm=fc->selected();
   strncpy(tmp,nm->string(),nm->length());
    tmp[nm->length()]=0;
    
   fprintf(stderr,"File :>%s<\n",tmp);
//   ed->Load(tmp);
    {
      FILE *text=fopen("aa","wb");
      FILE *rtf =fopen(tmp,"rb");

      umtGRTFEditor::RtfToText(rtf,text,15);
      
      fclose(text);
      fclose(rtf);
    }
  }

}















void App::exit()
{
  delete win;
  session->quit();
}

int main(int argc, char** argv) {
    App* a = new App(argc,argv);
    a->run();
    return 0;
}









/*
  {
    Font f("xtermbold");
    FontBoundingBox b;
    
    fprintf(stderr,"!!Font\n");
    fprintf(stderr,"name     :>%s<\n",f.name());
    fprintf(stderr,"encoding :>%s<\n",f.encoding());
    fprintf(stderr,"width    :>%f<\n",(float)f.width('W'));
    fprintf(stderr,"size     :>%f<\n",(float)f.size());
    
    f.font_bbox(b);
    fprintf(stderr,"b.left_bearing:>%f<\n",(float)b.left_bearing());
    fprintf(stderr,"b.right_bearing:>%f<\n",(float)b.right_bearing());
    fprintf(stderr,"b.width(:>%f<\n",(float)b.width());
    fprintf(stderr,"b.ascent:>%f<\n",(float)b.ascent());
    fprintf(stderr,"b.descent:>%f<\n",(float)b.descent());
    fprintf(stderr,"b.font_ascent:>%f<\n",(float)b.font_ascent());
    fprintf(stderr,"b.font_descent:>%f<\n",(float)b.font_descent());


    fprintf(stderr,"!!!Char W\n");
    f.char_bbox('W',b);
    fprintf(stderr,"b.left_bearing:>%f<\n",(float)b.left_bearing());
    fprintf(stderr,"b.right_bearing:>%f<\n",(float)b.right_bearing());
    fprintf(stderr,"b.width(:>%f<\n",(float)b.width());
    fprintf(stderr,"b.ascent:>%f<\n",(float)b.ascent());
    fprintf(stderr,"b.descent:>%f<\n",(float)b.descent());
    fprintf(stderr,"b.font_ascent:>%f<\n",(float)b.font_ascent());
    fprintf(stderr,"b.font_descent:>%f<\n",(float)b.font_descent());
    

    fprintf(stderr,"!!!Char q\n");
    f.char_bbox('q',b);
    fprintf(stderr,"b.left_bearing:>%f<\n",(float)b.left_bearing());
    fprintf(stderr,"b.right_bearing:>%f<\n",(float)b.right_bearing());
    fprintf(stderr,"b.width(:>%f<\n",(float)b.width());
    fprintf(stderr,"b.ascent:>%f<\n",(float)b.ascent());
    fprintf(stderr,"b.descent:>%f<\n",(float)b.descent());
    fprintf(stderr,"b.font_ascent:>%f<\n",(float)b.font_ascent());
    fprintf(stderr,"b.font_descent:>%f<\n",(float)b.font_descent());
    
    fprintf(stderr,"!!!Char \"\n");
    f.char_bbox('"',b);
    fprintf(stderr,"b.left_bearing:>%f<\n",(float)b.left_bearing());
    fprintf(stderr,"b.right_bearing:>%f<\n",(float)b.right_bearing());
    fprintf(stderr,"b.width(:>%f<\n",(float)b.width());
    fprintf(stderr,"b.ascent:>%f<\n",(float)b.ascent());
    fprintf(stderr,"b.descent:>%f<\n",(float)b.descent());
    fprintf(stderr,"b.font_ascent:>%f<\n",(float)b.font_ascent());
    fprintf(stderr,"b.font_descent:>%f<\n",(float)b.font_descent());
    
    fprintf(stderr,"\n");
    fprintf(stderr,"\n");
    fprintf(stderr,"\n");
    
  }
*/
