#include "rtf2ps.h"

RTF2PS::RTF2PS(FILE *inf,FILE *outf)
{
  infile=inf;outfile=outf;
  charinbuf=pos=0;buf[pos]=0;
  needmove=1;
}
  


void RTF2PS::writeheader(void)
{
  put_string("%!PS-Adobe-2.0\n");
  put_string("%%Title: Untitled\n");
  put_string("%%Creator: RTF2PS\n");
  put_string("%%EndComments\n\n");
  put_string("/buff 128 string def\n");
  put_string("/rb { currentfile buff readline pop} def\n");
  put_string("/s { moveto rb  show} def\n");
  put_string("/ns { rb show} def\n");
  put_string("/CS { moveto rb dup stringwidth 2 div neg exch 2 div neg exch\n");
  put_string(" rmoveto show } bind def\n");
  put_string("/RS { moveto rb dup stringwidth neg exch neg exch\n");
  put_string("rmoveto show } bind def\n");    
  put_string("/nRS { rb dup stringwidth neg exch neg exch\n");
  put_string("rmoveto show } bind def\n\n");    
  fontchanged=1;justifychanged=0;
  ypos=700;xpos=XINITPOS;
}

void RTF2PS::db(void)
{
  char *s=buf;
  int k=0;
  while(*s==' ' || *s=='\t') s++;
  if(s==buf) return;
  while(*s) buf[k++]=*s++;
  buf[k]='\0';
  pos=k;
}

void RTF2PS::de(void)
{
  char *s=buf+pos-1;
  if(!pos) return;
  while((*s==' ' || *s=='\t') && s-buf>=0) s--;
  *++s=0;
  pos=strlen(buf);
}

void RTF2PS::show(void)
{
  char str[256];
  if(justify==leftjust) db();
  else if(justify==rightjust) de();
  if(!pos) return;
  if(justify==center) { move(290,ypos);put_string("CS ");
		      }
  else 
    {
      if (needmove)  move(xpos,ypos);
      else put_string("n");
      if(justify!=rightjust)
	put_string("s ");
      else put_string("RS ");
    }
  
  strcpy(str,buf);strcat(str,"\n");
  put_string(str);
  needmove=0;
}


// File I/O functions
int RTF2PS::getnext(void)
{
  return getc(infile);
}


void RTF2PS::put_char(char c)
{
  if(fontchanged) { clear();writefont();fontchanged=0;}
  if(justifychanged) { justifychanged=0;clear();xpos=XINITPOS;needmove=1;}
  charinbuf=1;
  buf[pos++]=c;
  buf[pos]=0;
  
}

void RTF2PS::put_string(char *s)
{ fputs(s,outfile); }


void RTF2PS::move(int x,int y)
{ 
  xpos=x;ypos=y;
  put_string(ltoa(xpos));put_string(" ");put_string(ltoa(ypos));
  put_string(" ");
}

void RTF2PS::clear(void)
{ 
  show();pos=0;buf[0]='\0'; 
}

void RTF2PS::new_line(void)
{
  if(charinbuf)  clear();
  
  ypos-=size+1;
  if(ypos<size+20) {
    put_string("showpage\n");
    ypos=700;
  }
  charinbuf=0;
  needmove=1;
  xpos=XINITPOS;
 }

void RTF2PS::excerpt(void)
{
  font_name f;
  if(name==times) f=helvetica;
  else f=times;
  changefontname(f);
}



void RTF2PS::signature(int i)
{
  if(i==1) changefontsize(small);
  else restorefontsize();
}

void RTF2PS::changejustify(justify_type j)
{
  justifychanged=1;
  justify_type *jt=new justify_type;
  *jt=justify;
  jstack.push(jt);
  setjustify(j);
}

void RTF2PS::restorejustify(void)
{
  justify_type *jt=jstack.pop();
  justifychanged=1;
  setjustify(*jt);
  delete jt;
}

void RTF2PS::changedirection(direction_type d)
{
  justifychanged=1;
  direction_type *dt=new direction_type;
  *dt=direction;
  dstack.push(dt);
  if (d==indent)
    indcount++;
  else
    if (d==outdent) indcount--;
  setdirection(d);
}

void RTF2PS::restoredirection(void)
{
  direction_type *dt=dstack.pop();
  justifychanged=1;
  if(direction==indent) indcount--;
  else if(direction==outdent) indcount++;
  setdirection(*dt);
  delete dt;
}


void RTF2PS::changefonttype(font_type t)
{
  fontchanged=1;
  font_type *ft=new font_type;
  *ft=type;
  tstack.push(ft);
  settype(t);
}

void RTF2PS::restorefonttype(void)
{
  font_type *ft=tstack.pop();
  fontchanged=1;
  settype(*ft);
  delete ft;
}

void RTF2PS::changefontname(font_name t)
{
  fontchanged=1;
  setfont(t);
}

void RTF2PS::changefontsize(font_size t)
{
  fontchanged=1;
  font_size *fs=new font_size;
  *fs=size;
  sstack.push(fs);
  setsize(t);
}

void RTF2PS::restorefontsize(void)
{
   font_size *fs=sstack.pop();
   fontchanged=1;
   setsize(*fs);
   delete fs;
}



void RTF2PS::paragraph(void)
{
 endparagraph();
 xpos+=20;
}


void RTF2PS::endparagraph(void)
{
 new_line();
 if(ypos!=700)  new_line();
}

void RTF2PS::endfooting(void)
{
  heading();
}

void RTF2PS::heading(void)
{
  if(ypos==700) return;
  put_string("showpage\n");
  ypos=700;
}

void RTF2PS::endsamepage(void)
{
}

void RTF2PS::endheading(void)
{
  new_line();
}


int RTF2PS::test_token(char *token)
{
  
  if (!strcmp(token,"lt"))
    put_char('<');
  else if (!strcmp(token,"nl"))
      new_line(); 
  else if (!strcmp(token,"np"))
    heading(); 
  else if (!strcmp(token,"/paragraph"))
    endparagraph();
  else if (!strcmp(token,"paragraph"))
    paragraph();
  else if (!strcmp(token,"bold"))
    changefonttype(bold);
  else if (!strcmp(token,"italic"))
    changefonttype(italic);
  else if (!strcmp(token,"/bold") ||
	   !strcmp(token,"/italic"))
    restorefonttype();
  else if (!strcmp(token,"smaller"))
    changefontsize(small);
  else if (!strcmp(token,"bigger"))
    changefontsize(big);
  else if (!strcmp(token,"/smaller") || 
	   !strcmp(token,"/bigger"))
    restorefontsize();
  else if (!strcmp(token,"center"))
    changejustify(center);
  else if (!strcmp(token,"indent") ||
	   !strcmp(token,"indentright"))
    changedirection(indent);
  else if (!strcmp(token,"outdent") ||
	   !strcmp(token,"outdentright"))
    changedirection(outdent);
  else if (!strcmp(token,"/indent") ||
	   !strcmp(token,"/indentright") ||
	   !strcmp(token,"/outdent") ||
	   !strcmp(token,"/outdentright"))
    restoredirection();
  else if (!strcmp(token,"flushright"))
    changejustify(rightjust);
  else if(!strcmp(token,"flushleft"))
    changejustify(leftjust);
  else if (!strcmp(token,"/flushright") ||
	   !strcmp(token,"/flushleft") ||
	   !strcmp(token,"/center"))
    restorejustify();
  
  
  /*
   else if (!strcmp(token,"fixed"))
   setfixed();
   else if (!strcmp(token,"underline"))
   setunderline();
      
*/
  
  else if (!strcmp(token,"/samepage"))
    endsamepage();
  else if(!strcmp(token,"heading"))
    heading();
  else if(!strcmp(token,"/heading"))
    endheading();
  else if(!strcmp(token,"excerpt"))
    excerpt();
  else if(!strcmp(token,"/excerpt"))
    excerpt();
  else if(!strcmp(token,"/footing"))
    endfooting();
  else if(!strcmp(token,"signature"))
    signature(1);
  else if(!strcmp(token,"/signature"))
    signature(0);
  else return 0;
  return 1;
}

// Main function 

void RTF2PS::Translate(void)
{
  int c,i;
  char token[256];
  writeheader();
  while((c=getnext()) != EOF )
    {
      if(c=='<')
	{
	  for (i=0;(i<255 && (c=getnext()) != '>' && c!= EOF);
	       ++i)
	    {
	      token[i]=isupper(c) ? tolower(c) : c ;
	    }
	  if (c==EOF) break;
	  if (c!='>')
	    while ((c=getnext())!='>' && c!=EOF) { ; }
	  if(c==EOF) break;
	  token[i]='\0';
	  if(!test_token(token))
	    if (!strcmp(token,"comment"))
	    {
	      int commct=1;
	      while (commct>0)
		{
		  while ((c=getnext()) != '<' && c!=EOF) ;
		  if (c==EOF) break;
		  for (i=0;(c=getnext()) != '>' && c!=EOF; ++i)
		    {
		      token[i]=isupper(c) ? tolower(c) : c;
		    }
		  if (c==EOF) break;
		  token[i]='\0';
		  if (!strcmp(token,"/comment")) --commct;
		  if (!strcmp(token,"comment")) ++commct;
		}
	    }
	  /* Ignore all other tokens */
	}
      else if (c!='\n') put_char(c);
        }
  new_line();
}



rtf_font::rtf_font(void)
{
  setfont(times);setsize(normalsize);settype(normal);
}

void rtf_font::setfont(font_name n)
{
  name=n;if(n==times) strcpy(cfont,"/Times"); 
  else strcpy(cfont,"/Helvetica");
}

void rtf_font::settype(font_type t)
{
  type=t;
  if(t==normal) strcpy(ctype,"-Roman");
    else if(t==bold) strcpy(ctype,"-Bold");
  else strcpy(ctype,"-Italic");
}

void rtf_font::setsize(font_size s)
{
  size=s;
}

void rtf_font::writefont(void)
{
  char s[50];*s='\0';
  strcpy(s,cfont);strcat(s,ctype);strcat(s," findfont ");
  strcat(s,ltoa(size));strcat(s," scalefont setfont\n");
  put_string(s);
}

rtf_justify::rtf_justify(void)
{
  setjustify(nojust);
  setdirection(noindent);
  indcount=0;
}

void rtf_justify::setjustify(justify_type j)
{
  justify=j;
  switch(j) {
  case leftjust:
  case nojust:
    XINITPOS=50;break;
  case rightjust:
    XINITPOS=530;break;
  case center:
    XINITPOS=290;break;
  }
  chxinit();
}

void rtf_justify::setdirection(direction_type d)
{
  direction=d;setjustify(justify);
}

void rtf_justify::chxinit(void)
{
  if(justify==leftjust || justify==nojust)
    XINITPOS+=20*indcount;
  else if(justify==rightjust) 
    XINITPOS-=20*indcount;
}






