/*
$Header: /export/CVS/UMT/src/umtAboutDialog.cc,v 1.2 1997/02/15 04:16:30 vlad Exp $

$Log: umtAboutDialog.cc,v $
Revision 1.2  1997/02/15 04:16:30  vlad
License protection is optional now. Define LICENSE_PROTECTION macro to switch on license protection.

Revision 1.1  1996/10/22 19:47:59  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:51  vlad
Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:46:52  sebast
Revision 2.0

Revision 1.25  1996/03/15  16:49:13  vlad
#include "umtVersionNumber.h++"

Revision 1.24  1996/02/17  12:39:13  bird
Set Window title

Revision 1.23  1996/02/17  12:21:53  vlad
*** empty log message ***

Revision 1.22  1995/11/21  19:06:47  sebast
unregistered added

Revision 1.21  1995/10/30  09:57:46  bird
#ifdef IRIX in CloseWindow()

Revision 1.20  1995/10/28  14:36:49  bird
wm_delete

Revision 1.19  1995/10/26  15:55:21  bird
remove fprintf(stderr,'');

Revision 1.18  1995/09/06  15:45:45  lord
Error with build number fixed.

Revision 1.17  1995/09/06  14:53:58  lord
extern int UMTBuildNumber;

Revision 1.16  1995/09/06  14:13:52  lord
Add build number

Revision 1.15  1995/08/24  13:37:55  lord
String->Str

Revision 1.14  1995/08/08  10:25:01  sebast
umtCodingRules

Revision 1.13  1995/07/15  11:05:58  lord
do nothing

Revision 1.12  1995/06/22  10:53:41  sebast
call of member() changed

Revision 1.11  1995/06/16  17:37:52  sebast
multilang done

Revision 1.10  1995/06/10  15:12:52  lord
UMTSTR("OK")

Revision 1.9  1995/06/07  08:37:41  lord
AboutDialogDock added and used

Revision 1.8  1995/04/26  11:27:54  lord
Change extensions of standard header files from .h to .h++

Revision 1.7  1995/04/26  09:11:35  lord
.h -> .h++

Revision 1.6  1995/02/28  20:02:03  lord
UMT_ABOUT_IMAGE removed

Revision 1.5  95/02/28  17:29:47  17:29:47  lord (Vadim Zaliva)
Remove path fro include

Revision 1.4  95/02/28  12:30:02  12:30:02  lord (Vadim Zaliva)
Show image in about window

Revision 1.3  95/02/27  22:19:19  22:19:19  lord (Vadim Zaliva)
Make about dialog prettier

Revision 1.2  95/02/27  20:58:07  20:58:07  lord (Vadim Zaliva)
Add Action* parameter to constructor

Revision 1.1  95/02/19  17:20:30  17:20:30  lord (Vadim Zaliva)
Initial revision

*/

#include <IV-look/kit.h>
#include <InterViews/layout.h>

#include <stdio.h>

#include "umt_error.h++"
#include "umt_const.h++"

#include "UMT.h++"
#include "umtVersionNumber.h++"

#include "umtAboutDialog.h++"
#include "umtHandler.h++"
#include "umtApp.h++"

extern int UMTBuildNumber;

declareActionCallback  (umtAboutDialog    ) 
implementActionCallback(umtAboutDialog    )
declareActionCallback  (umtAboutDialogDock) 
implementActionCallback(umtAboutDialogDock)

const  int SUMTVersion        = 1;
const  int SUMTLicenseNumber  = 2;

umtAboutDialogDock::umtAboutDialogDock(ManagedWindow *group_leader)
{
    leader=group_leader;
    dialog=nil;
}

umtAboutDialogDock::~umtAboutDialogDock()
{
    if(dialog)
	Delete(dialog);
}

void umtAboutDialogDock::Open()
{
    if (!dialog)
	dialog=new umtAboutDialog(leader,
				  new ActionCallback(umtAboutDialogDock)
				  (this, &umtAboutDialogDock::Close)
	);
}

void umtAboutDialogDock::Close()
{
    if(dialog)
	Delete(dialog);
}

int  umtAboutDialogDock::IsOpened()
{
    return (dialog!=nil);
}

umtAboutDialog::umtAboutDialog(ManagedWindow *leader, Action *done)
{
    Glyph *i;
    WidgetKit *kit;
    LayoutKit *layout;
    char s[80];
    umtString us1,us2,us3;

    // push_button("ok",act);

    kit=WidgetKit::instance();
    layout=LayoutKit::instance();

    done_ = done;

    image = TIFFRaster::load(UMT_ABOUT_IMAGE);
    if (image == nil) {
	sprintf(s, "Open tiff image %s failed\n", UMT_ABOUT_IMAGE);
	UMTError->Msg(umtError::Critical,s);
	return;
    }

    us1 = UMTSTR(SUMTVersion);
    us1 += UMTVersion;
    
#ifdef LICENSE_PROTECTION
    if (UMTLicenceNumber) {
	us2.Sprintf( "%s %lu", UMTSTR(SUMTLicenseNumber), UMTLicenceNumber );
    }
    else us2 = "unregistered";
#else
    us2 = "";
#endif
    
    sprintf(s,"Build # %d",UMTBuildNumber);
    us3=s;
    
    i=kit->inset_frame(
	layout->vbox(
	    layout->margin(
		kit->outset_frame(
		    layout->margin(
			layout->vbox(
			    layout->vglue(5.0),
			    layout->hcenter(new Image(image)),
			    layout->vglue(5.0),
			    layout->hcenter(kit->label(us1.Str())),
			    layout->hcenter(kit->label(us3.Str())),
			    layout->hcenter(kit->label(us2.Str()))
			), // vbox around text
			10.0) // margin inside farame
		) // outset frame
		,10.0), // margin
	    layout->hcenter(kit->push_button(UMTSTR(110),done)),
	    layout->vglue(10.0)
	) // vbox around all stuff
    );
  
    wnd=new TopLevelWindow(i);
    wnd->group_leader(leader);
    WindowName(wnd,"About",UMTApplication->CStyle);
    wnd->wm_delete( new umtHandler(this) );
    wnd->map();
}

int umtAboutDialog::CloseWindow()
{
#ifdef IRIX
    done_->execute();
#endif
    return 1;
}

umtAboutDialog::~umtAboutDialog()
{
    wnd->unmap();
    Delete(wnd);
}








