/*  $Header: /export/CVS/UMT/src/umtAttachDialog.cc,v 1.1 1996/10/22 19:48:00 lord Exp $ 

    $Log: umtAttachDialog.cc,v $
    Revision 1.1  1996/10/22 19:48:00  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:49  vlad
    Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:46:58  sebast
// Revision 2.0
//
// Revision 1.18  1996/03/18  14:54:29  bird
// Init() added
//
// Revision 1.17  1996/03/03  17:18:30  sebast
// #include <InterViews/display.h> added
//
// Revision 1.16  1996/02/20  13:21:08  bird
// use umtFieldEditor()
//
// Revision 1.15  1996/02/17  16:26:26  bird
// Use OpenFileDialog
//
// Revision 1.14  1996/02/17  12:42:35  bird
// Set Window title
//
// Revision 1.13  1996/02/16  11:43:19  bird
// Use SaveFileDialog
//
// Revision 1.12  1996/01/27  15:56:14  vlad
// Partyanka in attachments fixed.
//
// Revision 1.11  1996/01/26  19:28:52  bird
// *** empty log message ***
//
// Revision 1.10  1995/11/21  18:37:19  bird
// Localisation
//
// Revision 1.9  1995/10/27  19:11:41  bird
// use UMTError
//
// Revision 1.8  1995/08/31  16:22:36  lord
// FileChoose dialog in this window
//
// Revision 1.7  1995/08/31  15:39:52  lord
// StripJunk in file name for attachment.
//
// Revision 1.6  1995/08/31  13:36:34  lord
// Ref/Unref bug fixed
//
// Revision 1.5  1995/08/31  11:12:34  lord
// Style->CStyle
//
// Revision 1.4  1995/08/30  15:50:47  lord
// unref fc_dialog
//
// Revision 1.3  1995/08/30  14:28:09  lord
// Bug append->Append fixed
//
// Revision 1.2  1995/08/24  14:10:16  lord
// String -> Str
//
// Revision 1.1  1995/08/24  14:09:48  lord
// Initial revision
//
*/


#include <IV-look/kit.h>
#include <InterViews/layout.h>
#include <InterViews/event.h>
#include <InterViews/deck.h>
#include <InterViews/color.h>
#include <InterViews/bitmap.h>
#include <InterViews/transformer.h>
#include <InterViews/tformsetter.h>
#include <InterViews/raster.h>
#include <InterViews/display.h>

#include <OS/string.h>
#include <strings.h>

#include "umtAttachDialog.h++"
#include "umtFieldEditor.h++"
#include "umtApp.h++"

implementActionCallback(umtAttachDialog);

umtAttachDialog::umtAttachDialog() 
    :umtDialog(UMTApplication->Layout->vbox(),UMTApplication->CStyle,"Attachments")
{
    FullName = "                              ";
    ContentField.ContentEncoding  =  base64 ;
    ContentField.SContentEncoding = "base64";
    Init();
}

umtAttachDialog::umtAttachDialog(umtAttachment *at,umtString f_name) 
    :umtDialog(UMTApplication->Layout->vbox(),UMTApplication->CStyle,"Attachments")
{
    ContentField=at->ContentField;
    FullName = f_name + "/" + ContentField.Name;
    Init();
}

void umtAttachDialog::Init() 
{
    const int  hspacing=20;
    const int  vmargin=15;
//    const char *templ="                              ";
    Glyph      *encodings_box;
    umtString  *i;
    clineList  *lst;
    int        j,n; 
    umtFancyStrSelectionListEntry *first;
    umtFancyStrSelectionListEntry *entry;
    umtFancyStrSelectionListEntry *sel;
    
    fc_dialog=nil;
    first=nil;
    sel = nil;
    
    acoding = new TelltaleGroup;
    if(!acoding) return;
    acoding->Resource::ref();
  
    types=new umtSelectionList();
    if(types) 
    {
	types->Resource::ref();
	lst=UMTConfig.GetParsByName("Attachments");
	if(lst) {
	    n=lst->GetCount();
	    for(i=(umtString *)lst->GetFirst(); i ; i=(umtString *)lst->GetNext(i))   {
		entry=new umtFancyStrSelectionListEntry(
		    *i,
			types,
			UMTApplication->CStyle,
			UMTApplication->Kit,
			UMTApplication->Layout
		);
		types->Append(entry);
		if(!first) first=entry;
		if(*i == ContentField.SContentType + "/" + ContentField.SContentSubtype)
		    sel = entry;
	    }
	}
	else {
	    UMTError->Msg(umtError::Error,"No Attachments statement in config!");
	}
    }
    
    if(sel)
	sel->ClickL();
    else
    {
	if(first)
	    first->ClickL();
    }
    
    body()->append(
	UMTApplication->Kit->outset_frame(
	    UMTApplication->Layout->vbox(
		UMTApplication->Layout->vspace(vmargin),
		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hglue(),
		    UMTApplication->Kit->label(UMTSTR(660)),
		    UMTApplication->Layout->hglue()        
		),
		UMTApplication->Layout->vspace(vmargin),
		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hspace(hspacing),
		    UMTApplication->Kit->label(UMTSTR(661)),
		    ef_fname=new umtFieldEditor(FullName.Str(),
						UMTApplication->Kit,
						UMTApplication->CStyle),
		    UMTApplication->Layout->hglue(),        
		    UMTApplication->Layout->hspace(hspacing),
		    UMTApplication->Kit->push_button(
			UMTApplication->Kit->label(UMTSTR(112)),
			new ActionCallback(umtAttachDialog)
			(this, &umtAttachDialog::browse_button_pressed)
		    ),
		    UMTApplication->Layout->hspace(hspacing)
		),
		UMTApplication->Layout->vspace(vmargin), 
		// Type

		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hspace(hspacing),
			UMTApplication->Layout->vnatural(
		    UMTApplication->Layout->vbox(
			UMTApplication->Layout->hbox(
			    UMTApplication->Kit->label(UMTSTR(662)),
			    UMTApplication->Layout->hglue()
			),
			UMTApplication->Kit->inset_frame(
			    UMTApplication->Layout->hbox(
				types,
				UMTApplication->Kit->vscroll_bar(types)
			    )
			) // scroll box with scroller in frame
		    ),UMTApplication->UMTSession->default_display()->height()/5)
		),

		UMTApplication->Layout->vspace(vmargin), 
		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hspace(hspacing),
		    UMTApplication->Kit->label(UMTSTR(663)),
		    UMTApplication->Layout->hglue()
		),
		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hspace(hspacing),
		    UMTApplication->Kit->inset_frame(
			encodings_box=UMTApplication->Layout->vbox(
			    //    nil
			    )),
		    UMTApplication->Layout->hglue()
		),
		UMTApplication->Layout->vspace(vmargin) 
	    ))
    );

    body()->append(
	UMTApplication->Kit->outset_frame(
	    UMTApplication->Layout->hbox(
		UMTApplication->Layout->hglue(),
		UMTApplication->Kit->push_button(
		    UMTApplication->Kit->label(UMTSTR(110)),
		    new ActionCallback(umtAttachDialog)(
			(umtAttachDialog *)this,umtAttachDialog::cb_ok
		    )
		),
		UMTApplication->Layout->hglue(),
		UMTApplication->Kit->push_button(
		    UMTApplication->Kit->label(UMTSTR(111)),
		    new ActionCallback(umtAttachDialog)(
			(umtAttachDialog *)this,umtAttachDialog::cb_cancel
		    )
		),
// 		UMTApplication->Layout->hglue(),
// 		UMTApplication->Kit->push_button(
// 		    UMTApplication->Kit->label("Help"),
// 		    new ActionCallback(umtAttachDialog)(
// 			(umtAttachDialog *)this,umtAttachDialog::cb_help)
// 		),
		UMTApplication->Layout->hglue()
	    ))
    );


    append_input_handler(ef_fname);

// Get list of encodings from cfg
  
    b=new Button*[NUMBER_OF_ENCODINGS_SUPPORTED];
    if(b) 
    {
	for(j=0;j<NUMBER_OF_ENCODINGS_SUPPORTED;j++) 
	{
	    b[j]=UMTApplication->Kit->radio_button
		(
		    acoding,
			UMTApplication->Layout->hfixed(
			    UMTApplication->Kit->label(EncodingNames[j].Name),
				150),
			nil
		);
	    encodings_box->append(b[j]);
	}
    } else {
	UMTError->Msg(umtError::Warning,"No Encodings statement in config!");
    }
    
    for(j = 0; j<NUMBER_OF_ENCODINGS_SUPPORTED; j++)
	if(ContentField.SContentEncoding == EncodingNames[j].Name)
	    break;
    if(j == NUMBER_OF_ENCODINGS_SUPPORTED)
	j = 0;
    b[j]->state()->set(TelltaleState::is_chosen,true);
}

umtAttachDialog::~umtAttachDialog() 
{
    int i;

//    if(b) {
//	for(i=0;i<NUMBER_OF_ENCODINGS_SUPPORTED;i++) Delete(b[i]);
//    }  

    if(b) Delete(b);
    if(acoding) acoding->Resource::unref();
    if(types  )   types->Resource::unref();
    //  remove_all_input_handlers();
}

void umtAttachDialog::browse_button_pressed() 
{
    umtPath tmpp;

    UMTApplication->OpenFileDialog(&tmpp,Wnd);
    
    if( !tmpp.IsEmpty() )
	ef_fname->field(tmpp.Str());
}

void umtAttachDialog::cb_ok()
{
    char   ds[MAXSTRING];
    int i;
    umtFancyStrSelectionListEntry *e;
    int n;

    FullName=ef_fname->text()->string();
    FullName.StripJunk();

    if(access(FullName.Str(),R_OK)!=0)
    {
	// TODO Error Dialog.
	sprintf(ds,"File %s does not exists!\n",FullName.Str());
	UMTError->Msg(umtError::Error,ds);
//	dismiss(false);
	return;
    }
  
    for(i=0;i<NUMBER_OF_ENCODINGS_SUPPORTED;i++)
	if(b[i]->state()->test(TelltaleState::is_chosen))
	{
	    ContentField.ContentEncoding=::EncodingNames[i].Code;
	    ContentField.SContentEncoding=::EncodingNames[i].Name;
	    break;
	}

    for(
	e=(umtFancyStrSelectionListEntry *)(types->Members.GetFirst());
	e; 
	e=(umtFancyStrSelectionListEntry *)(types->Members.GetNext(e))
    )
	if(e->IsSelected) 
	{
	    n=e->Str.Index('/');
	    ContentField.SContentType=e->Str.Left(n);
	    ContentField.SContentSubtype=e->Str.Right(n+1);

	    // 	fprintf(stderr,"T/S=>%s< >%s<\n",
	    // 		ContentField.sContentType.string(),
	    // 		ContentField.sContentSubtype.string()
	    // 		);
		
	    break;
	}

    n=FullName.RIndex('/'); // Unix only!
    ContentField.Name=FullName.Right(n+1);
  
    dismiss(true);
}

void umtAttachDialog::cb_cancel()
{
    dismiss(false);
}

void umtAttachDialog::cb_help()
{
    //TODO: Help
}


