/*  $Header: /export/CVS/UMT/src/umtAttachments.cc,v 1.1 1996/10/22 19:48:01 lord Exp $

    $Log: umtAttachments.cc,v $
    Revision 1.1  1996/10/22 19:48:01  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:49  vlad
    Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:46:59  sebast
// Revision 2.0
//
// Revision 1.27  1996/02/15  19:12:43  bird
// Use SaveFileDialog
//
// Revision 1.26  1995/10/27  19:11:32  bird
// use UMTError
//
// Revision 1.25  1995/10/03  13:01:59  sebast
// movie contenttype => video
//
// Revision 1.24  1995/10/02  13:54:13  bird
// umtPid delete
//
// Revision 1.23  1995/09/17  12:08:55  vlad
// exeption _BSD_COMPAT deleted.
//
// Revision 1.22  1995/09/17  11:38:45  sebast
// #ifdef _BSD_COMPAT for wait added (because vlad)
//
// Revision 1.21  1995/09/11  12:01:12  sebast
// attach' size showing algorithm changed
//
// Revision 1.20  1995/09/04  14:26:41  bird
// correct wait_fork
//
// Revision 1.19  1995/08/31  16:56:59  lord
// Wnd added
//
// Revision 1.18  1995/08/31  15:52:40  lord
// Check if there is somthing to launch on double click.
//
// Revision 1.17  1995/08/31  11:11:56  lord
// Style -> CStyle
//
// Revision 1.16  1995/08/27  15:16:51  lord
// Take Mailcap for Application
//
// Revision 1.15  1995/08/27  15:09:08  lord
// UMTApplication.mailcap -> ::Mailcap
//
// Revision 1.14  1995/08/24  13:52:26  lord
// String->Str
//
// Revision 1.13  1995/08/22  10:23:36  lord
// umtAPp.h++
//
// Revision 1.12  1995/08/09  17:44:10  sebast
// umtCodingRules
//
// Revision 1.11  1995/07/31  10:53:17  sebast
// format of wait_fork() changed
//
// Revision 1.10  1995/07/29  13:30:03  sebast
// some members made static
//
// Revision 1.9  1995/07/13  07:54:26  lord
// err in wait_fork fixed
//
// Revision 1.8  1995/07/13  07:52:19  lord
// printf format in wait_fork corrected
//
// Revision 1.7  1995/07/13  07:34:59  lord
// Pids and wait_fork added
// wait_fork added
//
// Revision 1.6  1995/07/05  16:21:56  sebast
// using string' ContentField instead content_type
//
// Revision 1.5  1995/06/16  11:28:10  sebast
// format of GetInterfacePresentation() changed
//
// Revision 1.4  1995/06/13  16:05:24  sebast
// MailCap init removed
//
// Revision 1.3  1995/06/12  14:57:20  sebast
// qq
//
// Revision 1.2  1995/06/07  14:39:43  sebast
// I gonna to src/
//
// Revision 1.1  1995/05/11  14:38:47  sebast
// Initial revision
//
*/
#include <string.h>

#include <InterViews/event.h>
#include <OS/string.h>

#include "UMT.h++"
#include "umtApp.h++"
#include "umtAttachments.h++"

const  int umtAttachment::AttachTypeMaxStringLength = 25;

umtAttachDragFrom::umtAttachDragFrom(Glyph *g, umtAttachment *a) :
    InputHandler(g,UMTApplication->CStyle)
{
    attach = a;
}

umtAttachDragFrom::~umtAttachDragFrom() {}

void umtAttachDragFrom::move(const Event &/*event*/) {}

void umtAttachDragFrom::release(const Event &event)
{
    if(event.pointer_button() == Event::right)
	attach->ClickR();
    else 
	attach->ClickL();
}

const char SHELL[] = "/bin/sh";

void umtAttachDragFrom::double_click(const Event &/*event*/)
{
    umtString us;
    pid_t ret;

    us=UMTApplication->MailCap.ViewMessage(*attach);
    us.StripJunk();
    if(us.IsEmpty())
    {
	UMTError->Msg(umtError::Error,"No program for this type. Edit your mailcap file.");
	return;
    }
    signal(SIGCHLD,wait_fork);
    switch(ret=fork()) {
    case  0:  execlp(SHELL,SHELL,"-c",us.Str(),NULL);
	break;
    case -1:  perror("Could not fork the program");
	break;
    default:  ProcessId.Append(new umtPid(ret));
    }
}

umtAttachment::umtAttachment(umtMsgComponent *m,Window *w) : umtMsgComponent(m)
{
    Drg = NULL;
    fc_dialog = NULL;
    Wnd=w;

    if (ContentField.SContentType.CaseInsensitiveEqual("application"))
	ComponentImage = TIFFRaster::load(UMTApplicationIcon);
    else 
	if (ContentField.SContentType.CaseInsensitiveEqual("audio"))
	    ComponentImage = TIFFRaster::load(UMTAudioIcon);
	else
	    if (ContentField.SContentType.CaseInsensitiveEqual("image"))
		ComponentImage = TIFFRaster::load(UMTImageIcon);
	    else
		if (ContentField.SContentType.CaseInsensitiveEqual("message"))
		    ComponentImage = TIFFRaster::load(UMTMessageIcon);
		else
		    if (ContentField.SContentType.CaseInsensitiveEqual("multipart"))
			ComponentImage = TIFFRaster::load(UMTMultipartIcon);
		    else
			if (ContentField.SContentType.CaseInsensitiveEqual("text"))
			    ComponentImage = TIFFRaster::load(UMTTextIcon);
			else
			    if (ContentField.SContentType.CaseInsensitiveEqual("video"))
				ComponentImage = TIFFRaster::load(UMTVideoIcon);
			    else 
				ComponentImage = TIFFRaster::load(UMTApplicationIcon);

}

umtAttachment::~umtAttachment()
{
//  if (drg) Delete(drg);
//  Delete (ComponentImage);
}

char * umtAttachment::GetInterfacePresentation(char *sout)
{
    char s[MAXSTRING],s1[MAXSTRING];
    sprintf(s,"%s/%s %20s",
	    ContentField.SContentType.Str(),
	    ContentField.SContentSubtype.Str(),
	    (char *)ContentField.Name);
    long size = GetSize();
    if (size > 10240) {
	sprintf(s1,"%%-%ds (%%4dK)", AttachTypeMaxStringLength);
	sprintf(sout,s1,s,(int)(size/(double)1024));
    }
    else  if (size > 1024) {
	sprintf(s1,"%%-%ds (%%2.1fK)", AttachTypeMaxStringLength);
	sprintf(sout,s1,s,(size/(double)1024));
    }
    else {
	sprintf(s1,"%%-%ds (%%4dB)", AttachTypeMaxStringLength);
	sprintf(sout,s1,s,(int)size);
    }
    return sout;
}

void umtAttachment::ClickL() {}

void umtAttachment::ClickR()
{
    int           is_append;
    umtPath       us;
    us = ContentField.Name;
    UMTApplication->SaveFileDialog(&us,&is_append,Wnd);
    if (us != "")
    {
	if (WriteToFile(&us))
	    UMTError->Msg(umtError::Error,"Error writing to file!");
    }

}

//----
#ifdef IRIX
void wait_fork(int i, ...)
#else
void wait_fork(int i)
#endif
{
    char  ds[MAXSTRING];
    pid_t ret;
    ret = wait(&i);
    
    for (umtPid *p = (umtPid *)ProcessId.GetFirst();
	 p;
	 p=(umtPid *)ProcessId.GetNext(p)) 
	if (p->Pid == ret)
	{
	    sprintf(ds,"The child process (PID:%ld) terminated!\n", ret);
	    UMTError->Msg(umtError::Info,ds);
	    ProcessId.Kill(p);
	    return;
	}
    return;
}

umtAttachmentsList::umtAttachmentsList() : umtSlist() {}

umtAttachmentsList::~umtAttachmentsList()
{
    Kill(NULL);
}



