/*  $Header: /export/CVS/UMT/src/umtFilterList.cc,v 1.1 1996/10/22 19:48:01 lord Exp $

    $Log: umtFilterList.cc,v $
    Revision 1.1  1996/10/22 19:48:01  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:49  vlad
    Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:47:03  sebast
// Revision 2.0
//
// Revision 1.16  1996/03/18  15:10:41  sebast
// Help(), Index() added
//
// Revision 1.15  1996/02/17  12:40:08  bird
// Set Window title
//
// Revision 1.14  1996/02/15  13:20:20  sebast
// some changes because case in RegExp
//
// Revision 1.13  1996/02/15  11:43:45  sebast
// some cosmetic: cancel!, scroll_to when deleting/adding, ...
//
// Revision 1.12  1996/02/12  12:54:52  sebast
// filters changes done
//
// Revision 1.11  1995/11/21  18:36:40  bird
// Localisation
//
// Revision 1.10  1995/11/18  13:40:36  bird
// insert Menu in bright_inset_frame for Openlook style
//
// Revision 1.9  1995/10/30  09:57:36  bird
// #ifdef IRIX in CloseWindow()
//
// Revision 1.8  1995/10/28  14:37:36  bird
// wm_delete
//
// Revision 1.7  1995/10/25  18:57:49  sebast
// lots remade
//
// Revision 1.6  1995/09/14  11:07:14  sebast
// small non-significant changes
//
// Revision 1.5  1995/08/31  11:13:54  lord
// Style->STyle
//
// Revision 1.4  1995/08/22  10:25:48  lord
// umtApp.h++
//
// Revision 1.3  1995/08/22  10:02:25  lord
// umt coding rules applyed
//
// Revision 1.2  1995/07/31  11:09:39  sebast
// some lines changed to work under SGI compiler
//
// Revision 1.1  1995/07/06  14:18:49  sebast
// Initial revision
//
*/

#include <stdio.h>
#include <string.h>

#include <IV-look/kit.h>
#include <InterViews/layout.h>
#include <InterViews/event.h>
#include <InterViews/deck.h>
#include <InterViews/color.h>
#include <InterViews/bitmap.h>
#include <InterViews/transformer.h>
#include <InterViews/tformsetter.h>
#include <InterViews/raster.h>

#include "umtApp.h++"
#include "umtFilterList.h++"
#include "umtHandler.h++"
#include "umtConfirmDialog.h++"

umtFilterListDialogDock::umtFilterListDialogDock(umtFilterList *f, ManagedWindow *group_leader)
{
    filter_list = f;
    leader        = group_leader;
    dialog        = NULL;
}

umtFilterListDialogDock::umtFilterListDialogDock(umtFilterListDialogDock *m)
{
    filter_list = m->filter_list;
    leader        = m->leader;
    dialog        = m->dialog;
}

umtFilterListDialogDock::~umtFilterListDialogDock()
{
    if(dialog)
	Delete(dialog);
}

void umtFilterListDialogDock::Open()
{
    if (!dialog)
	dialog = new umtFilterListDialog (
	    filter_list,this,leader,
	    new ActionCallback(umtFilterListDialogDock)(this, &umtFilterListDialogDock::Close)
	);
}

void umtFilterListDialogDock::Close()
{
    if (dialog) {
	Delete(dialog);
	dialog = NULL;
    }
}

int  umtFilterListDialogDock::IsOpened()
{
  return (dialog!=nil);
}
//---

umtFilterListDialog::umtFilterListDialog(umtFilterList *f, umtFilterListDialogDock *d,
					 ManagedWindow *leader, Action *close ) 
{
    int i;
    umtFilter *ff;
    char s[MAXSTRING];
    umtSelectionListEntry *eli, *first=NULL;
    
    wnd             = NULL;
    filter_list     = f;
    dock            = d;
    filter_dialog   = NULL;

    sel_lst = new umtSelectionList(0);
    if (sel_lst) {
	sel_lst->Resource::ref();
	for (ff = filter_list->GetFirst(),i=0;ff;ff=filter_list->GetNext(ff),++i) {
	    sel_lst->Append(
		eli = new umtFancyStrSelectionListEntry(
		    ff->FilterName + (ff->IsActive ? "" : "(non active)"),
			sel_lst,
			UMTApplication->CStyle,
			UMTApplication->Kit,
			UMTApplication->Layout
		)
	    );
	    if (!first) first=eli;
	}
    }
    if (first)
	first->ClickL();
    
    wnd = new TopLevelWindow(
	UMTApplication->Layout->vbox(
	    UMTApplication->Kit->bright_inset_frame(
		make_menu(UMTApplication->Kit,UMTApplication->Layout)),
		UMTApplication->Kit->outset_frame(
		    UMTApplication->Layout->vbox(
			UMTApplication->Kit->inset_frame(
			    UMTApplication->Layout->hbox(
				sel_lst,
				    UMTApplication->Kit->vscroll_bar(sel_lst)
			    )
			),
			    UMTApplication->Kit->inset_frame(
				UMTApplication->Layout->hbox(
				    UMTApplication->Layout->hglue(),
					UMTApplication->Kit->push_button(
					    UMTApplication->Kit->label(UMTSTR(680)),
						new ActionCallback(umtFilterListDialog)(
						    (umtFilterListDialog *)this,umtFilterListDialog::CbApply
						)
					),
// 					UMTApplication->Layout->hglue(),
// 					UMTApplication->Kit->push_button(
// 					    UMTApplication->Kit->label(UMTSTR(707)),
// 						new ActionCallback(umtFilterListDialog)(
// 						    (umtFilterListDialog *)this,umtFilterListDialog::CbNewItem
// 						)
// 					),
// 					UMTApplication->Layout->hglue(),
// 					UMTApplication->Kit->push_button(
// 					    UMTApplication->Kit->label(UMTSTR(708)),
// 						new ActionCallback(umtFilterListDialog)(
// 						    (umtFilterListDialog *)this,umtFilterListDialog::CbEditItem
// 						)
// 					),
// 					UMTApplication->Layout->hglue(),
// 					UMTApplication->Kit->push_button(
// 					    UMTApplication->Kit->label(UMTSTR(709)),
// 						new ActionCallback(umtFilterListDialog)(
// 						    (umtFilterListDialog *)this,umtFilterListDialog::CbDeleteItem
// 						)
//					),
					UMTApplication->Layout->hglue(),
					UMTApplication->Kit->push_button(
					    UMTApplication->Kit->label(UMTSTR(111)),
						new ActionCallback(umtFilterListDialog)(
						    (umtFilterListDialog *)this,umtFilterListDialog::CbCancel)
					),
					UMTApplication->Layout->hglue(),
					UMTApplication->Kit->push_button(
					    UMTApplication->Kit->label(UMTSTR(114)),
						new ActionCallback(umtFilterListDialog)(
						    (umtFilterListDialog *)this,umtFilterListDialog::CbHelp)
					),
					UMTApplication->Layout->hglue()
				)
			    )
		    )
		)
	)
    );

    wnd->group_leader(leader);
    WindowName(wnd, "Filter Book" ,UMTApplication->CStyle);
    wnd->wm_delete(new umtHandler(this));
    wnd->map();    
}

umtFilterListDialog::~umtFilterListDialog()
{
    sel_lst->unref();
    if (wnd) {
	wnd->unmap();
	Delete(wnd);
    }
}

void umtFilterListDialog::Quit()
{
    dock->Close();
}

void umtFilterListDialog::Save()
{
    filter_list->Save();
}

void umtFilterListDialog::CbApply()
{
    Save();
    Quit();
}
void umtFilterListDialog::CbCancel()
{
    UMTApplication->FilterList.Kill(NULL);
    Delete(UMTApplication->FilterList.Lock);
    if(UMTApplication->FilterList.Load()!=OK) {
	UMTError->Msg(umtError::Warning,"Can't load filter file!");
	UMTApplication->FilterList.Kill(NULL);
    }
    Quit();
}

void umtFilterListDialog::CbNewItem()
{
    umtFilter *f;
    char s[20];
    umtSelectionListEntry *eli;
    umtString us;
    int i, found;
    
    if (!filter_dialog) {
	for (i=0;;++i) {
	    us.Sprintf("Filter N%d",i);
	    found=0;
	    for (f = filter_list->GetFirst();
		 f;
		 f = filter_list->GetNext(f)
	    ) {
		if (us == f->FilterName) {
		    found = 1;
		    break;
		}
	    }
	    if (!found) break;
	}

	umtFilterCondition cond(8,"*UMT*","");
	f = new umtFilter(us,1,cond,0,"","","");
	filter_dialog = new umtFilterDialog(f);
	Resource::ref(filter_dialog);
	
	if (filter_dialog->post_for(wnd)) {
	    UMTApplication->FilterList.Append(f);
	    us = f->FilterName+ (f->IsActive ? "" : "(non active)");
	    sel_lst->Append(
		eli =  new umtFancyStrSelectionListEntry(us,
							 sel_lst,
							 UMTApplication->CStyle,
							 UMTApplication->Kit,
							 UMTApplication->Layout
		)
	    );
	    sel_lst->UnmarkAll();
	    eli->ClickL();

	    GlyphIndex ind = sel_lst->count();
	    while (!sel_lst->shown(ind-1))
		sel_lst->page_backward(Dimension_Y);
 	}
	else
	    Delete(f);
	Resource::unref(filter_dialog);
	filter_dialog=NULL;
    }
}

void umtFilterListDialog::CbEditItem()
{
    if (!filter_dialog)
    {
	umtFilter *f, *fff;
	umtSelectionListEntry *e;
	umtStrSelectionListEntry *eli;
	int number_checked = 0;

	for (f = filter_list->GetFirst(),
		 e=(umtSelectionListEntry *)(sel_lst->Members.GetFirst());
	     f && e;
	     f = filter_list->GetNext(f),
		 e=(umtSelectionListEntry *)(sel_lst->Members.GetNext(e))
	) {
	    if (e->IsSelected) {
		fff  = f;
		eli  = (umtStrSelectionListEntry *)e;
		++number_checked;
	    }
	}
	if (number_checked != 1) {
	    UMTError->Msg(umtError::Error,"You should select exactly ONE filter to edit!");
	    return;
	}
	filter_dialog = new umtFilterDialog(fff);
	Resource::ref(filter_dialog);
      
	if (filter_dialog->post_for(wnd)) {
	    eli->ChangeString(fff->FilterName+(fff->IsActive ? "" : "(non active)"));
	}
      
	Resource::unref(filter_dialog);
	filter_dialog=NULL;
    }
}
void umtFilterListDialog::CbDeleteItem()
{
    int changed = 0, i, first_removed = 0;
    if (!filter_dialog) {
	umtFilter *f, *ff;
	umtSelectionListEntry *e, *ee;

	for (f = filter_list->GetFirst(),
		 e=(umtSelectionListEntry *)(sel_lst->Members.GetFirst()),
		 i = 0;
	     f && e; ++i
	) {
	    ff = f;
	    ee = e;
	    f = filter_list->GetNext(f);
	    e = (umtSelectionListEntry *)(sel_lst->Members.GetNext(e));
	    if (ee->IsSelected) {
		umtString ustr1 = "You are going to remove filter";
		umtString ustr2 = "Are you sure?";
		umtConfirmDialog *confirm_dialog = new umtConfirmDialog(
		    UMTApplication->Kit,
			UMTApplication->Layout,
			UMTApplication->CStyle,
			&ustr1,
			&ff->FilterName,
			&ustr2
		    );
		if (confirm_dialog) {
		    confirm_dialog->ref();
		    if (confirm_dialog->post_for(wnd)) { //OK
			filter_list->Kill(ff);
			sel_lst->Remove(ee);
			changed = 1;
			if (!first_removed)
			    first_removed = i;
		    }
		    else {
			//cancel
		    }
		    confirm_dialog->unref();
		}
	    }
	}
	if (changed) {
	    if (!sel_lst->Members.IsEmpty()) {
		while (!((umtSelectionListEntry *)sel_lst->Members.Element(first_removed)))
		    --first_removed;
		((umtSelectionListEntry *)sel_lst->Members.Element(first_removed))->ClickL();
		sel_lst->scroll_to(Dimension_Y, sel_lst->length(Dimension_Y)*first_removed);
	    }
	}

    }
}

void umtFilterListDialog::CbHelp()
{
    Help();
}
void umtFilterListDialog::Help()
{
    UMTHelpDock.Open(UMT_HELP_FILTER_LIST);
}
void umtFilterListDialog::Index()
{
    UMTHelpDock.Open(UMT_HELP_INDEX);
}

int umtFilterListDialog::CloseWindow()
{
#ifdef IRIX
    Quit();
#endif
    return 1;
}

implementActionCallback(umtFilterListDialog);
implementActionCallback(umtFilterListDialogDock);

