/*
   $Header: /export/CVS/UMT/src/umtMsgView.h++,v 1.1.1.1 1996/10/21 20:46:50 vlad Exp $

   $Log: umtMsgView.h++,v $
   Revision 1.1.1.1  1996/10/21 20:46:50  vlad
   Puting to CVS. Version 1.00B3

# Revision 2.1  1996/04/07  11:22:31  bird
# void add_to_addrbook(); added
#
# Revision 2.0  1996/03/18  16:46:25  sebast
# Revision 2.0
#
# Revision 1.23  1996/03/18  15:06:17  sebast
# useing GRTFEditor instead RTFView added
#
# Revision 1.22  1996/02/27  13:52:40  bird
# Change constructors
#
# Revision 1.21  1996/02/24  16:36:01  sebast
# some functions added (save_body(), ...
#
# Revision 1.20  1996/02/22  12:39:21  bird
#    Glyph *a1, *a2 added
#
# Revision 1.19  1995/10/28  14:37:53  bird
# wm_delete
#
# Revision 1.18  1995/10/27  17:50:51  sebast
# forward and resend added
#
# Revision 1.17  1995/10/27  13:03:05  sebast
# quotting() removed
#
# Revision 1.16  1995/09/28  17:49:02  sebast
#     Action *close; added
#
# Revision 1.15  1995/09/27  16:22:03  lord
# Make     void UpdateStatus(); and     void UpdateDelButton(); public
#
# Revision 1.14  1995/09/18  18:15:17  sebast
# work with quotting/replying
#
# Revision 1.13  1995/09/17  12:08:28  sebast
# some reply*() functions added
#
# Revision 1.12  1995/09/04  17:50:21  lord
# busy removed
#
# Revision 1.11  1995/09/02  08:36:22  lord
# busy added
#
# Revision 1.10  1995/08/08  16:05:26  sebast
# umtCodingRules
#
# Revision 1.9  1995/07/29  13:29:55  sebast
# some members made static
#
# Revision 1.8  1995/06/22  11:19:15  sebast
# classname() removed
#
# Revision 1.7  1995/06/11  15:52:30  sebast
# body(),header()
#
# Revision 1.6  1995/06/08  17:51:00  sebast
# simple lock
#
# Revision 1.5  1995/06/07  14:39:23  sebast
# I gonna to src/
#
# Revision 1.4  1995/06/01  16:27:32  sebast
# *** empty log message ***
#
# Revision 1.3  1995/05/10  18:04:08  sebast
# it works ?!
#
# Revision 1.2  1995/04/30  13:40:22  sebast
# something works
#
# Revision 1.1  1995/04/29  15:41:51  sebast
# Initial revision
#
*/
  
#ifndef MSG_VIEW_H_FLAG
#define MSG_VIEW_H_FLAG

#include <IV-look/kit.h>
#include <IV-look/dialogs.h>
#include <InterViews/action.h>
#include <InterViews/background.h>
#include <InterViews/layout.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/patch.h>
#include <InterViews/background.h>
#include <InterViews/stencil.h>

#include "umtMessagesList.h++"
#include "umtWindowOwner.h++"
#include "umtAttachments.h++"
#include "umtGRTFEditor.h++"
#include "umtDock.h++"

class umtMessagesList;
class umtMessagesListEntry;

class umtMsgViewDock;

class umtMsgView : public umtWindowOwner
{
public: 
    umtMsgView(umtMessagesList *,umtMessagesListEntry * , umtMsgViewDock *,
	       ManagedWindow *leader, Action *close);
    virtual ~umtMsgView();
    
    void UpdateView();
    void UpdateStatus();
    void UpdateDelButton();
  
protected:   

    TopLevelWindow *wnd;

    Stencil *current_face;
    
    Patch *face_patch;
    Patch *folder_patch;
    Patch *size_patch;
    Patch *status_patch;
    Patch *number_patch;
    Patch *attach_patch;

    Patch *screen_patch;

    Patch *del_button_patch;

    void update_face();
    void update_folder();
    void update_size();
    void update_number();
  
    void update_attachments();
    void update_header();
    void update_body();
    void update_screen();

    void del_item();
    void undel_item();

    void print();
    void dummy();
    
    virtual int CloseWindow();

    umtGRTFEditor *header_box;
    umtGRTFEditor *body_box;

    TBScrollBox *attachments_box;
    
    umtAttachmentsList attaches;
private: 

    unsigned  long        number;
    umtMessagesList       *folder;
    umtMessagesListEntry  *msg;
    umtMsgViewDock        *dock;

    Menu *make_menu(WidgetKit *kit,LayoutKit *layout);
    Action *close;
    Menu *main_menu;

    void next_button_pressed();
    void prev_button_pressed();
    void compose_button_pressed();
    void reply_button_pressed();
    void close_button_pressed();
    void delete_button_pressed();

    void reply_without_quotting();
    void reply_with_quotting();
    void reply( int is_quotting);
    void forward();
    void resend ();

    void save_body();
    void save2unix_folder();

    void copy2folder();
    void move2folder();
    void copy_to_folder(int is_remove);
    void add_to_addrbook();
    void del_undel_action(int);

    static const  int MaxFolderLength;
    static const  int MaxSizeLength  ;
    static const  int MaxStatusLength;
    static const  int MaxNumberLength;

    char s_tmp1[MAXSTRING],s_tmp2[MAXSTRING];

    void Help();
    void Index();
};

class umtMsgViewDock : public umtDock {
public: 
    umtMsgViewDock(umtMessagesList *f,umtMessagesListEntry *e, ManagedWindow *group_leader);
    umtMsgViewDock(umtMsgViewDock *);
    ~umtMsgViewDock();

    virtual void Open();
    virtual void Close();
    virtual int  IsOpened();

    umtMsgView *dialog;
    umtMessagesListEntry *entry;

private: 
  
    ManagedWindow *leader;

    umtMessagesList      *m_list;
};

declareActionCallback(umtMsgView);
declareActionCallback(umtMsgViewDock);

#endif

