/*
$Header: /export/CVS/UMT/src/umtPrintMsg.cc,v 1.1 1996/10/22 19:48:06 lord Exp $

$Log: umtPrintMsg.cc,v $
Revision 1.1  1996/10/22 19:48:06  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:50  vlad
Puting to CVS. Version 1.00B3

Revision 2.1  1996/04/10 13:28:03  vlad
defines for gcc-2.7.0 commented.

Revision 2.0  1996/03/18 16:47:25  sebast
Revision 2.0

// Revision 1.15  1996/03/15  16:51:30  bird
// umtVersionNumber.h++ included
//
// Revision 1.14  1996/03/01  18:16:41  vlad
// gcc 2.7.0 for LINUXelf port.
//
Revision 1.13  1996/02/29 18:41:31  bird
correct config

// Revision 1.12  1996/02/15  14:15:03  sebast
// index to language file changed
//
// Revision 1.11  1996/02/13  15:37:08  bird
// Font to Config
//
// Revision 1.10  1995/11/16  14:40:25  bird
// bug for empty message fixed
//
// Revision 1.9  1995/09/25  12:01:02  lord
// Printer.PsFontMetricsDir
//
// Revision 1.8  1995/09/25  10:42:30  lord
// Correct print From & Subject
//
// Revision 1.7  1995/09/24  17:53:24  bird
// Print XFace
//
// Revision 1.6  1995/09/21  15:22:41  bird
// *** empty log message ***
//
// Revision 1.5  1995/09/19  06:34:42  bird
// Color adjusted.
//
// Revision 1.4  1995/09/18  10:19:31  bird
// putenv comment
//
// Revision 1.3  1995/09/18  09:39:23  bird
// UMT/src/ for Sebast
//
*/

#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <OS/file.h>
#include <OS/string.h>
// //For gcc 2.7.0.   Shit.
// #ifndef __STRICT_ANSI__
// #define __STRICT_ANSI__
// #include <fstream.h>
// #undef __STRICT_ANSI__
// #else
#include <fstream.h>
// #endif

#include "UMT.h++" 
#include "umtApp.h++" 
#include "umtPath.h++" 
#include "umtInternetHeader.h++" 
#include "umtMsgComponent.h++" 
#include "umtVersionNumber.h++" 

#include "umtPrintMsg.h++" 

//char PsFontDir[100];

const int PAttachDescription = 350;

umtPrintMsg::umtPrintMsg(umtMsg *m, Patch *e, WidgetKit& w, LayoutKit& l) :
    widgets(w),
    layout(l)
{
    umtString fnHH;
    umtString fnHV;
    umtString fnT;
    umtString fnB;
    umtString fnA;
    
    umtString cpr;
    umtString frm;
    umtString sbj;

    if( getenv("PSFONTDIR") == nil )
    {
	char *PsFontDir = new char[64];
	umtString ps_dir;
	ps_dir = UMTConfig.GetStrField("Printer.Fonts.PsFontMetricsDir");
	if( ps_dir.IsEmpty() )
	{
	UMTError->Msg(umtError::Error,
		      "Can't find PostScript fonts");
	is_error++;
	return;
	}
#ifdef LINUX
	setenv("PSFONTDIR",ps_dir.Str(),1);
#else	
	sprintf(PsFontDir,"PSFONTDIR=%s",ps_dir.Str());
	putenv(PsFontDir);
#endif
	
    }
    
    is_attach = 0;
    number_page = 1;
    cur_pos = 0;
    extern_patch = e;
    msg = m;

    cpr = "Printed from UMT version ";
    cpr += UMTVersion;
    cpr += "  at ";
    cpr += msg->GetInternetDate(time(NULL));

    fnHH = UMTConfig.GetStrField("Printer.Fonts.FontHeaderHandler");
    fnHV = UMTConfig.GetStrField("Printer.Fonts.FontHeaderValue");
    fnT  = UMTConfig.GetStrField("Printer.Fonts.FontTitle");
    fnB  = UMTConfig.GetStrField("Printer.Fonts.FontBody");
    fnA  = UMTConfig.GetStrField("Printer.Fonts.FontAttach");

    is_error = 0;
    if( fnHH.IsEmpty() || PSFont::exists( fnHH.Str() )   == false )
    {
	UMTError->Msg(umtError::Error,
		      "Can't find PostScript font metrics for FontHeaderHandler");
	is_error++;
	return;
    }
    else
	if( fnHV.IsEmpty() || PSFont::exists(fnHV.Str()) == false )
	{
	    UMTError->Msg(umtError::Error,
			  "Can't find PostScript font metrics for FontHeaderValue");
	    is_error++;
	    return;
	}
	else
	    if( fnB.IsEmpty() || PSFont::exists(fnB.Str()) == false )
	    {
		UMTError->Msg(umtError::Error,
			      "Can't find PostScript font metrics for FontHeaderBody");
		is_error++;
		return;
	    }
	    else
		if( fnA.IsEmpty() || PSFont::exists(fnA.Str()) == false )
		{
		    UMTError->Msg(umtError::Error,
				  "Can't find PostScript font metrics for FontAttach");
		    is_error++;
		    return;
		}
    
    font_header_handler = new PSFont(fnHH.Str(),SIZE_FONT_HEADER,
				     "-*-*-*-*-*-*-10-*-*-*-*-*-*-*",1.0);
    Resource::ref(font_header_handler);

    font_title = new PSFont(fnT.Str(),SIZE_FONT_TITLE,
			    "-*-*-*-*-*-*-*-*-*-*-*-*-*-*",1.5);
    Resource::ref(font_title);
    
    font_header_value = new PSFont(fnHV.Str(),SIZE_FONT_HEADER,
				   "-*-*-*-i-*-*-10-*-*-*-*-*-*-*",1.0);
    Resource::ref(font_header_value);
  
    font_body = new PSFont(fnB.Str(),SIZE_FONT_BODY,
			   "-*-*-medium-*-*-*-10-*-*-*-*-*-*-*",1.0);
    Resource::ref(font_body);

    font_cpr = new PSFont(fnB.Str(),SIZE_FONT_CPR,
			  "-*-*-*-*-*-*-*-*-*-*-*-*-*-*",1.0);
    Resource::ref(font_cpr);

    font_attach = new PSFont(fnA.Str(),SIZE_FONT_BODY,
			     "-*-*-*-*-*-*-10-*-*-*-*-*-*-*",1.0);
    Resource::ref(font_attach);

    color_black = new Color(0.0f,0.0f,0.0f); 
    Resource::ref(color_black);  

    color_white = new Color(1.0f,1.0f,1.0f); 
    Resource::ref(color_white);  

    color_gray = new Color(0.12f,0.12f,0.12f); 
    Resource::ref(color_gray);  

    page   = new Patch(nil);
    Resource::ref(page);
  
    body1 = new Patch(nil);
    Resource::ref(body1);

    PageTitle = new Patch(nil);
    Resource::ref(PageTitle);

    Coord len = 0;
    int c = 0;

    sbj = " Subject: ";
    sbj += *(msg->GetSubjField());
    for(c = 0,len = 0;c < sbj.Length() && len < WIDTH_BODY-XFACE_WIDTH; c++)
	len += font_title->width(sbj[c]);
    sbj = umtString(sbj,(len<WIDTH_BODY-XFACE_WIDTH)?c:c-1);
  
    frm = " From: ";
    frm += ((umtInternetAddr *)(msg->GetFromField()->GetFirst()))->GetAddrAndName();
    for(c = 0,len = 0;c < frm.Length() && len < WIDTH_BODY-XFACE_WIDTH; c++)
	len += font_title->width(frm[c]);
    frm = umtString(frm,(len<WIDTH_BODY-XFACE_WIDTH)?c:c-1);
  
    SubjectTitle = new Label(sbj,font_title,color_white);
    Resource::ref(SubjectTitle);
  
    FromTitle = new Label(frm,font_title,color_white);
    Resource::ref(FromTitle);
  
    Box   *vb  = (Box *)layout.vbox();
    Box   *vb1 = (Box *)layout.vbox();
    Box   *hb1 = (Box *)layout.hbox();
    vbox_body  = (Box *)layout.vbox();
  
    char *morda;
    if ((morda=msg->GetFaceField()) != NULL)
    {
	face = new Stencil( 
	    new Bitmap(morda,XFACE_WIDTH,XFACE_HEIGHT,0,0),
	    UMTApplication->DefaultFaceColor
	);
    }
    else face = UMTApplication->DefaultFace;
  
    PageTitle->body( new Label("Page 100",font_header_value,color_black));

    vb1->append(layout.vglue());
    vb1->append(FromTitle);
    vb1->append(layout.vglue());
    vb1->append(SubjectTitle);
    vb1->append(layout.vglue());

    hb1->append(face);
    hb1->append(PageBox =  new Patch(new Background(layout.h_natural_span(vb1,
									  WIDTH_BODY-XFACE_WIDTH+1),
						    color_black)));

    umtString empty_str;
    for( len = 0; len < WIDTH_BODY; len += font_body->width('W'))
	empty_str += 'W';
    
    for( int i = 0; i < HIGTH_BODY/SIZE_FONT_BODY; i++ )
	vbox_body->append( new Label(empty_str.Str(),font_body,color_black));
  
    vb->append(layout.hcenter(new Border(layout.natural_span(hb1,
							     WIDTH_BODY,
							     XFACE_HEIGHT-1),
					 color_black)));
    vb->append(layout.vspace(5));
  
    vb->append(layout.vspace(15));
    vb->append(layout.hcenter(layout.v_natural_span(vbox_body,HIGTH_BODY)));
    vb->append(layout.vglue());
    vb->append(layout.vspace(15));
  
    vb->append(
	layout.hcenter(layout.h_natural_span(new Border(layout.hglue(),
							color_black,
							0.5f),
					     WIDTH_BODY)));
    vb->append(
	layout.hcenter(
	    layout.h_natural_span(layout.hbox(
		new Label(cpr,
			  font_cpr,
			  color_black),
		layout.hglue(),
		PageTitle),
				  WIDTH_BODY)));
    
    page->body(layout.margin(layout.natural_span(vb,WIDTH_BODY,720),25,25,0,0));
    
    
    Msg2Str();
}

umtPrintMsg::~umtPrintMsg()
{
    if( is_error )
	return;
    Resource::unref(page);
    Resource::unref(body1);
    Resource::unref(SubjectTitle);
    Resource::unref(PageTitle);
    Resource::unref(font_title);
    Resource::unref(font_body);
    Resource::unref(font_attach);
    Resource::unref(font_cpr);
    Resource::unref(font_header_handler);
    Resource::unref(font_header_value);
    Resource::unref(color_black);
    Resource::unref(color_white);
    Resource::unref(color_gray);
}

umtString umtPrintMsg::GetStr()
{
    char *i;
    umtString r(view_msg.Str()+cur_pos,(int)(WIDTH_BODY/font_body->width('W')));

    i = strchr(r.Str(),'\n');
    if( i != NULL )
    {
	if( i == r.Str() )
	    r = umtString(" ");
	else
	{
	    r = umtString(r, i-r.Str());
	    cur_pos++;
	}
    }
    cur_pos += r.Length();
    if( !is_attach )
    {
	if( r.SubStr(0,strlen("  [ Attachment:")) == "  [ Attachment:")
	    is_attach = 1;
    }
    else if( r == " " )
	is_attach = 0;

    return r;
}

void umtPrintMsg::DelTab(umtString &s)
{
    char *i;
    umtString tmp1;
    umtString tmp2;
  
    for(;;)
    {
	i = strchr(s.Str(),'\t');
	if(i == NULL)
	    break;
	tmp1 = umtString(s.Str(),i-s.Str());
	tmp2 = umtString(i+1);
	s = tmp1;
	s += "    "; 
	s += tmp2;
    }
}

void umtPrintMsg::Msg2Str()
{
    char             s[MAXSTRING];
    umtMsgComponent *curr_component;
  
    if( msg->GetBody()->IsMultipart() )
	curr_component = ((umtMsgMultipartComponent *)(msg->GetBody()))->GetFirst();
    else curr_component = msg->GetBody();
  
    read_file(curr_component);

    if( (msg->GetBody())->IsMultipart() )
	for(
	    curr_component = (umtMsgComponent *)curr_component->GetNext();
	    curr_component;
	    curr_component = (umtMsgComponent *)curr_component->GetNext()
	)
	{
	    sprintf(s,
		    UMTSTR(PAttachDescription),
		    curr_component->ContentField.FullContentTypeString.Str(),
		    curr_component->GetSize());
	    view_msg += "\n";
	    view_msg += s;
	    if(	curr_component->IsText() &&
		UMTConfig.GetStrField("Printer.PrintAttacments").CaseInsensitiveEqual("yes") )
		read_file(curr_component);
	}
    if( view_msg.IsEmpty() != 1 )
	DelTab(view_msg);
}

void umtPrintMsg::read_file(umtMsgComponent *c)
{
    umtPath         path;
    InputFile       *file;
    const char      *data_;
    int len;
  
    path = c->ThePath;
    file = InputFile::open(path.Str());
    for(;;)
    {
	len = file->read(data_);
	if (len <= 0)
	    break;
	view_msg += "\n";
	view_msg += umtString(data_,len);
    }
    Delete(file);
}

int umtPrintMsg::PrintHeader()
{
    int i = 0;
    int flg;
    umtConfiguration *cfg, *cfg_tmp;
    umtInternetHeader *header = msg->GetHeader();


    umtString us = UMTConfig.GetStrField("ShowHeaderOrFields");
    if (us.IsEmpty() || us.CaseInsensitiveEqual("Header"))
	flg = 0;
    else 
    {
	flg = 1;
	cfg = UMTConfig.GetConfiguration("HeaderShow");
    }
  
    for(umtDictionaryEntry *de = header->GetFirst();
	de && i < HIGTH_BODY/SIZE_FONT_BODY;
	de = header->GetNext(de))
    {
	umtString hand;
	umtString val;
	umtString tmp;
	int len = 0;
      
	hand = *(de->Handler);
	if(flg)
	{
	    for(cfg_tmp = cfg->GetFirst();cfg_tmp;cfg_tmp=cfg->GetNext(cfg_tmp))
		if(cfg_tmp->GetParByNumber(0).CaseInsensitiveEqual(hand))
		    break;
	    if(cfg_tmp == nil)
		continue;
	}

	val = *(de->Value);
	while(
	    len < val.Length() &&
	    font_header_value->width(tmp.Str(),tmp.Length()) +
	    font_header_handler->width(hand.Str(),hand.Length()) < WIDTH_BODY // + 50
	)		
	    tmp += val[len++];
      
	Box *bbb = (Box *)layout.hbox(new Label(hand.Str(),font_header_handler,color_black),
				      new Label(tmp.Str(),font_header_value,color_black));
	vbox_body->replace(i,bbb);
	i++;
      
	while( len < val.Length() )
	{
	    tmp = "";
	    while(
		len < val.Length() &&
		font_header_value->width(tmp.Str(),tmp.Length()) < WIDTH_BODY // + 50
	    )		
		tmp += val[len++];
	  
	    vbox_body->replace(i,new Label(tmp.Str(),font_header_value,color_black));
	    i++;
	}
    }
  
    vbox_body->replace(i, new Label(" ",font_body,color_black));
    i++;
    vbox_body->replace(i,
		       layout.h_natural_span(
			   new Border(layout.hglue(),color_black,0.5f),
			   WIDTH_BODY));
    i++;
    return i;
}

void umtPrintMsg::page_to(int n)
{
    umtString data;
    char  str[100];
    int   i = 0;
  
    sprintf(str,"Page %d",n);
    PageTitle->body( new Label(str,font_header_value,color_black) );
  
    // Append Header
    if( n == 1 )
	i = PrintHeader();
    else
    {
	Glyph *tmp_g = ((Background *)PageBox->body())->body();
	PageBox->body(new Background(tmp_g,color_gray));
    }

    for(; i < HIGTH_BODY/SIZE_FONT_BODY && cur_pos < view_msg.Length(); i++ )
    {
	data = GetStr();
	vbox_body->replace(i, new Label(data,
					is_attach?font_attach:font_body,
					color_black));
    }
  
    for( ; i < HIGTH_BODY/SIZE_FONT_BODY ; i++ )
	vbox_body->replace(i, new Label(" ",font_body,color_black));
  
}

void umtPrintMsg::do_print()
{
    char s[100];
    char *pm;
  
    if( is_error )
	return;

    extern_patch->append(page);
    extern_patch->reallocate();

    pm = tempnam("/tmp","msg_");
    if(pm == nil)
	return;
    umtString path = pm;
    path += ".ps";
    free(pm);

    ofstream out(path.Str());
    Printer* p = new Printer(&out);

    page->reallocate();
    const Allocation& a = page->allocation();
    p->resize(a.left(), a.bottom(), a.right(), a.top());
  
    extern_patch->remove( extern_patch->count() - 1 );
    extern_patch->reallocate();
  
    p->prolog("UMT");
  
    while ( cur_pos < view_msg.Length() || number_page  == 1 )
    {
	sprintf(s,"%d",number_page);
	p->page(s);
	page_to( number_page );
	number_page++;
	page->print(p, a);
    }
  
    p->epilog();

    extern_patch->reallocate();
    extern_patch->redraw();

    out.flush();
    delete p;
    
    sprintf(s,UMTConfig.GetStrField("Printer.Command").Str(),path.Str());
    system(s);
    
    if(UMTConfig.GetStrField("Printer.RemoveFileAfterPrinting").CaseInsensitiveEqual("yes")  )
	unlink(path.Str());

}











