/*
  $Header: /export/CVS/UMT/src/umtRenameFolderDialog.cc,v 1.1 1996/10/22 19:48:06 lord Exp $
  
  $Log: umtRenameFolderDialog.cc,v $
  Revision 1.1  1996/10/22 19:48:06  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:50  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:47:26  sebast
// Revision 2.0
//
// Revision 1.16  1996/03/04  10:52:35  sebast
// display.h added
//
// Revision 1.15  1996/02/20  13:21:39  bird
// use umtFieldEditor()
//
// Revision 1.14  1996/02/17  15:13:43  bird
// Use OpenFileDialog
//
// Revision 1.13  1996/02/17  12:43:02  bird
// Set Window title
//
// Revision 1.12  1996/02/16  14:27:54  vlad
// I don't remember already why a lock it?
//
// Revision 1.11  1995/11/22  18:45:38  vlad
// Parse error.
//
// Revision 1.10  1995/11/21  15:56:13  bird
// Localisation
//
// Revision 1.9  1995/09/14  14:58:25  lord
// is_new
//
// Revision 1.8  1995/09/14  12:24:24  voloh
// using ',' before ')' ...
//
// Revision 1.7  1995/09/12  17:00:55  lord
// Tranform added
//
// Revision 1.6  1995/09/12  16:36:32  lord
// initialise fc_dialog.
//
// Revision 1.5  1995/09/12  16:18:12  lord
// Some experiments with transformers.
//
// Revision 1.4  1995/09/12  15:52:52  lord
// umtRenameFolderFiledEditor added
//
// Revision 1.3  1995/09/12  11:39:53  lord
// make icon_p *umtPath.
//
// Revision 1.2  1995/09/12  11:25:00  lord
// Setting up initial values of name and icon fields.
//
// Revision 1.1  1995/09/12  11:16:32  lord
// Initial revision
//
  */


#include "umtRenameFolderDialog.h++"
#include "umtConfirmDialog.h++"
#include "umt_const.h++"
#include "umtApp.h++"

#include <InterViews/image.h>
#include <InterViews/tiff.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/event.h>
#include <OS/string.h>

implementActionCallback(umtRenameFolderDialog);

umtRenameFolderFiledEditor::umtRenameFolderFiledEditor(const String &t,Style *s,umtRenameFolderDialog *ta):
    umtFieldEditor(t,UMTApplication->Kit,s)
{
    target=ta;
}

umtRenameFolderFiledEditor::~umtRenameFolderFiledEditor()
{
}

void umtRenameFolderFiledEditor::keystroke(const Event &ev)
{
    char c;
    
    (void) ev.mapkey(&c,1);
    if(c=='\r' || c=='\n')
	target->UpdateIcon();
    umtFieldEditor::keystroke(ev);
}

umtRenameFolderDialog::umtRenameFolderDialog(umtString *mesg,umtPath *new_icon,int is_incoming, int is_new):umtDialog(
    UMTApplication->Layout->vbox(),
	UMTApplication->CStyle,
	is_new?"New folder":"Rename Folder"
)
{
    const int  hspacing=20;
    const int  vmargin=15;
    const char *templ="                              ";
    Raster      *image;
    String      tmp;

    fc_dialog=nil;
    tmp=templ;
    namep=mesg;
    iconp=new_icon;
    
    IsIncoming=is_incoming;
    
    if(iconp->IsEmpty() || (iconp->IsExists()!=OK))
	*iconp=IsIncoming?UMTDefaultNewFolderIcon:UMTDefaultFolderIcon;
    
    image = TIFFRaster::load(iconp->Str());
    if(image)
	t.scale(FolderIconWidth/image->width(),FolderIconHeight/image->height());

    body()->append(
	UMTApplication->Layout->vbox(
	    UMTApplication->Kit->outset_frame(
		UMTApplication->Layout->vbox(
		    UMTApplication->Layout->vspace(vmargin),
		    UMTApplication->Layout->hbox(
			UMTApplication->Layout->hglue(),
			UMTApplication->Kit->label(is_new?UMTSTR(600):UMTSTR(443)),
			UMTApplication->Layout->hglue()        
		    ),

		    UMTApplication->Layout->vspace(vmargin),
		    UMTApplication->Layout->hbox(
			UMTApplication->Layout->hspace(hspacing),
			UMTApplication->Kit->label(UMTSTR(601)),
			ef_name= new umtFieldEditor(templ,UMTApplication->Kit,UMTApplication->CStyle),
			UMTApplication->Layout->hglue(),        
			UMTApplication->Layout->hspace(hspacing)
		    ),


		    UMTApplication->Layout->vspace(vmargin),
		    UMTApplication->Layout->hbox(
			UMTApplication->Layout->hspace(hspacing),
			UMTApplication->Kit->label(UMTSTR(602)),
			ef_icon=new umtRenameFolderFiledEditor(tmp,UMTApplication->CStyle,this),
			UMTApplication->Layout->hglue(),        
			UMTApplication->Layout->hspace(hspacing),
			icon_patch=new Patch(
			    UMTApplication->Kit->outset_frame(
				new TransformSetter(
				    new Image(image),t
				)
			    )
			),
			UMTApplication->Layout->hspace(hspacing)
		    ),
		    UMTApplication->Layout->vspace(vmargin),
		    UMTApplication->Layout->hbox(
			UMTApplication->Layout->hspace(hspacing),
			UMTApplication->Kit->push_button(
			    UMTApplication->Kit->label(UMTSTR(112)),
			    new ActionCallback(umtRenameFolderDialog)
			    (this, &umtRenameFolderDialog::browse_button_pressed)
			),
			UMTApplication->Layout->hglue(),        
			UMTApplication->Layout->hspace(hspacing)
		    ),
		    UMTApplication->Layout->vspace(vmargin)
		)
	    ),
	    UMTApplication->Kit->outset_frame(
		UMTApplication->Layout->hbox(
		    UMTApplication->Layout->hglue(),
		    UMTApplication->Kit->push_button(
			UMTApplication->Kit->label(UMTSTR(110)),
			new ActionCallback(umtRenameFolderDialog)((umtRenameFolderDialog *)this,umtRenameFolderDialog::cb_ok)
		    ),
		    UMTApplication->Layout->hglue(),
		    UMTApplication->Kit->push_button(
			UMTApplication->Kit->label(UMTSTR(111)),
			new ActionCallback(umtRenameFolderDialog)((umtRenameFolderDialog *)this,umtRenameFolderDialog::cb_cancel)
		    ),
		    UMTApplication->Layout->hglue()
// 		    ,UMTApplication->Kit->push_button(
// 			UMTApplication->Kit->label("Help"),
// 			new ActionCallback(umtRenameFolderDialog)((umtRenameFolderDialog *)this,umtRenameFolderDialog::cb_help)
// 		    ),
// 		    UMTApplication->Layout->hglue()
			))
	)
    );

    append_input_handler(ef_name);
    append_input_handler(ef_icon);

    if(!(iconp->IsEmpty())) ef_icon->field(iconp->Str());
    if(!(namep->IsEmpty())) ef_name->field(namep->Str());

    focus(ef_name);

}

umtRenameFolderDialog::~umtRenameFolderDialog()
{
}

void umtRenameFolderDialog::cb_ok()
{
    umtConfirmDialog *confirm_dialog;
    umtString mesg;
    
    *namep=ef_name->text()->string();
    namep->StripJunk();
    *iconp=ef_icon->text()->string();
    iconp->StripJunk();

    mesg=UMTSTR(610);
    mesg+=*iconp;
    mesg+=UMTSTR(611);
    
    if(iconp->IsExists()!=OK)
    {
	confirm_dialog = new umtConfirmDialog(
	    UMTApplication->Kit,
		UMTApplication->Layout,
		UMTApplication->CStyle,
		"Warning",
		&mesg
	    );
	if(confirm_dialog)
	{
	    Resource::ref(confirm_dialog);
	    if(confirm_dialog->post_for(Wnd))
	    {
		Resource::unref(confirm_dialog);
		dismiss(true); //OK
	    } else
	    { 
		Resource::unref(confirm_dialog);
		return;
	    }
	}
    }
    dismiss(true);
}

void umtRenameFolderDialog::cb_cancel()
{
    dismiss(false);
}

void umtRenameFolderDialog::cb_help()
{
    //TODO: Help
}

void umtRenameFolderDialog::browse_button_pressed() 
{
    umtPath tmpp;
    
    UMTApplication->OpenFileDialog(&tmpp,Wnd);
    
    if( !tmpp.IsEmpty() )
    {
	ef_icon->field(tmpp.Str());
	UpdateIcon();
    }
}

void umtRenameFolderDialog::UpdateIcon()
{
    Raster      *image;
    umtPath     image_file;
    Transformer t1;
    
    image_file=ef_icon->text()->string();
    
    if(image_file.IsEmpty() || (image_file.IsExists()!=OK))
	image_file=IsIncoming?UMTDefaultNewFolderIcon:UMTDefaultFolderIcon;
    
    image = TIFFRaster::load(image_file.Str());
    if(image)
    {
	t=t1; // Clear scale.
	t.scale(FolderIconWidth/image->width(),FolderIconHeight/image->height());
	icon_patch->body(
	    UMTApplication->Kit->outset_frame(
		new TransformSetter(
		    new Image(image),t
		)
	    )
	); 
    } else {
	// Emtry box.
	icon_patch->body(
	    UMTApplication->Kit->outset_frame(
		UMTApplication->Layout->fixed(
		    UMTApplication->Layout->vbox(
			UMTApplication->Layout->hglue(),
			UMTApplication->Layout->vglue()
		    ),
		    FolderIconWidth,
		    FolderIconHeight
		)
	    )
	);
    }
    icon_patch->redraw();
}





